/*
 * $Id: //depot/prod/newport_news/main/modules/crypto-util/src/main/java/com/netapp/crypto/Sha1PrngSecureRandomFactory.java#1 $
 *
 * Copyright (c) 2013 NetApp, Inc.
 * All rights reserved.
 */
package com.netapp.crypto;

import java.security.SecureRandom;
import java.util.concurrent.Callable;

/**
 * Creates {@link SecureRandom} instances that use the {@link #ALGORITHM} algorithm.
 */
class Sha1PrngSecureRandomFactory implements Callable<SecureRandom> {

    private static final String ALGORITHM = "SHA1PRNG";

    @Override
    public SecureRandom call() throws Exception {
        return SecureRandom.getInstance(ALGORITHM);
    }
}
