-- Copyright (c) 2013 NetApp. All rights reserved

-- Connect any snap mirror where the destination volume has just been introduced, and the source
-- volume is already present in the system from another originator
--
-- tagname: SnapMirror
-- temporary table name: snapmirror_temp

UPDATE
  netapp_model.snap_mirror sm, netapp_model.snapmirror_temp t, netapp_model.volume dv, netapp_model.volume sv, netapp_model.vserver vs, netapp_model.cluster c
SET
  sm.sourceVolumeId = sv.objid,
  sm.sourceVserverId = sv.vserverId,
  sm.sourceClusterId = sv.clusterId
WHERE
  sm.objid=t.objid
  AND sm.sourceVolumeId IS NULL
  AND sm.volumeId=dv.objid
  AND sm.sourceVolume=sv.name
  AND sv.vserverId=vs.objid
  AND sm.sourceVserver=vs.name
  AND vs.clusterId=c.objid
  AND sm.sourceCluster=c.name
  AND sv.objState = 'LIVE';
