-- Copyright (c) 2015 NetApp. All rights reserved

-- Connect a new vserver peer with the peer vserver, if the peer vserver is already present in the system
-- from another originator
--
-- tagname: VServerPeer
-- temporary table name: vserverpeer_temp

UPDATE netapp_model.vserver_peer vp,
  netapp_model.vserverpeer_temp t,
  netapp_model.vserver v,
  netapp_model.cluster c
SET
  vp.peerVServerId = v.objid,
  vp.peerClusterId = v.clusterId
WHERE
  vp.objid = t.objid
  AND vp.peerClusterId IS NULL
  AND vp.peerVServerId IS NULL
  AND (vp.peerVServerUUID IS NOT NULL AND vp.peerVServerUUID = v.uuid OR vp.peerVServerUUID IS NULL AND vp.peerVServerName = v.name)
  AND v.clusterId = c.objid
  AND vp.peerClusterName = c.name
  AND v.objState = 'LIVE';
  