package com.netapp.oci.netapp.performance.networkport.interfaces.remote;

import com.netapp.oci.netapp.interfaces.data.NetappInterfaceException;
import com.netapp.oci.netapp.performance.networkport.interfaces.data.NetworkPortMeasurements;
import com.netapp.oci.platform.common.interfaces.data.performance.RawSample;

import javax.ejb.Remote;
import java.util.Collection;

/**
 * @author Nancy Walia
 */
@Remote
public interface NetworkPortPerformanceRemote {
    String JNDI_NAME = "NetworkPortPerformanceRemote";

    /**
     * The Acq use this method to report on NetworkPort performance
     *
     * @param datasourceId - id of the datasource reporting performance data
     * @param clusterKey - the cluster Key Identifier
     * @param time - the report time, it is the datasource responsibility to make sure that the earlier sample and the
     *               latest sample time difference is less then X minute (1 by default),
     * @param rawSamples - raw networkPort samples
     * @param leaseTime    the time for datasource to be registered in the in the registry (in milliseconds)
     *
     * @throws com.netapp.oci.netapp.interfaces.data.NetappInterfaceException if failed to report
     */
    void reportNetworkPortSamples(Long datasourceId, String clusterKey, long time, Collection<RawSample<NetworkPortMeasurements>> rawSamples, long leaseTime) throws NetappInterfaceException;
}
