ALTER TABLE netapp_model.vserver ADD COLUMN nfsV41PnfsEnabled BOOL DEFAULT NULL COMMENT 'If true, then Parallel NFS support for NFS version 4.1 is enabled' AFTER nfsV41Supported;
ALTER TABLE netapp_model.vserver ADD COLUMN nfs41AclEnabled BOOL DEFAULT NULL COMMENT 'If true, then NFSv4.1 ACL feature is enabled' AFTER nfsV41PnfsEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN nfsV4ReadDelegationEnabled BOOL DEFAULT NULL COMMENT 'If true, NFSv4.0 read delegation feature is enabled' AFTER nfs41AclEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN nfsV4WriteDelegationEnabled BOOL DEFAULT NULL COMMENT 'If true, NFSv4.0 write delegation feature is enabled' AFTER nfsV4ReadDelegationEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN nfsV4MigrationEnabled BOOL DEFAULT NULL COMMENT 'If true, NFSv4.0 migration feature is enabled' AFTER nfsV4WriteDelegationEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN nfsV4ReferralsEnabled BOOL DEFAULT NULL COMMENT 'If true, NFSv4.0 referrals feature is enabled' AFTER nfsV4MigrationEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN nfsV41MigrationEnabled BOOL DEFAULT NULL COMMENT 'If true, NFSv4.1 migration feature is enabled' AFTER nfsV4ReferralsEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN nfsV41ReferralsEnabled BOOL DEFAULT NULL COMMENT 'If true, NFSv4.1 referrals feature is enabled' AFTER nfsV41MigrationEnabled;

ALTER TABLE netapp_model.vserver ADD COLUMN nisEnabled BOOL DEFAULT NULL COMMENT 'Specifies whether the NIS domain configuration is active or inactive' AFTER fcpNodeName;
ALTER TABLE netapp_model.vserver ADD COLUMN nisServers VARCHAR(255) DEFAULT NULL COMMENT 'Specifies the IP address of one or more NIS servers in the domain. Multiple values will be sorted comma separated' AFTER nisEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN nisDomainName VARCHAR(255) DEFAULT NULL COMMENT 'Specifies the NIS domain' AFTER nisServers;
ALTER TABLE netapp_model.vserver ADD COLUMN dnsEnabled BOOL DEFAULT NULL COMMENT 'True if DNS enabled' AFTER nisDomainName;
ALTER TABLE netapp_model.vserver ADD COLUMN dnsServers VARCHAR(255) DEFAULT NULL COMMENT 'IPv4 addresses of name servers. Multiple values will be sorted comma separated' AFTER dnsEnabled;
ALTER TABLE netapp_model.vserver ADD COLUMN dnsDomainNames VARCHAR(255) DEFAULT NULL COMMENT 'List of DNS domains. The first domain is the one that the Vserver belongs to' AFTER dnsServers;
ALTER TABLE netapp_model.vserver ADD COLUMN maximumVolumes INT DEFAULT NULL COMMENT 'Maximum number of volumes that can be created on the Vserver' AFTER dnsDomainNames;
ALTER TABLE netapp_model.vserver ADD COLUMN language VARCHAR(255) DEFAULT NULL COMMENT 'Language to use for the Vserver' AFTER maximumVolumes;
ALTER TABLE netapp_model.vserver ADD COLUMN nameServerSwitch VARCHAR(255) DEFAULT NULL COMMENT 'Name Server switch configuration details for the Vserver.Multiple values will be ordered comma separated' AFTER language;
ALTER TABLE netapp_model.vserver ADD COLUMN volumeBytesUsed BIGINT(20) DEFAULT NULL COMMENT 'DERIVED. Sum of all used bytes on volumes in Vserver' AFTER nameServerSwitch;
ALTER TABLE netapp_model.vserver ADD COLUMN volumeBytesTotal BIGINT(20) DEFAULT NULL COMMENT 'DERIVED. Sum of all total bytes on volumes in Vserver' AFTER volumeBytesUsed;
ALTER TABLE netapp_model.vserver ADD COLUMN isRepository BOOL DEFAULT NULL COMMENT 'Specifies if this Vserver is a repository Vserver' AFTER volumeBytesTotal;

ALTER TABLE netapp_model.vserver DROP COLUMN cifsSmb2Supported;

ALTER TABLE netapp_model.node ADD COLUMN nvramId VARCHAR(255) DEFAULT NULL COMMENT 'Vendor specific NVRAM ID of the node. ZAPI: system-node-get-iter node-nvram-id' AFTER productType;
ALTER TABLE netapp_model.node ADD COLUMN cpuFirmwareRelease VARCHAR(255) DEFAULT NULL COMMENT 'Firmware release number. ZAPI: system-node-get-iter cpu-firware-relsease' AFTER nvramId;
ALTER TABLE netapp_model.node ADD COLUMN isOverTemperature BOOL DEFAULT NULL COMMENT 'An indication of whether the hardware is currently operating outside of its recommended temperature range. ZAPI: system-node-get-iter env-over-temperature' AFTER cpuFirmwareRelease;
ALTER TABLE netapp_model.node ADD COLUMN failedFanCount INT DEFAULT NULL COMMENT 'Number of failed fans. ZAPI: system-node-get-iter env-failed-fan-count' AFTER isOverTemperature;
ALTER TABLE netapp_model.node ADD COLUMN failedPowerSupplyCount INT DEFAULT NULL COMMENT 'Number of failed power supply units. ZAPI: system-node-get-iter env-failed-power-supply-count' AFTER failedFanCount;
ALTER TABLE netapp_model.node ADD COLUMN nvramBatteryStatus ENUM ('BATTERY_OK', 'BATTERY_PARTIALLY_DICHARGED', 'BATTERY_FULL_DISCHARGED', 'BATTERY_NOT_PRESENT', 'BATTERY_NEAR_END_OF_LIFE', 'BATTERY_AT_END_OF_LIFE', 'BATTERY_UNKNOWN', 'BATTER_OVER_CHARGED', 'BATTERY_FULLY_CHARGED', 'NOT_MAPPED') DEFAULT NULL COMMENT 'NVRAM Battery Attributes. ZAPI: system-node-get-iter nvram-battery-status' AFTER failedPowerSupplyCount;
ALTER TABLE netapp_model.node ADD COLUMN rawDiskBytesTotal BIGINT(20) DEFAULT NULL COMMENT 'DERIVED.Sum of all disks size total' AFTER nvramBatteryStatus;
ALTER TABLE netapp_model.node ADD COLUMN rawDiskBytesUsed BIGINT(20) DEFAULT NULL COMMENT 'DERIVED.Sum of all disks size used' AFTER rawDiskBytesTotal;
ALTER TABLE netapp_model.node ADD COLUMN isFailoverEnabled BOOL DEFAULT NULL COMMENT 'True, if the storage failover facility is enabled, false otherwise. ZAPI: cf-status is-enabled' AFTER rawDiskBytesUsed;
ALTER TABLE netapp_model.node ADD COLUMN isTakeOverPossible BOOL DEFAULT NULL COMMENT 'True, if storage failover takeover is currently possible, false otherwise. ZAPI: cf-status takeover-possible' AFTER isFailoverEnabled;
ALTER TABLE netapp_model.node ADD COLUMN partnerFirmwareState VARCHAR(255) DEFAULT NULL COMMENT 'Partner firmware state as communicated by the partner through interconnect. ZAPI: cf-status partner-firmware-state' AFTER isTakeOverPossible;
ALTER TABLE netapp_model.node ADD COLUMN localFirmwareState VARCHAR(255) DEFAULT NULL COMMENT 'Local firmware state that will be communicated through interconnect to the partner. ZAPI: cf-status local-firmware-state' AFTER partnerFirmwareState;
ALTER TABLE netapp_model.node ADD COLUMN isInterconnectUp BOOL DEFAULT NULL COMMENT 'True, if high availability interconnect is up. ZAPI: cf-status is-interconnect-up' AFTER localFirmwareState;
ALTER TABLE netapp_model.node ADD COLUMN interconnectLinks VARCHAR(255) DEFAULT NULL COMMENT 'States of the individual interconnect links. ZAPI: cf-status interconnect-links' AFTER isInterconnectUp;
ALTER TABLE netapp_model.node ADD COLUMN versionGeneration INT DEFAULT NULL COMMENT 'First integer of the Data ONTAP version tuple corresponding to this Node.' AFTER interconnectLinks;
ALTER TABLE netapp_model.node ADD COLUMN versionMajor INT DEFAULT NULL COMMENT 'Second integer of the Data ONTAP version tuple corresponding to this Node' AFTER versionGeneration;
ALTER TABLE netapp_model.node ADD COLUMN versionMinor INT DEFAULT NULL COMMENT 'Third integer of the Data ONTAP version tuple corresponding to this Node' AFTER versionMajor;
ALTER TABLE netapp_model.node ADD COLUMN owner VARCHAR(255) DEFAULT NULL COMMENT 'The owner of the Node. ZAPI: system-node-get-iter node-owner' AFTER versionMinor;
ALTER TABLE netapp_model.node ADD COLUMN isNodeHealthy BOOL DEFAULT NULL COMMENT 'The RDB health of the node. True means the node is in quorum. ZAPI: system-node-get-iter is-node-healthy' AFTER owner;
ALTER TABLE netapp_model.node ADD COLUMN envFailedFanMessage VARCHAR(255) DEFAULT NULL COMMENT 'Text message describing the current condition of chassis fans. This is useful only if env-failed-fan-count is not zero. ZAPI: system-node-get-iter.env-failed-fan-message' AFTER isNodeHealthy;
ALTER TABLE netapp_model.node ADD COLUMN envFailedPowerSupplyMessage VARCHAR(255) DEFAULT NULL COMMENT 'Text message describing the state of any power supplies which are currently degraded. This is useful only if env-failed-power-supply-count is not zero. ZAPI: system-node-get-iter.env-failed-power-supply-message' AFTER envFailedFanMessage;

ALTER TABLE netapp_model.aggregate ADD COLUMN sizeAvail BIGINT(20) DEFAULT NULL COMMENT 'Number of bytes still available in the referenced file system. ZAPIs: aggr-get-iter aggr-space-attributes size-available' AFTER sizeUsed;
ALTER TABLE netapp_model.aggregate ADD COLUMN snapshotSizeAvail BIGINT(20) DEFAULT NULL COMMENT 'Number of bytes still available in the referenced file system. ZAPIs: aggr-get-iter aggr-snapshot-attributes size-available' AFTER snapshotSizeUsed;
ALTER TABLE netapp_model.aggregate ADD COLUMN mirrorStatus ENUM('INVALID', 'UNINITIALIZED', 'NEEDS_CP_COUNT_CHECK', 'CP_COUNT_CHECK_IN_PROGRESS', 'UNMIRRORED', 'MIRRORED', 'MIRROR_DEGRADED', 'MIRROR_RESYNCHRONIZING', 'FAILED', 'LIMBO', 'NOT_MAPPED') DEFAULT NULL COMMENT 'Aggregate\'s mirror status, ZAPIs: aggr-get-iter mirror-status' AFTER raidType;
ALTER TABLE netapp_model.aggregate ADD COLUMN blockType ENUM('32_BIT', '64_BIT', 'NOT_MAPPED') DEFAULT NULL COMMENT 'The indirect block format that the aggregate can have. ZAPIs: aggr-get-iter block-type' AFTER mirrorStatus;
ALTER TABLE netapp_model.aggregate ADD COLUMN is64BitUpgradeInProgress BOOL DEFAULT NULL COMMENT 'True if the 64-bit upgrade is in progress. ZAPIs: aggr-get-iter is-64-bit-upgrade-in-progress' AFTER blockType;
ALTER TABLE netapp_model.aggregate ADD COLUMN logicalSize BIGINT(20) DEFAULT NULL COMMENT '[DERVIED] Sum of effectiveBytesUsed on all SIS enabled Volumes residing on this Aggregate. NOTE:  This should just be added as a place holder until we derive this field on the Volume object.' AFTER is64BitUpgradeInProgress;
ALTER TABLE netapp_model.aggregate ADD COLUMN volumeDedupeSpaceSavings BIGINT(20) DEFAULT NULL COMMENT '[DERVIED] Sum of dedupe savings on SIS enabled Volumes residing on this Aggregate.  In bytes.' AFTER logicalSize;
ALTER TABLE netapp_model.aggregate ADD COLUMN volumeCompressionSpaceSavings BIGINT(20) DEFAULT NULL COMMENT '[DERVIED] Sum of compression savings on SIS enabled Volumes residing on this Aggregate.  In bytes.' AFTER volumeDedupeSpaceSavings;
ALTER TABLE netapp_model.aggregate ADD COLUMN volumeCloneSpaceSavings BIGINT(20) DEFAULT NULL COMMENT '[DERVIED] Sum of clone savings on Volumes residing on this Aggregate.  In bytes. NOTE:  This should just be added as a place holder until we derive this field on the Volume object.' AFTER volumeCompressionSpaceSavings;
ALTER TABLE netapp_model.aggregate ADD COLUMN raidSize BIGINT(20) DEFAULT NULL COMMENT 'Specifies the maximum number of disks in each RAID group in the aggregate. The maximum value for this parameter is 28. ZAPIs: aggr-get-iter raid-size' AFTER volumeCloneSpaceSavings;
ALTER TABLE netapp_model.aggregate ADD COLUMN totalCommitted BIGINT(20) DEFAULT NULL COMMENT 'A derived measure of the committed capacity of all Volumes on this Aggregate.  Committed here is defined as the total capacity a volume might consume if entirely full.' AFTER sizeAvail;

ALTER TABLE netapp_model.cluster ADD COLUMN resourceKey VARCHAR(255) NOT NULL COMMENT 'DERIVED.  A structured key that may be used to uniquely identify this resource globally.' AFTER uuid;
