ALTER TABLE netapp_model.changes CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin;
ALTER TABLE netapp_model.volume_flexcache CONVERT TO CHARACTER SET utf8 COLLATE utf8_bin;

CREATE TABLE netapp_performance.sample_current_iscsilif (
    objid bigint(20),
    time bigint(20),
    empty bool,
    containerkey varchar(255),
    containerid bigint(20) COMMENT 'Vserver container reference ID',
    dataInBlocks float COMMENT 'Bytes sent from iSCSI sessions on this LIF (bytes/s)',
    dataOutBlocks float COMMENT 'Bytes of blocks read from iSCSI sessions on this LIF (bytes/s)',
    iscsiReadOps float COMMENT 'iSCSI read operations per second on this LIF (op/s)',
    iscsiWriteOps float COMMENT 'iSCSI write operations per second on this LIF (op/s)',
    protocolErrors float COMMENT 'Number of protocol errors from iSCSI sessions on this LIF (number/s)',
    KEY containerkey_index (containerkey),
    PRIMARY KEY (objid, containerid)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin
    PARTITION BY LIST(containerid) (PARTITION p0 VALUES IN (0));
