CREATE TABLE netapp_model.vserver_to_aggregate (
	objid BIGINT(20) NOT NULL,
	originid BIGINT(20) NOT NULL,
	uuid VARCHAR(255) NOT NULL COMMENT 'The uuid of this relationship.  DERIVED as the composite of vserver and aggregate UUIDs.',
    vserverId BIGINT(20) NOT NULL,
    aggregateId BIGINT(20) NOT NULL,
    clusterId BIGINT(20) NOT NULL,
    checksum INT NOT NULL,
	changeDetailChecksum INT NOT NULL,
	updatetime BIGINT(20) NOT NULL,
	KEY updatetime_index (updatetime),
    KEY originId_index (originid),
	CONSTRAINT FOREIGN KEY FK_clusterId (clusterId) REFERENCES netapp_model.cluster (objid),
	CONSTRAINT FOREIGN KEY FK_vserverId (vserverId) REFERENCES netapp_model.vserver (objid),
	CONSTRAINT FOREIGN KEY FK_aggregateId (aggregateId) REFERENCES netapp_model.aggregate (objid),
	PRIMARY KEY (objid)
) ENGINE=INNODB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;