CREATE TABLE netapp_model.snapshot_policy_vserver_relationship (
    objid BIGINT(20) NOT NULL COMMENT 'Locally unique object identifier.',
    originid BIGINT(20) NOT NULL,
    uuid VARCHAR(255) NOT NULL COMMENT 'Globally unique ID of the Snapshot Policy to vserver relationship.',
    vserverId BIGINT(20) NULL COMMENT 'ID of the vserver that this Snapshot Policy is associated with.',
    checksum INT NOT NULL,
    changeDetailChecksum INT NOT NULL,
    updatetime BIGINT(20) NOT NULL,
    KEY updatetime_index (updatetime),
    KEY originId_index (originid),
    PRIMARY KEY (objid),
    CONSTRAINT FOREIGN KEY FK_objid (objid) REFERENCES netapp_model.snapshot_policy (objid),
    CONSTRAINT FOREIGN KEY FK_vserverId (vserverId) REFERENCES netapp_model.vserver (objid)
    ) ENGINE=INNODB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;