-- adding 'inactive' column to the 'volume move job' table
ALTER TABLE netapp_model.volume_move_job ADD COLUMN inactive BOOL DEFAULT FALSE NOT NULL AFTER estimatedCompletionTime;

-- adding "inactive" to the indexes
ALTER TABLE netapp_model.volume_move_job DROP INDEX originId_index;
ALTER TABLE netapp_model.volume_move_job ADD INDEX originId_inactive_index(originId, inactive);  -- for cache load
ALTER TABLE netapp_model.volume_move_job DROP INDEX updatetime_index;
ALTER TABLE netapp_model.volume_move_job ADD INDEX updatetime_inactive_index(updatetime, inactive); -- for the prune job

-- changing the foreign key constraints of 'volume_move_job' table to be "on delete cascade"
ALTER TABLE netapp_model.volume_move_job DROP FOREIGN KEY volume_move_job_ibfk_1;
ALTER TABLE netapp_model.volume_move_job DROP FOREIGN KEY volume_move_job_ibfk_2;
ALTER TABLE netapp_model.volume_move_job DROP FOREIGN KEY volume_move_job_ibfk_3;
ALTER TABLE netapp_model.volume_move_job DROP FOREIGN KEY volume_move_job_ibfk_4;

ALTER TABLE netapp_model.volume_move_job DROP KEY FK_clusterId;
ALTER TABLE netapp_model.volume_move_job DROP KEY FK_volumeId;
ALTER TABLE netapp_model.volume_move_job DROP KEY FK_sourceAggregateId;
ALTER TABLE netapp_model.volume_move_job DROP KEY FK_destinationAggregateId;

ALTER TABLE netapp_model.volume_move_job ADD CONSTRAINT FOREIGN KEY FK_clusterId (clusterId) REFERENCES netapp_model.cluster (objid) ON DELETE CASCADE;
ALTER TABLE netapp_model.volume_move_job ADD CONSTRAINT FOREIGN KEY FK_volumeId (volumeId) REFERENCES netapp_model.volume (objid) ON DELETE CASCADE;
ALTER TABLE netapp_model.volume_move_job ADD CONSTRAINT FOREIGN KEY FK_sourceAggregateId (sourceAggregateId) REFERENCES netapp_model.aggregate (objid) ON DELETE CASCADE;
ALTER TABLE netapp_model.volume_move_job ADD CONSTRAINT FOREIGN KEY FK_destinationAggregateId (destinationAggregateId) REFERENCES netapp_model.aggregate (objid) ON DELETE CASCADE;

-- the life time in milliseconds for a history record.
INSERT INTO netapp_model.param (param, value) VALUES ('HISTORY_LIFETIME', 2592000000); --  30 days in milliseconds
