-- Copyright (c) 2012 NetApp. All rights reserved

CREATE TABLE netapp_model.qos_service_center_relationship (
    objid BIGINT(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: qos-workload-get-iter.qos-workload-info',
    originid BIGINT(20) NOT NULL,
    uuid VARCHAR(255) NOT NULL COMMENT 'Globally unique ID of the QoS Service Center',
    parentQosServiceCenterId BIGINT(20) NOT NULL COMMENT 'ID of the parent service center',
    checksum INT NOT NULL,
    changeDetailChecksum INT NOT NULL,
    updatetime BIGINT(20) NOT NULL,
    KEY updatetime_index (updatetime),
    KEY originId_index (originid),
    CONSTRAINT FOREIGN KEY FK_objid (objid) REFERENCES netapp_model.qos_service_center (objid),
    CONSTRAINT FOREIGN KEY FK_parentResourceId (parentQosServiceCenterId) REFERENCES netapp_model.qos_service_center (objid),
    PRIMARY KEY (objid)
    ) ENGINE=INNODB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

ALTER TABLE netapp_model.qos_service_center DROP FOREIGN KEY qos_service_center_ibfk_4;
ALTER TABLE netapp_model.qos_service_center DROP KEY FK_parentResourceId;
ALTER TABLE netapp_model.qos_service_center DROP COLUMN parentResourceId;