-- Copyright (c) 2012 NetApp. All rights reserved

ALTER TABLE netapp_model.snap_mirror ADD COLUMN jobScheduleId BIGINT(20) DEFAULT NULL AFTER relationshipIdentifier;
ALTER TABLE netapp_model.snap_mirror ADD CONSTRAINT FK_jobScheduleId FOREIGN KEY (jobScheduleId) REFERENCES netapp_model.job_schedule (objId);

CREATE TABLE netapp_model.volume_self_relationship (
    objid BIGINT(20) NOT NULL COMMENT 'Locally unique object identifier.',
    originid BIGINT(20) NOT NULL,
    uuid VARCHAR(255) NOT NULL COMMENT 'UUID of the Volume',
    junctionParentId BIGINT(20) DEFAULT NULL COMMENT 'ID of the parent volume the QoS Policy Group references',
    checksum INT NOT NULL,
    updatetime BIGINT(20) NOT NULL,
    changeDetailChecksum INT NOT NULL,
    KEY updatetime_index (updatetime),
    KEY originId_index (originid),
    PRIMARY KEY (objid),
    CONSTRAINT FOREIGN KEY FK_objid (objid) REFERENCES netapp_model.volume (objid),
    CONSTRAINT FOREIGN KEY FK_junctionParentid (junctionParentId) REFERENCES netapp_model.volume (objid)

) ENGINE=INNODB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;