-- Copyright (c) 2013 NetApp. All rights reserved

-- update node table
ALTER TABLE netapp_model.node ADD COLUMN currentMode VARCHAR(255) DEFAULT NULL COMMENT 'Current HA mode' AFTER giveBackState;
ALTER TABLE netapp_model.node ADD COLUMN takeoverByPartnerNotPossibleReason VARCHAR(512) DEFAULT NULL COMMENT 'If takeover by the partner is not possible, list of one or more reasons why. Translated to a comma separated, lexiographically sorted, list of reasons' AFTER currentMode;
ALTER TABLE netapp_model.node ADD COLUMN takeoverOfPartnerNotPossibleReason VARCHAR(512) DEFAULT NULL COMMENT 'If is-enabled is false, list of one or more reasons why. Translated to a comma separated, lexiographically sorted, list of reasons' AFTER takeoverByPartnerNotPossibleReason;
ALTER TABLE netapp_model.node ADD COLUMN takeoverFailureReason VARCHAR(255) DEFAULT NULL COMMENT 'If is-enabled is false, list of one or more reasons why. If state == takeover_failed, this is the reason for the takeover failure' AFTER takeoverOfPartnerNotPossibleReason;

-- add vserverid to igroup_initiator
ALTER TABLE netapp_model.igroup_initiator ADD COLUMN vserverId bigint(20) NOT NULL AFTER clusterId;

UPDATE
  netapp_model.igroup_initiator i
JOIN
  netapp_model.igroup g
ON
  i.igroupId=g.objid
SET
  i.vserverId = g.vserverId;

ALTER TABLE netapp_model.igroup_initiator ADD CONSTRAINT FOREIGN KEY FK_vserverId (vserverId) REFERENCES netapp_model.vserver (objid);