CREATE TABLE netapp_model.application_record (
    objid BIGINT(20) NOT NULL COMMENT 'Locally unique object identifier.',
    originid BIGINT(20) NOT NULL,
    uuid VARCHAR(255) NOT NULL COMMENT 'Globally unique ID of ApplicationRecord. Not from ZAPI',
    resourceKey VARCHAR(512) NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally',
    clusterId BIGINT(20) NOT NULL,
    recordName  VARCHAR(255) DEFAULT NULL COMMENT ' The name of the record key to set the value.',
    recordValue  VARCHAR(255) DEFAULT NULL COMMENT 'The value for the record key.',
    modifiedFrom VARCHAR(255) DEFAULT NULL COMMENT 'Location from where the value was last modified.',
    lastModifiedTimestamp TIMESTAMP NULL DEFAULT NULL COMMENT 'Last time the value was modified.',
    checksum INT NOT NULL,
    changeDetailChecksum INT NOT NULL,
    updatetime BIGINT(20) NOT NULL,
    objState ENUM ('LIVE', 'DEAD') DEFAULT 'LIVE' NOT NULL COMMENT 'Internal object state',
    KEY updatetime_index (updatetime),
    KEY originId_index (originid),
    CONSTRAINT FOREIGN KEY FK_clusterId (clusterId) REFERENCES netapp_model.cluster (objid),
    PRIMARY KEY (objid)
) ENGINE=INNODB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;