ALTER TABLE netapp_model.lun_map ADD COLUMN owningNodeId BIGINT(20) DEFAULT NULL COMMENT 'The owning node Id.' AFTER lunId;
ALTER TABLE netapp_model.lun_map ADD CONSTRAINT FOREIGN KEY FK_owningNodeId (owningNodeId) REFERENCES netapp_model.node (objid);

CREATE TABLE netapp_model.lun_map_reporting_node (
    objid BIGINT(20) NOT NULL COMMENT 'Locally unique object identifier.',
    originid BIGINT(20) NOT NULL,
    uuid VARCHAR(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the relationship',
	resourceKey VARCHAR(512)  NOT NULL,
	clusterId BIGINT(20) NOT NULL,	
	lunMapId BIGINT(20) NOT NULL,
	nodeId BIGINT(20) NOT NULL,
    checksum INT NOT NULL,
	changeDetailChecksum INT NOT NULL,
	createtime BIGINT(20) NOT NULL,
	updatetime BIGINT(20) NOT NULL,
	objState ENUM('LIVE','DEAD'),
	KEY FK_clusterId (clusterId),
	KEY FK_lunMapId (lunMapId),
	KEY FK_nodeId (nodeId),
	KEY updatetime_index (updatetime),
    KEY originId_index (originid),
	KEY objState_index (objState, objid),
	CONSTRAINT FOREIGN KEY FK_clusterId (clusterId) REFERENCES netapp_model.cluster (objid),
	CONSTRAINT FOREIGN KEY FK_lunMapId (lunMapId) REFERENCES netapp_model.lun_map (objid),
	CONSTRAINT FOREIGN KEY FK_nodeId (nodeId) REFERENCES netapp_model.node (objid),
	PRIMARY KEY (objid)
) ENGINE=INNODB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;