-- Copyright (c) 2013 NetApp. All rights reserved
-- Upgrade script for adding the ip space uuid to the broadcast domain uuid.

ALTER TABLE netapp_model.`network_port_broadcast_domain` MODIFY `uuid` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the broadcast domain DERIVED: cluster_uuid.broadcast_domain_name.';

UPDATE netapp_model.`network_port_broadcast_domain` b
  inner join
  netapp_model.`network_ip_space` i ON (b.networkIpSpaceId = i.objid)
  inner join
  netapp_model.`cluster` c ON (i.clusterId = c.objid)
set
  b.uuid = concat(c.uuid, '.', i.uuid, '.', b.name),
  b.resourceKey = concat(c.uuid,
                         ':type=network_port_broadcast_domain,IP_SPACE_UUID=',
                         i.uuid,
                         ',BROADCAST_DOMAIN=',
                         b.name);
commit;