-- Alter table to add new columns to store AFF Attributes ---

-- This feature was added in 1.2 after 1.3 was started. The create_db_netapp_model,sql is updated to include this
-- change. This upgrade sql is to facilitate the upgrade between internal 1.3 development builds.
DELIMITER $$
CREATE PROCEDURE netapp_model.alter_node_table()
  BEGIN
    DECLARE column_count INT DEFAULT 0;
    SELECT
      COUNT(*)
    INTO column_count FROM
                        INFORMATION_SCHEMA.COLUMNS
    WHERE
      TABLE_SCHEMA = 'netapp_model'
      AND TABLE_NAME = 'node'
      AND COLUMN_NAME = 'isAllFlashOptimized';
    IF column_count = 0 THEN
      ALTER TABLE netapp_model.node ADD COLUMN isAllFlashOptimized tinyint(1) DEFAULT NULL COMMENT 'Is this node configured to only support SSD drives. If true, no HDDs are allowed on this node.' AFTER isEpsilonNode;
    END IF;
  END
$$

DELIMITER ;

CALL netapp_model.alter_node_table();
DROP PROCEDURE netapp_model.alter_node_table;
ALTER TABLE netapp_model.disk MODIFY containerType enum('NOT_MAPPED','AGGREGATE','BROKEN','FOREIGN','LABELMAINT','MAINTENANCE','SPARE','SHARED','UNASSIGNED','VOLUME','UNSUPPORTED','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of overlying disk container';

