-- Fcp_Port
SET @fcpPort = ' <columns>'
                    '<columnName>totalOps</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Total number of ops (readOps + writeOps + otherOps).\'</comments>'
              '</columns> ';

-- FCP_PORT_RAW
SET @fcpPortRaw = ' <columns>'
                    '<columnName>totalOps</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Total number of ops raw (readOps + writeOps + otherOps).\'</comments>'
                 '</columns> ';

-- Fcp LIF
SET @fcpLif =   ' <columns>'
                  '<columnName>avgOtherLatency</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'Avg other latency for FCP operations.\'</comments>'
                   '<columnName>avgReadLatency</columnName>'
                   '<columnType>FLOAT DEFAULT NULL</columnType>'
                   '<comments> COMMENT \'Avg read latency for FCP operations..\'</comments>'
                    '<columnName>avgWriteLatency</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Avg write latency for FCP operations..\'</comments>'
                    '<columnName>opmFcpLifThroughput</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Throughput (readData + writeData).\'</comments>'
                '</columns> ';

--FCP LIf raw
SET @fcpLifRaw = ' <columns>'
                    '<columnName>opm_fcplif_throughput</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Raw Throughput (readData + writeData).\'</comments>'
                 '</columns> ';

-- iscsi Lif
SET @iscsiLif = ' <columns>'
                  '<columnName>avgOtherLatency</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'Average latency through iSCSI sessions this LIF.\'</comments>'
                  '<columnName>avgReadLatency</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'Average Read latency through iSCSI sessions this LIF.\'</comments>'
                  '<columnName>avgWriteLatency</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'Average write latency through iSCSI sessions  this LIF.\'</comments>'
                  '<columnName>iscsiOtherOps</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'iSCSI other operations per second this LIF.\'</comments>'
                  '<columnName>opmIscsiLifOps</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'Operations per second this LIF.\'</comments>'
                  '<columnName>opmIscsiLifthroughput</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'Throughput at this LIF.\'</comments>'
                '</columns> ';

-- iscsi Lif raw
SET @iscsiLifRaw =  ' <columns>'
                    '<columnName>opm_iscsilif_ops</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Operations per second on this LIF (Raw).\'</comments>'
                    '<columnName>opm_iscsilif_throughput</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Throughput at on this LIF (Raw).\'</comments>'
                '</columns> ';

-- stored procedure calls for all three types
-- FCP port
CALL netapp_performance.add_columns('sample_fcpport$',@fcpPort);
CALL netapp_performance.add_columns('summary_fcpport$',@fcpPort);
CALL netapp_performance.add_columns('sample_fcpport_raw$',@fcpPortRaw);

-- FCP lif
CALL netapp_performance.add_columns('sample_fcplif$',@fcpLif);
CALL netapp_performance.add_columns('summary_fcplif$',@fcpLif);
CALL netapp_performance.add_columns('sample_fcplif_raw$',@fcpLifRaw);

-- Iscsi lif
CALL netapp_performance.add_columns('sample_iscsilif$',@iscsiLif);
CALL netapp_performance.add_columns('summary_iscsilif$',@iscsiLif);
CALL netapp_performance.add_columns('sample_iscsilif_raw$',@iscsiLifRaw);