-- Add columns cifs vserver
SET @cifsVserver = ' <columns>'
                    '<columnName>cifsReadThroughput</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'read throughput for cifs at vserver level.\'</comments>'
                    '<columnName>cifsWriteThroughput</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'write throughput for cifs at vserver level.\'</comments>'
                    '<columnName>opmCifsThroughput</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'total throughput for cifs at vserver level (cifs_read_throughput + cifs_write_throughput).\'</comments>'
             '</columns> ';

SET @cifsVserverRaw = ' <columns>'
                    '<columnName>cifs_read_throughput</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Raw read throughput for cifs at vserver level.\'</comments>'
                    '<columnName>cifs_write_throughput</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Raw write throughput for cifs at vserver level.\'</comments>'
                     '<columnName>opm_cifs_throughput</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Raw total throughput for cifs at vserver level (cifs_read_throughput + cifs_write_throughput).\'</comments>'
              '</columns> ';

-- Rename cifs:vserver
SET @cifsVserverRename = ' <columns>'
		                    '<oldColumnName>cifs_latency_base</oldColumnName>'
		                    '<newColumnName>cifsLatencyBase</newColumnName>'
		                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
							'<oldColumnName>cifs_latency</oldColumnName>'
		                    '<newColumnName>cifsLatency</newColumnName>'
		                    '<columnType>FLOAT</columnType>'
							'<oldColumnName>cifs_ops</oldColumnName>'
		                    '<newColumnName>cifsOps</newColumnName>'
		                    '<columnType>FLOAT</columnType>'
							'<oldColumnName>cifs_read_latency</oldColumnName>'
		                    '<newColumnName>cifsReadLatency</newColumnName>'
		                    '<columnType>FLOAT</columnType>'
		                    '<oldColumnName>cifs_read_ops</oldColumnName>'
                            '<newColumnName>cifsReadOps</newColumnName>'
                            '<columnType>FLOAT</columnType>'
                            '<oldColumnName>cifs_write_latency</oldColumnName>'
                            '<newColumnName>cifsWriteLatency</newColumnName>'
                            '<columnType>FLOAT</columnType>'
                            '<oldColumnName>cifs_write_ops</oldColumnName>'
                            '<newColumnName>cifsWriteOps</newColumnName>'
                            '<columnType>FLOAT</columnType>'
						'</columns> ';


-- Add columns for fcpLifVserver
SET @fcpLifVserver =   ' <columns>'
                  '<columnName>avgOtherLatency</columnName>'
                  '<columnType>FLOAT DEFAULT NULL</columnType>'
                  '<comments> COMMENT \'Avg other latency for FCP operations.\'</comments>'
                   '<columnName>avgReadLatency</columnName>'
                   '<columnType>FLOAT DEFAULT NULL</columnType>'
                   '<comments> COMMENT \'Avg read latency for FCP operations..\'</comments>'
                    '<columnName>avgWriteLatency</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Avg write latency for FCP operations..\'</comments>'
                    '<columnName>opmFcpLifThroughput</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Throughput (readData + writeData).\'</comments>'
                '</columns> ';

SET @fcpLifVserverRaw = ' <columns>'
                    '<columnName>opm_fcplif_throughput</columnName>'
                    '<columnType>BIGINT UNSIGNED DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Raw Throughput (readData + writeData).\'</comments>'
                 '</columns> ';

-- change column names for cifsVserver to camelcase
CALL netapp_performance.change_columns('sample_cifsvserver$', @cifsVserverRename);
CALL netapp_performance.change_columns('summary_cifsvserver$', @cifsVserverRename);

-- stored procedure calls for fcpLifVserver
CALL netapp_performance.add_columns('sample_fcpLifVserver$',@fcpLifVserver);
CALL netapp_performance.add_columns('sample_fcpLifVserver_raw$',@fcpLifVserverRaw);
CALL netapp_performance.add_columns('summary_fcpLifVserver$',@fcpLifVserver);

-- stored procedure calls for cifsVserver
CALL netapp_performance.add_columns('sample_cifsvserver$',@cifsVserver);
CALL netapp_performance.add_columns('sample_cifsvserver_raw_[[:digit:]]',@cifsVserverRaw);
CALL netapp_performance.add_columns('summary_cifsvserver$',@cifsVserver);