DROP PROCEDURE IF EXISTS netapp_performance.rename_table;

-- Reset the delimiter to write a procedure.
DELIMITER $$

-- Create procedure
CREATE PROCEDURE netapp_performance.rename_table(IN table_schema VARCHAR(255), IN source_table VARCHAR(255), IN dest_table VARCHAR(255))
BEGIN
	SET @buffer = concat('RENAME TABLE ', source_table, ' TO ', dest_table);

	SET @query = If((SELECT Count(*)
		 FROM information_schema.tables
		 WHERE table_schema = table_schema
		 AND table_name = source_table)>0,
		@buffer,
	   'SELECT \'nothing to rename\' status');

	PREPARE stmt FROM @query;
	EXECUTE stmt;
	DEALLOCATE PREPARE stmt;
END;

$$
DELIMITER ;