-- Drop re-dundant columns from sample_vservertable and rename it to sample_volumeVserver

SET @dropVserverColumns = ' <columns>'
				 		'<columnName>fcpLifAvgOtherLatency</columnName>'
				 		'<columnName>fcpLifAvgReadLatency</columnName>'
				 		'<columnName>fcpLifAvgWriteLatency</columnName>'
				 		'<columnName>fcpLifOtherOps</columnName>'
				 		'<columnName>fcpLifReadData</columnName>'
                        '<columnName>fcpLifReadOps</columnName>'
                        '<columnName>fcpLifTotalOps</columnName>'
                        '<columnName>fcpLifWriteData</columnName>'
                        '<columnName>fcpLifWriteOps</columnName>'
                        '<columnName>iscsiLifAvgOtherLatency</columnName>'
                        '<columnName>iscsiLifAvgReadLatency</columnName>'
                        '<columnName>iscsiLifAvgWriteLatency</columnName>'
                        '<columnName>iscsiLifDataInBlocks</columnName>'
                        '<columnName>iscsiLifDataOutBlocks</columnName>'
                        '<columnName>iscsiLifOtherOps</columnName>'
                        '<columnName>iscsiLifReadOps</columnName>'
                        '<columnName>iscsiLifWriteOps</columnName>'
						'</columns> ';

-- Call stored procedure to det
CALL netapp_performance.drop_columns('summary_vserver$', @dropVserverColumns);
CALL netapp_performance.drop_columns('sample_vserver$', @dropVserverColumns);


-- Call stored proc to Rename tables vserver to volumeVserver
CALL netapp_performance.rename_table('netapp_performance', 'summary_vserver', 'summary_volumeVserver');
CALL netapp_performance.rename_table('netapp_performance', 'sample_vserver', 'sample_volumeVserver');

-- Add Additonal columns to sample_volumeVserver and summary_volumeVserver tables
SET @volumeVserver = ' <columns>'
                  	'<columnName>opmVolNfsOps</columnName>'
                  	'<columnType>FLOAT DEFAULT NULL</columnType>'
                  	'<comments> COMMENT \'OPM synthetic counter Volume Nfs Ops.\'</comments>'
                  	'<columnName>opmVolCifsOps</columnName>'
                  	'<columnType>FLOAT DEFAULT NULL</columnType>'
                  	'<comments> COMMENT \'OPM synthetic counter Volume Cifs Ops.\'</comments>'
                  	'<columnName>opmVolIscsiOps</columnName>'
                  	'<columnType>FLOAT DEFAULT NULL</columnType>'
                  	'<comments> COMMENT \'OPM synthetic counter Volume Iscsi Ops.\'</comments>'
                  	'<columnName>opmVolFcpOps</columnName>'
                  	'<columnType>FLOAT DEFAULT NULL</columnType>'
                  	'<comments> COMMENT \'OPM synthetic counter Volume Fcp Ops.\'</comments>'
           		  '</columns> ';

CALL netapp_performance.add_columns('sample_volumeVserver',@volumeVserver);
CALL netapp_performance.add_columns('summary_volumeVserver',@volumeVserver);