SET @xmlDoc = ' <columns>'
                    '<columnName>opmAggrThroughput</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Sum of userReadBlocks, userWriteBlocks and cpReadBlocks.\'</comments>'
                    '<columnName>opmAggrLatency</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Weighted_Average(opmAggrUserReadLatency, userReads, opmAggrUserWriteLatency, userWrites, opmAggrCpReadLatency, cpReads).\'</comments>'
                    '<columnName>opmAggrUserReadLatency</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Max(disk.user_read_latency) for all Data disks in the Aggregate.\'</comments>'
                     '<columnName>opmAggrUserWriteLatency</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Max(disk.user_write_latency) for all Data disks in the Aggregate..\'</comments>'
                    '<columnName>opmAggrCpReadLatency</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Max(disk.cp_read_latency) for all Data disks in the Aggregate..\'</comments>'
                    '<columnName>opmAggrUtilization</columnName>'
                    '<columnType>FLOAT DEFAULT NULL</columnType>'
                    '<comments> COMMENT \'Max(disk.disk_busy) for all Data disks in the Aggregate..\'</comments>'
             '</columns> ';

CALL netapp_performance.add_columns('sample_aggregate_[[:digit:]]',@xmlDoc);
CALL netapp_performance.add_columns('summary_aggregate_[[:digit:]]',@xmlDoc);


SET @xmlDocRename = ' <columns>'
                    '<oldColumnName>userWriteBlock</oldColumnName>'
                     '<newColumnName>userWriteBlocks</newColumnName>'
					          '<columnType>FLOAT</columnType>'
              '</columns> ';
SET @xmlDocRenameRaw = ' <columns>'
                    '<oldColumnName>user_write_block</oldColumnName>'
                     '<newColumnName>user_write_blocks</newColumnName>'
					          '<columnType>BIGINT UNSIGNED</columnType>'
              '</columns> ';

CALL netapp_performance.change_columns('sample_aggregate_[[:digit:]]', @xmlDocRename);
CALL netapp_performance.change_columns('summary_aggregate_[[:digit:]]', @xmlDocRename);
CALL netapp_performance.change_columns('sample_aggregate_raw_[[:digit:]]', @xmlDocRenameRaw);