/*
 * Copyright (c) 2013 NetApp
 * All rights reserved
 */

package com.netapp.oci.platform.common.jms;

import org.apache.log4j.Logger;

import javax.jms.Connection;
import javax.jms.JMSException;

/**
 * Collection of utilities methods w.r.t JMS
 */
public class JmsUtils {

    private static Logger logger = Logger.getLogger(JmsUtils.class);

    private JmsUtils() {}  // to prevent instantiation

    /**
     * Closes the provided JMS resources for proper cleanup. It is enough to close the connection.
     * The session and produce will also be closed.
     */
    public static void close(Connection connection) {
        if (connection != null) {
            try {
                connection.close();
            } catch (JMSException e) {
                logger.warn("Error while closing JMS connection", e);
            }
        }
    }
}
