package com.netapp.oci.simulation;

import com.netapp.oci.simulation.time.schedule.Trigger;

/**
 * Represents participant of the simulation process.
 * Participation is expressed by time trigger and run() method.
 * 
 * @author Anton Sergeev
 */
public abstract class SimulationActor {
    /**
     * Returns schedule using which actor will take part in simulation
     *
     * @return time trigger
     */
    public abstract Trigger getTrigger();

    /**
     * Method is invoked when participation is required at given time
     *
     * @param time when to participate
     */
    public abstract void act(long time);
}
