package com.netapp.oci.simulation.time;

/**
 * Represent normal, day to day flow of time
 *
 * @author Anton Sergeev
 */
public class NormalTimeFlow implements TimeFlow {
    private long duration;

    private long startTime;

    private boolean shouldStop = false;

    private boolean isSynchronous;

    public NormalTimeFlow(long duration) {
        this(duration, true);
    }

    public NormalTimeFlow(long duration, boolean synchronous) {
        this.duration = duration;
        isSynchronous = synchronous;
    }

    public NormalTimeFlow() {
    }

    public long getCurrentTimeMillis() {
        return System.currentTimeMillis();
    }

    public void sleep(long timeMillis) {
        try {
            Thread.sleep(timeMillis);
        } catch (InterruptedException ex) {
            shouldStop = true;
        }
    }

    public boolean shouldStop() {
        if (startTime == 0) {
            startTime = getCurrentTimeMillis();
        }

        return shouldStop || (duration != 0 && startTime + duration < getCurrentTimeMillis());
    }

    public boolean isSynchronous() {
        return isSynchronous;
    }
}
