package com.netapp.oci.simulation.time;

/**
 * Represents the flow of time
 *
 * @author Anton Sergeev
 */
public interface TimeFlow {
    /**
     * Gets current time in milliseconds whithin the time flow abstraction
     *
     * @return time in milliseconds
     */
    long getCurrentTimeMillis();

    /**
     * Immitates the sleeping function within the time flow abstraction
     *
     * @param timeMillis how long to sleep for
     */
    void sleep(long timeMillis);

    /**
     * Checks if time flow should be stopped. For that could be multiple reasons.
     * It could be that time was supposed to flow for only limited period or simply interruption signal was received
     *
     * @return if <code>true</code> then it is indication that simulation should be stopped
     */
    boolean shouldStop();

    /**
     * Answers if execution of the logic in this timw flow should be synchronous or asynchronous
     *
     * @return <code>true</code> if synch <code>false</code> if asynch
     */
    boolean isSynchronous();
}
