package com.netapp.oci.simulation.time.schedule;

import java.util.Arrays;
import java.util.Collection;
import java.util.LinkedList;

/**
 * @author Anton Sergeev
 */
public class CompositeTrigger extends Trigger {
    private Collection<Trigger> triggers = new LinkedList<Trigger>();

    public CompositeTrigger(Trigger ... triggers) {
        this.triggers.addAll(Arrays.asList(triggers));
    }

    @Override
    public boolean itIsTime(long time) {
        for (Trigger trigger: triggers) {
            if (trigger.itIsTime(time)) {
                return true;
            }
        }

        return false;
    }
}
