package com.netapp.oci.simulation.time.schedule;

import com.onaro.commons.types.Period;

/**
 * @author Anton Sergeev
 */
public class PeriodicTrigger extends Trigger {
    protected long lastTimeTriggered = 0;

    protected Period period;

    protected int units;

    public PeriodicTrigger(Period period, int units) {
        this.period = period;
        this.units = units;
    }

    @Override
    public boolean itIsTime(long time) {
        boolean itIsTime = time - lastTimeTriggered > period.milliseconds() * units;

        if (itIsTime) {
            lastTimeTriggered = time;
        }

        return itIsTime;
    }
}
