/**
 * NetApp 2014
 */

package com.netapp.oci.statsutils;

/**
 * This class defines the different types of resources that MEGA/OCIE
 * currently stores statistics for in the database.
 *
 * @author Michael Rydeen
 *
 */ 
public enum ResourceType {

    /**
     * Resource type is unknown.
     */
    UNKNOWN("unknown", 0),
    DISK("disk", 1),
    AGGREGATE("aggregate", 2),
    VOLUME("volume", 3),
    LUN("lun", 4),
    NODE("node", 5),
    VSERVER("vserver", 6),
    NETWORKPORT("networkport", 7),
    FCPPORT("fcpport", 8),
    LIF("lif", 9),
    NETWORKLIF("networklif", 10),
    FCPLIF("fcplif", 11),
    ISCSILIF("iscsilif", 12),
    PROCESSOR("processor", 13),
    CLUSTER("cluster", 14);

    /**
     * The name of the enumeration.
     */
    private final String name;
    /**
     * The value of the enumeration
     */
    private final int value;

    /**
     * Default constructor.
     */
    ResourceType( String name, int value ) {
        this.name = name;
        this.value = value;
    }

    /**
     * Get name.
     *
     * @return name as String.
     */
    public String getName() {
        return name;
    }

    /**
     * Get value.
     *
     * @return value as int.
     */
    public int getValue() {
        return value;
    }

}

