package com.onaro.commons.prefs;

/**
 * A listener for receiving preference node change events.
 */
public interface NodeExtChangeListener extends java.util.EventListener {

    /**
     * This method gets called when a child node is added.
     *
     * @param evt A node change event object describing the parent
     *            and child node.
     */
    void childAdded(NodeExtChangeEvent evt);


    /**
     * This method gets called when a child node is removed.
     *
     * @param evt A node change event object describing the parent
     *            and child node.
     */
    void childRemoved(NodeExtChangeEvent evt);
}
