package com.onaro.commons.prefs;

import java.util.prefs.*;


/**
 * Thrown when a preference is requesed but wasn't found and no default was
 * specified.
 */
public class PreferenceNotFoundException extends RuntimeException {

    /**
     * Constructs an <code>PreferenceNotFoundException</code> reporting that the
     * specified pereference wasn't found in the specified node.
     *
     * @param node the node the preference was searched in
     * @param name the name of the searched preference
     */
    public PreferenceNotFoundException(Preferences node, String name) {
        super("Preference '" + name + "' wasn't found at node '" + node.absolutePath() + '\''); //$NON-NLS-1$ //$NON-NLS-2$
    }
}
