/*
 * Copyright (c) 2009 NetApp
 * All rights reserved
 */

package com.onaro.management.session;

import org.jboss.ejb3.annotation.ResourceAdapter;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.StatefulJob;

import javax.annotation.security.RunAs;
import javax.ejb.MessageDriven;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJB;

/**
 * @author Al Velella
 *         Date: Mar 8, 2010
 *         Time: 4:57:24 PM
 */
@MessageDriven(activationConfig = {
        @ActivationConfigProperty(propertyName = "cronTrigger", propertyValue = "0 50 23 * * ?"),
        @ActivationConfigProperty(propertyName = "jobName", propertyValue = "DailyManagementJob")})
@ResourceAdapter("quartz-ra.rar")
@RunAs("admin")
public class DailyManagementJob implements StatefulJob {
    @EJB
    ManagementRemote session;

    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {

        try {
            session.run();
        } catch (ManagementException e) {
            throw new JobExecutionException(e);
        }
    }
}
