package com.onaro.sanscreen.acquisition.cli.commands;

import com.onaro.sanscreen.acquisition.cli.CLI;
import java.util.Map;

public interface Command {
    /**
     * @return usage help string to describe syntax of this command
     */
    public String usageString();

    /**
     * @return usage description help.
     */
    public String usageDescription();

    /**
     * Parse and validate the arguments (throw a IllegalArgumentException on any problem)
     * Execute the command
     *
     * @param cli used for connection to server, etc...
     * @param args Arguments for this command
     *
     * @throws IllegalArgumentException On argument related error
     * @throws Exception on any error
     */
    public void run(final CLI cli, final Map<String, String> args) throws Exception;
}
