package com.onaro.sanscreen.acquisition.cli.commands;

public enum CommandType {
    add(new AddDsCommand(), "add"),
    update(new UpdateDsPropertyCommand(), "update"),
    rm(new RmDsCommand(), "rm"),
    ls(new LsDsCommand(), "ls"),
    lstype(new LsDsTypeCommand(), "lstype"),
    lsau(new LsAuCommand(), "lsau"),
    desc(new DescDsCommand(), "desc"),
    export(new ExportDsCommand(), "export"),
    start(new StartDsCommand(), "start"),
    stop(new StopDsCommand(), "stop"),
    force(new ForceDsCommand(), "force"),
    help(new HelpCommand(), "help", "?");

    private final Command command;
    private final String[] strings;

    private CommandType(final Command command, final String... strings) {
        this.command = command;
        this.strings = strings;
    }

    public Command getCommand() {
        return command;
    }

    public static CommandType fromCommandString(final String commandString) {
        for (final CommandType commandType : CommandType.values()) {
            for (final String string : commandType.strings) {
                if (commandString.equals(string))
                    return commandType;
            }
        }

        throw new IllegalArgumentException("Command '" + commandString + "' not recognized");
    }
}
