package com.onaro.sanscreen.acquisition.cli.commands;

import com.onaro.sanscreen.acquisition.cli.CLI;
import com.onaro.sanscreen.acquisition.sessions.AcquisitionFacadeSession;

import java.util.Map;

public class StartDsCommand implements Command {
    @Override
    public String usageString() {
        return "start -id=<dsid>";
    }

    @Override
    public String usageDescription() {
        return "Start a data source with the given id";
    }

    @Override
    public void run(final CLI cli, final Map<String, String> args) throws Exception {
        cli.checkMandatoryArguments(args, true, "id");
        long dsid = Long.parseLong(args.get("id"));

        // Get a list of all data sources
        final AcquisitionFacadeSession facadeSession = cli.getSession(AcquisitionFacadeSession.JNDI_NAME);
        facadeSession.updateManual(dsid, 1);

        System.out.println("Data source started");
    }
}
