package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.archiver.common;

import java.io.File;
import java.io.IOException;
import org.apache.commons.io.FileUtils;


public abstract class AbstractFileDownloader implements  FileDownloader {
    /**
     * Given a directory path cleans up all the files and sub-directories under it.
     * The directory itself is not deleted.
     *
     *
     * @param downloadDir Root download directory
     * @return true on successful clean up
     */
    @Override
    public Boolean cleanDownloadedFiles(final String downloadDir) {
        try {
            FileUtils.cleanDirectory(new File(downloadDir));
            return true;
        } catch (IOException e) {
            return false;
        }
    }
}
