package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import org.apache.log4j.Logger;
import org.jdom.Element;

import java.util.LinkedHashMap;

/**
 * @author Iti Behari
 *         Date: 7/9/13
 */
public class ApplicationRecordBuilder extends IterBuilderBase {

    @SuppressWarnings({"UnusedDeclaration"})
        private static final Logger logger = Logger.getLogger(ApplicationRecordBuilder.class);

        protected ApplicationRecordBuilder() {
            super("cluster-application-record-get-iter", "cluster-application-record-info", getDefaultMaxRecords(), new LinkedHashMap<String[], String[]>() {{
                put(new String[]{"cluster-application-record-info",}, new String[]{"record-name", "record-value", "modified-from", "last-modified-timestamp",});
            }});
        }


        @Override
        protected void buildIterInstance(final CModeCluster cluster, final Element applicationElt) {
            final String recordName = BuilderUtil.getChildTextTrim(applicationElt, "record-name");
            final String recordValue = BuilderUtil.getChildTextTrim(applicationElt, "record-value");
            final String modifiedFrom = BuilderUtil.getChildTextTrim(applicationElt, "modified-from");
            final Long lastModifiedTimestamp = BuilderUtil.parseLongFromChild(applicationElt, "last-modified-timestamp");
            cluster.createAndAddApplicationRecord(recordName, recordValue, modifiedFrom, lastModifiedTimestamp);
        }
}
