package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi.ZAPIConnection;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import org.apache.log4j.Logger;
import org.jdom.Element;

import java.util.LinkedHashMap;
import java.util.Map;

public class EventBuilder {

    @SuppressWarnings({"UnusedDeclaration"})
    private static final Logger logger = Logger.getLogger(LUNBuilder.class);

    public void executeAndBuild(final CModeCluster cluster, final ZAPIConnection zapiConnection) throws DataSourceErrorException {
        final Map<String, String> args = new LinkedHashMap<String, String>();
        String nextTag = null;      // keeps track of next tag to request when iterating.   Not specified on the first call.
        do {
            args.clear();
            args.put("max-records", "100");
            if (nextTag != null) {
                // Not the first call, and there are more records to iterate.   Specify where iteration left off
                args.put("tag", nextTag);
            }
            final ZAPIConnection.ZapiResponse zapiResponse = zapiConnection.invokeCommand("ems-message-get-iter", args);
            final Element messageInfoElt = zapiResponse.getElement();
            // Are there more records to iterate?
            final Element nextTagElt = messageInfoElt.getChild("next-tag");   // won't exist if no more records
            if (nextTagElt == null) {
                nextTag = null;                         // No more elements to iterate
            }
            else {
                nextTag = nextTagElt.getTextTrim();     // More elements to iterate
            }
        }
        while (nextTag != null);
    }
}
