package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi.ZAPIConnection;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi.ZAPINames;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi.ZAPIUtils;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import com.onaro.sanscreen.acquisition.framework.datasource.PackageContext;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileWriter;

import netapp.manage.NaElement;

import org.jdom.Element;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.util.*;

import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi.ZAPIUtils.children;

/**
 * Base class for iterator based foundation builders.   Handles iterator tag management and allows derived
 * classes to parse the repeated XML element.
 */
public abstract class IterBuilderBase extends IterBuilderBaseImpl<CModeCluster>
{
    protected IterBuilderBase(final String zapiCommand, final String repeatingInstanceEltName, final int maxRecords,
                              final LinkedHashMap<String[], String[]> desiredAttributesMap, final LinkedHashMap<String, String> args) {
        this(zapiCommand, repeatingInstanceEltName, maxRecords,
                ZAPIUtils.convertDesiredAttributes(desiredAttributesMap), children(args));
    }

    protected IterBuilderBase(final String zapiCommand, final String repeatingInstanceEltName, final int maxRecords) {
        this(zapiCommand, repeatingInstanceEltName, maxRecords, null, (NaElement[])null);
    }

    protected IterBuilderBase(final String zapiCommand, final String repeatingInstanceEltName, final int maxRecords,
                              final NaElement desiredAttributes) {
        this(zapiCommand, repeatingInstanceEltName, maxRecords, desiredAttributes, (NaElement[])null);
    }

    protected IterBuilderBase(final String zapiCommand, final String repeatingInstanceEltName, final int maxRecords,
                              final NaElement desiredAttributes, final NaElement... additionalElements) {
       super(zapiCommand, repeatingInstanceEltName, maxRecords, desiredAttributes, additionalElements );
    }

    protected IterBuilderBase(final String zapiCommand, final String repeatingInstanceEltName, final int maxRecords,
                              final LinkedHashMap<String[], String[]> desiredAttributesMap) {
        this(zapiCommand, repeatingInstanceEltName, maxRecords, desiredAttributesMap, new LinkedHashMap<String, String>());
    }
}
