package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeKerbero;
import org.jdom.Element;

import java.util.LinkedHashMap;


public class KerberorsBuilder extends IterBuilderBase {

    public KerberorsBuilder() {
        super("kerberos-config-get-iter", "kerberos-config-info", 50, new LinkedHashMap<String[], String[]>() {{
            put(new String[]{"kerberos-config-info",}, new String[]{"interface-name", "ip-address", "is-kerberos-enabled", "vserver", });
        }});
    }

    @Override
    protected void buildIterInstance(final CModeCluster cluster, final Element configElt) {
        final String interfaceName = BuilderUtil.getChildTextTrim(configElt, "interface-name");
        final String ipAddress = BuilderUtil.getChildTextTrim(configElt, "ip-address");
        final Boolean isKerberosEnabled = BuilderUtil.parseBooleanFromChild(configElt, "is-kerberos-enabled");
        final String vServerName = BuilderUtil.getChildTextTrim(configElt, "vserver");
        final CModeKerbero kerbero = cluster.createKerbero(vServerName);
        kerbero.setInterfaceName(interfaceName);
        kerbero.setInterfaceName(ipAddress);
        kerbero.setKerberosEnabled(isKerberosEnabled);
        cluster.getKerberos().add(kerbero);
    }
}
