package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import org.jdom.Element;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

public class PerfInstanceBuilder extends IterBuilderBase {
    private final Map<String, String> uuidNameMap = new HashMap<String, String>();

    public PerfInstanceBuilder(final String objectName) {
        super("perf-object-instance-list-info-iter", "instance-info", getDefaultMaxRecords(), new LinkedHashMap<String[], String[]>() {{
            put(new String[]{"instance-info",}, new String[]{"name", "uuid",});
        }}, new LinkedHashMap<String, String>() {{
            put("objectname", objectName);
        }});
    }

    public Map<String, String> getUUIDNameMap() {
        return uuidNameMap;
    }

    @Override
    protected void buildIterInstance(final CModeCluster cluster, final Element instanceInfoElt) {
        final String name = BuilderUtil.getChildTextTrim(instanceInfoElt, "name");
        final String uuid = BuilderUtil.getChildTextTrim(instanceInfoElt, "uuid");
        // names are not globally unique, only UUIDs are.   UUIDs must be the key
        uuidNameMap.put(uuid, name);
    }
}
