package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi.ZAPIConnection;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import netapp.manage.NaElement;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.LinkedHashMap;

public abstract class RuntimeIterBuilder extends IterBuilderBase
{
  private static final Logger logger = LoggerFactory.getLogger( ZAPIConnection.class );
  protected RuntimeIterBuilder(String zapiCommand, String repeatingInstanceEltName, int maxRecords, LinkedHashMap<String[], String[]> desiredAttributesMap, LinkedHashMap<String, String> args)
  {
    super( zapiCommand, repeatingInstanceEltName, maxRecords, desiredAttributesMap, args );
    setForceDeviceCall( true );
  }

  protected RuntimeIterBuilder(String zapiCommand, String repeatingInstanceEltName, int maxRecords)
  {
    super( zapiCommand, repeatingInstanceEltName, maxRecords );
    setForceDeviceCall( true );
  }

  protected RuntimeIterBuilder(String zapiCommand, String repeatingInstanceEltName, int maxRecords, NaElement desiredAttributes)
  {
    super( zapiCommand, repeatingInstanceEltName, maxRecords, desiredAttributes );
    setForceDeviceCall( true );
  }

  protected RuntimeIterBuilder(String zapiCommand, String repeatingInstanceEltName, int maxRecords, NaElement desiredAttributes, NaElement... additionalElements)
  {
    super( zapiCommand, repeatingInstanceEltName, maxRecords, desiredAttributes, additionalElements );
    setForceDeviceCall( true );
  }

  protected RuntimeIterBuilder(String zapiCommand, String repeatingInstanceEltName, int maxRecords, LinkedHashMap<String[], String[]> desiredAttributesMap)
  {
    super( zapiCommand, repeatingInstanceEltName, maxRecords, desiredAttributesMap );
    setForceDeviceCall( true );
  }

  @Override
  public void buildModel(final CModeCluster model, final ZAPIConnection zapiConnection) throws DataSourceErrorException
  {
    if( zapiConnection.getPartialPollContext().needsRuntimeUpdate( getZapiCommand() ) )
    {
      if( logger.isTraceEnabled() ) logger.trace( "Retrieving runtime values for " + getZapiCommand() );
      super.buildModel( model, zapiConnection );
    }
  }
}
