package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import java.util.LinkedHashMap;
import org.jdom.Element;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeStoragePoolAggregate;

public class StoragePoolAggregateBuilder extends IterBuilderBase {

    protected StoragePoolAggregateBuilder() {
        super("storage-pool-aggregate-get-iter", "storage-pool-aggregate-info", getDefaultMaxRecords(), new LinkedHashMap<String[], String[]>() {{
            put(new String[]{"storage-pool-aggregate-info",}, new String[]{"aggregate", "allocated-unit-count", "storage-pool", "used-capacity",});
        }});
    }

    @Override
    protected void buildIterInstance(final CModeCluster cluster, final Element storagePoolAggregateInfo) {
        final String aggregateName = BuilderUtil.getChildTextTrim(storagePoolAggregateInfo, "aggregate");
        final Long allocatedUnitCount = BuilderUtil.parseLongFromChild(storagePoolAggregateInfo, "allocated-unit-count");
        final Long usedCapacity = BuilderUtil.parseLongFromChild(storagePoolAggregateInfo, "used-capacity");
        final String storagePoolName = BuilderUtil.getChildTextTrim(storagePoolAggregateInfo, "storage-pool");

        final CModeStoragePoolAggregate storagePoolAggregate = cluster.createStoragePoolAggregate(storagePoolName, aggregateName);
        storagePoolAggregate.setAllocatedUnitCount(allocatedUnitCount);
        storagePoolAggregate.setUsedCapacity(usedCapacity);
        cluster.getStoragePoolAggregates().add(storagePoolAggregate);
    }
}
