package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeStoragePoolAvailableSize;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.StoragePool;
import org.jdom.Element;

import java.util.LinkedHashMap;

public class StoragePoolAvailableSizeBuilder extends IterBuilderBase {

    protected StoragePoolAvailableSizeBuilder() {
        super("storage-pool-available-capacity-get-iter", "storage-pool-available-capacity-info", getDefaultMaxRecords(), new LinkedHashMap<String[], String[]>() {{
            put(new String[]{"storage-pool-available-capacity-info",}, new String[]{"node", "storage-pool", "allocation-unit-count", "allocation-unit-size", "available-size", "syncmirror-pool", "storage-type",});
        }});
    }

    @Override
    protected void buildIterInstance(final CModeCluster cluster, final Element storagePoolSparCapInfo) {
        final String nodeName = BuilderUtil.getChildTextTrim(storagePoolSparCapInfo, "node");
        final String storagePoolName = BuilderUtil.getChildTextTrim(storagePoolSparCapInfo, "storage-pool");
        final Long allocationUnitCount = BuilderUtil.parseLongFromChild(storagePoolSparCapInfo, "allocation-unit-count");
        final Long allocationUnitSize = BuilderUtil.parseLongFromChild(storagePoolSparCapInfo, "allocation-unit-size");
        final Long availableSize = BuilderUtil.parseLongFromChild(storagePoolSparCapInfo, "available-size");
        final String syncMirrorPool = BuilderUtil.getChildTextTrim(storagePoolSparCapInfo, "syncmirror-pool");
        final EnumWrapper<StoragePool.StorageType> storageType = BuilderUtil.getEnumWrapperByValue(StoragePool.StorageType.class, storagePoolSparCapInfo, "storage-type", StoragePool.StorageType.NOT_MAPPED);

        final CModeStoragePoolAvailableSize storagePoolAvailableSize = cluster.createStoragePoolAvailableSize(nodeName, storagePoolName);
        storagePoolAvailableSize.setAllocationUnitCount(allocationUnitCount);
        storagePoolAvailableSize.setAllocationUnitSize(allocationUnitSize);
        storagePoolAvailableSize.setAvailableSize(availableSize);
        storagePoolAvailableSize.setSyncMirrorPool(syncMirrorPool);
        storagePoolAvailableSize.setStorageType(storageType);
        cluster.getStoragePoolAvailableSizes().add(storagePoolAvailableSize);
    }
}