package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeCluster;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode.CModeStorageService;
import org.apache.log4j.Logger;
import org.jdom.Element;

import java.util.LinkedHashMap;



public class StorageServiceBuilder extends IterBuilderBase {

    private static final Logger logger = Logger.getLogger(StorageServiceBuilder.class);

    public StorageServiceBuilder() {
        super("volume-storage-service-get-iter", "storage-service-info", getDefaultMaxRecords(), new LinkedHashMap<String[], String[]>() {{
            put(new String[]{"storage-service-info",}, new String[]{"constituent-group-id", "storage-service", "storage-service-id", "storage-service-type", "volume", "vserver",});
        }});
    }

    @Override
    protected void buildIterInstance(final CModeCluster cluster, final Element storageServiceElt) {
        final Long constituentGroupID = BuilderUtil.parseLongFromChild(storageServiceElt, "constituent-group-id");
        final String storageServiceName = BuilderUtil.getChildTextTrim(storageServiceElt, "storage-service");
        final Long storageServiceID = BuilderUtil.parseLongFromChild(storageServiceElt, "storage-service-id");
        final String storageServiceType = BuilderUtil.getChildTextTrim(storageServiceElt, "storage-service-type");
        final String volumeName = BuilderUtil.getChildTextTrim(storageServiceElt, "volume");
        final String vServerName = BuilderUtil.getChildTextTrim(storageServiceElt, "vserver");

        final CModeStorageService storageService = cluster.createStorageService(vServerName, volumeName, storageServiceID);
        storageService.setConstituentGroupID(constituentGroupID);
        storageService.setStorageService(storageServiceName);
        storageService.setStorageServiceType(storageServiceType);
        cluster.getStorageServices().add(storageService);
    }
}
