package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappstorageperformance;

import com.netapp.oci.netapp.performance.networkport.interfaces.data.NetworkPortMeasurements;
import com.netapp.oci.platform.common.interfaces.data.performance.RawSample;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.NetAppOCIEPerformancePackage;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.MetricsRowScratchPad;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappIpPortMetrics;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi.ZAPIConnection;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.Cluster;
import com.onaro.sanscreen.acquisition.netappstorageperformance.datasource.NetAppDefaultStorageContext;
import org.apache.log4j.Logger;

import java.util.Collection;
import java.util.List;
import java.util.Map;

public class IpPortMetricsBuilder extends MetricsBuilderBase<Cluster.ClusterKey,
                                                             NetworkPortMeasurements,
                                                             NetworkPortMeasurements,
                                                             NetappIpPortMetrics,
                                                             NetappIpPortMetrics.IpPortCounter,
                                                             NetappIpPortMetrics.IpPortCounter> {
    @SuppressWarnings({"UnusedDeclaration"})
    private static final Logger logger = Logger.getLogger(IpPortMetricsBuilder.class);

    public IpPortMetricsBuilder(final NetAppOCIEPerformancePackage reportingPackage) {
        super(reportingPackage, "ifnet", NetappIpPortMetrics.IpPortCounter.class);
    }

    @Override
    List<String> getTargetPerfUUIDs(final NetAppDefaultStorageContext context, final ZAPIConnection zapiConnection) {
        return context.getIpPortPerfUUIDs();
    }

    @Override
    Cluster.ClusterKey getParentInventoryUUIDKey(final NetAppDefaultStorageContext context, final String perfInstanceUUID) {
        return context.getKey();
    }

    @Override
    String getIventoryUUIDFromPerfUUID(final NetAppDefaultStorageContext context, final String perfInstanceUUID) {
        return context.getIpPortPerfUUIDToUUIDMap().get(perfInstanceUUID);
    }

    @Override
    NetappIpPortMetrics createMetricsFromValues(final MetricsRowScratchPad<NetappIpPortMetrics.IpPortCounter> currentValues, final MetricsRowScratchPad<NetappIpPortMetrics.IpPortCounter> previousValues) {
        return new NetappIpPortMetrics(currentValues, previousValues);
    }

    @Override
    void reportPerformance(Cluster.ClusterKey clusterKey, final Map<Cluster.ClusterKey, Collection<RawSample<NetworkPortMeasurements>>> measurements) throws DataSourceErrorException {
        for (final Map.Entry<Cluster.ClusterKey, Collection<RawSample<NetworkPortMeasurements>>> measureEntry : measurements.entrySet()) {
            storagePerformanceReporter.reportIpPortPerformance(measureEntry.getKey(), measureEntry.getValue());
        }
    }
}
