package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics;

import com.netapp.oci.netapp.performance.ext_cache_obj.interfaces.data.ExtCacheObjMeasurements;
import com.onaro.sanscreen.acquisition.netappstorageperformance.datasource.NetAppDefaultStorageContext;

public class NetappExtCacheObjMetrics extends MetricsRowSample<ExtCacheObjMeasurements, ExtCacheObjMeasurements, NetappExtCacheObjMetrics.ExtCachObjCounter,        // raw
        NetappExtCacheObjMetrics.ExtCachObjCounter> {      // final

    public static enum ExtCachObjCounter {
        accesses,
        disk_reads_replaced,
        hit_percent }

    public NetappExtCacheObjMetrics(final MetricsRowScratchPad<ExtCachObjCounter> currentValues, final MetricsRowScratchPad<ExtCachObjCounter> previousValues) {
        super(ExtCachObjCounter.class, currentValues, previousValues);
    }

    @Override
    ExtCachObjCounter getDenominatorForNumerator(final ExtCachObjCounter numeratorName) {
        final ExtCachObjCounter denominatorName;
        switch (numeratorName) {
            case hit_percent:
                denominatorName = ExtCachObjCounter.accesses;
                break;
            default:
                denominatorName = null;
        }
        return denominatorName;
    }

    @Override
    float getNormalizedFloatMetric(final ExtCachObjCounter counterName) {
        final float normalizedMetric;
        switch (counterName) {
            case disk_reads_replaced:
                normalizedMetric = currentValues.getCounterRatePerSec(counterName);
                break;
            case hit_percent:
                normalizedMetric = currentValues.getPercentFromDeltas(counterName,
                                                                      getDenominatorForNumerator(counterName));
                break;
            default:
                normalizedMetric = NULL_FLOAT;
        }
        return normalizedMetric;
    }

    @Override
    public ExtCacheObjMeasurements normalizeMetrics(final NetAppDefaultStorageContext context) {
        final ExtCacheObjMeasurements m = new ExtCacheObjMeasurements();
        m.setDiskReadsReplaced(getNormalizedFloatMetric(ExtCachObjCounter.disk_reads_replaced));
        m.setHitPercent(getNormalizedFloatMetric(ExtCachObjCounter.hit_percent));
        return m;
    }
}
