package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics;

import com.netapp.oci.netapp.performance.networkport.interfaces.data.NetworkPortMeasurements;
import com.onaro.sanscreen.acquisition.netappstorageperformance.datasource.NetAppDefaultStorageContext;

import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappIpPortMetrics.IpPortCounter.*;

public class NetappIpPortMetrics extends MetricsRowSample<NetworkPortMeasurements, NetworkPortMeasurements, NetappIpPortMetrics.IpPortCounter,
                                                                                   NetappIpPortMetrics.IpPortCounter> {

    public static enum IpPortCounter {
        recv_data,
        recv_packets,
        send_data,
        send_packets, }

    public NetappIpPortMetrics(final MetricsRowScratchPad<IpPortCounter> currentValues, final MetricsRowScratchPad<IpPortCounter> previousValues) {
        super(IpPortCounter.class, currentValues, previousValues);
    }

    @Override
    float getNormalizedFloatMetric(final IpPortCounter counterName) {
        final float normalizedMetric;
        switch (counterName) {
            case recv_data:
            case recv_packets:
            case send_data:
            case send_packets:
                normalizedMetric = currentValues.getCounterRatePerSec(counterName);
                break;
            default:
                normalizedMetric = NULL_FLOAT;
        }
        return normalizedMetric;
    }

    @Override
    public NetworkPortMeasurements normalizeMetrics(final NetAppDefaultStorageContext context) {
        final NetworkPortMeasurements m = new NetworkPortMeasurements();
        m.setRecvData(getNormalizedFloatMetric(recv_data));
        m.setRecvPackets(getNormalizedFloatMetric(recv_packets));
        m.setSendData(getNormalizedFloatMetric(send_data));
        m.setSendPackets(getNormalizedFloatMetric(send_packets));
        return m;
    }
}
