package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics;

import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.avg_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_other_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_other_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_read_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_read_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_read_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_write_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_write_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.cifs_write_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_other_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_other_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_read_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_read_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_read_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_write_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_write_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.fcp_write_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_other_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_other_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_read_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_read_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_read_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_write_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_write_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.iscsi_write_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_other_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_other_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_read_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_read_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_read_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_write_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_write_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.nfs_write_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.other_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.other_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.read_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.read_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.read_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_other_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_other_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_read_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_read_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_read_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_write_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_write_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.san_write_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.total_ops;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.total_protocol_other_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.total_protocol_read_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.total_protocol_write_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.write_data;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.write_latency;
import static com.onaro.sanscreen.acquisition.datasource.netapp_ocie.metrics.NetappVolumeMetrics.VolumeCounter.write_ops;

import java.math.BigInteger;
import java.util.Map;

import com.netapp.oci.netapp.performance.volume.interfaces.data.VolumeMeasurements;
import com.netapp.oci.netapp.performance.volume.interfaces.data.VolumeRawMeasurements;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.archiver.builders.VolumeMetricsBuilder.VolumeCounter;
import com.onaro.sanscreen.acquisition.netappstorageperformance.datasource.NetAppDefaultStorageContext;

public class NetappVolumeMetrics extends MetricsRowSample<VolumeMeasurements, VolumeRawMeasurements, NetappVolumeMetrics.VolumeCounter,
                                                                              NetappVolumeMetrics.VolumeCounter> {

    public static enum VolumeCounter {
        avg_latency,
        cifs_other_latency,
        cifs_other_ops,
        cifs_read_data,
        cifs_read_latency,
        cifs_read_ops,
        cifs_write_data,
        cifs_write_latency,
        cifs_write_ops,
        fcp_other_latency,
        fcp_other_ops,
        fcp_read_data,
        fcp_read_latency,
        fcp_read_ops,
        fcp_write_data,
        fcp_write_latency,
        fcp_write_ops,
        iscsi_other_latency,
        iscsi_other_ops,
        iscsi_read_data,
        iscsi_read_latency,
        iscsi_read_ops,
        iscsi_write_data,
        iscsi_write_latency,
        iscsi_write_ops,
        nfs_other_latency,
        nfs_other_ops,
        nfs_read_data,
        nfs_read_latency,
        nfs_read_ops,
        nfs_write_data,
        nfs_write_latency,
        nfs_write_ops,
        other_latency,
        other_ops,
        read_data,
        read_latency,
        read_ops,
        san_other_latency,
        san_other_ops,
        san_read_data,
        san_read_latency,
        san_read_ops,
        san_write_data,
        san_write_latency,
        san_write_ops,
        total_protocol_other_latency,
        total_protocol_read_latency,
        total_protocol_write_latency,
        total_ops,
        write_data,
        write_latency,
        write_ops, }

    public NetappVolumeMetrics(final MetricsRowScratchPad<VolumeCounter> currentValues, final MetricsRowScratchPad<VolumeCounter> previousValues) {
        super(VolumeCounter.class, currentValues, previousValues);
    }

    VolumeCounter getDenominatorForNumerator(final VolumeCounter numeratorName) {
        final VolumeCounter denominatorName;
        switch (numeratorName) {
            case avg_latency:
                denominatorName = total_ops;
                break;
            case cifs_other_latency:
                denominatorName = cifs_other_ops;
                break;
            case cifs_read_latency:
                denominatorName = cifs_read_ops;
                break;
            case cifs_write_latency:
                denominatorName = cifs_write_ops;
                break;
            case fcp_other_latency:
                denominatorName = fcp_other_ops;
                break;
            case fcp_read_latency:
                denominatorName = fcp_read_ops;
                break;
            case fcp_write_latency:
                denominatorName = fcp_write_ops;
                break;
            case iscsi_other_latency:
                denominatorName = iscsi_other_ops;
                break;
            case iscsi_read_latency:
                denominatorName = iscsi_read_ops;
                break;
            case iscsi_write_latency:
                denominatorName = iscsi_write_ops;
                break;
            case nfs_other_latency:
                denominatorName = nfs_other_ops;
                break;
            case nfs_read_latency:
                denominatorName = nfs_read_ops;
                break;
            case nfs_write_latency:
                denominatorName = nfs_write_ops;
                break;
            case other_latency:
                denominatorName = other_ops;
                break;
            case read_latency:
                denominatorName = read_ops;
                break;
            case san_other_latency:
                denominatorName = san_other_ops;
                break;
            case san_read_latency:
                denominatorName = san_read_ops;
                break;
            case san_write_latency:
                denominatorName = san_write_ops;
                break;
            case write_latency:
                denominatorName = write_ops;
                break;
            default:
                denominatorName = null;
                break;
        }
        return denominatorName;
    }

    @Override
    float getNormalizedFloatMetric(final VolumeCounter counterName) {
        final float normalizedMetric;
        switch (counterName) {
            case avg_latency:
            case cifs_other_latency:
            case cifs_read_latency:
            case cifs_write_latency:
            case fcp_other_latency:
            case fcp_read_latency:
            case fcp_write_latency:
            case iscsi_other_latency:
            case iscsi_read_latency:
            case iscsi_write_latency:
            case nfs_other_latency:
            case nfs_read_latency:
            case nfs_write_latency:
            case other_latency:
            case read_latency:
            case san_other_latency:
            case san_read_latency:
            case san_write_latency:
            case write_latency:
                normalizedMetric = currentValues.getLatencyPerOp(counterName,
                                                                 getDenominatorForNumerator(counterName));
                break;

            case cifs_read_data:
            case cifs_write_data:
            case fcp_read_data:
            case fcp_write_data:
            case iscsi_read_data:
            case iscsi_write_data:
            case nfs_read_data:
            case nfs_write_data:
            case read_data:
            case san_read_data:
            case san_write_data:
            case write_data:
            case cifs_other_ops:
            case cifs_read_ops:
            case cifs_write_ops:
            case fcp_other_ops:
            case fcp_read_ops:
            case fcp_write_ops:
            case iscsi_other_ops:
            case iscsi_read_ops:
            case iscsi_write_ops:
            case nfs_other_ops:
            case nfs_read_ops:
            case nfs_write_ops:
            case other_ops:
            case read_ops:
            case san_other_ops:
            case san_read_ops:
            case san_write_ops:
            case total_ops:
            case write_ops:
                normalizedMetric = currentValues.getCounterRatePerSec(counterName);
                break;

            default:
                normalizedMetric = NULL_FLOAT;
                break;
        }
        return normalizedMetric;
    }    

    @Override
    public VolumeMeasurements normalizeMetrics(final NetAppDefaultStorageContext context) {
        // Server side VolumeMeasurements has no setters, only giant constructor
        VolumeMeasurements m =  new VolumeMeasurements();
        m.setAvgLatency(getNormalizedFloatMetric(avg_latency));
        m.setCifsOtherLatency(getNormalizedFloatMetric(cifs_other_latency));
		m.setCifsOtherOps(getNormalizedFloatMetric(cifs_other_ops));
		m.setCifsReadLatency(getNormalizedFloatMetric(cifs_read_latency));
		m.setCifsReadOps(getNormalizedFloatMetric(cifs_read_ops));
		m.setCifsWriteLatency(getNormalizedFloatMetric(cifs_write_latency));
		m.setCifsWriteOps(getNormalizedFloatMetric(cifs_write_ops));
		m.setFcpOtherLatency(getNormalizedFloatMetric(fcp_other_latency));
		m.setFcpOtherOps(getNormalizedFloatMetric(fcp_other_ops));
		m.setFcpReadLatency(getNormalizedFloatMetric(fcp_read_latency));
		m.setFcpReadOps(getNormalizedFloatMetric(fcp_read_ops));
		m.setFcpWriteLatency(getNormalizedFloatMetric(fcp_write_latency));
		m.setFcpWriteOps(getNormalizedFloatMetric(fcp_write_ops));
		m.setIscsiOtherOps(getNormalizedFloatMetric(iscsi_other_latency));
		m.setIscsiOtherOps(getNormalizedFloatMetric(iscsi_other_ops));
		m.setIscsiReadLatency(getNormalizedFloatMetric(iscsi_read_latency));
		m.setIscsiReadOps(getNormalizedFloatMetric(iscsi_read_ops));
		m.setIscsiWriteLatency(getNormalizedFloatMetric(iscsi_write_latency));
		m.setIscsiWriteOps(getNormalizedFloatMetric(iscsi_write_ops));
		m.setNfsOtherLatency(getNormalizedFloatMetric(nfs_other_latency));
		m.setNfsOtherOps(getNormalizedFloatMetric(nfs_other_ops));
		m.setNfsReadLatency(getNormalizedFloatMetric(nfs_read_latency));
		m.setNfsReadOps(getNormalizedFloatMetric(nfs_read_ops));
		m.setNfsWriteLatency(getNormalizedFloatMetric(nfs_write_latency));
		m.setNfsWriteOps(getNormalizedFloatMetric(nfs_write_ops));
		m.setNfsOtherLatency(getNormalizedFloatMetric(other_latency));
		m.setOtherOps(getNormalizedFloatMetric(other_ops));
		m.setReadLatency(getNormalizedFloatMetric(read_latency));
		m.setReadOps(getNormalizedFloatMetric(read_ops));
		m.setSanOtherLatency(getNormalizedFloatMetric(san_other_latency));
		m.setSanOtherOps(getNormalizedFloatMetric(san_other_ops));
		m.setSanReadLatency(getNormalizedFloatMetric(san_read_latency));
		m.setSanReadOps(getNormalizedFloatMetric(san_read_ops));
		m.setSanWriteLatency(getNormalizedFloatMetric(san_write_latency));
		m.setSanWriteOps(getNormalizedFloatMetric(san_write_ops));
		m.setTotalOps(getNormalizedFloatMetric(total_ops));
		m.setWriteLatency(getNormalizedFloatMetric(write_latency));
		m.setWriteOps(getNormalizedFloatMetric(write_ops));
        m.setCifsReadData(getNormalizedFloatMetric(cifs_read_data)); 
        m.setFcpReadData(getNormalizedFloatMetric(fcp_read_data)); 
        m.setNfsReadData(getNormalizedFloatMetric(nfs_read_data)); 
        m.setIscsiReadData(getNormalizedFloatMetric(iscsi_read_data)); 
        m.setSanReadData(getNormalizedFloatMetric(san_read_data)); 
        m.setCifsWriteData(getNormalizedFloatMetric(cifs_write_data)); 
        m.setFcpWriteData(getNormalizedFloatMetric(fcp_write_data)); 
        m.setNfsWriteData(getNormalizedFloatMetric(nfs_write_data)); 
        m.setIscsiWriteData(getNormalizedFloatMetric(iscsi_write_data));
        m.setSanWriteData(getNormalizedFloatMetric(san_write_data));
        m.setReadData(getNormalizedFloatMetric(read_data)); 
        m.setWriteData(getNormalizedFloatMetric(write_data)); 
		m.setOpmVolNfsOps(MetricsRowScratchPad.add(m.getNfsReadOps(), m.getNfsWriteOps(), m.getNfsOtherOps()));
		m.setOpmVolIscsiOps(MetricsRowScratchPad.add(m.getIscsiReadOps(), m.getIscsiWriteOps(), m.getIscsiOtherOps()));
		m.setOpmVolFcpOps(MetricsRowScratchPad.add(m.getFcpReadOps(), m.getFcpWriteOps(), m.getFcpOtherOps()));
		m.setOpmVolCifsOps(MetricsRowScratchPad.add(m.getCifsReadOps(), m.getCifsWriteOps(), m.getCifsOtherOps()));
        return m;
    }
    
    @Override
    public VolumeRawMeasurements rawMetrics(final NetAppDefaultStorageContext context) {
        final VolumeRawMeasurements m = new VolumeRawMeasurements();
        Map<VolumeCounter,BigInteger> counterValues = getCurrentValues().getCounterValues();
        m.setAvgLatency(counterValues.get(avg_latency));
        m.setCifsOtherLatency(counterValues.get(cifs_other_latency));
        m.setCifsOtherOps(counterValues.get(cifs_other_ops));
        m.setCifsReadLatency(counterValues.get(cifs_read_latency));
        m.setCifsReadOps(counterValues.get(cifs_read_ops));
        m.setCifsWriteLatency(counterValues.get(cifs_write_latency));
        m.setCifsWriteOps(counterValues.get(cifs_write_ops));
        m.setFcpOtherLatency(counterValues.get(fcp_other_latency));
        m.setFcpOtherOps(counterValues.get(fcp_other_ops));
        m.setFcpReadLatency(counterValues.get(fcp_read_latency));
        m.setFcpReadOps(counterValues.get(fcp_read_ops));
        m.setFcpWriteLatency(counterValues.get(fcp_write_latency));
        m.setFcpWriteOps(counterValues.get(fcp_write_ops));
        m.setIscsiOtherLatency(counterValues.get(iscsi_other_latency));
        m.setIscsiOtherOps(counterValues.get(iscsi_other_ops));
        m.setIscsiReadLatency(counterValues.get(iscsi_read_latency));
        m.setIscsiReadOps(counterValues.get(iscsi_read_ops));
        m.setIscsiWriteLatency(counterValues.get(iscsi_write_latency));
        m.setIscsiWriteOps(counterValues.get(iscsi_write_ops));
        m.setNfsOtherLatency(counterValues.get(nfs_other_latency));
        m.setNfsOtherOps(counterValues.get(nfs_other_ops));
        m.setNfsReadLatency(counterValues.get(nfs_read_latency));
        m.setNfsReadOps(counterValues.get(nfs_read_ops));
        m.setNfsWriteLatency(counterValues.get(nfs_write_latency));
        m.setNfsWriteOps(counterValues.get(nfs_write_ops));
        m.setOtherLatency(counterValues.get(other_latency));
        m.setOtherOps(counterValues.get(other_ops));
        m.setReadLatency(counterValues.get(read_latency));
        m.setReadOps(counterValues.get(read_ops));
        m.setWriteLatency(counterValues.get(write_latency));
        m.setWriteOps(counterValues.get(write_ops));
        m.setTotalOps(counterValues.get(total_ops));
        
        Map<VolumeCounter, String> rawValue = getCurrentValues().getRawValues();
        m.setTotalProtocolOtherLatency(rawValue.get(total_protocol_other_latency));
        m.setTotalProtocolReadLatency(rawValue.get(total_protocol_read_latency));
        m.setTotalProtocolWriteLatency(rawValue.get(total_protocol_write_latency));
        
        //Synthetic counters
		m.setOpmVolNfsOps(MetricsRowScratchPad.add(m.getNfsReadOps(), m.getNfsWriteOps(), m.getNfsOtherOps()));
		m.setOpmVolIscsiOps(MetricsRowScratchPad.add(m.getIscsiReadOps(), m.getIscsiWriteOps(), m.getIscsiOtherOps()));
		m.setOpmVolFcpOps(MetricsRowScratchPad.add(m.getFcpReadOps(), m.getFcpWriteOps(), m.getFcpOtherOps()));
		m.setOpmVolCifsOps(MetricsRowScratchPad.add(m.getCifsReadOps(), m.getCifsWriteOps(), m.getCifsOtherOps()));
        return m;
    }
    
}
