package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation.BuilderUtil;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.ModelKeyBase;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.StorageAdapter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.util.EnumMap;

public class CModeAdapter extends BaseCRCXMLNode<CModeCluster> {

    private final AdapterKey key;
    private String nodeWWN;
    private String portWWN;
    private String model;
    private Boolean isInUse;
    private EnumWrapper<StorageAdapter.State> adapterState;
    private String cableEndIdentifier;
    private String cableLength;
    private String cableManufacturer;
    private String cablePartNumber;
    private String cableSerialNumber;
    private String attachedSerialNumber;
    private String cableTechnology;
    private EnumWrapper<StorageAdapter.Type> type;

    CModeAdapter(final CModeCluster parent, final String nodeName, final String adapterName){
        super(parent, CModeAdapter.class.getSimpleName());
        this.key = new AdapterKey(nodeName, adapterName);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public AdapterKey getKey() {
        return key;
    }

    public String getNodeWWN() {
        return nodeWWN;
    }

    public String getModel() {
        return model;
    }

    public Boolean getInUse() {
        return isInUse;
    }

    public void setNodeWWN(final String nodeWWN) {
        this.nodeWWN = nodeWWN;
    }

    public void setModel(final String model) {
        this.model = model;
    }

    public void setInUse(final Boolean inUse) {
        isInUse = inUse;
    }

    public String getPortWWN() {
        return portWWN;
    }

    public void setPortWWN(final String portWWN) {
        this.portWWN = portWWN;
    }

    public EnumWrapper<StorageAdapter.State> getAdapterState() {
        return adapterState;
    }

    public void setAdapterState(EnumWrapper<StorageAdapter.State> adapterState) {
        this.adapterState = adapterState;
    }

    public String getCableEndIdentifier() {
        return cableEndIdentifier;
    }

    public void setCableEndIdentifier(String cableEndIdentifier) {
        this.cableEndIdentifier = cableEndIdentifier;
    }

    public String getCableLength() {
        return cableLength;
    }

    public void setCableLength(String cableLength) {
        this.cableLength = cableLength;
    }

    public String getCableManufacturer() {
        return cableManufacturer;
    }

    public void setCableManufacturer(String cableManufacturer) {
        this.cableManufacturer = cableManufacturer;
    }

    public String getCablePartNumber() {
        return cablePartNumber;
    }

    public void setCablePartNumber(String cablePartNumber) {
        this.cablePartNumber = cablePartNumber;
    }

    public String getCableSerialNumber() {
        return cableSerialNumber;
    }

    public String getAttachedSerialNumber() {
        return attachedSerialNumber;
    }

    public void setAttachedSerialNumber(String attachedSerialNumber) {
        this.attachedSerialNumber = attachedSerialNumber;
    }

    public void setCableSerialNumber(String cableSerialNumber) {
        this.cableSerialNumber = cableSerialNumber;
    }

    public String getCableTechnology() {
        return cableTechnology;
    }

    public void setCableTechnology(String cableTechnology) {
        this.cableTechnology = cableTechnology;
    }

    public void setType(EnumWrapper<StorageAdapter.Type> type) {
        this.type = type;
    }

    public EnumWrapper<StorageAdapter.Type> getType() {
        return type;
    }

    public final static class AdapterKey extends ModelKeyBase<AdapterKey.Field> {
        public static enum Field {
            node_name,
            adapter_name
        }

        public AdapterKey(final String nodeName, final String adapterName) {
            super("adapter", new EnumMap<Field, String>(Field.class) {{
                put(Field.node_name, nodeName);
                put(Field.adapter_name, adapterName);
            }});
        }

    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "NodeName", key.getID(AdapterKey.Field.node_name));
        addAttributeNoCRC(writer, "AdapterName", key.getID(AdapterKey.Field.adapter_name));
        addAttributeNoCRC(writer, "NodeWWN", nodeWWN);
        addAttributeNoCRC(writer, "PortWWN", portWWN);
        addAttributeNoCRC(writer, "Model", model);
        addAttributeNoCRC(writer, "InUse", isInUse);
        addAttributeNoCRC(writer, "AdapterState", adapterState);
        addAttributeNoCRC(writer, "CableEndIdentifier", cableEndIdentifier);
        addAttributeNoCRC(writer, "CableLength", cableLength);
        addAttributeNoCRC(writer, "CableManufacturer", cableManufacturer);
        addAttributeNoCRC(writer, "CablePartNumber", cablePartNumber);
        addAttributeNoCRC(writer, "CableSerialNumber", cableSerialNumber);
        addAttributeNoCRC(writer, "AttachedSerialNumber", attachedSerialNumber);
        addAttributeNoCRC(writer, "CableTechnology", cableTechnology);
    }
}
