package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.FcpPort;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeAdapterStatus extends BaseCRCXMLNode<CModeCluster> {
    private final CModeAdapter.AdapterKey key;
    private EnumWrapper<FcpPort.Status> status;

    CModeAdapterStatus(final CModeCluster parent, final String adapterName, final String nodeName) {
        super(parent, CModeAdapterStatus.class.getSimpleName());
        this.key = new CModeAdapter.AdapterKey(nodeName, adapterName);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public CModeAdapter.AdapterKey getKey() {
        return key;
    }

    public EnumWrapper<FcpPort.Status> getStatus() {
        return status;
    }

    public void setStatus(final EnumWrapper<FcpPort.Status> status) {
        this.status = status;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "NodeName", key.getID(CModeAdapter.AdapterKey.Field.node_name));
        addAttributeNoCRC(writer, "AdapterName", key.getID(CModeAdapter.AdapterKey.Field.adapter_name));
        addAttributeNoCRC(writer, "Status", status);
    }
}
