package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.Aggregate;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class CModeAggregate extends BaseCRCXMLNode<CModeCluster> {

    // Raw values from XML
    private final UUIDKey aggregateKey;
    private String aggrName = null;
    private String aggrType = null;
    private Long diskCount = null;
    private EnumWrapper<Aggregate.AggregateState> aggrState = null;
    private Boolean isHybrid = null;
    private Boolean isHybridEnabled = null;
    private Boolean usesSharedDisks = null;
    private Long snapshotSizeTotal = null;
    private Long snapshotSizeUsed = null;
    private Long hybridCacheSizeTotal = null;
    private List<String> nodeNameStrings = new ArrayList<String>();
    private Long sizeTotal = null;
    private Long sizeUsed = null;
    private Long sizeAvailable = null;
    private Long raidSize = null;
    private EnumWrapper<Aggregate.BlockType> blockType = null;
    private Long snapShotSizeAvailable;
    private Long totalReservedSpace = null;
    private String raidStatus = null;
    private String raidType = null;
    private Boolean is64UpgradeInProgress = null;
    private EnumWrapper<Aggregate.MirrorStatus> mirrorStatus = null;
    private Integer sizeUsedPercent = null;
    private Integer sizeAvailPercent = null;

    private Boolean hasLocalRoot = null;
    private Boolean hasPartnerRoot = null;


    private EnumWrapper<Aggregate.AggregateType> aggregateType = null;



    // Children
    private final CModePlexes plexes;

    // derived values

    CModeAggregate(final CModeCluster parent, final String uuid) {
        super(parent, CModeAggregate.class.getSimpleName());
        this.aggregateKey = new UUIDKey("aggregate", uuid);
        this.plexes = new CModePlexes(this);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return aggregateKey;
    }

    public String getAggrName() {
        return aggrName;
    }

    public void setAggrName(final String aggrName) {
        this.aggrName = aggrName;
    }

    public String getAggrType() {
        return aggrType;
    }

    public void setAggrType(final String aggrType) {
        this.aggrType = aggrType;
    }

    public Long getDiskCount() {
        return diskCount;
    }

    public void setDiskCount(final Long diskCount) {
        this.diskCount = diskCount;
    }

    public EnumWrapper<Aggregate.AggregateState> getAggrState() {
        return aggrState;
    }

    public void setAggrState(final EnumWrapper<Aggregate.AggregateState> aggrState) {
        this.aggrState = aggrState;
    }

    public EnumWrapper<Aggregate.AggregateType> getAggregateType() {
        return aggregateType;
    }

    public void setAggregateType(EnumWrapper<Aggregate.AggregateType> aggregateType) {
        this.aggregateType = aggregateType;
    }

    public Boolean isHybrid() {
        return isHybrid;
    }

    public void setHybrid(final Boolean hybrid) {
        isHybrid = hybrid;
    }

    public Boolean isHybridEnabled() {
        return isHybridEnabled;
    }

    public void setHybridEnabled(final Boolean hybridEnabled) {
        isHybridEnabled = hybridEnabled;
    }

    public Long getSnapshotSizeTotal() {
        return snapshotSizeTotal;
    }

    public void setSnapshotSizeTotal(final Long snapshotSizeTotal) {
        this.snapshotSizeTotal = snapshotSizeTotal;
    }

    public Long getSnapshotSizeUsed() {
        return snapshotSizeUsed;
    }

    public void setSnapshotSizeUsed(final Long snapshotSizeUsed) {
        this.snapshotSizeUsed = snapshotSizeUsed;
    }

    public Long getHybridCacheSizeTotal() {
        return hybridCacheSizeTotal;
    }

    public void setHybridCacheSizeTotal(final Long hybridCacheSizeTotal) {
        this.hybridCacheSizeTotal = hybridCacheSizeTotal;
    }

    public List<String> getNodeNameStrings() {
        return nodeNameStrings;
    }

    public void setNodeNameStrings(final List<String> nodeNameStrings) {
        this.nodeNameStrings = nodeNameStrings;
    }

    public Long getSizeTotal() {
        return sizeTotal;
    }

    public void setSizeTotal(final Long sizeTotal) {
        this.sizeTotal = sizeTotal;
    }

    public Long getSizeUsed() {
        return sizeUsed;
    }

    public void setSizeUsed(final Long sizeUsed) {
        this.sizeUsed = sizeUsed;
    }

    public Long getSizeAvailable() {
        return sizeAvailable;
    }

    public void setSizeAvailable(final Long sizeAvailable) {
        this.sizeAvailable = sizeAvailable;
    }

    public Long getRaidSize() {
        return raidSize;
    }

    public void setRaidSize(final Long raidSize) {
        this.raidSize = raidSize;
    }

    public EnumWrapper<Aggregate.BlockType> getBlockType() {
        return blockType;
    }

    public void setBlockType(final EnumWrapper<Aggregate.BlockType> blockType) {
        this.blockType = blockType;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Long getSnapShotSizeAvailable() {
        return snapShotSizeAvailable;
    }

    public void setSnapShotSizeAvailable(final Long snapShotSizeAvailable) {
        this.snapShotSizeAvailable = snapShotSizeAvailable;
    }

    public Long getTotalReservedSpace() {
        return totalReservedSpace;
    }

    public void setTotalReservedSpace(final Long totalReservedSpace) {
        this.totalReservedSpace = totalReservedSpace;
    }

    public String getRaidStatus() {
        return raidStatus;
    }

    public void setRaidStatus(final String raidStatus) {
        this.raidStatus = raidStatus;
    }

    public String getRaidType() {
        return raidType;
    }

    public void setRaidType(String raidType) {
        this.raidType = raidType;
    }

    public Boolean isIs64UpgradeInProgress() {
        return is64UpgradeInProgress;
    }

    public void setIs64UpgradeInProgress(final Boolean is64UpgradeInProgress) {
        this.is64UpgradeInProgress = is64UpgradeInProgress;
    }

    public EnumWrapper<Aggregate.MirrorStatus> getMirrorStatus() {
        return mirrorStatus;
    }

    public void setMirrorStatus(final EnumWrapper<Aggregate.MirrorStatus> mirrorStatus) {
        this.mirrorStatus = mirrorStatus;
    }

    public Integer getSizeUsedPercent() {
        return sizeUsedPercent;
    }

    public void setSizeUsedPercent(final Integer sizeUsedPercent) {
        this.sizeUsedPercent = sizeUsedPercent;
        if (sizeUsedPercent != null) {
            this.sizeAvailPercent = 100 - sizeUsedPercent;
        }
    }

    public Integer getSizeAvailPercent() {
        return sizeAvailPercent;
    }

    public Boolean hasLocalRoot() {
        return hasLocalRoot;
    }

    public void setHasLocalRoot(final Boolean hasLocalRoot) {
        this.hasLocalRoot = hasLocalRoot;
    }

    public Boolean hasPartnerRoot() {
        return hasPartnerRoot;
    }

    public void setHasPartnerRoot(final Boolean hasPartnerRoot) {
        this.hasPartnerRoot = hasPartnerRoot;
    }

    public CModePlexes getPlexes() {
        return plexes;
    }

    public CModePlex createPlex(final String name, final Boolean isOnline) {
        return new CModePlex(this, name, isOnline);
    }

    public Boolean getUsesSharedDisks() {
        return usesSharedDisks;
    }

    public void setUsesSharedDisks(Boolean usesSharedDisks) {
        this.usesSharedDisks = usesSharedDisks;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "Name", aggrName);
        addAttributeNoCRC(writer, "UUID", aggregateKey.getUUID());
        addAttributeNoCRC(writer, "Type", aggrType);
        addAttributeNoCRC(writer, "State", aggrState.getEnumValue());
        addAttributeNoCRC(writer, "StateRaw", aggrState.getRawValue());
        addAttributeNoCRC(writer, "DiskCount", diskCount);
        addAttributeNoCRC(writer, "IsHybrid", isHybrid);
        addAttributeNoCRC(writer, "IsHybridEnabled", isHybridEnabled);
        addAttributeNoCRC(writer, "UsesSharedDisks", usesSharedDisks);
        addAttributeNoCRC(writer, "SnapshotSizeTotal", snapshotSizeTotal);
        addAttributeNoCRC(writer, "SnapshotSizeTotalUsed", snapshotSizeUsed);
        addAttributeNoCRC(writer, "SnapshotSizeAvailable", snapShotSizeAvailable);
        addAttributeNoCRC(writer, "HybridCacheSizeTotal", hybridCacheSizeTotal);
        addAttributeNoCRC(writer, "SizeTotal", sizeTotal);
        addAttributeNoCRC(writer, "SizeUsed", sizeUsed);
        addAttributeNoCRC(writer, "SizeAvailable", sizeAvailable);
        addAttributeNoCRC(writer, "TotalReservedSpace", totalReservedSpace);
        addAttributeNoCRC(writer, "RAIDStatus", raidStatus);
        addAttributeNoCRC(writer, "RAIDType", raidType);
        addAttributeNoCRC(writer, "BlockType", Aggregate.BlockType.toXML(blockType.getEnumValue()));
        addAttributeNoCRC(writer, "BlockTypeRaw", blockType.getRawValue());
        addAttributeNoCRC(writer, "RaidSize", raidSize);
        addAttributeNoCRC(writer, "Is64BitUpgradeInProgress", is64UpgradeInProgress);
        addAttributeNoCRC(writer, "MirrorStatus", mirrorStatus.getEnumValue());
        addAttributeNoCRC(writer, "MirrorStatusRaw", mirrorStatus.getRawValue());
        addAttributeNoCRC(writer, "SizeUsedPercent", sizeUsedPercent);
        addAttributeNoCRC(writer, "SizeAvailablePercent", sizeAvailPercent);
        addAttributeNoCRC(writer, "HasLocalRoot", hasLocalRoot);
        addAttributeNoCRC(writer, "HasPartnerRoot", hasPartnerRoot);
        addAttributeNoCRC(writer, "AggregateType", aggregateType.getEnumValue());
        addAttributeNoCRC(writer, "AggregateTypeRaw", aggregateType.getRawValue());
    }

    @Override
    protected boolean hasChildren() {
        return !nodeNameStrings.isEmpty() || !plexes.isEmpty();
    }

    @Override
    protected void marshallChildrenToFileAndCRC(final MarshallingCache cache, final DSFileCRCWriter writer, final int tabs) throws IOException, SchemaException {
        final String xmlNodeName = "Nodes";
        addTabulation(writer, tabs);
        writer.append("<").append(xmlNodeName).append(">").append(lineSeperator);
        for (final String nodeName : nodeNameStrings) {
            addTabulation(writer, tabs + 1);
            writer.append("<Node>");
            writer.append(nodeName);
            writer.append("</Node>").append(lineSeperator);
        }
        addTabulation(writer, tabs);
        writer.append("</").append(xmlNodeName).append(">").append(lineSeperator);

        addAllChildrenUnderNodeAndCRC(cache, writer, CModePlexes.class.getSimpleName(), plexes.values(), tabs);
    }


    public boolean isOffline() {
        if (Aggregate.AggregateState.OFFLINE == aggrState.getEnumValue()
                || Aggregate.AggregateState.RESTRICTED == aggrState.getEnumValue()
                || Aggregate.AggregateState.FAILED == aggrState.getEnumValue()) {
            return true;
        } else {
            return false;
        }
    }
}

