package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapperList;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;

import java.io.IOException;

/**
 * Base class for C-mode model XML nodes.
 */
public abstract class CModeBaseXMLNode<P> extends BaseCRCXMLNode<P> {

    protected CModeBaseXMLNode(final P parent, final String name) {
        super(parent, name);
    }

    /**
     * Marshall the specified list of enum wrappers to the specified writer.
     */
    protected void marshallEnumWrapperList(final DSFileCRCWriter writer, final EnumWrapperList<?> list,
            final String nodeName, final String elementName, final int tabs) throws IOException {
        if ((list == null) || list.isEmpty()) {
            // Nothing to marshall
            return;
        }
        addTabulation(writer, tabs);
        writer.append("<");
        writer.append(nodeName);
        writer.append(">");
        writer.append(lineSeperator);
        for (final EnumWrapper<?> enumWrapper : list) {
            addTabulation(writer, tabs + 1);
            writer.append("<");
            writer.append(elementName);
            if (enumWrapper.getEnumValue() != null) {
                writer.append(" Value=\"");
                writer.append(enumWrapper.getEnumValue().toString());
                writer.append("\"");
            }
            writer.append(" RawValue=\"");
            writer.append(enumWrapper.getRawValue());
            writer.append("\"");
            writer.append(" />");
//            writer.append("<");
//            writer.append(elementName);
//            writer.append(">");
//            writer.append(enumWrapper.getRawValue());
//            writer.append("</");
//            writer.append(elementName);
//            writer.append(">");
            writer.append(lineSeperator);
        }
        addTabulation(writer, tabs);
        writer.append("</");
        writer.append(nodeName);
        writer.append(">");
        writer.append(lineSeperator);
    }
}
