package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeFcpLif extends BaseCRCXMLNode<CModeCluster> {
    private final CModeLif.LifKey lifKey;
    private String nodeWWN;
    private String portWWN;

    CModeFcpLif(final CModeCluster parent, final String interfaceName, final String vServerName) {
        super(parent, CModeLif.class.getSimpleName());
        this.lifKey = new CModeLif.LifKey(vServerName, interfaceName);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public CModeLif.LifKey getKey() {
        return lifKey;
    }

    public String getNodeWWN() {
        return nodeWWN;
    }

    public String getPortWWN() {
        return portWWN;
    }

    public void setNodeWWN(final String nodeWWN) {
        this.nodeWWN = nodeWWN;
    }

    public void setPortWWN(final String portWWN) {
        this.portWWN = portWWN;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "VServerName", lifKey.getID(CModeLif.LifKey.Field.vserver_name));
        addAttributeNoCRC(writer, "LifName", lifKey.getID(CModeLif.LifKey.Field.interface_name));
        addAttributeNoCRC(writer, "NodeWWN", nodeWWN);
        addAttributeNoCRC(writer, "PortWWN", portWWN);
    }
}
