package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.JobSchedule;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeJobSchedule extends BaseCRCXMLNode<CModeCluster> {

    private final UUIDKey scheduleKey;
    private EnumWrapper<JobSchedule.ScheduleType> jobScheduleType;
    private String description;

    CModeJobSchedule(final CModeCluster parent, final String scheduleName) {
        super(parent, CModeJobSchedule.class.getSimpleName());
        scheduleKey = new UUIDKey("job_schedule", scheduleName);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return scheduleKey;
    }

    public EnumWrapper<JobSchedule.ScheduleType> getJobScheduleType() {
        return jobScheduleType;
    }

    public void setJobScheduleType(final EnumWrapper<JobSchedule.ScheduleType> jobScheduleType) {
        this.jobScheduleType = jobScheduleType;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(final String description) {
        this.description = description;
    }


    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "UUID", scheduleKey.getUUID());
        addAttributeNoCRC(writer, "Name", scheduleKey.getUUID());
        addAttributeNoCRC(writer, "Type", EnumWrapper.toStringOrNull(jobScheduleType));
        addAttributeNoCRC(writer, "Description", description);
    }
}
