package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeJobScheduleInterval extends BaseCRCXMLNode<CModeCluster> {

    private final UUIDKey scheduleKey;
    private Long days;
    private Long hours;
    private Long minutes;
    private Long seconds;

    CModeJobScheduleInterval(final CModeCluster parent, final String jobScheduleName) {
        super(parent, CModeJobScheduleInterval.class.getSimpleName());
        this.scheduleKey = new UUIDKey("job_schedule_interval", jobScheduleName);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return scheduleKey;
    }

    public Long getDays() {
        return days;
    }

    public void setDays(final Long days) {
        this.days = days;
    }

    public Long getHours() {
        return hours;
    }

    public void setHours(final Long hours) {
        this.hours = hours;
    }

    public Long getMinutes() {
        return minutes;
    }

    public void setMinutes(final Long minutes) {
        this.minutes = minutes;
    }

    public Long getSeconds() {
        return seconds;
    }

    public void setSeconds(final Long seconds) {
        this.seconds = seconds;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "UUID", scheduleKey.getUUID());
        addAttributeNoCRC(writer, "Name", scheduleKey.getName());
        addAttributeNoCRC(writer, "Days", days);
        addAttributeNoCRC(writer, "Hours", hours);
        addAttributeNoCRC(writer, "Minutes", minutes);
        addAttributeNoCRC(writer, "Seconds", seconds);
    }
}
