package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.ModelKeyBase;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.util.EnumMap;

public class CModeNetworkFailoverGroupNetworkPortRelationship extends BaseCRCXMLNode<CModeCluster> {

    private final NetworkFailoverGroupNetworkPortRelationshipKey networkFailoverGroupNetworkPortRelationshipKey;

  /**
   * network Failover Group Name
   */
    private final String networkFailoverGroupName;

  /**
   * network Port Name
   */
  private final String networkPortName;

  /**
   * server Node Name
   */
  private final String serverNodeName;


  protected CModeNetworkFailoverGroupNetworkPortRelationship(final CModeCluster parent, String serverNodeName, final String networkFailoverGroupName, final String networkPortName ) {
        super(parent, CModeNetworkFailoverGroupNetworkPortRelationship.class.getSimpleName());
        this.networkFailoverGroupName = networkFailoverGroupName;
        this.networkPortName = networkPortName;
        this.serverNodeName = serverNodeName;
        this.networkFailoverGroupNetworkPortRelationshipKey = new NetworkFailoverGroupNetworkPortRelationshipKey(networkFailoverGroupName, networkPortName, serverNodeName);
    }


    public static final class NetworkFailoverGroupNetworkPortRelationshipKey extends ModelKeyBase<NetworkFailoverGroupNetworkPortRelationshipKey.Field> {
        public static enum Field {
            network_failover_group_name,
            network_port_name,
            node_name
        }

        public NetworkFailoverGroupNetworkPortRelationshipKey(final String networkFailoverGroupName, final String networkPortName, final String serverNodeName) {
            super("network_failover_group_network_port_relationship", new EnumMap<Field, String>(Field.class) {{
                put(Field.network_failover_group_name, networkFailoverGroupName);
                put(Field.node_name, serverNodeName );
                put(Field.network_port_name, networkPortName);
            }});
        }
    }

  public String getServerNodeName()
  {
    return serverNodeName;
  }

  public String getNetworkFailoverGroupName()
  {
    return networkFailoverGroupName;
  }

  public String getNetworkPortName()
  {
    return networkPortName;
  }

  @Override
    @SuppressWarnings({"unchecked"})
    public NetworkFailoverGroupNetworkPortRelationshipKey getKey() {
        return networkFailoverGroupNetworkPortRelationshipKey;
    }


    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache cache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributesToFileAndCRC(cache, writer);
        addAttributeNoCRC(writer, "NetworkFailoverGroupName", networkFailoverGroupName);
        addAttributeNoCRC(writer, "NetworkPortName", networkPortName);
        addAttributeNoCRC(writer, "NodeName", serverNodeName);
    }
}