package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.Node;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

/**
 * Created with IntelliJ IDEA.
 * User: jianwei
 * Date: 1/26/14
 * Time: 4:50 PM
 * To change this template use File | Settings | File Templates.
 */
public class CModeNodeMetrocluster extends BaseCRCXMLNode<CModeCluster> {
    private final UUIDKey key;
    private String mtDrPartnerNodeUUID;
    private String mtDrPartnerClusterUUID;
    private EnumWrapper<Node.MtDrOperationState> mtDrOperationState;    //state of DR operation
    private String mtDrOperationStateRaw; //Raw enum value from ZAPI
    private Boolean mtAutomaticUso;

    CModeNodeMetrocluster(final CModeCluster parent, final String nodeUUID) {
        super(parent, CModeNodeMetrocluster.class.getSimpleName());
        this.key = new UUIDKey("node_metrocluster", nodeUUID);
    }

    @Override
    public UUIDKey getKey() {
        return key;
    }

    public String getMtDrPartnerNodeUUID() {
        return mtDrPartnerNodeUUID;
    }

    public void setMtDrPartnerNodeUUID(String mtDrPartnerNodeUUID) {
        this.mtDrPartnerNodeUUID = mtDrPartnerNodeUUID;
    }

    public String getMtDrPartnerClusterUUID() {
        return mtDrPartnerClusterUUID;
    }

    public void setMtDrPartnerClusterUUID(String mtDrPartnerClusterUUID) {
        this.mtDrPartnerClusterUUID = mtDrPartnerClusterUUID;
    }

    public EnumWrapper<Node.MtDrOperationState> getMtDrOperationState() {
        return mtDrOperationState;
    }

    public void setMtDrOperationState(EnumWrapper<Node.MtDrOperationState> mtDrOperationState) {
        this.mtDrOperationState = mtDrOperationState;
    }

    public String getMtDrOperationStateRaw() {
        return mtDrOperationStateRaw;
    }

    public void setMtDrOperationStateRaw(String mtDrOperationStateRawRaw) {
        this.mtDrOperationStateRaw = mtDrOperationStateRaw;
    }

    public Boolean getMtAutomaticUso() { return mtAutomaticUso; }

    public void setMtAutomaticUso(Boolean mtAutomaticUso) {
        this.mtAutomaticUso = mtAutomaticUso;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "UUID", key.getID());
        addAttributeNoCRC(writer, "MtDrOperationState", mtDrOperationState);
        addAttributeNoCRC(writer, "MtDrPartnerClusterUUID", mtDrPartnerClusterUUID);
        addAttributeNoCRC(writer, "MtDrPartnerNodeUUID", mtDrPartnerNodeUUID);
        addAttributeNoCRC(writer, "MtAutomaticUso", mtAutomaticUso);
    }

}
