package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;
import org.apache.log4j.Logger;

import java.io.IOException;

public class CModePerfObjInstance extends BaseCRCXMLNode<CModePerfObject> {

    @SuppressWarnings({"UnusedDeclaration"})
    private static final Logger logger = Logger.getLogger(CModePerfObjInstance.class);

    private final UUIDKey key;
    private final String instanceName;

    CModePerfObjInstance(final CModePerfObject parent, final String instanceName, final String instannceUUID) {
        super(parent, CModePerfObjInstance.class.getSimpleName());
        this.key = new UUIDKey("perf_object_instance", instannceUUID);
        this.instanceName = instanceName;
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return key;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "UUID", key.getID());
        addAttributeNoCRC(writer, "InstanceUUID", key.getID());
        addAttributeNoCRC(writer, "InstanceName", instanceName);

    }
}
