package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;
import org.apache.log4j.Logger;

import java.io.IOException;

public class CModePerfObject extends BaseCRCXMLNode<CModeCluster> {

    @SuppressWarnings({"UnusedDeclaration"})
    private static final Logger logger = Logger.getLogger(CModePerfObject.class);

    private final CModePerfObjInstances cModePerfObjInstances;
    //private final CModePerfObjCounterTypes cModePerfObjCounterTypes;
    private final UUIDKey key;

    CModePerfObject(final CModeCluster parent, final String objectName) {
        super(parent, CModePerfObject.class.getSimpleName());
        this.key = new UUIDKey("perf_object", objectName);
        this.cModePerfObjInstances = new CModePerfObjInstances(this);
        //this.cModePerfObjCounterTypes = new CModePerfObjCounterTypes(this);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return key;
    }

    public String getObjectName() {
        return key.getName();
    }


    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "ObjectName", getObjectName());
    }

    @Override
    protected boolean hasChildren() {
        return !cModePerfObjInstances.isEmpty();
    }

    @Override
    protected void marshallChildrenToFileAndCRC(final MarshallingCache cache, final DSFileCRCWriter writer, final int tabs) throws IOException, SchemaException {
        //addAllChildrenUnderNodeAndCRC(cache, writer, CModePerfObjCounterTypes.class.getSimpleName(), cModePerfObjCounterTypes.values(), tabs);
        addAllChildrenUnderNodeAndCRC(cache, writer, CModePerfObjInstances.class.getSimpleName(), cModePerfObjInstances.values(), tabs);
    }
}
