package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import java.io.IOException;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.builders.zapi.cmode.netappfoundation.BuilderUtil;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.SnapMirror;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.SnapMirrorHistory;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;


@SuppressWarnings("serial")
public class CModeSnapMirrorHistory extends BaseCRCXMLNode<CModeCluster> {   
    private UUIDKey key; 
    private String destinationVolume;
    private String destinationLocation;
    private String destinationVServer;
    private String sourceVolume;
    private String additionalInfo;
    private String operationId;
    private Long startTime;
    private Long endTime;
    private Long transferSize;
    private EnumWrapper<SnapMirrorHistory.OperationType> operationType;
    private EnumWrapper<SnapMirrorHistory.Result> result;
    private EnumWrapper<SnapMirrorHistory.RelationshipGroupType> relationshipGroupType;
    
    CModeSnapMirrorHistory(final CModeCluster parent, final String operationId) {
        super(parent, CModeSnapMirrorHistory.class.getSimpleName());
        this.key = new UUIDKey("snapMirrorHistory", operationId);
        this.operationId = operationId;
    }
    
    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return key;
    }
    
    public String getDestinationVolume() {
        return destinationVolume;
    }
    
    public void setDestinationVolume(String destinationVolume) {
        this.destinationVolume = destinationVolume;
    }
    
    public String getDestinationLocation() {
        return destinationLocation;
    }
    
    public void setDestinationLocation(String destinationLocation) {
        this.destinationLocation = destinationLocation;
    }
    
    public String getDestinationVServer() {
        return destinationVServer;
    }
    
    public void setDestinationVServer(String destinationVServer) {
        this.destinationVServer = destinationVServer;
    }
    
    public String getSourceVolume() {
        return sourceVolume;
    }
    
    public void setSourceVolume(String sourceVolume) {
        this.sourceVolume = sourceVolume;
    }
 
    public String getAdditionalInfo() {
        return additionalInfo;
    }
    
    public void setAdditionalInfo(String additionalInfo) {
        this.additionalInfo = additionalInfo;
    }
    
    public String getOperationId() {
        return operationId;
    }
    
    public void setOperationId(String operationId) {
        this.operationId = operationId;
    }
   
    public Long getStartTime() {
        return startTime;
    }
 
    public void setStartTime(Long startTime) {
        this.startTime = startTime;
    }
  
    public Long getEndTime() {
        return endTime;
    }

    public void setEndTime(Long endTime) {
        this.endTime = endTime;
    }

    public Long getTransferSize() {
        return transferSize;
    }
    
    public void setTransferSize(Long transferSize) {
        this.transferSize = transferSize;
    }
    
    public EnumWrapper<SnapMirrorHistory.OperationType> getOperationType() {
        return operationType;
    }
    
    public void setOperationType(EnumWrapper<SnapMirrorHistory.OperationType> operationType) {
        this.operationType = operationType;
    }
    
    public EnumWrapper<SnapMirrorHistory.Result> getResult() {
        return result;
    }
    
    public void setResult(EnumWrapper<SnapMirrorHistory.Result> result) {
        this.result = result;
    }
    
    public EnumWrapper<SnapMirrorHistory.RelationshipGroupType> getRelationshipGroupType() {
        return relationshipGroupType;
    }
    
    public void setRelationshipGroupType(EnumWrapper<SnapMirrorHistory.RelationshipGroupType> relationshipGroupType) {
        this.relationshipGroupType = relationshipGroupType;
    }
  
    public void setKey(UUIDKey key) {
        this.key = key;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributesToFileAndCRC(marshallingCache, writer);
        addAttributeNoCRC(writer, "UUID", key.getID());
        addAttributeNoCRC(writer, "DestinationVolume", destinationVolume);
        addAttributeNoCRC(writer, "DestinationLocation", destinationLocation);
        addAttributeNoCRC(writer, "DestinationVServer", destinationVServer);
        addAttributeNoCRC(writer, "SourceVolume", sourceVolume);
        addAttributeNoCRC(writer, "AdditionalInfo", additionalInfo);
        addAttributeNoCRC(writer, "StartTime", startTime);
        addAttributeNoCRC(writer, "EndTime", endTime);
        addAttributeNoCRC(writer, "TransferSize", transferSize);
        addAttributeNoCRC(writer, "OperationType", operationType.getEnumValue());
        addAttributeNoCRC(writer, "OperationTypeRaw", operationType.getRawValue());
        addAttributeNoCRC(writer, "Result", result.getEnumValue());
        addAttributeNoCRC(writer, "ResultRaw", result.getRawValue());
        addAttributeNoCRC(writer, "RelationshipGroupType", relationshipGroupType.getEnumValue());
        addAttributeNoCRC(writer, "RelationshipGroupTypeRaw", relationshipGroupType.getRawValue());
    }
    
}
