package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeSnapshotSchedule extends BaseCRCXMLNode<CModeSnapshotPolicy> {

    private final UUIDKey scheduleKey;

    private String prefix;
    private Long count;
    private String snapmirrorLabel;

    CModeSnapshotSchedule(final CModeSnapshotPolicy parent, final String scheduleName) {
        super(parent, CModeSnapshotSchedule.class.getSimpleName());
        this.scheduleKey = new UUIDKey("snapshot_schedule", scheduleName);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return scheduleKey;
    }

    public String getPrefix() {
        return prefix;
    }

    public void setPrefix(final String prefix) {
        this.prefix = prefix;
    }

    public Long getCount() {
        return count;
    }

    public void setCount(final Long count) {
        this.count = count;
    }

    public String getSnapmirrorLabel() {
        return snapmirrorLabel;
    }

    public void setSnapmirrorLabel(final String snapmirrorLabel) {
        this.snapmirrorLabel = snapmirrorLabel;
    }


    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "ScheduleName", scheduleKey.getName());
        addAttributeNoCRC(writer, "Count", count);
        addAttributeNoCRC(writer, "Prefix", prefix);
        addAttributeNoCRC(writer, "SnapmirrorLabel", snapmirrorLabel);
    }
}
