package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeVServerCIFSSecurityInfo extends BaseCRCXMLNode<CModeCluster> {

    private final UUIDKey infoKey;
    private Boolean isSmbEncryptionRequired;

    CModeVServerCIFSSecurityInfo(final CModeCluster parent, final String uuid) {
        super(parent, CModeVServerCIFSSecurityInfo.class.getSimpleName());
        this.infoKey = new UUIDKey("cifs_sec_info", uuid);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return infoKey;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Boolean isSmbEncryptionRequired() {
        return isSmbEncryptionRequired;
    }

    public void setSmbEncryptionRequired(final Boolean isSmbEncryptionRequired) {
        this.isSmbEncryptionRequired = isSmbEncryptionRequired;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "UUID", infoKey.getUUID());
        addAttributeNoCRC(writer, "IsSmbEncryptionRequired", isSmbEncryptionRequired);
	}
}

