package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.schema.NodeMap;
import java.util.HashMap;
import java.util.Map;

public class CModeVServerPeers extends NodeMap<CModeCluster, CModeVServerPeer.VServerPeerKey, CModeVServerPeer> {
    final Map<String, String> vServerNamesToClusterNameMap = new HashMap<>();

    CModeVServerPeers(final CModeCluster modelParent) {
        super(modelParent);
    }

    public boolean add(final CModeVServerPeer cModeVServerPeer) {
        vServerNamesToClusterNameMap.put(
                getVServerPeerKey(cModeVServerPeer.getPeerVServerName(), cModeVServerPeer.getVServerName()),
                cModeVServerPeer.getPeerClusterName());
        return (put(cModeVServerPeer.getKey(), cModeVServerPeer) == null);
    }

    public String getClusterName(final String peerVServerName, final String vServerName) {
        if ((vServerName == null) || (peerVServerName == null)) {
            return null;
        }
        
        return vServerNamesToClusterNameMap.get(getVServerPeerKey(peerVServerName, vServerName));
    }

    private String getVServerPeerKey(final String s1, final String s2) {
        return s1 + ":" + s2;
    }
}
