package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeVolumeFlexCache extends BaseCRCXMLNode<CModeCluster> {

    private final CModeVolume.VolumeNameKey key;

    private String cacheAggregateName;
    private String originAggregateName;
    private String originVolumeName;

    CModeVolumeFlexCache(final CModeCluster parent, final String vServerName, final String cacheVolumeName) {
        super(parent, CModeVolume.class.getSimpleName());
        this.key = new CModeVolume.VolumeNameKey(vServerName, cacheVolumeName);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public CModeVolume.VolumeNameKey getKey() {
        return key;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getCacheAggregateName() {
        return cacheAggregateName;
    }

    public void setCacheAggregateName(final String cacheAggregateName) {
        this.cacheAggregateName = cacheAggregateName;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getOriginAggregateName() {
        return originAggregateName;
    }

    public void setOriginAggregateName(final String originAggregateName) {
        this.originAggregateName = originAggregateName;
    }

    public String getOriginVolumeName() {
        return originVolumeName;
    }

    public void setOriginVolumeName(final String originVolumeName) {
        this.originVolumeName = originVolumeName;
    }


    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "ID", key.getID());
        addAttributeNoCRC(writer, "VServerName", key.getID(CModeVolume.VolumeNameKey.Field.vserver_name));
        addAttributeNoCRC(writer, "CacheVolumeName", key.getID(CModeVolume.VolumeNameKey.Field.volume_name));
        addAttributeNoCRC(writer, "CacheAggregateName", cacheAggregateName);
        addAttributeNoCRC(writer, "OriginAggregateName", originAggregateName);
        addAttributeNoCRC(writer, "OriginVolumeName", originVolumeName);
    }
}
