package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.cmode;

import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.EnumWrapper;
import com.onaro.sanscreen.acquisition.datasource.netapp_ocie.model.UUIDKey;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.VolumeMove;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

public class CModeVolumeMove extends BaseCRCXMLNode<CModeCluster> {

    private final UUIDKey volumeMoveKey;

    private Long actualCompletionTimestamp;
    private String destinationAggregate;
    private String details;
    private Long jobID;
    private Integer percentComplete;
    private EnumWrapper<VolumeMove.Phase> phase = null;
    private String sourceAggregate;
    private Long startTimestamp;
    private Long estimatedCompletionTime;
    private EnumWrapper<VolumeMove.State> state = null;
    private String volume;
    private String vServer;

    CModeVolumeMove(final CModeCluster parent, final String jobUUID) {
        super(parent, CModeVolumeMove.class.getSimpleName());
        this.volumeMoveKey = new UUIDKey("volume_move_job", jobUUID);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public UUIDKey getKey() {
        return volumeMoveKey;
    }

    public Long getActualCompletionTimestamp() {
        return actualCompletionTimestamp;
    }

    public void setActualCompletionTimestamp(final Long actualCompletionTimestamp) {
        this.actualCompletionTimestamp = actualCompletionTimestamp;
    }

    public String getDestinationAggregate() {
        return destinationAggregate;
    }

    public void setDestinationAggregate(final String destinationAggregate) {
        this.destinationAggregate = destinationAggregate;
    }

    public String getDetails() {
        return details;
    }

    public void setDetails(final String details) {
        this.details = details;
    }

    public Long getJobID() {
        return jobID;
    }

    public void setJobID(final Long jobID) {
        this.jobID = jobID;
    }

    public Integer getPercentComplete() {
        return percentComplete;
    }

    public void setPercentComplete(final Integer percentComplete) {
        this.percentComplete = percentComplete;
    }

    public String getPhaseRaw() {
        return phase.getRawValue();
    }

    public VolumeMove.Phase getPhaseEnum() {
        return phase.getEnumValue();
    }

    public void setPhase(final EnumWrapper<VolumeMove.Phase> phase) {
        this.phase = phase;
    }

    public String getSourceAggregate() {
        return sourceAggregate;
    }

    public void setSourceAggregate(final String sourceAggregate) {
        this.sourceAggregate = sourceAggregate;
    }

    public Long getStartTimestamp() {
        return startTimestamp;
    }

    public void setStartTimestamp(final Long startTimestamp) {
        this.startTimestamp = startTimestamp;
    }

    public void setState(final EnumWrapper<VolumeMove.State> state) {
        this.state = state;
    }

    public String getStateRaw() {
        return state.getRawValue();
    }

    public VolumeMove.State getStateEnum() {
        return state.getEnumValue();
    }

    public String getVolume() {
        return volume;
    }

    public void setVolume(final String volume) {
        this.volume = volume;
    }

    public void setEstimatedCompletionTime(final Long estimatedCompletionTime) {
        this.estimatedCompletionTime = estimatedCompletionTime;
    }

    public Long getEstimatedCompletionTime() {
        return estimatedCompletionTime;
    }

    public void setVServer(final String vServer) {
        this.vServer = vServer;
    }

    public String getVServer() {
        return vServer;
    }


    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributes(marshallingCache, writer);
        addAttributeNoCRC(writer, "JobUUID", volumeMoveKey.getUUID());
        addAttributeNoCRC(writer, "ActualCompletionTimestamp", actualCompletionTimestamp);
        addAttributeNoCRC(writer, "DestinationAggregate", destinationAggregate);
        addAttributeNoCRC(writer, "Details", details);
        addAttributeNoCRC(writer, "JobID", jobID);
        addAttributeNoCRC(writer, "PercentComplete", percentComplete);
        addAttributeNoCRC(writer, "PhaseEnum", phase.getEnumValue());
        addAttributeNoCRC(writer, "PhaseRaw", phase.getRawValue());
        addAttributeNoCRC(writer, "StartTimestamp", startTimestamp);
        addAttributeNoCRC(writer, "EstimatedCompletionTime", estimatedCompletionTime);
        addAttributeNoCRC(writer, "StateEnum", state.getEnumValue());
        addAttributeNoCRC(writer, "StateRaw", state.getRawValue());
        addAttributeNoCRC(writer, "Volume", volume);
    }
}
