package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi;

import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileWriter;
import netapp.manage.NaServer;

import java.net.UnknownHostException;

public class SimpleZapiConnection extends ZAPIConnection
{
  private SimpleConnectionConfiguration configuration;
  public SimpleZapiConnection(SimpleConnectionConfiguration configuration) throws UnknownHostException
  {
    super( createServer( configuration ) );
    this.configuration = configuration;
    this.dsName = configuration.getName(); //not parent constructor so this is setting a protected value in the parent
  }

  @Override
  public DSFileWriter getResponseTimesWriter()
  {
    return null;
  }

  @Override
  public void recordAttributes()
  {

  }

  @Override
  public void recordRequestedAttribute(String s)
  {

  }

  @Override
  public String getIP()
  {
    return configuration.getIpAddress();
  }

  @Override
  public void close() throws DataSourceErrorException
  {

  }

  @Override
  protected boolean isDataSourceStopped()
  {
    return false;
  }

  @Override
  protected int getMaxRetries()
  {
    return 1;
  }

  @Override
  protected boolean isSimulating()
  {
    return false;
  }

  protected static NaServer createServer(SimpleConnectionConfiguration connection) throws UnknownHostException
  {
    final NaServer server = new NaServer( connection.getIpAddress(), connection.getOntapMajor(), connection.getOntapMinor() );
    server.setTimeout( connection.getTimeout() );
    server.setPort( connection.getPort() );
    server.setAdminUser( connection.getUser(), connection.getPassword() );
    server.setServerType( NaServer.SERVER_TYPE_FILER );
    return server;
  }
}
