package com.onaro.sanscreen.acquisition.datasource.netapp_ocie.transport.zapi;

import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import com.onaro.sanscreen.acquisition.framework.datasource.PackageContext;
import com.onaro.sanscreen.acquisition.framework.datasource.Package;

import java.util.Properties;

/**
 * Factory for ZAPI connections. This class is needed to hide the details of recording and simulation from the builders
 * using it.
 * <p/>
 * An instance of this class is being maintained in the main DATA source class and passed on to the root builder for
 * creating connections to the different arrays participating in a cluster
 */
public class ZAPIConnectionFactory
{
  public static ZAPIConnection createConnection() throws DataSourceErrorException
  {
    return createConnection( null );
  }

  public static ZAPIConnection createConnection(final Properties properties) throws DataSourceErrorException
  {
    return createConnection( PackageContext.getPackage(), properties );
  }

  public static ZAPIConnection createConnection(final Package thePackage, final Properties properties) throws DataSourceErrorException
  {
    return new PackageZAPIConnection( thePackage, properties );
  }
}
