package com.onaro.sanscreen.acquisition.foundation.datasource;

import com.onaro.sanscreen.acquisition.foundation.datasource.config.FoundationConfiguration;
import com.onaro.sanscreen.acquisition.framework.datasource.BaseDataSource;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceLifeCycleListener;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceSampleListener;

/**
 * Base class for all storage data sources.
 * This is the location where we can perform heuristic validataion of the data returned
 * by the data source.
 */
public abstract class BaseStorageFoundationPackage<C extends FoundationConfiguration> extends BaseFoundationPackage<C> {
    protected BaseStorageFoundationPackage(final BaseDataSource dataSource, final C configuration, final DataSourceLifeCycleListener dataSourceLifeCycleListener, final DataSourceSampleListener dataSourceSampleListener, final FoundationUpdatesListener foundationUpdatesListener, final OriginatorProvider originatorProvider) {
        super(dataSource, configuration, dataSourceLifeCycleListener, dataSourceSampleListener, foundationUpdatesListener, originatorProvider);
    }
}
