package com.onaro.sanscreen.acquisition.foundation.datasource.dependant;

import com.onaro.sanscreen.acquisition.schema.Root;

import java.io.Serializable;

public class FoundationData implements Serializable {
    private final static long serialVersionUID = 1;

    private final String originatorKey;
    private final Root odataRoot;
    private final boolean changed;
    private final Serializable context;
    private final String odataXml;

    public FoundationData(final String originatorKey, final Root odataRoot, final boolean changed, final Serializable context, final String odataXml) {
        this.originatorKey = originatorKey;
        this.odataRoot = odataRoot;
        this.changed = changed;
        this.context = context;
        this.odataXml = odataXml;
    }

    public String getOriginatorKey() {
        return originatorKey;
    }

    public Root getOdataRoot() {
        return odataRoot;
    }

    public boolean isChanged() {
        return changed;
    }

    public Serializable getContext() {
        return context;
    }

    public String getOdataXml() {
        return odataXml;
    }
}