package com.onaro.sanscreen.acquisition.framework.datasource.io;

import java.io.IOException;
import java.io.File;
import java.io.FileNotFoundException;

/**
 * Represents a file that was created outside the framework and therefore managed not by the framework. These files
 * are usually generated by external utilities (like the symapi_recorder.exe utility).
 *
 * This is a marker class to tell the framework not to try to 'close' this file.
 */
public class DSFileExternallyManaged implements DSFile {
    private String fileName;

    public DSFileExternallyManaged(final String fileName) throws FileNotFoundException {
        this.fileName = fileName;
    }

    public void close() throws IOException {
        // Do nothing! This file is not being managed by the framework!
    }

    public String getFileName() {
        return fileName;
    }
}
