package com.onaro.sanscreen.acquisition.framework.datasource.io;

import java.io.InputStream;
import java.io.IOException;

public class DSInputStream extends InputStream implements DSFile {

    private String fileName;
    private InputStream is;

    public DSInputStream(final InputStream is, final String fileName) {
        super();

        this.is = is ;
        this.fileName = fileName;
    }

    public String getFileName() {
        return fileName;
    }

    public int read() throws IOException {
        return is.read();
    }

    public void close() throws IOException{
        is.close();
    }

    public int read(byte b[]) throws IOException {
        return is.read(b);
    }

    public int read(byte b[], int off, int len) throws IOException {
        return is.read(b, off, len);
    }

    public long skip(long n) throws IOException {
        return is.skip(n);
    }

    public int available() throws IOException {
        return is.available();
    }

    public synchronized void mark(int readlimit) {
        is.mark(readlimit);
    }

    public synchronized void reset() throws IOException {
        is.reset();
    }

    public boolean markSupported() {
        return is.markSupported();
    }
}