package com.onaro.sanscreen.acquisition.framework.mgmt;

import com.onaro.sanscreen.acquisition.framework.FrameworkException;

/**
 * Lists the supported methods of communication with the SANscreen server.
 */
public enum Transport {
    /**
     * Opens a Java RMI connection with the server
     */
    RMI("RMI"),
    /**
     * Opens a RMI connection tunnelled through HTTP / HTTPS
     */
    RMI_OVER_HTTP("RMI-OVER-HTTP");

    private String e;

    private Transport(final String e) {
        this.e = e;
    }

    public static Transport fromConfiguration(final String configurationString) throws FrameworkException {
        for (Transport s : Transport.values()) {
            if (s.e.equals(configurationString))
                return s;
        }

        throw new FrameworkException("Invalid transport type '" + configurationString + "'");
    }
}



