package com.onaro.sanscreen.acquisition.netappfoundation.datasource;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import com.onaro.sanscreen.acquisition.framework.FrameworkException;
import com.onaro.sanscreen.acquisition.framework.datasource.BaseDataSource;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import com.onaro.sanscreen.acquisition.framework.datasource.PollingPackage;
import com.onaro.sanscreen.acquisition.netappfoundation.datasource.config.NetAppFoundationConfiguration;


public class NetAppFoundationReplayListener extends NetAppFoundationListener {
    private final static Logger logger = Logger.getLogger(NetAppFoundationReplayListener.class);
    
    protected long originatorID;;
    
    public NetAppFoundationReplayListener(final NetAppFoundationConfiguration configuration, final long originatorID) {
        super(configuration);
        this.originatorID = originatorID; 
    }
    
    @Override
    public long getOriginatorID(final Long datasourceID, final String originatorKey, final String originatorDisplayName) throws FrameworkException {
        return originatorID;
    }

    @Override
    public void deleteOriginatorID(final Long originatorID, final String originatorKey) throws FrameworkException {
        logger.info("Deleting originator id");
    }
    
    @Override
    public void startingSample(final BaseDataSource dataSource, final PollingPackage pollType) {
        logger.info("Starting sample");
    }

    @Override
    public void sampleSuccessfull(final BaseDataSource baseDataSource, final PollingPackage aPackage) throws FrameworkException {
        logger.info("Sample successfull");
    }

    @Override
    public void finishedSample(final BaseDataSource dataSource, final PollingPackage aPackage) throws FrameworkException {
        logger.info("Finished sample");
    }

    @Override
    public void sampleFailed(final BaseDataSource dataSource, final PollingPackage aPackage, final DataSourceErrorException e) {
        logger.error("Sample failed: " + e.getMessage(), e);
    }

    @Override
    public void sampleFailed(final BaseDataSource dataSource, final PollingPackage aPackage, final Throwable e) {
        logger.error("Sample failed: " + e.getMessage(), e);
    }
}
