package com.onaro.sanscreen.acquisition.netappschema.netappdata;

import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEResourceType;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIETable;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.KeyBase;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.util.EnumMap;


// TODO DEPRECATE ME
@OCIETable("disk")
@OCIEResourceType("disk")
public class DiskOwnerNodeRelationship extends BaseCRCXMLNode<Cluster> {

    private final DiskOwnerKey key;
    private final Node.NodeKey nodeKey;
    private final Disk.DiskKey diskKey;

    DiskOwnerNodeRelationship(final Cluster parent, final Node.NodeKey nodeKey, final Disk.DiskKey diskKey) {
        super(parent, "DiskOwnerNodeRelationship");
        final String nodeUUID = nodeKey.getOcieUUID();
        final String diskUUID = diskKey.getOcieUUID();
        this.key = new DiskOwnerKey(parent.getClusterUUID(), nodeUUID, diskUUID);
        this.nodeKey = nodeKey;
        this.diskKey = diskKey;
    }

    @SuppressWarnings({"UnusedDeclaration"})    
    public String getNodeUUID() {
        return key.getID(DiskOwnerKey.Field.node_uuid);
    }


    @Override
    @SuppressWarnings({"unchecked"})
    public DiskOwnerKey getKey() {
        return key;
    }

    public final static class DiskOwnerKey extends KeyBase<DiskOwnerKey.Field> {
        public static enum Field {
            cluster_uuid,
            node_uuid,
            disk_uuid
        }

        public DiskOwnerKey(final String clusterUUID, final String nodeUUID, final String diskUID) {
            super("disk",
                  new EnumMap<Field, String>(Field.class) {{
                        put(Field.cluster_uuid, clusterUUID);
                        put(Field.node_uuid, nodeUUID);
                        put(Field.disk_uuid, diskUID);
                  }});
        }

        public String getOcieUUID() {
            return getID(Field.node_uuid) + '.' + getID(Field.disk_uuid);
        }
    }

    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributesToFileAndCRC(marshallingCache, writer);
//        addRequiredAttributeAndCRC(writer, "ResourceKey", key);
        addRequiredAttributeAndCRC(writer, "DiskUUID", diskKey.getOcieUUID());
        addRequiredAttributeAndCRC(writer, "NodeUUID", nodeKey.getOcieUUID());
    }
}
