package com.onaro.sanscreen.acquisition.netappschema.netappdata;

import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEResourceType;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIETable;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEValue;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEZapiSource;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;


@OCIETable("node")
@OCIEResourceType("node")
public class HaPair extends BaseCRCXMLNode<Cluster> {

    @OCIEZapiSource(
        sourceZapi = "cf-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.storage-failover-info.node-name"
    )
    @OCIEValue(
        ocieColumn = "name"
    )
    private final Node.NodeKey keyA;

    @OCIEZapiSource(
        sourceZapi = "cf-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.storage-failover-info.partner-name"
    )
    @OCIEValue(
        ocieColumn = "partner-node-id"
    )
    private Node.NodeKey keyB;

    HaPair(final Cluster parentCluster, final Node.NodeKey nodeAKey) {
        super(parentCluster, "HAPair");
        this.keyA = nodeAKey;
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public Node.NodeKey getKey() {
        return keyA;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Node.NodeKey getNodeBUUID() {
        return keyB;
    }

    public void setNodeBUUID(final Node.NodeKey nodeBUUID) {
        this.keyB = nodeBUUID;
    }

    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributesToFileAndCRC(marshallingCache, writer);
//        addRequiredAttributeAndCRC(writer, "ResourceKey", keyA);
        addRequiredAttributeAndCRC(writer, "Node1UUID", keyA.getOcieUUID());
        addRequiredAttributeAndCRC(writer, "Node2UUID", keyB.getOcieUUID());
    }
}
