package com.onaro.sanscreen.acquisition.netappschema.netappdata;

import com.onaro.sanscreen.acquisition.schema.StreamingCRCRoot;

/**
 * Defines the basic functionality of a odata root object.
 *
 * <p/>Each acquisition report is sent to the SANscreen server in XML format. On the data source package implementation
 * side, building this report is done by utilizing the odata schema library (<code>com.onaro.sanscreen.acquisition.schema.odata.*</code>).
 *
 * <p/>To start building an <code>odata</code> object tree, a <code>Root</code> object has to be created. Using the {@link RootFactory}
 * factory class, root of different kinds can be created, depending on the type of report the data source will generate.
 * There is a specific root object for every type of report that can be generated by the package.
 *
 * <p/>A package implementation can choose to report more than one roots in a single sample (this is achieved by construction
 * a "Multiple Originator ID (MOID)" package).
 */
public interface NetAppRoot extends StreamingCRCRoot {

}
