package com.onaro.sanscreen.acquisition.netappschema.netappdata;

import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.annotations.*;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.KeyBase;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.util.EnumMap;

@OCIETable("network_failover_group_network_port_relationship")
@OCIEResourceType("network_failover_group_network_port_relationship")
public class NetworkFailoverGroupNetworkPortRelationship extends BaseCRCXMLNode<Cluster> {

    public final static class NetworkFailoverGroupNetworkPortRelationshipKey extends KeyBase<NetworkFailoverGroupNetworkPortRelationshipKey.Field> {
        public static enum Field {
            @OCIEZapiSource(
                    sourceZapi = "net-failover-group-get-iter",
                    zapiResponsePath = "netapp.results.attributes-list.failover-group",
                    notes = "SN: Uses a different XML then FS "
            )
            network_failover_group_uuid,

            @OCIEZapiSource(
                    sourceZapi = "net-failover-group-get-iter",
                    zapiResponsePath = "netapp.results.attributes-list.failover-group.target",
                    notes = "SN: Uses a different XML then FS "
            )
            network_port_uuid
        }

        public NetworkFailoverGroupNetworkPortRelationshipKey(final String networkFailoverGroupUUID, final String networkPortUUID) {
            super("network_failover_group_network_port_relationship",
                    new EnumMap<Field, String>(Field.class) {{
                        put(Field.network_failover_group_uuid, networkFailoverGroupUUID);
                        put(Field.network_port_uuid, networkPortUUID);
                    }});
        }

        @Override
        @OCIEUUID(uuidDescr = "network_failover_group_uuid.network_port_uuid")
        public String getOcieUUID() {
            final String networkFailoverGroupUUID = getID(Field.network_failover_group_uuid);
            final String networkPortUUID = getID(Field.network_port_uuid);
            return networkFailoverGroupUUID + '.' + networkPortUUID;
        }
    }

    @OCIEZapiSource(
            sourceZapi = "net-failover-group-get-iter",
            zapiResponsePath = "netapp.results.attributes-list.failover-group.target",
            notes = "SN: Uses a different XML then FS "
    )
    @OCIEValue(
            ocieColumn = "nodeId"
    )
    private final Node.NodeKey nodeKey;

    @OCIEZapiSource(
            sourceZapi = "net-failover-group-get-iter",
            zapiResponsePath = "netapp.results.attributes-list.failover-group.target",
            notes = "SN: Uses a different XML then FS "
    )
    @OCIEValue(
            ocieColumn = "networkFailoverGroupId"
    )
    private final NetworkFailoverGroup.NetworkFailoverGroupKey networkFailoverGroupKey;

    @OCIEZapiSource(
            sourceZapi = "net-failover-group-get-iter",
            zapiResponsePath = "netapp.results.attributes-list.failover-group.target",
            notes = "SN: Uses a different XML then FS "
    )
    @OCIEValue(
            ocieColumn = "networkPortId"
    )
    private final NetworkPort.PortKey networkPortKey;


    private final NetworkFailoverGroupNetworkPortRelationshipKey key;

    protected NetworkFailoverGroupNetworkPortRelationship(final Cluster cluster, final Node.NodeKey nodeKey, final NetworkFailoverGroup.NetworkFailoverGroupKey networkFailoverGroupKey, final NetworkPort.PortKey networkPortIdKey) {
        super(cluster, NetworkFailoverGroupNetworkPortRelationship.class.getSimpleName());
        this.key = new NetworkFailoverGroupNetworkPortRelationshipKey(networkFailoverGroupKey.getOcieUUID(), networkPortIdKey.getOcieUUID());
        this.nodeKey = nodeKey;
        this.networkFailoverGroupKey = networkFailoverGroupKey;
        this.networkPortKey = networkPortIdKey;
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public NetworkFailoverGroupNetworkPortRelationshipKey getKey() {
        return this.key;
    }

    public NetworkFailoverGroup.NetworkFailoverGroupKey getNetworkFailoverGroupKey() {
        return networkFailoverGroupKey;
    }

    public NetworkPort.PortKey getNetworkPortKey() {
        return networkPortKey;
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache cache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributesToFileAndCRC(cache, writer);
        addRequiredAttributeAndCRC(writer, "UUID", key.getOcieUUID());
        addRequiredAttributeAndCRC(writer, "ResourceKey", key);
        addRequiredAttributeAndCRC(writer, "NodeUUID", nodeKey.getOcieUUID());
        addRequiredAttributeAndCRC(writer, "NetworkFailoverGroupUUID", networkFailoverGroupKey.getOcieUUID());
        addRequiredAttributeAndCRC(writer, "NetworkPortUUID", networkPortKey.getOcieUUID());
    }
}
