package com.onaro.sanscreen.acquisition.netappschema.netappdata;

import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEResourceType;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIETable;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEValue;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEZapiSource;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.KeyBase;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;

@OCIETable("network_lif")
@OCIEResourceType("network_lif")
public class NetworkLif extends BaseCRCXMLNode<VServer> {

    public static final String KEY_TYPE = "network_lif";
    private final Lif.LifKey key;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.interface-name"
    )
    @OCIEValue(
        ocieColumn = "name"
    )
    private String interfaceName;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.current-node"
    )
    @OCIEValue(
        ocieColumn = "currentNodeId"
    )
    private Node.NodeKey currentNodeKey;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.current-port"
    )
    @OCIEValue(
        ocieColumn = "currentPortId"
    )
    private NetworkPort.PortKey currentPortKey;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.home-node"
    )
    @OCIEValue(
        ocieColumn = "homeNodeId"
    )
    private Node.NodeKey homeNodeKey;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.home-port"
    )
    @OCIEValue(
        ocieColumn = "homePortId"
    )
    private NetworkPort.PortKey homePortKey;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.is-auto-revert"
    )
    @OCIEValue(
        ocieColumn = "isAutoRevert"
    )
    private Boolean isAutoRevert;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.is-home"
    )
    @OCIEValue(
        ocieColumn = "isHome"
    )
    private Boolean isHome;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.address"
    )
    @OCIEValue(
        ocieColumn = "address"
    )
    private String ipAddress;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.netmask"
    )
    @OCIEValue(
        ocieColumn = "netmask"
    )
    private String networkMask;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.netmask-length"
    )
    @OCIEValue(
        ocieColumn = "netmaskLength"
    )
    private Integer netmaskLen;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.dns-domain-name"
    )
    @OCIEValue(
        ocieColumn = "dnsDomainName"
    )
    private String dnsDomainName;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.routing-group-name"
    )
    @OCIEValue(
        ocieColumn = "routingGroupId"
    )
    private RoutingGroup.RoutingGroupKey routingGroupKey;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.operational-status"
    )
    @OCIEValue(
        ocieColumn = "operationalStatus"
    )
    private Lif.Status operStatus;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.operational-status"
    )
    @OCIEValue(
        ocieColumn = "operationalStatusRaw"
    )
    private String operStatusRaw;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.administrative-status"
    )
    @OCIEValue(
        ocieColumn = "administrativeStatus"
    )
    private Lif.Status adminStatus;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.administrative-status"
    )
    @OCIEValue(
        ocieColumn = "administrativeStatusRaw"
    )
    private String adminStatusRaw;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.roll"
    )
    @OCIEValue(
        ocieColumn = "role"
    )
    private Lif.Role role;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.roll"
    )
    @OCIEValue(
        ocieColumn = "roleRaw"
    )
    private String roleRaw;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.data-protocols.data-protocol"
    )
    @OCIEValue(
        ocieColumn = "dataProtocols"
    )
    private String dataProtocols;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.failover-group"
    )
    @OCIEValue(
        ocieColumn = "failoverGroupId"
    )
    private NetworkFailoverGroup.NetworkFailoverGroupKey failoverGroupKey;

    @OCIEZapiSource(
            sourceZapi = "net-interface-get-iter",
            zapiResponsePath = "netapp.results.attributes-list.net-interface-info.failover-group"
    )
    @OCIEValue(
            ocieColumn = "failoverGroup"
    )
    private String failoverGroupName;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.failover-policy"
    )
    @OCIEValue(
        ocieColumn = "failoverPolicy"
    )
    private Lif.FailoverPolicy failoverPolicy;

    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.failover-policy"
    )
    @OCIEValue(
        ocieColumn = "failoverPolicyRaw"
    )
    private String failoverPolicyRaw;
    
    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.is-dns-update-enabled"
    )
    @OCIEValue(
        ocieColumn = "isDNSUpdateEnabled"
    )
    private Boolean isDNSUpdateEnabled;
    
    @OCIEZapiSource(
        sourceZapi = "net-interface-get-iter",
        zapiResponsePath = "netapp.results.attributes-list.net-interface-info.listen-for-dns-query"
    )
    @OCIEValue(
        ocieColumn = "listenForDNSQuery"
    )
    private Boolean listenForDNSQuery;

    public NetworkLif(final VServer parent, final String lifUUID) {
        super(parent, "NetworkLIF");
        final VServer.VServerKey parentKey = parent.getKey();

        this.key = new Lif.LifKey(KEY_TYPE, parentKey.getID(VServer.VServerKey.Field.cluster_uuid), parentKey.getOcieUUID(), lifUUID);
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public Lif.LifKey getKey() {
        return key;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getInterfaceName() {
        return interfaceName;
    }

    public void setInterfaceName(final String interfaceName) {
        this.interfaceName = interfaceName;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Node.NodeKey getCurrentNodeKey() {
        return currentNodeKey;
    }

    public void setCurrentNodeKey(final Node.NodeKey currentNodeKey) {
        this.currentNodeKey = currentNodeKey;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public NetworkPort.PortKey getCurrentPortKey() {
        return currentPortKey;
    }

    public void setCurrentPortKey(final NetworkPort.PortKey currentPortKey) {
        this.currentPortKey = currentPortKey;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Node.NodeKey getHomeNodeKey() {
        return homeNodeKey;
    }

    public void setHomeNodeKey(final Node.NodeKey homeNodeKey) {
        this.homeNodeKey = homeNodeKey;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public NetworkPort.PortKey getHomePortKey() {
        return homePortKey;
    }

    public void setHomePortKey(final NetworkPort.PortKey homePortKey) {
        this.homePortKey = homePortKey;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Boolean getAutoRevert() {
        return isAutoRevert;
    }

    public void setAutoRevert(final Boolean autoRevert) {
        isAutoRevert = autoRevert;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Boolean getHome() {
        return isHome;
    }

    public void setHome(final Boolean home) {
        isHome = home;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getIpAddress() {
        return ipAddress;
    }

    public void setIpAddress(final String ipAddress) {
        this.ipAddress = ipAddress;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getNetworkMask() {
        return networkMask;
    }

    public void setNetworkMask(final String networkMask) {
        this.networkMask = networkMask;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Integer getNetmaskLen() {
        return netmaskLen;
    }

    public void setNetmaskLen(final Integer netmaskLen) {
        this.netmaskLen = netmaskLen;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getDnsDomainName() {
        return dnsDomainName;
    }

    public void setDnsDomainName(final String dnsDomainName) {
        this.dnsDomainName = dnsDomainName;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public RoutingGroup.RoutingGroupKey getRoutingGroupUUID() {
        return routingGroupKey;
    }

    public void setRoutingGroupKey(final RoutingGroup.RoutingGroupKey routingGroupKey) {
        this.routingGroupKey = routingGroupKey;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Lif.Status getOperStatus() {
        return operStatus;
    }

    public void setOperStatus(final Lif.Status operStatus) {
        this.operStatus = operStatus;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getOperStatusRaw() {
        return operStatusRaw;
    }

    public void setOperStatusRaw(final String operStatusRaw) {
        this.operStatusRaw = operStatusRaw;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Lif.Status getAdminStatus() {
        return adminStatus;
    }

    public void setAdminStatus(final Lif.Status adminStatus) {
        this.adminStatus = adminStatus;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getAdminStatusRaw() {
        return adminStatusRaw;
    }

    public void setAdminStatusRaw(final String adminStatusRaw) {
        this.adminStatusRaw = adminStatusRaw;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Lif.Role getRole() {
        return role;
    }

    public void setRole(final Lif.Role role) {
        this.role = role;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getRoleRaw() {
        return roleRaw;
    }

    public void setRoleRaw(final String roleRaw) {
        this.roleRaw = roleRaw;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getDataProtocols() {
        return dataProtocols;
    }

    public void setDataProtocols(final String dataProtocols) {
        this.dataProtocols = dataProtocols;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getFailoverGroupName()
    {
      return failoverGroupName;
    }

    public void setFailoverGroupName(String failoverGroupName)
    {
      this.failoverGroupName = failoverGroupName;
    }

  @SuppressWarnings({"UnusedDeclaration"})
    public Lif.FailoverPolicy getFailoverPolicy() {
        return failoverPolicy;
    }

    public void setFailoverPolicy(final Lif.FailoverPolicy failoverPolicy) {
        this.failoverPolicy = failoverPolicy;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public String getFailoverPolicyRaw() {
        return failoverPolicyRaw;
    }

    public void setFailoverPolicyRaw(final String failoverPolicyRaw) {
        this.failoverPolicyRaw = failoverPolicyRaw;
    }
    
    @SuppressWarnings({"UnusedDeclaration"})
    public Boolean getIsDNSUpdateEnabled() {
        return isDNSUpdateEnabled;
    }

    public void setIsDNSUpdateEnabled(final Boolean isDNSUpdateEnabled) {
        this.isDNSUpdateEnabled = isDNSUpdateEnabled;
    }

    @SuppressWarnings({"UnusedDeclaration"})
    public Boolean getListenForDNSQuery() {
        return listenForDNSQuery;
    }

    public void setListenForDNSQuery(final Boolean listenForDNSQuery) {
        this.listenForDNSQuery = listenForDNSQuery;
    }
    
    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributesToFileAndCRC(marshallingCache, writer);
        addRequiredAttributeAndCRC(writer, "ResourceKey", key);
        addRequiredAttributeAndCRC(writer, "UUID", key.getOcieUUID());
        addRequiredAttributeAndCRC(writer, "Name", interfaceName);
        addRequiredAttributeAndCRC(writer, "CurrentNodeUUID", KeyBase.getOcieUUIDOrNull(currentNodeKey));
        addRequiredAttributeAndCRC(writer, "CurrentPortUUID", KeyBase.getOcieUUIDOrNull(currentPortKey));
        addRequiredAttributeAndCRC(writer, "HomeNodeUUID", KeyBase.getOcieUUIDOrNull(homeNodeKey));
        addRequiredAttributeAndCRC(writer, "HomePortUUID", KeyBase.getOcieUUIDOrNull(homePortKey));
        addRequiredAttributeAndCRC(writer, "IsAutoRevert", isAutoRevert);
        addRequiredAttributeAndCRC(writer, "IsHome", isHome);
        addRequiredAttributeAndCRC(writer, "Address", ipAddress);
        addRequiredAttributeAndCRC(writer, "Netmask", networkMask);
        addRequiredAttributeAndCRC(writer, "NetmaskLength", netmaskLen);
        addRequiredAttributeAndCRC(writer, "DNSDomainName", dnsDomainName);
        addRequiredAttributeAndCRC(writer, "RoutingGroupUUID", KeyBase.getOcieUUIDOrNull(routingGroupKey));
        addRequiredAttributeAndCRC(writer, "OperationalStatus", operStatus);
        addRequiredAttributeAndCRC(writer, "OperationalStatusRaw", operStatusRaw);
        addRequiredAttributeAndCRC(writer, "AdministrativeStatus", adminStatus);
        addRequiredAttributeAndCRC(writer, "AdministrativeStatusRaw", adminStatusRaw);
        addRequiredAttributeAndCRC(writer, "Role", role);
        addRequiredAttributeAndCRC(writer, "RoleRaw", roleRaw);
        addRequiredAttributeAndCRC(writer, "DataProtocols", dataProtocols);
        addRequiredAttributeAndCRC(writer, "FailoverGroup", failoverGroupName);
        addRequiredAttributeAndCRC(writer, "FailoverPolicy", failoverPolicy);
        addRequiredAttributeAndCRC(writer, "FailoverPolicyRaw", failoverPolicyRaw);
        addRequiredAttributeAndCRC(writer, "IsDNSUpdateEnabled", isDNSUpdateEnabled);
        addRequiredAttributeAndCRC(writer, "ListenForDNSQuery", listenForDNSQuery);
    }
}
