package com.onaro.sanscreen.acquisition.netappschema.netappdata;

import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileCRCWriter;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIEResourceType;
import com.onaro.sanscreen.acquisition.netappschema.annotations.OCIETable;
import com.onaro.sanscreen.acquisition.schema.BaseCRCXMLNode;
import com.onaro.sanscreen.acquisition.schema.KeyBase;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.util.EnumMap;

@OCIETable("snapshot_policy")
@OCIEResourceType("snapshot_policy")
public class SnapshotPolicyVserverRelationship extends BaseCRCXMLNode<Cluster> {

    private final SnapshotPolicyVserverRelationshipKey key;
    private final SnapshotPolicy.SnapshotPolicyKey snapshotPolicyKey;
    final VServer.VServerKey vServerKey;


    SnapshotPolicyVserverRelationship(final Cluster parent, final SnapshotPolicy.SnapshotPolicyKey snapshotPolicyKey, final VServer.VServerKey vServerKey) {
        super(parent, "SnapshotPolicyVserverRelationship");
        this.key = new SnapshotPolicyVserverRelationshipKey(parent.getClusterUUID(), snapshotPolicyKey.getID(SnapshotPolicy.SnapshotPolicyKey.Field.name), vServerKey.getZapiUUID());
        this.snapshotPolicyKey = snapshotPolicyKey;
        this.vServerKey = vServerKey;
    }

    @Override
    @SuppressWarnings({"unchecked"})
    public SnapshotPolicyVserverRelationshipKey getKey() {
        return key;
    }

    public final static class SnapshotPolicyVserverRelationshipKey extends KeyBase<SnapshotPolicyVserverRelationshipKey.Field> {
        public static enum Field {
            cluster_uuid,
            snapshot_policy_name,
            vserver_uuid
        }

        public SnapshotPolicyVserverRelationshipKey(final String clusterUUID, final String snapshotPolicyUUID, final String vServerUUID) {
            super("snapshot_policy_relationship", new EnumMap<Field, String>(Field.class) {{
                put(Field.cluster_uuid, clusterUUID);
                put(Field.snapshot_policy_name, snapshotPolicyUUID);
                put(Field.vserver_uuid, vServerUUID);
            }});
        }

        public String getOcieUUID() {
            return getFQID();
        }
    }

    @Override
    protected void marshallAttributesToFileAndCRC(final MarshallingCache marshallingCache, final DSFileCRCWriter writer) throws IOException, SchemaException {
        super.marshallAttributesToFileAndCRC(marshallingCache, writer);
        // addRequiredAttributeAndCRC(writer, "ResourceKey", key);
        addRequiredAttributeAndCRC(writer, "SnapshotPolicyUUID", snapshotPolicyKey.getOcieUUID());
        addRequiredAttributeAndCRC(writer, "VserverUUID", vServerKey.getOcieUUID());
    }
}
