package com.onaro.sanscreen.acquisition.netappstorageperformance.datasource;

import com.netapp.acquisition.aquisitionserverside.interfaces.remote.AcquisitionServerSession;
import com.netapp.oci.netapp.interfaces.data.NetappInterfaceException;
import com.netapp.oci.netapp.performance.aggregate.interfaces.data.AggregateMeasurements;
import com.netapp.oci.netapp.performance.aggregate.interfaces.data.AggregateRawMeasurements;
import com.netapp.oci.netapp.performance.aggregate.interfaces.data.WaflHyaAggrMeasurements;
import com.netapp.oci.netapp.performance.aggregate.interfaces.remote.AggregatePerformanceRemote;
import com.netapp.oci.netapp.performance.cifsvserver.interfaces.data.CifsVserverMeasurements;
import com.netapp.oci.netapp.performance.cifsvserver.interfaces.data.CifsVserverRawMeasurements;
import com.netapp.oci.netapp.performance.cifsvserver.interfaces.remote.CifsVserverPerformanceRemote;
import com.netapp.oci.netapp.performance.cluster.interfaces.data.ClusterMeasurements;
import com.netapp.oci.netapp.performance.cluster.interfaces.remote.ClusterPerformanceRemote;
import com.netapp.oci.netapp.performance.disk.interfaces.data.DiskMeasurements;
import com.netapp.oci.netapp.performance.disk.interfaces.data.DiskRawMeasurements;
import com.netapp.oci.netapp.performance.disk.interfaces.remote.DiskPerformanceRemote;
import com.netapp.oci.netapp.performance.ext_cache_obj.interfaces.data.ExtCacheObjMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifRawMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifVserverMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifVserverRawMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.remote.FcpLifPerformanceRemote;
import com.netapp.oci.netapp.performance.fcplif.interfaces.remote.FcpLifVserverPerformanceRemote;
import com.netapp.oci.netapp.performance.fcpport.interfaces.data.FcpPortMeasurements;
import com.netapp.oci.netapp.performance.fcpport.interfaces.data.FcpPortRawMeasurements;
import com.netapp.oci.netapp.performance.fcpport.interfaces.remote.FcpPortPerformanceRemote;
import com.netapp.oci.netapp.performance.hostadapter.interfaces.data.HostadapterMeasurements;
import com.netapp.oci.netapp.performance.hostadapter.interfaces.remote.HostadapterPerformanceRemote;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifRawMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifVserverMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifVserverRawMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.remote.IscsiLifPerformanceRemote;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.remote.IscsiLifVserverPerformanceRemote;
import com.netapp.oci.netapp.performance.lun.interfaces.data.LunMeasurements;
import com.netapp.oci.netapp.performance.lun.interfaces.data.LunRawMeasurements;
import com.netapp.oci.netapp.performance.lun.interfaces.remote.LunPerformanceRemote;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifRawMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifVserverMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifVserverRawMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.remote.NetworkLifPerformanceRemote;
import com.netapp.oci.netapp.performance.networklif.interfaces.remote.NetworkLifVserverPerformanceRemote;
import com.netapp.oci.netapp.performance.networkport.interfaces.data.NetworkPortMeasurements;
import com.netapp.oci.netapp.performance.networkport.interfaces.remote.NetworkPortPerformanceRemote;
import com.netapp.oci.netapp.performance.nfs.interfaces.data.*;
import com.netapp.oci.netapp.performance.nfs.interfaces.remote.NfsPerformanceRemote;
import com.netapp.oci.netapp.performance.nfs.interfaces.remote.Nfsv3PerformanceRemote;
import com.netapp.oci.netapp.performance.nfs.interfaces.remote.Nfsv41PerformanceRemote;
import com.netapp.oci.netapp.performance.nfs.interfaces.remote.Nfsv4PerformanceRemote;
import com.netapp.oci.netapp.performance.nic.interfaces.data.NicMeasurements;
import com.netapp.oci.netapp.performance.nic.interfaces.data.NicRawMeasurements;
import com.netapp.oci.netapp.performance.nic.interfaces.remote.NicPerformanceRemote;
import com.netapp.oci.netapp.performance.node.interfaces.data.*;
import com.netapp.oci.netapp.performance.node.interfaces.remote.NodePerformanceRemote;
import com.netapp.oci.netapp.performance.processor.interfaces.data.ProcessorMeasurements;
import com.netapp.oci.netapp.performance.processor.interfaces.remote.ProcessorPerformanceRemote;
import com.netapp.oci.netapp.performance.qosservicecenter.interfaces.data.QosServiceCenterMeasurements;
import com.netapp.oci.netapp.performance.qosservicecenter.interfaces.remote.QosServiceCenterPerformanceRemote;
import com.netapp.oci.netapp.performance.qosworkload.interfaces.data.QosVolumeWorkloadMeasurements;
import com.netapp.oci.netapp.performance.qosworkload.interfaces.remote.QosVolumeWorkloadPerformanceRemote;
import com.netapp.oci.netapp.performance.qosworkloaddblade.interfaces.data.QosWorkloadQueueDBladeMeasurements;
import com.netapp.oci.netapp.performance.qosworkloaddblade.interfaces.remote.QosWorkloadQueueDBladePerformanceRemote;
import com.netapp.oci.netapp.performance.qosworkloaddetail.interfaces.data.QosWorkloadDetailMeasurements;
import com.netapp.oci.netapp.performance.qosworkloaddetail.interfaces.remote.QosWorkloadDetailPerformanceRemote;
import com.netapp.oci.netapp.performance.qosworkloadnblade.interfaces.data.QosWorkloadQueueNBladeMeasurements;
import com.netapp.oci.netapp.performance.qosworkloadnblade.interfaces.remote.QosWorkloadQueueNBladePerformanceRemote;
import com.netapp.oci.netapp.performance.volume.interfaces.data.VolumeMeasurements;
import com.netapp.oci.netapp.performance.volume.interfaces.data.VolumeRawMeasurements;
import com.netapp.oci.netapp.performance.volume.interfaces.remote.VolumePerformanceRemote;
import com.netapp.oci.netapp.performance.volumenode.interfaces.data.VolumeNodeMeasurements;
import com.netapp.oci.netapp.performance.vserver.interfaces.data.VolumeVserverMeasurements;
import com.netapp.oci.netapp.performance.vserver.interfaces.data.VserverMeasurements;
import com.netapp.oci.netapp.performance.vserver.interfaces.remote.VolumeVserverPerformanceRemote;
import com.netapp.oci.netapp.performance.vserver.interfaces.remote.VserverPerformanceRemote;
import com.netapp.oci.netapp.performance.wafl.interfaces.data.WaflMeasurements;
import com.netapp.oci.netapp.performance.wafl.interfaces.remote.WaflPerformanceRemote;
import com.netapp.oci.platform.acq.interfaces.data.PackagePollCompleteStatus;
import com.netapp.oci.platform.acq.interfaces.remote.AcquisitionStatusRemote;
import com.netapp.oci.platform.common.interfaces.data.performance.RawSample;
import com.onaro.sanscreen.acquisition.framework.FrameworkException;
import com.onaro.sanscreen.acquisition.framework.datasource.*;
import com.onaro.sanscreen.acquisition.framework.datasource.Package;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFile;
import com.onaro.sanscreen.acquisition.framework.datasource.io.DSFileWriter;
import com.onaro.sanscreen.acquisition.framework.mgmt.ServiceManager;
import com.onaro.sanscreen.acquisition.netappfoundation.datasource.NetAppClockSynchronizer;
import com.onaro.sanscreen.acquisition.netappfoundation.datasource.config.NetAppFoundationConfiguration;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.Cluster;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.Cluster.ClusterKey;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.VServer;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.VServer.VServerKey;
import com.onaro.sanscreen.acquisition.netappstorageperformance.datasource.config.NetAppStoragePerformanceConfiguration;
import com.onaro.sanscreen.server.interfaces.data.ServerInterfaceException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.File;
import java.io.IOException;
import java.util.Collection;
import java.util.Date;
import java.util.List;

@SuppressWarnings("rawtypes")
public class NetAppStoragePerformanceListener implements NetAppStoragePerformanceUpdatesListener, NetAppClockSynchronizer, DataSourceSampleListener {
    private static final Logger LOG = LoggerFactory.getLogger(NetAppStoragePerformanceListener.class);
    
    private static final String FINISHED_SEND_DEBUG_MSG = "{} - Finished sending {} performance to server ({} msecs)";

	private final NetAppStoragePerformanceConfiguration netAppStoragePerformanceConfiguration;
    private final AuditSession auditSession;

    public NetAppStoragePerformanceListener(final NetAppStoragePerformanceConfiguration netAppStoragePerformanceConfiguration) {
        this.netAppStoragePerformanceConfiguration = netAppStoragePerformanceConfiguration;
        auditSession = new AuditSession(this.netAppStoragePerformanceConfiguration);
    }

    public void recordingSessionDone(final BaseDataSource dataSource,
                                     final PollingPackage aPackage,
                                     final File recordingSession,
                                     final boolean shouldReport) throws FrameworkException {
        try {
            if (recordingSession != null && shouldReport) {
                final long reportStartTime = System.currentTimeMillis();
                ServiceManager.getInstance().getLogsManager().sendZipToServer(ServiceManager.getInstance().getAcquisitionUnitManager().getAcquisitionUnit().getName(), recordingSession);
                final long reportEndTime = System.currentTimeMillis();
                final long reportDuration = reportEndTime - reportStartTime;
                LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "performance zip", reportDuration});
            }
        }
        catch (IOException e) {
            throw new FrameworkException("Failed to send ZIP file: " + e.getMessage(), e);
        }
    }

    public boolean reportAggregatePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<AggregateMeasurements>> samples, final long leaseTime) {

        try {
            final AggregatePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(AggregatePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportAggregateData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportAggregateSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Aggregate", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportAggregateRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<AggregateRawMeasurements>> samples, final long leaseTime) {

        try {
            final AggregatePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(AggregatePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportAggregateRawData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportAggregateRawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Aggregate raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportCifsVserverRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<CifsVserverRawMeasurements>> samples, final long leaseTime) {

        try {
            final CifsVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(CifsVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportCifsVserverRawData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportCifsVserverRawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending cifs:vserver raw performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportCifsVserverPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<CifsVserverMeasurements>> samples, final long leaseTime) {

        try {
            final CifsVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(CifsVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportCifsVserverData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportCifsVserverSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending cifs:vserver performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportLifVserverRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<NetworkLifVserverRawMeasurements>> samples, final long leaseTime) {

        try {
            final NetworkLifVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NetworkLifVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportLifVserverRawData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportLifVserverRawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending lif:vserver raw performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportLifVserverPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<NetworkLifVserverMeasurements>> samples, final long leaseTime) {

        try {
            final NetworkLifVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NetworkLifVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportLifVserverData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportLifVserverSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending lif:vserver performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportNfsv3RawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<Nfsv3RawMeasurements>> samples, final long leaseTime) {

        try {
            final Nfsv3PerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(Nfsv3PerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNfsv3RawData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNfsv3RawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfsv3 raw performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportNfsv3Performance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<Nfsv3Measurements>> samples, final long leaseTime) {

        try {
            final Nfsv3PerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(Nfsv3PerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNfsv3Data(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNfsv3Samples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfsv3 performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportNfsv4RawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<Nfsv4RawMeasurements>> samples, final long leaseTime) {

        try {
            final Nfsv4PerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(Nfsv4PerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNfsv4RawData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNfsv4RawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfsv4 raw performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportNfsv4Performance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<Nfsv4Measurements>> samples, final long leaseTime) {

        try {
            final Nfsv4PerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(Nfsv4PerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNfsv4Data(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNfsv4Samples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfsv4 performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportNfsv41RawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<Nfsv41RawMeasurements>> samples, final long leaseTime) {

        try {
            final Nfsv41PerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(Nfsv41PerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNfsv41RawData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNfsv41RawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfsv41 raw performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportNfsv41Performance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<Nfsv41Measurements>> samples, final long leaseTime) {

        try {
            final Nfsv41PerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(Nfsv41PerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNfsv41Data(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNfsv41Samples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfsv41 performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportNfsPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<NfsMeasurements>> samples, final long leaseTime) {

        try {
            final NfsPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NfsPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNfsData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNfsSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfs performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportVserverPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<VserverMeasurements>> samples, final long leaseTime) {

        try {
            final VserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(VserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportVserverData(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportVserverSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending nfs performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }


    public boolean reportDiskPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<DiskMeasurements>> samples, final long leaseTime) {

        try {
            final DiskPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(DiskPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportDiskSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportDiskSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Disk", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportDiskRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<DiskRawMeasurements>> samples, final long leaseTime) {

        try {
            final DiskPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(DiskPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportDiskRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportDiskRawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Disk raw", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportVolumePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final VServer.VServerKey vServerKey, final long pollStartTime, final Collection<RawSample<VolumeMeasurements>> samples) {
        try {
            final VolumePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(VolumePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportVolumeSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), vServerKey.getOcieUUID(), pollStartTime, samples, -1L);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportVolumeSamples", pollStartTime, vServerKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Volume", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance ", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportVolumePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final VServer.VServerKey vServerKey, final long pollStartTime, final Collection<RawSample<VolumeMeasurements>> samples, final long leaseTime) {
        try {
            final VolumePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(VolumePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportVolumeSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), vServerKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportVolumeSamples", pollStartTime, vServerKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Volume", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }
    
	@Override
	public boolean reportVolumeRawPerformance(NetAppStoragePerformancePackage aPackage, ClusterKey clusterKey, VServerKey vServerKey, long pollStartTime,
			Collection<RawSample<VolumeRawMeasurements>> samples, long leaseTime) {
        try {
            final VolumePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(VolumePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportVolumeRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), vServerKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportVolumeRawSamples", pollStartTime, vServerKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Volume raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e ) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
	}
    

    @Override
    public boolean reportVolumeNodePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long time, final Collection<RawSample<VolumeNodeMeasurements>> samples) {
        // TODO
        return false;
    }

    @Override
    public boolean reportVolumeNodePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long time, final Collection<RawSample<VolumeNodeMeasurements>> samples, final long leaseTime) {
        // TODO
        return false;
    }

    @Override
    public boolean reportLunPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final VServer.VServerKey vServerKey, final long pollStartTime, final Collection<RawSample<LunMeasurements>> samples, final long leaseTime) {
        try {
            final LunPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(LunPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportLunSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), vServerKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportLunSamples", pollStartTime, vServerKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "LUN", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    @Override
	public boolean reportLunRawPerformance(NetAppStoragePerformancePackage aPackage, ClusterKey clusterKey,	VServerKey vServerKey, long pollStartTime, Collection<RawSample<LunRawMeasurements>> samples, long leaseTime) {
        try {
            final LunPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(LunPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportLunRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), vServerKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportLunSamples", pollStartTime, vServerKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "LUN raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance" + e.getMessage(), e);
            return false;
        }
	}
    
    @Override
    public boolean reportNodePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<NodeMeasurements>> samples) {
        return reportNodePerformance(aPackage, clusterKey, pollStartTime, samples, -1);
    }

    @Override
    public boolean reportNodePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<NodeMeasurements>> samples, final long leaseTime) {
        try {
            final NodePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NodePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNodeSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNodeSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Node", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    @Override
    public boolean reportNodeRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<NodeRawMeasurements>> samples, final long leaseTime) {
        try {
            final NodePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NodePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNodeRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNodeSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Node raw", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }
    
    @Override
    public boolean reportFcpLifPerformance(final NetAppStoragePerformancePackage aPackage, 
                                           final Cluster.ClusterKey clusterKey, 
                                           final VServer.VServerKey key, 
                                           final long pollStartTime, 
                                           final Collection<RawSample<FcpLifMeasurements>> samples, final long leaseTime) {
        try {
            final FcpLifPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(FcpLifPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportFcpLifSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportFcpLifSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "FCP Lif", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    @Override
    public boolean reportFcpLifVserverPerformance(final NetAppStoragePerformancePackage aPackage, 
                                           final Cluster.ClusterKey clusterKey, 
                                           final long pollStartTime, 
                                           final Collection<RawSample<FcpLifVserverMeasurements>> samples, final long leaseTime) {
        try {
            final FcpLifVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(FcpLifVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportFcpLifVserverSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportFcpLifVserverSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "FcpLifVserver", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }
    
    @Override
    public boolean reportFcpLifRawPerformance(final NetAppStoragePerformancePackage aPackage, 
                                              final Cluster.ClusterKey clusterKey, 
                                              final VServer.VServerKey key, 
                                              final long pollStartTime, 
                                              final Collection<RawSample<FcpLifRawMeasurements>> samples, final long leaseTime) {
        try {
            final FcpLifPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(FcpLifPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportFcpLifRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), 
                                           clusterKey.getOcieUUID(), 
                                           key.getOcieUUID(), 
                                           pollStartTime, 
                                           samples, 
                                           leaseTime);

            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportFcpLifRawSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending FCP Lif raw performance to server (" + reportDuration + " msecs)");
            
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    @Override
    public boolean reportFcpLifVserverRawPerformance(final NetAppStoragePerformancePackage aPackage, 
                                              final Cluster.ClusterKey clusterKey, 
                                              final long pollStartTime, 
                                              final Collection<RawSample<FcpLifVserverRawMeasurements>> samples, final long leaseTime) {
        try {
            final FcpLifVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(FcpLifVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportFcpLifVserverRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), 
                                           clusterKey.getOcieUUID(), 
                                           pollStartTime, 
                                           samples, 
                                           leaseTime);

            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportFcpLifVserverRawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending FcpLifVserver raw performance to server (" + reportDuration + " msecs)");
            
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportFcpPortPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<FcpPortMeasurements>> samples, final long leaseTime) {
        try {
            final FcpPortPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(FcpPortPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportFcpPortSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportFcpPortSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "FCP Port", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportFcpPortRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<FcpPortRawMeasurements>> samples, final long leaseTime) {
        try {
            final FcpPortPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(FcpPortPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportFcpPortRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportFcpPortRawSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "FCP Port Raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportIpPortPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<NetworkPortMeasurements>> samples, final long leaseTime) {
        try {
            final NetworkPortPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NetworkPortPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNetworkPortSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNetworkPortSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "IP Port", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportNicRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<NicRawMeasurements>> samples, final long leaseTime) {
        try {
            final NicPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NicPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNicRawData(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNicRawSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Nic raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to nic raw report performance " + e.getMessage(), e);
            return false;
        }
    }
    
    public boolean reportNicPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<NicMeasurements>> samples, final long leaseTime) {
        try {
            final NicPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NicPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNicData(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNicSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Nic raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to nic report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportVolumeVServerPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<VolumeVserverMeasurements>> samples, final long leaseTime) {
        try {
            final VolumeVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(VolumeVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportVolumeVserverSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportVolumeVserverSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "VolumeVServer", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    @Override
    public boolean reportLifPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final long pollStartTime, final Collection<RawSample<NetworkLifMeasurements>> samples, final long leaseTime) {
        try {
            final NetworkLifPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NetworkLifPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNetworkLifSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNetworkLifSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Network LIF", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

	@Override
	public boolean reportLifRawPerformance(NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final VServerKey key, final long pollStartTime, final Collection<RawSample<NetworkLifRawMeasurements>> samples, final long leaseTime) {
        try {
            final NetworkLifPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(NetworkLifPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportNetworkLifRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportNetworkLifRawSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Network LIF raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
	}
    
    @Override
    public boolean reportIscsiLifPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final long pollStartTime, final Collection<RawSample<IscsiLifMeasurements>> samples, final long leaseTime) {
        try {
            final IscsiLifPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(IscsiLifPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportIscsiLifSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportIscsiLifSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "iSCSI LIF", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }

    }
    
    @Override
    public boolean reportIscsiLifRawPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final long pollStartTime, final Collection<RawSample<IscsiLifRawMeasurements>> samples, final long leaseTime) {
        try {
            final IscsiLifPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(IscsiLifPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportIscsiLifRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportIscsiLifRawSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "iSCSI LIF raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }

    }

    @Override
    public boolean reportIscsiLifVserverPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<IscsiLifVserverMeasurements>> samples, final long leaseTime) {
        try {
            final IscsiLifVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(IscsiLifVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportIscsiLifVserverSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportIscsiLifVserverSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "iSCSI LIF Vserver", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }

    }

	@Override
	public boolean reportIscsiLifVserverRawPerformance(NetAppStoragePerformancePackage aPackage, ClusterKey clusterKey,	long pollStartTime, Collection<RawSample<IscsiLifVserverRawMeasurements>> samples, long leaseTime) {
        try {
            final IscsiLifVserverPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(IscsiLifVserverPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportIscsiLifVserverRawSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportIscsiLifRawSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "iSCSI LIF Vserver raw", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }

	}
   
    @Override
    public boolean reportProcessorPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<ProcessorMeasurements>> samples, final long leaseTime) {
        try {
            final ProcessorPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(ProcessorPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportProcessorSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportProcessorSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Processor", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }

        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportQosVolumeWorkloadPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<QosVolumeWorkloadMeasurements>> samples) {
        return reportQosVolumeWorkloadPerformance(aPackage, clusterKey, pollStartTime, samples, -1l);
    }

    public boolean reportQosVolumeWorkloadPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<QosVolumeWorkloadMeasurements>> samples, final long leaseTime) {
        try {
            final QosVolumeWorkloadPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(QosVolumeWorkloadPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportQosVolumeWorkloadRemoteSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportQosVolumeWorkloadRemoteSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Workload", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportQosWorkloadDetailPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<QosWorkloadDetailMeasurements>> samples) {
        return reportQosWorkloadDetailPerformance(aPackage, clusterKey, pollStartTime, samples, -1l);
    }

    public boolean reportQosWorkloadDetailPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<QosWorkloadDetailMeasurements>> samples, final long leaseTime) {
        try {
            final QosWorkloadDetailPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(QosWorkloadDetailPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportQosWorkloadDetailSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportQosWorkloadDetailSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(aPackage.getLogPrefix() + " - Finished sending Workload performance to server (" + reportDuration + " msecs)");
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportQosWorkloadQueueDBladePerformance(final NetAppStoragePerformancePackage aPackage,
                                                           final Cluster.ClusterKey clusterKey, final long pollStartTime,
                                                           final Collection<RawSample<QosWorkloadQueueDBladeMeasurements>> samples) {
        return reportQosWorkloadQueueDBladePerformance(aPackage, clusterKey, pollStartTime, samples, -1l);
    }

    public boolean reportQosWorkloadQueueDBladePerformance(final NetAppStoragePerformancePackage aPackage,
                                                           final Cluster.ClusterKey clusterKey, final long pollStartTime,
                                                           final Collection<RawSample<QosWorkloadQueueDBladeMeasurements>> samples,
                                                           final long leaseTime) {
        try {
            final QosWorkloadQueueDBladePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(QosWorkloadQueueDBladePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportQosWorkloadQueueDBladeRemoteSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportQosWorkloadQueueDBladeSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Workload Queue DBlade", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    public boolean reportQosWorkloadQueueNBladePerformance(final NetAppStoragePerformancePackage aPackage,
                                                           final Cluster.ClusterKey clusterKey, final long pollStartTime,
                                                           final Collection<RawSample<QosWorkloadQueueNBladeMeasurements>> samples) {
        return reportQosWorkloadQueueNBladePerformance(aPackage, clusterKey, pollStartTime, samples, -1l);
    }

    public boolean reportQosWorkloadQueueNBladePerformance(final NetAppStoragePerformancePackage aPackage,
                                                           final Cluster.ClusterKey clusterKey, final long pollStartTime,
                                                           final Collection<RawSample<QosWorkloadQueueNBladeMeasurements>> samples,
                                                           final long leaseTime) {
        try {
            final QosWorkloadQueueNBladePerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(QosWorkloadQueueNBladePerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportQosWorkloadQueueNBladeRemoteSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportQosWorkloadQueueNBladeSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Workload Queue NBlade", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }


    @Override
    public boolean reportQosServiceCenterPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<QosServiceCenterMeasurements>> samples) {
        return reportQosServiceCenterPerformance(aPackage, clusterKey, pollStartTime, samples, -1L);
    }

    @Override
    public boolean reportQosServiceCenterPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<QosServiceCenterMeasurements>> samples, final long leaseTime) {
        try {
            final QosServiceCenterPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(QosServiceCenterPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportQosServiceCenterSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportQosServiceCenterSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Service Center", reportDuration});
            return true;
        }
        catch (FrameworkException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
            return false;
        }
        catch (NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
            return false;
        }
    }

    @Override
    public boolean reportWaflPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<WaflMeasurements>> samples) {
        return reportWaflPerformance(aPackage, clusterKey, pollStartTime, samples, -1L);
    }

    @Override
    public boolean reportWaflPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<WaflMeasurements>> samples, final long leaseTime) {
    	        try {
    	            final WaflPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(WaflPerformanceRemote.JNDI_NAME);
    	            final long reportStartTime = System.currentTimeMillis();
    	            session.reportWaflSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
    	            final long reportEndTime = System.currentTimeMillis();
    	            final long reportDuration = reportEndTime - reportStartTime;
    	            recordReportTime("reportWaflSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
    	            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Wafl", reportDuration});
    	            return true;
    	        }
    	        catch (FrameworkException e) {
    	            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
    	            return false;
    	        }
    	        catch (NetappInterfaceException e) {
    	            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
    	            return false;
    	        }
    }

    @Override
    public boolean reportClusterPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<ClusterMeasurements>> samples) {
        return reportClusterPerformance(aPackage, clusterKey, pollStartTime, samples, -1L);
    }

    
    @Override
    public boolean reportClusterPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<ClusterMeasurements>> samples, final long leaseTime) {
    	        try {
    	            final ClusterPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(ClusterPerformanceRemote.JNDI_NAME);
    	            final long reportStartTime = System.currentTimeMillis();
    	            session.reportClusterSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
    	            final long reportEndTime = System.currentTimeMillis();
    	            final long reportDuration = reportEndTime - reportStartTime;
    	            recordReportTime("reportClusterSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
    	            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Cluster", reportDuration});
    	            return true;
    	        }
    	        catch (FrameworkException e) {
    	            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
    	            return false;
    	        }
    	        catch (NetappInterfaceException e) {
    	            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
    	            return false;
    	        }
    }
    
    @Override
    public boolean  reportWaflHyaAggrPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long time, final Collection<RawSample<WaflHyaAggrMeasurements>> samples) {

        return false;
    }

    @Override
    public boolean  reportWaflHyaAggrPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long time, final Collection<RawSample<WaflHyaAggrMeasurements>> samples, long leaseTime) {
        return false;
    }


    @Override
    public boolean reportExtCachePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<ExtCacheObjMeasurements>> samples) {
        return reportExtCachePerformance(aPackage, clusterKey, pollStartTime, samples, -1L);
    }

    @Override
    public boolean reportExtCachePerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey clusterKey, final long pollStartTime, final Collection<RawSample<ExtCacheObjMeasurements>> samples, final long leaseTime) {
        // TODO
        //        try {
        //            final ExtCacheObjPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(ExtCacheObjPerformanceRemote.JNDI_NAME);
        //            final long reportStartTime = System.currentTimeMillis();
        //            session.reportExtCacheObjRemoteSamples(netAppStoragePerformanceConfiguration.getDataSourceID(), clusterKey.getOcieUUID(), pollStartTime, samples, leaseTime);
        //            final long reportEndTime = System.currentTimeMillis();
        //            final long reportDuration = reportEndTime - reportStartTime;
        //            recordReportTime("reportExtCacheSamples", pollStartTime, clusterKey.getOcieUUID(), reportStartTime, reportDuration, samples.size());
        //            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), "Ext Cache Obj", reportDuration});
        //            return true;
        //        }
        //        catch (FrameworkException e) {
        //            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance", e);
        //            return false;
        //        }
        //        catch (NetappInterfaceException e) {
        //            LOG.error(aPackage.getLogPrefix() + " - Failed to report performance " + e.getMessage(), e);
        //            return false;
        //        }
        return false;
    }


    // Node Protocol Counters

    @Override
    public boolean reportCIFSNodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<CIFSNodeMeasurements>> samples) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportCIFSNodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<CIFSNodeMeasurements>> samples, long leaseTime) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportSMB1NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<SMB1NodeMeasurements>> samples) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportSMB1NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<SMB1NodeMeasurements>> samples, long leaseTime) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportSMB2NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<SMB2NodeMeasurements>> samples) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportSMB2NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<SMB2NodeMeasurements>> samples, long leaseTime) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportNFSv3NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<NFSv3NodeMeasurements>> samples) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportNFSv3NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<NFSv3NodeMeasurements>> samples, long leaseTime) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportNFSv4NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<NFSv4NodeMeasurements>> samples) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportNFSv4NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<NFSv4NodeMeasurements>> samples, long leaseTime) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportNFSv41NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<NFSv41NodeMeasurements>> samples) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    @Override
    public boolean reportNFSv41NodePerformance(NetAppStoragePerformancePackage aPackage, Cluster.ClusterKey key, long time, Collection<RawSample<NFSv41NodeMeasurements>> samples, long leaseTime) throws DataSourceErrorException {
        // We are not reporting to the server yet
        return false;
    }

    public long getServerTime() throws FrameworkException {
        return ServiceManager.getInstance().getCommunicationManager().getServerTime();
    }

    public void startingSample(final BaseDataSource dataSource, final PollingPackage pollType) {
        auditSession.createSession("Acquiring device");
    }

    public void sampleSuccessfull(final BaseDataSource dataSource, final PollingPackage aPackage) throws FrameworkException {
        auditSession.updateFinalStatus(AcquisitionServerSession.AuditType.SUCCESS, "Success");
        reportAcqPollStatus(dataSource, aPackage, true);
    }

    public void sampleFailed(final BaseDataSource dataSource, final PollingPackage aPackage, final DataSourceErrorException e) {
        auditSession.updateFinalStatus(e);
        reportAcqPollStatus(dataSource, aPackage, false);
    }

    public void sampleFailed(final BaseDataSource dataSource, final PollingPackage aPackage, final Throwable e) {
        LOG.error(aPackage.getLogPrefix() + " - Unhandled exception: " + e.getMessage(), e);

        //noinspection ThrowableInstanceNeverThrown
        auditSession.updateFinalStatus(new DataSourceErrorException(DataSourceErrorType.INTERNAL_ERROR,
                                                                    "Package " + aPackage.getPackageName() + " Failed with error:" + e.getMessage(),
                                                                    aPackage.getLogPrefix() + " - Unhandled exception: " + e.getMessage(),
                                                                    e));

        reportAcqPollStatus(dataSource, aPackage, false);
    }

    public void finishedSample(final BaseDataSource dataSource, final PollingPackage aPackage) throws FrameworkException {
        auditSession.closeSession(aPackage);
    }

    private void reportAcqPollStatus(final BaseDataSource dataSource, final PollingPackage aPackage, final boolean success) {
        if (dataSource.isStopped()) {
            return;
        }
        final NetAppStoragePerformanceConfiguration performanceConfiguration = (NetAppStoragePerformanceConfiguration) aPackage.getConfiguration();
        final NetAppFoundationConfiguration foundationConfiguration = performanceConfiguration.getNetAppFoundationConfiguration();
        final String packageName = aPackage.getPackageName();
        final NetAppFoundationConfiguration.AcquisitionPollStatus acquisitionPollStatus = foundationConfiguration.getAcquisitionPollStatus(packageName);
        foundationConfiguration.putAcquisitionPollStatus(packageName, null);
        if (acquisitionPollStatus == null) {
            // Expected on first poll when no previous foundation poll exists,
            // and NetAppOCIEPerformancePackage has not been invoked to initialize the poll status
            return;
        }

        if (success && !acquisitionPollStatus.isDataReported()) {
            // Just priming the pipeline with samples for rate calculations
            // and poll start estimates.   No data reported so don't send the
            // message.
            return;
        }

        final PackagePollCompleteStatus packagePollStatus = acquisitionPollStatus.getPackagePollCompleteStatus(success);

        try {
            final AcquisitionStatusRemote acqStatusSession = ServiceManager.getInstance().
                    getCommunicationManager().getSession(AcquisitionStatusRemote.JNDI_NAME);
            if (acqStatusSession == null) {
                LOG.error(dataSource.getDataSourceName() + " - Failed to update AcquisitionStatusRemote packageCompleted "
                             + dataSource.getDataSourceName() + " " + aPackage.getPackageName());
                return;
            }
            acqStatusSession.packageCompleted(NetAppFoundationConfiguration.AcquisitionPollStatus.schema, packagePollStatus);
        }
        catch (FrameworkException fe) {
            LOG.error(dataSource.getDataSourceName() + " - Failed to update AcquisitionStatusRemote packageCompleted "
                         + dataSource.getDataSourceName() + " " + aPackage.getPackageName());
        }
        catch (ServerInterfaceException sie) {
            LOG.error(dataSource.getDataSourceName() + " - Failed to update AcquisitionStatusRemote packageCompleted "
                         + dataSource.getDataSourceName() + " " + aPackage.getPackageName());
        }
    }

    private void recordReportTime(final String apiName, final long pollStartTime, final String parentFoundationUUID, final long apiStartTime, final long reportDurationMS, final long sampleSize) {
        final Package thePackage = PackageContext.getPackage();
        final List<DSFile> fileHandles = thePackage.getRecordingSession().getCurrentSample().getFileHandles();

        final NetAppStoragePerformanceConfiguration performanceConfiguration = (NetAppStoragePerformanceConfiguration) thePackage.getConfiguration();
        final NetAppFoundationConfiguration foundationConfiguration = performanceConfiguration.getNetAppFoundationConfiguration();
        final NetAppFoundationConfiguration.AcquisitionPollStatus pollStatus = foundationConfiguration.getAcquisitionPollStatus(thePackage.getPackageName());
        if (pollStatus != null) {
            pollStatus.recordOCIEReportTime(apiName, reportDurationMS);
        }

        for (final DSFile dsFile : fileHandles) {
            if (dsFile.getFileName().endsWith("ocie_report_times.txt")) {
                final DSFileWriter reportDurationsWriter = (DSFileWriter) dsFile;
                try {
                    reportDurationsWriter.writeln(PackageContext.getPackage().getConfiguration().getDataSourceName() + ", "
                                                  + apiName + ", "
                                                  + parentFoundationUUID + ", "
                                                  + new Date(pollStartTime) + ", "
                                                  + pollStartTime + ", "
                                                  + apiStartTime + ", "
                                                  + reportDurationMS + ", "
                                                  + sampleSize + ", ");
                }
                catch (IOException ioe) {
                    LOG.warn("{} - Failed to record OCIE report time for: {}", PackageContext.getLogPrefix(), apiName);
                }
            }
        }
    }
    
    public boolean reportHostadapterPerformance(final NetAppStoragePerformancePackage aPackage, final Cluster.ClusterKey key, final long pollStartTime, final Collection<RawSample<HostadapterMeasurements>> samples, final long leaseTime) {
        try {
            final HostadapterPerformanceRemote session = ServiceManager.getInstance().getCommunicationManager().getSession(HostadapterPerformanceRemote.JNDI_NAME);
            final long reportStartTime = System.currentTimeMillis();
            session.reportHostadapterData(netAppStoragePerformanceConfiguration.getDataSourceID(), key.getOcieUUID(), pollStartTime, samples, leaseTime);
            final long reportEndTime = System.currentTimeMillis();
            final long reportDuration = reportEndTime - reportStartTime;
            recordReportTime("reportHostadapterSamples", pollStartTime, key.getOcieUUID(), reportStartTime, reportDuration, samples.size());
            LOG.debug(FINISHED_SEND_DEBUG_MSG, new Object[]{aPackage.getLogPrefix(), " Hostadapter ", reportDuration});
            return true;
        }
        catch (FrameworkException | NetappInterfaceException e) {
            LOG.error(aPackage.getLogPrefix() + " - Failed to Hostadapter report performance " + e.getMessage(), e);
            return false;
        }
    }


}
