package com.onaro.sanscreen.acquisition.netappstorageperformance.datasource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.onaro.sanscreen.acquisition.framework.FrameworkException;
import com.onaro.sanscreen.acquisition.framework.datasource.BaseDataSource;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import com.onaro.sanscreen.acquisition.framework.datasource.PollingPackage;
import com.onaro.sanscreen.acquisition.netappstorageperformance.datasource.config.NetAppStoragePerformanceConfiguration;

public class NetAppStoragePerformanceReplayListener extends NetAppStoragePerformanceListener {
    private static final Logger logger = LoggerFactory.getLogger(NetAppStoragePerformanceReplayListener.class);
    
    public NetAppStoragePerformanceReplayListener(final NetAppStoragePerformanceConfiguration netAppStoragePerformanceConfiguration) {
        super(netAppStoragePerformanceConfiguration);
    } 
    
    @Override
    public void startingSample(final BaseDataSource dataSource, final PollingPackage pollType) {
        logger.info("Starting sample"); 
    }
    
    @Override
    public void sampleSuccessfull(final BaseDataSource dataSource, final PollingPackage aPackage) throws FrameworkException {
        logger.info("Sample successfull");
    }

    @Override
    public void sampleFailed(final BaseDataSource dataSource, final PollingPackage aPackage, final DataSourceErrorException e) {
        logger.error("Sample failed: " + e.getMessage(), e);
    }

    @Override
    public void sampleFailed(final BaseDataSource dataSource, final PollingPackage aPackage, final Throwable e) {
        logger.error("Sample failed: " + e.getMessage(), e);
    }

    @Override
    public void finishedSample(final BaseDataSource dataSource, final PollingPackage aPackage) throws FrameworkException {
        logger.info("Finished sample");
    }
}
