package com.onaro.sanscreen.acquisition.netappstorageperformance.datasource;

import com.netapp.oci.netapp.performance.aggregate.interfaces.data.AggregateMeasurements;
import com.netapp.oci.netapp.performance.aggregate.interfaces.data.AggregateRawMeasurements;
import com.netapp.oci.netapp.performance.aggregate.interfaces.data.WaflHyaAggrMeasurements;
import com.netapp.oci.netapp.performance.cifsvserver.interfaces.data.CifsVserverMeasurements;
import com.netapp.oci.netapp.performance.cifsvserver.interfaces.data.CifsVserverRawMeasurements;
import com.netapp.oci.netapp.performance.disk.interfaces.data.DiskMeasurements;
import com.netapp.oci.netapp.performance.disk.interfaces.data.DiskRawMeasurements;
import com.netapp.oci.netapp.performance.ext_cache_obj.interfaces.data.ExtCacheObjMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifRawMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifVserverMeasurements;
import com.netapp.oci.netapp.performance.fcplif.interfaces.data.FcpLifVserverRawMeasurements;
import com.netapp.oci.netapp.performance.fcpport.interfaces.data.FcpPortMeasurements;
import com.netapp.oci.netapp.performance.fcpport.interfaces.data.FcpPortRawMeasurements;
import com.netapp.oci.netapp.performance.hostadapter.interfaces.data.HostadapterMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifRawMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifVserverMeasurements;
import com.netapp.oci.netapp.performance.iscsilif.interfaces.data.IscsiLifVserverRawMeasurements;
import com.netapp.oci.netapp.performance.lun.interfaces.data.LunMeasurements;
import com.netapp.oci.netapp.performance.lun.interfaces.data.LunRawMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifRawMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifVserverMeasurements;
import com.netapp.oci.netapp.performance.networklif.interfaces.data.NetworkLifVserverRawMeasurements;
import com.netapp.oci.netapp.performance.networkport.interfaces.data.NetworkPortMeasurements;
import com.netapp.oci.netapp.performance.nfs.interfaces.data.*;
import com.netapp.oci.netapp.performance.nic.interfaces.data.NicMeasurements;
import com.netapp.oci.netapp.performance.nic.interfaces.data.NicRawMeasurements;
import com.netapp.oci.netapp.performance.node.interfaces.data.*;
import com.netapp.oci.netapp.performance.processor.interfaces.data.ProcessorMeasurements;
import com.netapp.oci.netapp.performance.qosservicecenter.interfaces.data.QosServiceCenterMeasurements;
import com.netapp.oci.netapp.performance.qosworkload.interfaces.data.QosVolumeWorkloadMeasurements;
import com.netapp.oci.netapp.performance.qosworkloaddblade.interfaces.data.QosWorkloadQueueDBladeMeasurements;
import com.netapp.oci.netapp.performance.qosworkloaddetail.interfaces.data.QosWorkloadDetailMeasurements;
import com.netapp.oci.netapp.performance.qosworkloadnblade.interfaces.data.QosWorkloadQueueNBladeMeasurements;
import com.netapp.oci.netapp.performance.volume.interfaces.data.VolumeMeasurements;
import com.netapp.oci.netapp.performance.volume.interfaces.data.VolumeRawMeasurements;
import com.netapp.oci.netapp.performance.volumenode.interfaces.data.VolumeNodeMeasurements;
import com.netapp.oci.netapp.performance.vserver.interfaces.data.VolumeVserverMeasurements;
import com.netapp.oci.netapp.performance.vserver.interfaces.data.VserverMeasurements;
import com.netapp.oci.netapp.performance.wafl.interfaces.data.WaflMeasurements;
import com.netapp.oci.platform.common.interfaces.data.performance.RawSample;
import com.onaro.sanscreen.acquisition.framework.datasource.DataSourceErrorException;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.Cluster;
import com.onaro.sanscreen.acquisition.netappschema.netappdata.VServer;

import java.util.Collection;

public interface NetAppStoragePerformanceReporter {

	public void reportAggregatePerformance(final Cluster.ClusterKey key, final Collection<RawSample<AggregateMeasurements>> samples) throws DataSourceErrorException;
	
    public void reportAggregateRawPerformance(final Cluster.ClusterKey key, final Collection<RawSample<AggregateRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportDiskPerformance(final Cluster.ClusterKey key, final Collection<RawSample<DiskMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportDiskRawPerformance(final Cluster.ClusterKey key, final Collection<RawSample<DiskRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportExtCachePerformance(final Cluster.ClusterKey key, final Collection<RawSample<ExtCacheObjMeasurements>> samples) throws DataSourceErrorException;

    public void reportFcpLifPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<FcpLifMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportFcpLifRawPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<FcpLifRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportFcpLifVserverPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<FcpLifVserverMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportFcpLifVserverRawPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<FcpLifVserverRawMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportFcpPortPerformance(final Cluster.ClusterKey key, final Collection<RawSample<FcpPortMeasurements>> samples) throws DataSourceErrorException;

    public void reportFcpPortRawPerformance(final Cluster.ClusterKey key, final Collection<RawSample<FcpPortRawMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportIpPortPerformance(final Cluster.ClusterKey key, final Collection<RawSample<NetworkPortMeasurements>> samples) throws DataSourceErrorException;

    public void reportNicRawPerformance(final Cluster.ClusterKey key, final Collection<RawSample<NicRawMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportNicPerformance(final Cluster.ClusterKey key, final Collection<RawSample<NicMeasurements>> samples) throws DataSourceErrorException;
 
    public void reportLifPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<NetworkLifMeasurements>> samples) throws DataSourceErrorException;

    public void reportLifRawPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<NetworkLifRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportIscsiLifPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<IscsiLifMeasurements>> samples) throws DataSourceErrorException;

    public void reportIscsiLifRawPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<IscsiLifRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportIscsiLifVserverPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<IscsiLifVserverMeasurements>> samples) throws DataSourceErrorException;

    public void reportIscsiLifVserverRawPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<IscsiLifVserverRawMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportLunPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<LunMeasurements>> samples) throws DataSourceErrorException;

    public void reportLunRawPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<LunRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportCifsVserverRawPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<CifsVserverRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportVserverPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<VserverMeasurements>> samples) throws DataSourceErrorException;

    public void reportCifsVserverPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<CifsVserverMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportNfsv3Performance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<Nfsv3Measurements>> samples) throws DataSourceErrorException;
    
    public void reportNfsv3RawPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<Nfsv3RawMeasurements>> samples) throws DataSourceErrorException;

    public void reportNfsv4Performance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<Nfsv4Measurements>> samples) throws DataSourceErrorException;
    
    public void reportNfsv4RawPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<Nfsv4RawMeasurements>> samples) throws DataSourceErrorException;

    public void reportNfsv41Performance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<Nfsv41Measurements>> samples) throws DataSourceErrorException;
    
    public void reportNfsv41RawPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<Nfsv41RawMeasurements>> samples) throws DataSourceErrorException;

    public void reportNfsPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<NfsMeasurements>> samples) throws DataSourceErrorException;

    public void reportLifVserverPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<NetworkLifVserverMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportLifVserverRawPerformance(final Cluster.ClusterKey clusterKey, final Collection<RawSample<NetworkLifVserverRawMeasurements>> samples) throws DataSourceErrorException;
    
    public void reportNodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<NodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportNodeRawPerformance(final Cluster.ClusterKey key, final Collection<RawSample<NodeRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportProcessorPerformance(final Cluster.ClusterKey key, final Collection<RawSample<ProcessorMeasurements>> samples) throws DataSourceErrorException;

    public void reportVolumePerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<VolumeMeasurements>> samples) throws DataSourceErrorException;

    public void reportVolumeRawPerformance(final Cluster.ClusterKey clusterKey, final VServer.VServerKey key, final Collection<RawSample<VolumeRawMeasurements>> samples) throws DataSourceErrorException;

    public void reportVolumeNodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<VolumeNodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportVolumeVserverPerformance(final Cluster.ClusterKey key, final Collection<RawSample<VolumeVserverMeasurements>> samples) throws DataSourceErrorException;

    public void reportQosVolumeWorkloadPerformance(final Cluster.ClusterKey key, final Collection<RawSample<QosVolumeWorkloadMeasurements>> samples) throws DataSourceErrorException;

    public void reportQosServiceCenterPerformance(final Cluster.ClusterKey key, final Collection<RawSample<QosServiceCenterMeasurements>> samples) throws DataSourceErrorException;

    public void reportWaflPerformance(final Cluster.ClusterKey key, final Collection<RawSample<WaflMeasurements>> samples) throws DataSourceErrorException;

    public void reportWaflHyaAggrPerformance(final Cluster.ClusterKey key, final Collection<RawSample<WaflHyaAggrMeasurements>> samples) throws DataSourceErrorException;
    public void reportCIFSNodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<CIFSNodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportSMB1NodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<SMB1NodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportSMB2NodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<SMB2NodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportNFSv3NodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<NFSv3NodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportNFSv4NodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<NFSv4NodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportNFSv41NodePerformance(final Cluster.ClusterKey key, final Collection<RawSample<NFSv41NodeMeasurements>> samples) throws DataSourceErrorException;

    public void reportQosWorkloadQueueNBladePerformance(final Cluster.ClusterKey key, final Collection<RawSample<QosWorkloadQueueNBladeMeasurements>> samples) throws DataSourceErrorException;

    public void reportQosWorkloadQueueDBladePerformance(final Cluster.ClusterKey key, final Collection<RawSample<QosWorkloadQueueDBladeMeasurements>> samples) throws DataSourceErrorException;

    public void reportQosWorkloadDetailPerformance(final Cluster.ClusterKey key, final Collection<RawSample<QosWorkloadDetailMeasurements>> samples) throws DataSourceErrorException;
			
    public void reportHostadapterPerformance(final Cluster.ClusterKey key, final Collection<RawSample<HostadapterMeasurements>> samples) throws DataSourceErrorException;

    
    public long getCachedServerTime();

    public long getSampleTime();

    public long getCurrentServerTime();
}
