package com.onaro.sanscreen.acquisition.netappstorageperformance.datasource.integrity;

import com.netapp.oci.netapp.performance.disk.interfaces.data.DiskMeasurements;
import com.netapp.oci.platform.common.interfaces.data.performance.RawSample;
import com.onaro.sanscreen.acquisition.framework.datasource.IntegrityException;
import com.onaro.sanscreen.acquisition.netappfoundation.datasource.dependant.integrity.NetAppFoundationDependentIntegrityChecker;
import com.onaro.sanscreen.acquisition.netappfoundation.datasource.dependant.integrity.NetAppIntegrityCheckType;

import java.util.Collection;

public final class NetAppDiskPerformanceIntegrityChecker extends NetAppFoundationDependentIntegrityChecker<DiskMeasurements> {

    public static final int MAX_THROUGHPUT = 1000000;  //MB/s
    public static final int MAX_IOPS = 1000000;

    public NetAppDiskPerformanceIntegrityChecker(final Collection<RawSample<DiskMeasurements>> samples,
                                           final String deviceId,
                                           final String logPrefix) {
        super(samples, deviceId, logPrefix, NetAppIntegrityCheckType.DISK);
    }

    @Override
    public void checkIntegrity() throws IntegrityException {

//        int negativeCount = 0;
//        int accessError = 0;
//        int zeroReadIOPS = 0;
//        int zeroWriteIOPS = 0;
//
//        int maxUtilizationViolations = 0;
//        int maxThroughputViolations = 0;
//        int maxIOPSViolations = 0;
//
//        for (final RawSample<DiskMeasurements> sample : getSamples()) {
//
//            final DiskMeasurements counters = sample.getCounters();
//
//            //check negatives. Note -1 is a flag to the server as an unknown value.
//            if (counters.getReadIops() < -1 || counters.getReadThroughput() < -1
//                || counters.getReadUtilization() < -1 || counters.getWriteIops() < -1
//                || counters.getWriteThroughput() < -1 || counters.getWriteUtilization() < -1) {
//
//                negativeCount++;
//            }
//
//            if (!counters.isAccessed() &&
//                (counters.getReadIops() > 0 && counters.getWriteIops() > 0)) {
//                accessError++;
//            }
//
//            if (counters.getReadUtilization() > 100.0 || counters.getWriteUtilization() > 100.0) {
//                maxUtilizationViolations++;
//            }
//
//            if (counters.getReadThroughput() > MAX_THROUGHPUT || counters.getWriteThroughput() > MAX_THROUGHPUT) {
//                 maxThroughputViolations++;
//            }
//
//            if (counters.getReadIops() > MAX_IOPS || counters.getWriteIops() > MAX_IOPS) {
//                maxIOPSViolations ++;
//            }
//
//        }
//
//        //process error messaging.
//        if (negativeCount > 0) {
//            addError(negativeCount + " disks had illegal negative counter values.");
//        }
//        if (accessError > 0) {
//            addError(accessError + " disks registered  as not being accessed but had finite IOPS.");
//        }
//        if (maxUtilizationViolations > 0) {
//            addError(maxUtilizationViolations + " disks have read and/or write utilization values > 100%.");
//        }
//        if (maxIOPSViolations > 0) {
//            addError(maxIOPSViolations + " disks have suspicious read and/or write IOPS values  > " + MAX_IOPS + " IOP/s");
//        }
//        if (maxThroughputViolations > 0) {
//            addError(maxThroughputViolations + " disks have suspicious read and/or write throughput values  > " + MAX_THROUGHPUT + " MB/s");
//        }
//        if (zeroReadIOPS > 0) {
//            addError(zeroReadIOPS + " disks had zero read IOPS with non-zero read throughput.");
//        }
//        if (zeroWriteIOPS > 0) {
//            addError(zeroWriteIOPS + " disks had zero write IOPS with non-zero write throughput.");
//        }
//
//        if (hasErrors()) {
//            dumpErrors();
//            throw generateException();
//        }

    }

}
