package com.onaro.sanscreen.acquisition.schema;

import java.io.IOException;
import java.io.Writer;

/**
 * Parsed Characted Data Node  
 */
public class PCData<Cache> extends BaseXMLNode<Cache> {
    private String pcdata;

    public PCData(String name, String pcdata) {
        super(name);
        this.pcdata = pcdata;
    }

    public PCData(String name, int pcdata) {
        super(name);
        this.pcdata = String.valueOf(pcdata);
    }

    public PCData(String name, boolean pcdata) {
        super(name);
        this.pcdata = String.valueOf(pcdata);
    }

    public String getPCData() {
        return pcdata;
    }

    public void setPCData(String pcdata) {
        this.pcdata = pcdata;
    }

    public void setPCData(int pcdata) {
        this.pcdata = String.valueOf(pcdata);
    }

    public void setPCData(boolean pcdata) {
        this.pcdata = String.valueOf(pcdata);
    }

    protected void marshallAttributes(final Cache cache, final Writer writer) throws IOException, SchemaException {
        throw new SchemaException(getNodeName() + ": Should not have called marshallAttributes on a PCData node");
    }

    protected void marshallChildren(final Cache cache, final Writer writer, final int tabs) throws IOException, SchemaException {
        throw new SchemaException(getNodeName() + ": Should not have called marshallChildren on a PCData node");
    }

    protected boolean hasChildren() {
        return true;
    }

    /**
     * Override the marshal of this object to handle text values (like &lt;A&gt;text&lt;/A&gt;)
     */
    public void marshall(final Cache cache, final Writer writer, final int tabs) throws IOException, SchemaException {
        for (int i = 0; i < tabs; i++)
            writer.append('\t');

        writer.append("<").append(getNodeName()).append(">");
        writer.append(pcdata != null ? pcdata : "");
        writer.append("</").append(getNodeName()).append(">").append(lineSeperator);
    }
}
