package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.util.Collection;

/**
 * Interface defining the structure of a fabric
 */
public interface FabricRoot extends OData2Root {
    public ChassisSwitches getChassisSwitches();

    public ChassisSwitch createChassisSwitch(final String wwn, final String ip) throws SchemaException;

    public ChassisSwitch createNpvChassisSwitch(final String wwn, final String ip) throws SchemaException;

    public Fabrics getFabrics();

    public Fabrics getNPVFabrics();

    public Fabric createFabric(final String wwn) throws SchemaException;

    public VSAN createVSAN(final String wwn) throws SchemaException;

    public IVRPhysicalFabric createIVRPhysicalFabric(final Collection<String> ivrChassisWWNs) throws SchemaException;

    public IVRPhysicalFabric getIVRPhysicalFabric();

    public void setIVRPhysicalFabric(final IVRPhysicalFabric ivrPhysicalFabric);

    public WWNAlias createSwitchZoneAlias(final String alias, final String wwn) throws SchemaException;

}
