package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.util.Capacity;

import java.io.Serializable;

@SuppressWarnings({"UnusedDeclaration"})
public class InternalVolumeCapacity implements Serializable {
    private Capacity snapshotused;
    private Capacity snapshotAllocated;
    private Capacity dataUsed;
    private Capacity dataAllocated;
    private Capacity totalUsed;
    private Capacity totalAllocated;
    private Capacity rawUsedCapacity;
    private Capacity otherUsedCapacity;
    private Capacity otherAllocatedCapacity;
    private Capacity totalCloneSavedCapacityMB;

    private Capacity totalUsedCapacityFromDevice;


    /**
     *      Used to report the used capacity as reported by the device.
     *  In odata, this is translated to totalUsedCapacityMB_2. This unpleasant name 
     *  should change in version 6.1.
     */
    public Capacity getTotalUsedCapacityFromDevice() {
        return totalUsedCapacityFromDevice;
    }

    /**
     *      Used to report the used capacity as reported by the device.
     *  In odata, this is translated to totalUsedCapacityMB_2. This unpleasant name
     *  should change in version 6.1.
     */
    public void setTotalUsedCapacityFromDevice(final Capacity totalUsedCapacityFromDevice) {
        this.totalUsedCapacityFromDevice = Capacity.create(totalUsedCapacityFromDevice);
    }

    public Capacity getSnapshotUsed() {
        return snapshotused;
    }

    public void setSnapshotused(final Capacity snapshotused) {
        this.snapshotused = Capacity.create(snapshotused);
    }

    public Capacity getSnapshotAllocated() {
        return snapshotAllocated;
    }

    public void setSnapshotAllocated(final Capacity snapshotAllocated) {
        this.snapshotAllocated = Capacity.create(snapshotAllocated);
    }

    public Capacity getDataUsed() {
        return dataUsed;
    }

    public void setDataUsed(final Capacity dataUsed) {
        this.dataUsed = Capacity.create(dataUsed);
    }

    public Capacity getDataAllocated() {
        return dataAllocated;
    }

    public void setDataAllocated(final Capacity dataAllocated) {
        this.dataAllocated = Capacity.create(dataAllocated);
    }

    public Capacity getTotalUsed() {
        return totalUsed;
    }

    public void setTotalUsed(final Capacity totalUsed) {
        this.totalUsed = Capacity.create(totalUsed);
    }

    public Capacity getTotalAllocated() {
        return totalAllocated;
    }

    public void setTotalAllocated(final Capacity totalAllocated) {
        this.totalAllocated = Capacity.create(totalAllocated);
    }

    public Capacity getRawUsedCapacity() {
        return rawUsedCapacity;
    }

    public void setRawUsedCapacity(final Capacity rawUsedCapacity) {
        this.rawUsedCapacity = Capacity.create(rawUsedCapacity);
    }

    public Capacity getOtherUsedCapacity() {
        return otherUsedCapacity;
    }

    public void setOtherUsedCapacity(final Capacity otherUsedCapacity) {
        this.otherUsedCapacity = Capacity.create(otherUsedCapacity);
    }

    public Capacity getOtherAllocatedCapacity() {
        return otherAllocatedCapacity;
    }

    public void setOtherAllocatedCapacity(final Capacity otherAllocatedCapacity) {
        this.otherAllocatedCapacity = Capacity.create(otherAllocatedCapacity);
    }

    public Capacity getTotalCloneSavedCapacityMB() {
        return totalCloneSavedCapacityMB;
    }

    public void setTotalCloneSavedCapacityMB(final Capacity totalCloneSavedCapacityMB) {
        this.totalCloneSavedCapacityMB = Capacity.create(totalCloneSavedCapacityMB);
    }
}
