package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.io.Writer;

public class LogicalSwitch extends FabricSwitchType<VSAN> {
    private final String chassisWWN;

    /**
     * Use {@link VSAN#createLogicalSwitch} to create this object
     */
    LogicalSwitch(final VSAN parent,
                  final String wwn,
                  final String chassisWWN,
                  final int domainID,
                  final Type switchType) throws SchemaException {
        super(parent, "LogicalSwitch", wwn, switchType);

        if (chassisWWN == null || chassisWWN.length() == 0)
            throw new SchemaException(getNodeName() + " Type requires non-null chassisWWN");

        this.domainID = domainID;
        this.chassisWWN = chassisWWN.toUpperCase();
    }

    public String getChassisWWN() {
        return chassisWWN;
    }

    protected void marshallAttributes(final MarshallingCache cache, final Writer writer) throws IOException {
        super.marshallAttributes(cache, writer);

        addAttribute(writer, "ChassisWWN", chassisWWN);
    }

    public void setDomainIDType(final DomainIdType domainIdType) {
        this.domainIDType = domainIdType;
    }

    public DomainIdType getDomainIDType() {
        return this.domainIDType;
    }

    public void setPriority(Integer priority) {
        this.priority = priority;
    }
}
