package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.sanscreen.acquisition.schema.Nodes;

import java.util.Collection;

public class Maps extends Nodes<Volume, VolumeMap> {
    Maps(final Volume parent) {
        super(parent);
    }

    public boolean add(VolumeMap o) {
        // Indicate i n the storage that mapping was defined. Even though we didn't add the mapping yet, this is the most
        // reliableplace to indicate that since we have no call back when the mapping is being added.
        getParent().getStorage().setMappingDefined(true);
        return super.add(o);
    }

    public boolean addAll(Collection<? extends VolumeMap> c) {
        // Indicate in the storage that mapping was defined. Even though we didn't add the mapping yet, this is the most
        // reliable place to indicate that since we have no call back when the mapping is being added.
        getParent().getStorage().setMappingDefined(true);
        return (super.addAll(c));
    }
}
