package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.sanscreen.acquisition.framework.datasource.IntegrityException;
import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.io.Writer;


public class SRMRootImpl extends BaseRootImpl implements SRMRoot {
    SRMRootImpl(final RootFactory parent, final long originatorID, final String originatorType, final String dataSourceName) throws SchemaException {
        super(parent, originatorID, originatorType, dataSourceName);
    }

    public WWNAlias createSRMAlias(final String alias, final String wwn, final WWNAlias.ObjectType objectType) throws SchemaException {
        return new WWNAlias(this, WWNAlias.Source.SRM, alias, wwn, objectType);
    }

    protected void doMarshallChildren(final MarshallingCache cache, final Writer writer, final int tabs) throws IOException, SchemaException {
        // Do nothing since WWNAliases are already added by BaseRootImpl
        super.doMarshallChildren(cache, writer, tabs);
    }

    public void checkIntegrity() throws IntegrityException {
        // We have not yet invented integrity checks for SRM roots
    }

}