package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.util.Capacity;

import java.io.Serializable;


public class StorageCapacity implements Serializable {
    private Capacity rawCapacity = Capacity.create();
    private Capacity spareRaw = Capacity.create();
    private Capacity failedRaw = Capacity.create();

    protected StorageCapacity() {}

    /**
     * @return Total capacity of ALL disks on the device
     */
    public Capacity getRawCapacity() {
        return rawCapacity;
    }

    /**
     * @param rawCapacity Total capacity of ALL disks on the device
     */
    public void setRawCapacity(final Capacity rawCapacity) {
        this.rawCapacity = Capacity.create(rawCapacity);
    }

    /**
     * @return Total capacity of spare disks on the device
     */
    public Capacity getSpareRaw() {
        return spareRaw;
    }

    /**
     * @param spareRaw Total capacity of spare disks on the device
     */
    public void setSpareRaw(final Capacity spareRaw) {
        this.spareRaw = Capacity.create(spareRaw);
    }

    /**
     * @return Total capacity of failed disks on the device
     */
    public Capacity getFailedRaw() {
        return failedRaw;
    }

    /**
     * @param failedRaw Total capacity of failed disks on the device
     */
    public void setFailedRaw(final Capacity failedRaw) {
        this.failedRaw = Capacity.create(failedRaw);
    }
}
