package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.sanscreen.acquisition.schema.MarshallingCache;
import com.onaro.sanscreen.acquisition.schema.SchemaException;

import java.io.IOException;
import java.io.Writer;

/**
 * Represents a storage port
 */
public class StoragePort extends Port<Controller> {
    /**
     * Use {@link Controller#createPort} to create this object
     */

    private String portRole = null;

    StoragePort(final Controller parent, final String wwn) throws SchemaException {
        super(parent, wwn);

        // The unknown connectivity of a storage port is always defaulted to true!
        setUnknownConnectivity(true);
    }

    public final Controller getStorageController() {
        return getParent();
    }


    public String getPortRole() {
        return portRole;
    }

    public void setPortRole(final String portRole) {
        this.portRole = portRole;
    }


    @Override
    protected void marshallAttributes(final MarshallingCache cache, final Writer writer) throws IOException, SchemaException {
        super.marshallAttributes(cache, writer);
        if (portRole != null){
            addAttribute(writer, "PortRole", portRole);
        }
    }
}
