package com.onaro.sanscreen.acquisition.schema.odata2;

import com.onaro.sanscreen.acquisition.schema.SchemaException;

/**
 * Interface defining the structure of a storage
 */
public interface StorageRoot extends OData2Root {
    public DeviceGroups getDeviceGroups();

    public Storages getStorages();

    public Storage createStorage(final String ip) throws SchemaException;

    public WWNAlias createStorageHostAlias(final String alias, final String wwn) throws SchemaException;

    public DeviceGroup createDeviceGroup(final String name, final String storageManagementID) throws SchemaException;

    public boolean isDrPackageInstalled();

    public void setDrPackageInstalled(boolean drPackageInstalled);

    public ISCSINodes getNodes();

    public ISCSIUnKnownNode createISCSIInitiatorNode(final String iscsiNodeName) throws SchemaException;
}
