package com.onaro.sanscreen.acquisition.schema2;

import com.onaro.sanscreen.acquisition.schema.BaseRootFactory;
import com.onaro.sanscreen.acquisition.schema.Info;
import com.onaro.sanscreen.acquisition.schema.Key;
import com.onaro.sanscreen.acquisition.schema.Originator;
import com.onaro.sanscreen.acquisition.schema.OriginatorType;
import com.onaro.sanscreen.acquisition.schema.Root;

/**
 * Base class for all XML model roots.
 * Implements {@link Root} for compatibility with method
 * {@link com.onaro.sanscreen.acquisition.foundation.datasource.BaseFoundationPackage#reportModelData(com.onaro.sanscreen.acquisition.schema.Root)
 * BaseFoundationPackage.reportModelData(Root)}.
 */
abstract public class BaseModelRoot extends XmlRootNode
        implements RootNode, Root {

    protected BaseModelRoot() {
        super("root");
    }

    /** Unused. For compatibility only. */
    @Override
    public BaseRootFactory getParent() {
        return null;
    }

    /** Unused. For compatibility only. */
    @Override
    @SuppressWarnings("unchecked")
    public Key getKey() {
        return null;
    }

    /** Unused. For compatibility only. */
    @Override
    public Info getInfo() {
        return null;
    }

    /** Unused. For compatibility only. */
    @Override
    public OriginatorType getOriginatorType() {
        return null;
    }

    /** Unused. For compatibility only. */
    @Override
    public Originator getOriginator() {
        return null;
    }

    /** Unused. For compatibility only. */
    @Override
    public String getOriginatorKey() {
        return null;
    }

    /** Unused. For compatibility only. */
    @Override
    public void setOriginatorKey(final String originatorKey) {
    }

}
