package com.onaro.sanscreen.acquisition.schema2;

import com.onaro.util.Capacity;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Used to mark fields to be saved as XML node attributes.
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface NodeAttribute {
    /**
     * Allows the attribute name to be explicitly defined, instead of being
     * derived from the field name.
     */
    String name() default "";

    /**
     * Unit to use if the field is of type {@link Capacity}.
     */
    Capacity.Unit unit() default Capacity.Unit.BYTE;
}
