package com.onaro.sanscreen.acquisition.schema2.collect;

import java.io.Serializable;

/**
 * Represents an object with a single immutable key of type <tt>T1</tt>.
 * <p/>
 * It is important that the returned key be immutable, otherwise
 * {@link NodeSet1} will break.
 */
public interface Keyable1<T1 extends Comparable<? super T1> & Serializable> {

    /**
     * @return The immutable value of the first key.
     */
    public T1 getKey1();
}
