package com.onaro.sanscreen.acquisition.schema2.collect;

import java.io.Serializable;

/**
 * Represents an object with three immutable keys of types <tt>T1</tt>,
 * <tt>T2</tt>, and <tt>T3</tt>.
 * <p/>
 * It is important that the returned keys be immutable, otherwise
 * {@link NodeSet3} will break.
 */
public interface Keyable3<T1 extends Comparable<? super T1> & Serializable,
        T2 extends Comparable<? super T2> & Serializable,
        T3 extends Comparable<?super T3> & Serializable>
        extends Keyable2<T1, T2> {

    /**
     * @return The immutable value of the third key.
     */
    public T3 getKey3();
}
