package com.onaro.sanscreen.acquisition.sessions;

import javax.ejb.Local;

/**
 * Acquisition Facade local interaction
 *
 * @author Jason Sprague
 */
@Local
public interface AcquisitionFacadeSessionLocal {

    String JNDI_NAME = "AcquisitionFacadeSessionLocal";

    /**
     * Sets up acquisition server side for use.   Sets appropriate licensing information and deploys DataSource
     * meta-data to acquisition tables.  This prepares system for an AU to check in as well as for the client to
     * properly show Datasource UI screens.
     *
     * <p>This is enforced to happen exactly once per Server environment (current from @link{StartUpServerMBean}).   Further calls will be no-ops.
     *
     * @param force  force the deployment (or re-deployment).  Typically only true in test simulators.
     * @throws AcquisitionUnitException
     */
    void deploy(boolean force) throws AcquisitionUnitException;
}
