package com.onaro.sanscreen.acquisition.util.common;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;

public class FileUtils {

    private final static long serialVersionUID = 1;

    /**
     * Copy the stream 'in' to 'out'.   Closes streams after finishing.   Values should not be null.
     *
     * @param in  BufferedReader to read from.
     * @param out BufferedWriter to write to.
     *
     * @throws java.io.IOException for any copy error.
     */
    public static void copyStream(final BufferedReader in, final BufferedWriter out) throws IOException {

        try {
            char[] buffer = new char[4096];
            int count = in.read(buffer);
            while (count > 0) {
                out.write(buffer, 0, count);
                count = in.read(buffer);
            }
        }
        finally {

            try {
                in.close();
            }
            catch (IOException ioe) {
                //fall through
            }

            try {
                out.close();
            }
            catch (IOException ioe) {
                //fall through
            }
        }
    }
}
