package com.onaro.sanscreen.acquisition.util.resolver;

public class QLogicPortGenerator extends VendorPortGenerator {

    static final String QLOGIC_VENDOR_ID = "00:C0:DD";

    public boolean checkVendor(String chassisWWN) {
        final String vendorID = extractVendorFromWWN(chassisWWN);
        return QLOGIC_VENDOR_ID.equalsIgnoreCase(vendorID);
    }

    public String getVendorName() {
        return "QLogic";
    }

    public String getPortWWN(String chassisWWN, int bladeNumber, int portNumber) throws PortResolverException {

        if (chassisWWN == null)
            throw new IllegalArgumentException("Chassis WWN wasn't set");

        if (bladeNumber != 0)
            throw new IllegalArgumentException("Can't generate the port when blade provided");

        String hexPortNumber = String.format("%1$02X", portNumber);
        return "20:" + hexPortNumber + chassisWWN.substring(5);
    }
}
