package com.onaro.sanscreen.acquisition.util.resolver;

abstract class VendorPortGenerator {
    public abstract boolean checkVendor(String chassisWWN);

    public abstract String getPortWWN(final String chassisWWN, int bladeNumber, int numberOfPorts) throws PortResolverException;

    public abstract String getVendorName();

    protected String extractVendorFromWWN(final String wwn) {
        if (!(wwn.matches("(?:[0-9a-fA-F]{2}\\:){7}[0-9a-fA-F]{2}")))
            return "unknown";

        // http://en.wikipedia.org/wiki/World_Wide_Name
        if (wwn.startsWith("5") || wwn.startsWith("6")) {
            return new StringBuilder().append(wwn.charAt(1)).append(wwn.charAt(3)).append(":").append(wwn.charAt(4)).append(wwn.charAt(6))
                    .append(":").append(wwn.charAt(7)).append(wwn.charAt(9)).toString();
        }

        return wwn.substring(6, 14);
    }
}
