package com.onaro.sanscreen.acquisition.util.servercache;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;

@XmlAccessorType(XmlAccessType.FIELD)
public class ServerStorage {
    @XmlAttribute
    private final long objectId;
    private String displayIp;
    private String family;
    private String identifier;
    private String ip;
    private String model;
    private String name;
    private String serialNumber;
    private String vendor;

    @SuppressWarnings("UnusedDeclaration")
    private ServerStorage() {
        this.objectId = 0L;
    }

    ServerStorage(final long objectId) {
        this.objectId = objectId;
    }

    public long getObjectId() {
        return objectId;
    }

    public String getModel() {
        return model;
    }

    void setModel(final String model) {
        this.model = model;
    }

    public String getSerialNumber() {
        return serialNumber;
    }

    void setSerialNumber(final String serialNumber) {
        this.serialNumber = serialNumber;
    }

    public String getFamily() {
        return family;
    }

    void setFamily(final String family) {
        this.family = family;
    }

    public String getIp() {
        return ip;
    }

    void setIp(final String ip) {
        this.ip = ip;
    }

    public String getIdentifier() {
        return identifier;
    }

    void setIdentifier(final String identifier) {
        this.identifier = identifier;
    }

    public String getDisplayIp() {
        return displayIp;
    }

    void setDisplayIp(final String displayIp) {
        this.displayIp = displayIp;
    }

    public String getName() {
        return name;
    }

    void setName(final String name) {
        this.name = name;
    }

    public String getVendor() {
        return vendor;
    }

    void setVendor(final String vendor) {
        this.vendor = vendor;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final ServerStorage that = (ServerStorage) o;

        if (objectId != that.objectId) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return (int) (objectId ^ (objectId >>> 32));
    }
}
