package com.onaro.sanscreen.acquisition.util.servercache;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;

@XmlAccessorType(XmlAccessType.FIELD)
public class ServerVolume {
    @XmlAttribute
    private final long objectId;
    private long storageObjectId;
    private String name;

    @SuppressWarnings("UnusedDeclaration")
    private ServerVolume() {
        this.objectId = 0L;
    }

    ServerVolume(final long objectId) {
        this.objectId = objectId;
    }

    public long getObjectId() {
        return objectId;
    }

    public long getStorageObjectId() {
        return storageObjectId;
    }

    void setStorageObjectId(final long storageObjectId) {
        this.storageObjectId = storageObjectId;
    }

    public String getName() {
        return name;
    }

    void setName(final String name) {
        this.name = name;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final ServerVolume that = (ServerVolume) o;

        if (objectId != that.objectId) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return (int) (objectId ^ (objectId >>> 32));
    }
}
