package com.onaro.sanscreen.acquisition.util.servercache;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;

@XmlAccessorType(XmlAccessType.FIELD)
public class ServerVolumeMap {
    @XmlAttribute
    private final long objectId;
    private long volumeObjectId;
    private String storagePort;
    private String protocolController;
    private String lun;
    private boolean maskingRequired;

    @SuppressWarnings("UnusedDeclaration")
    private ServerVolumeMap() {
        this.objectId = 0L;
    }

    ServerVolumeMap(final long objectId) {
        this.objectId = objectId;
    }

    public long getObjectId() {
        return objectId;
    }

    public long getVolumeObjectId() {
        return volumeObjectId;
    }

    void setVolumeObjectId(final long volumeObjectId) {
        this.volumeObjectId = volumeObjectId;
    }

    public String getStoragePort() {
        return storagePort;
    }

    void setStoragePort(final String storagePort) {
        this.storagePort = storagePort;
    }

    public String getProtocolController() {
        return protocolController;
    }

    void setProtocolController(final String protocolController) {
        this.protocolController = protocolController;
    }

    public String getLun() {
        return lun;
    }

    void setLun(final String lun) {
        this.lun = lun;
    }

    public boolean isMaskingRequired() {
        return maskingRequired;
    }

    void setMaskingRequired(final boolean maskingRequired) {
        this.maskingRequired = maskingRequired;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final ServerVolumeMap that = (ServerVolumeMap) o;

        if (objectId != that.objectId) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return (int) (objectId ^ (objectId >>> 32));
    }
}
