package com.onaro.sanscreen.acquisition.util.servercache;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
class ServerVolumes {
    @XmlJavaTypeAdapter(MapXmlAdapter.class)
    private final Map<Long, Set<ServerVolume>> serverVolumeMap = new HashMap<Long, Set<ServerVolume>>();

    void addServerVolume(final Long storageObjectId, final ServerVolume serverVolume) {
        Set<ServerVolume> serverVolumes = serverVolumeMap.get(storageObjectId);
        if (serverVolumes == null) {
            serverVolumes = new HashSet<ServerVolume>();
            serverVolumeMap.put(storageObjectId, serverVolumes);
        }
        serverVolumes.add(serverVolume);
    }

    void addServerVolumeSet(final Long storageObjectId, final Set<ServerVolume> serverVolumes) {
        serverVolumeMap.put(storageObjectId, serverVolumes);
    }

    Map<Long, Set<ServerVolume>> getServerVolumeMap() {
        return serverVolumeMap;
    }
}
