package com.onaro.sanscreen.server.sessions;

import com.onaro.util.sessions.ClientLogin;
import com.onaro.util.sessions.SessionCache;
import com.onaro.util.sessions.SessionCacheException;

public class SessionFactory {

    private static SessionCache sessionCache = null;

    @SuppressWarnings({"RedundantCast"})
    static public synchronized <E> E createSession(final String sessionJndiName) throws SessionCacheException {
        return (E)createSession(sessionJndiName,true);
    }

    @SuppressWarnings({"RedundantCast"})
    static public synchronized <E> E createSession(final String sessionJndiName, boolean logExceptionsInCache) throws SessionCacheException {
        if (sessionCache == null) {
            sessionCache = new SessionCache(SessionFactory.class.getClassLoader(), new ClientLogin() {
                public void login() {
                }

                public boolean isLoggedIn() {
                    return true;
                }

                public void clean() {
                }

                public String getUser() {
                    return "admin";
                }
            }, 0, logExceptionsInCache);
        }

        return (E) sessionCache.getSession(sessionJndiName);
    }
}
