/*
 * counter_header_data.c
 *
 *  Created on: Dec 17 2014
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include "cmapl_wrapper_header.h"
#define CM_MAX_COUNTERS_PER_OBJECT 512

/**
 * Get a list of all counter header values. (E.g. archive_uuid_hi], dirty_buffers....).
 * Internally called by routine "get_counter_values_for_timestamp"
 */
cmapl_error_t get_counter_info(cmapl_object_handle_t * current_object, uint64_t time_period, const char *cnt_names[], uint32_t * cnt_idx) {
		// get the counter name of each counter at this period for this object
		cmapl_counter_handle_t* current_cnt;
		uint32_t counter_idx = 0;
		cmapl_error_t err_stat = cmapl_first_counter_by_period(current_object, time_period, &current_cnt);
		while (current_cnt != NULL) {
			// get counter info
			cmapl_counter_def_t cnt_info;
			err_stat = cmapl_get_counter_info(current_cnt, &cnt_info);
			if (err_stat != CMAPL_SUCCESS) {
				return  err_stat;
			}

			/* otherwise, store counter name for the query */
			cnt_names[counter_idx++] = cnt_info.name;

			// get next counter at this period for this object
			err_stat = cmapl_next_counter_by_period(current_object, time_period, &current_cnt);
			if (err_stat != CMAPL_SUCCESS) {
				return err_stat;
			}
		}

		*cnt_idx = counter_idx;

	return err_stat;
}


