DROP DATABASE IF EXISTS netapp_performance_view;

DROP DATABASE IF EXISTS netapp_model_view;

DROP DATABASE IF EXISTS netapp_performance;

DROP DATABASE IF EXISTS netapp_model;



DROP DATABASE IF EXISTS management;

CREATE DATABASE management;



CREATE TABLE management.info (

  info varchar(255) default NULL,

  value text,

  PRIMARY KEY (info)

) ENGINE=InnoDB;



CREATE TABLE management.scale (

  time bigint(20) NOT NULL,

  name varchar(255) NOT NULL,

  value bigint(20) NOT NULL,

  KEY `time_index` (`time`)

) ENGINE=InnoDB;



CREATE TABLE management.version (

  source varchar(255) NOT NULL,

  name varchar(255) NOT NULL,

  version varchar(255) NOT NULL,

  installTime bigint(20) NOT NULL,

  PRIMARY KEY (source, name, version, installTime)

) ENGINE=InnoDB;



CREATE TABLE management.id (

  id int(11) PRIMARY KEY,

  value bigint(20)

) ENGINE= InnoDB;



DROP DATABASE IF EXISTS sanscreen;

CREATE DATABASE sanscreen;



CREATE TABLE sanscreen.implicit_commit (

  starttime bigint(20) NOT NULL default '0'

) ENGINE=InnoDB;



CREATE TABLE sanscreen.user (

  userId bigint(20) NOT NULL default '0',

  username varchar(64) default NULL,

  passwd varchar(64) default NULL,

  email varchar(64) default NULL,

  lastLogin bigint(20) NOT NULL default '0',

  active bool,

  PRIMARY KEY (userId)

) ENGINE=InnoDB;



CREATE TABLE sanscreen.user_role (

  userId bigint(20) NOT NULL default '0',

  username varchar(64) NOT NULL default '',

  userRole varchar(64) NOT NULL default '',

  PRIMARY KEY (userId,userRole)

) ENGINE=InnoDB;



DROP database IF EXISTS acquisition;

CREATE database acquisition;



CREATE TABLE  acquisition.au (

  id bigint(20) unsigned auto_increment,

  name varchar(255) NOT NULL,

  ip VARCHAR(45) NOT NULL,

  status VARCHAR(255) NOT NULL,

  leaseperiod BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,

  nextleaserenewal BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY  (id),

  KEY name_index (name),

  CONSTRAINT UNIQUE (name)

) ENGINE=InnoDB ;



CREATE TABLE acquisition.au_attrs (

  id bigint(20) unsigned auto_increment,

  au_id BIGINT(20) UNSIGNED NOT NULL,

  type VARCHAR(255) NOT NULL,

  subtype VARCHAR(255) NOT NULL,

  name VARCHAR(255) NOT NULL,

  value TEXT NOT NULL,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY(id),

  CONSTRAINT UNIQUE business_key (au_id, type, subtype, name),

  CONSTRAINT FK_au_id_attrs FOREIGN KEY (au_id)

  REFERENCES acquisition.au(id)

    ON DELETE CASCADE

)ENGINE=InnoDB;



CREATE TABLE acquisition.au_audit (

  id bigint(20) unsigned auto_increment,

  time bigint(20) NOT NULL default '0',

  au_id BIGINT(20) UNSIGNED NOT NULL,

  status text,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY (id),

  CONSTRAINT UNIQUE (au_id, time),

  CONSTRAINT FK_au_id_audit FOREIGN KEY (au_id)

  REFERENCES acquisition.au(id)

    ON DELETE CASCADE

) ENGINE=InnoDB;



CREATE TABLE acquisition.ds_type(

  id BIGINT(20) UNSIGNED auto_increment,

  name VARCHAR(255) NOT NULL,

  description VARCHAR(255),

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY(`id`)

)ENGINE=InnoDB;



CREATE TABLE acquisition.ds (

  id BIGINT(20) UNSIGNED auto_increment,

  ds_type_id bigint(20) unsigned NOT NULL,

  au_id BIGINT(20) UNSIGNED NOT NULL,

  name VARCHAR(255) NOT NULL,

  vendor VARCHAR(255) NOT NULL,

  model VARCHAR(255) NOT NULL,

  status VARCHAR(255) NOT NULL DEFAULT 'Stopped',

  statusext VARCHAR(255) NOT NULL DEFAULT '',

  time BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,

  manual INT,

  active BOOL,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY(id),

  CONSTRAINT UNIQUE (name),

  CONSTRAINT FK_au_id_ds FOREIGN KEY (au_id)

  REFERENCES acquisition.au (id)

    ON DELETE CASCADE

)ENGINE=InnoDB;







CREATE TABLE  acquisition.ds_type_vendormodel (

  id BIGINT(20) UNSIGNED auto_increment,

  ds_type_id bigint(20) unsigned NOT NULL,

  vendorname varchar(255) NOT NULL,

  vendordescription varchar(255) NOT NULL,

  modelname varchar(255) NOT NULL,

  modeldescription varchar(255) NOT NULL,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY(id),

  KEY FK_ds_type_id_vendormodel (ds_type_id),

  CONSTRAINT FK_ds_type_id FOREIGN KEY (ds_type_id) REFERENCES acquisition.ds_type (id) ON DELETE CASCADE

) ENGINE=InnoDB ;





CREATE TABLE acquisition.ds_type_attrs (

  id BIGINT(20) UNSIGNED auto_increment,

  ds_type_id BIGINT(20) UNSIGNED NOT NULL,

  name VARCHAR(255) NOT NULL,

  value VARCHAR(1024) NOT NULL,

  type VARCHAR(255) DEFAULT 'string',

  role VARCHAR(255) DEFAULT 'optional',

  encrypt BOOL DEFAULT FALSE ,

  editable BOOL DEFAULT TRUE ,

  description VARCHAR(255) DEFAULT '',

  label VARCHAR(255) DEFAULT '',

  min varchar(255) DEFAULT NULL,

  max VARCHAR(255) DEFAULT NULL,

  enum VARCHAR(255) DEFAULT NULL,

  guiorder int,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY(id),

  CONSTRAINT UNIQUE (ds_type_id, name),

  CONSTRAINT FK_ds_type_id_attrs FOREIGN KEY (ds_type_id)

  REFERENCES acquisition.ds_type (id)

    ON DELETE CASCADE

)ENGINE=InnoDB;



CREATE TABLE acquisition.ds_attrs (

  id BIGINT(20) UNSIGNED auto_increment,

  ds_id BIGINT(20) UNSIGNED NOT NULL,

  name VARCHAR(255) NOT NULL,

  value VARCHAR(10240) NOT NULL,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY(id),

  CONSTRAINT UNIQUE (ds_id, name),

  CONSTRAINT FK_ds_id_attr FOREIGN KEY (ds_id)

  REFERENCES acquisition.ds (id)

    ON DELETE CASCADE

)ENGINE=InnoDB;



CREATE TABLE acquisition.ds_audit (

  id bigint(20) NOT NULL auto_increment,

  package varchar(255) NOT NULL default 'Inventory',

  status text,

  type varchar(255) NOT  NULL default 'START',

  uri varchar(255) default NULL,

  ds_id bigint(20) NOT NULL default '0',

  starttime bigint(20) NOT NULL default '0',

  endtime bigint(20) NOT NULL default '0',

  numberoftimes int(11) NOT NULL default '0',

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY (id),

  KEY (ds_id, endtime),

  KEY ds_id_starttime_index (ds_id, starttime)

) ENGINE=InnoDB;



CREATE TABLE acquisition.ds_audit_details (

  id bigint(20) NOT NULL auto_increment,

  audit_id bigint(20) NOT NULL,

  device_key varchar(255) NOT NULL,

  type varchar(255) NOT NULL,

  title text NOT NULL,

  message text NOT NULL,

  version BIGINT(20) UNSIGNED NOT NULL default 0,

  PRIMARY KEY (id),

  KEY audit_id_index (audit_id),

  CONSTRAINT FK_ds_audit_details_id FOREIGN KEY (audit_id) REFERENCES acquisition.ds_audit (id) ON DELETE CASCADE

) ENGINE=InnoDB;



CREATE TABLE acquisition.acquisition_storage_identify (

  storageidentifier varchar(255) NOT NULL,

  storageip varchar(255) NOT NULL,

  PRIMARY KEY (storageIdentifier)

) ENGINE=InnoDB;



CREATE TABLE acquisition.acquisition_volume_identify (

  storageidentifier varchar(255) NOT NULL,

  volumeidentifier varchar(255) NOT NULL,

  volumename varchar(255) NOT NULL,

  PRIMARY KEY (storageIdentifier, volumeIdentifier)

) ENGINE=InnoDB;



CREATE TABLE acquisition.originator (

  ds_id BIGINT(20) UNSIGNED NOT NULL,

  id BIGINT(20) UNSIGNED auto_increment,

  devicekey VARCHAR(255),

  name VARCHAR(255) NOT NULL,

  lastaccesstime bigint(20) NOT NULL,

  PRIMARY KEY(id),

  CONSTRAINT FK_ds_id_originator FOREIGN KEY (ds_id)

  REFERENCES acquisition.ds (id)

    ON DELETE CASCADE

) ENGINE=InnoDB;





INSERT INTO acquisition.au VALUES (0, "local", "127.0.0.1", "Not connected", 60000, 0, 0);



INSERT INTO management.id VALUES(1,1);

INSERT INTO sanscreen.user VALUES(0, "guest","2jmj7l5rSw0yVb/vlWAYkK/YBwk=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(0, "guest","guest");



INSERT INTO sanscreen.user VALUES(1, "admin","+GW1NiOxIf007lQmx5Llwzr4wic=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(1, "admin","guest");

INSERT INTO sanscreen.user_role VALUES(1, "admin","user");

INSERT INTO sanscreen.user_role VALUES(1, "admin","admin");

INSERT INTO sanscreen.user_role VALUES(1, "admin","acquisition");

INSERT INTO sanscreen.user_role VALUES(1, "admin","readmins");

INSERT INTO sanscreen.user_role VALUES(1, "admin","reproauthor");



INSERT INTO sanscreen.user VALUES(2, "user","lclGv2Iu+TsKIRzQ/QKN/fz3454=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(2, "user","guest");

INSERT INTO sanscreen.user_role VALUES(2, "user","user");



INSERT INTO sanscreen.user VALUES(3, "acquisition","x6JaEnAGAFUWj9W0r4v62+02KaA=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(3, "acquisition","acquisition");

INSERT INTO sanscreen.user_role VALUES(3, "acquisition","guest");



INSERT INTO sanscreen.user VALUES(4, "oadmin","8VuvXH/aPAlp8N2ikYVkoyXMMSI=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(4, "oadmin","guest");

INSERT INTO sanscreen.user_role VALUES(4, "oadmin","user");

INSERT INTO sanscreen.user_role VALUES(4, "oadmin","admin");

INSERT INTO sanscreen.user_role VALUES(4, "oadmin","onaroadmin");



INSERT INTO sanscreen.user VALUES(5, "scheduler","FC+BfD7AWG3g+WDBwEgwQ7YaDQY=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(5, "scheduler","scheduler");

INSERT INTO sanscreen.user_role VALUES(5, "scheduler","guest");



INSERT INTO sanscreen.user VALUES(6, "logger","FsxU//JGtEH3DeVIoHMVMS6RLhs=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(6, "logger","logger");



INSERT INTO sanscreen.user VALUES(7, "ssui_client","8/FlMSjUh9Ks7J5o7lnEnkelh28=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(7, "ssui_client","ssui_client");

INSERT INTO sanscreen.user_role VALUES(7, "ssui_client","admin");



INSERT INTO sanscreen.user VALUES(8, "cognos_admin","wLHbi7dWZl/jU9A0HWIjyDgil5A=","", 0, true);

INSERT INTO sanscreen.user_role VALUES(8, "cognos_admin","guest");



INSERT INTO sanscreen.implicit_commit VALUES(0);



commit;

