@echo off
rem Copyright (c) 2015 NetApp, Inc.
rem All rights reserved.

rem parameters
set java=java
set MAINClass="com.netapp.oci.tool.replay.FoundationReplay"
set NETAPP_KEY_BASE=HKEY_LOCAL_MACHINE\SOFTWARE\NetApp
set OCIE_SERVER_NAME=localhost

rem if server passed in use it instead of localhost
if ""=="%1" (
  set OCIE_SERVER_NAME="%1"
)

rem get platform install directory from registry
set COMMAND=get_registry_value.bat "%NETAPP_KEY_BASE%\Platform" "installDir"
FOR /F "usebackq tokens=1 delims=," %%A IN (`%COMMAND%`) DO set platform_install_dir=%%A
if not "%platform_install_dir:not found.=%"=="%platform_install_dir%" (
    echo "Platform not installed - '%COMMAND%' failed"
    goto:eof
)
echo platform_install_dir="%platform_install_dir%"

set ACQ_DIR="%platform_install_dir%\au"

rem Classpath
set Classpath="/opt/netapp/essentials/bin/replay/lib/*"
set Classpath="$Classpath:$ACQ_DIR/conf"
set Classpath="$Classpath:$ACQ_DIR/*"
set Classpath="$Classpath:$ACQ_DIR/lib/*"
set Classpath="$Classpath:$ACQ_DIR/lib/xml/xerces/*"
set Classpath="$Classpath:$ACQ_DIR/lib/xml/jdom/*"
set Classpath="$Classpath:$ACQ_DIR/lib/jboss/client/*"
set Classpath="$Classpath:$ACQ_DIR/lib/xml-3rd/*"
set Classpath="$Classpath:$ACQ_DIR/lib/shared/*"
set Classpath="$Classpath:$ACQ_DIR/../jboss/common/lib/*"

rem echo "#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  "
rem echo "Classpath:"
rem echo $Classpath
rem echo "#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  # "
rem echo ""
rem echo ""

rem JVM Args
set JVMArgs="$JVMArgs -Dlog4j.configuration=ocie-production.xml"
set JVMArgs="$JVMArgs -Donaro.home=/opt/netapp/essentials"
set JVMArgs="$JVMArgs -Dcodebase=https://$OCIE_SERVER_NAME:443"
set JVMArgs="$JVMArgs -Djava.library.path=$ACQ_DIR/bin"
set JVMArgs="$JVMArgs -Dacq.home=$ACQ_DIR"
set JVMArgs="$JVMArgs -Djavax.xml.transform.TransformerFactory=com.icl.saxon.TransformerFactoryImpl"
set JVMArgs="$JVMArgs -Djava.security.properties=$ACQ_DIR/conf/java.security"
rem set JVMArgs="$JVMArgs -Dcom.sun.management.jmxremote=true"
rem set JVMArgs="$JVMArgs -Dcom.sun.management.jmxremote.port=5679"
rem set JVMArgs="$JVMArgs -Dcom.sun.management.jmxremote.ssl=false"
rem set JVMArgs="$JVMArgs -Dcom.sun.management.jmxremote.authenticate=false"
set JVMArgs="$JVMArgs -Xmx2163m"
set JVMArgs="$JVMArgs -Xms256m"
set JVMArgs="$JVMArgs -XX:PermSize=64m"
set JVMArgs="$JVMArgs -XX:MaxPermSize=256m"
set JVMArgs="$JVMArgs -classpath $Classpath"
set JVMArgs="$JVMArgs -Dno.trap=false"
set JVMArgs="$JVMArgs -XX:+HeapDumpOnOutOfMemoryError"
set JVMArgs="$JVMArgs -XX:HeapDumpPath=/var/log/ocie"
set JVMArgs="$JVMArgs -XX:ErrorFile=/var/log/ocieau_error_%p.log"

rem export OCIE_PROFILE_AU=y
if [ -n "$OCIE_PROFILE_AU" ] ; then
    JVMArgs="$JVMArgs -Dprofiler.class=com.onaro.sanscreen.acquisition.framework.mgmt.AcqProfilerService"
    JVMArgs="$JVMArgs -Dprofiler.interval=30"
fi

rem Debugging
rem JVMArgs="$JVMArgs -Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8787"

rem echo "#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #"
rem echo "JVM Args:"
rem echo "%JVMArgs%"
rem echo "#  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #  #"
rem echo ""
rem echo ""

"%java%" "%JVMArgs%" "%MAINClass%" %* 
