@echo off

rem Copyright (c) 2015 NetApp, Inc.
rem All rights reserved.
rem Create a zip archive containing the DB backup and the keystore used to encrypt/decrypt passwords in the DB
if ""=="%1" (
  echo "usage: ocie-backup file"
  goto:eof
)

rem uses the jboss user with no password because it is in the option file
set fileName=%1
set user=-ujboss
set password=
set port=3306
set NETAPP_KEY_BASE=HKEY_LOCAL_MACHINE\SOFTWARE\NetApp

echo fileName="%fileName%".zip

rem get mysql install directory from registry
set COMMAND=get_registry_value.bat "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\MySQL AB\MySQL Server 5.6" "Location"
FOR /F "usebackq tokens=1 delims=," %%A IN (`%COMMAND%`) DO set mysqlbase_dir=%%A
if not "%mysqlbase_dir:not found.=%"=="%mysqlbase_dir%" (
    echo errorMessage="Mysql not installed - '%COMMAND%' failed"
    goto:eof
)
echo mysqlbase_dir="%mysqlbase_dir%"

rem get platform install directory from registry
set COMMAND=get_registry_value.bat "%NETAPP_KEY_BASE%\Platform" "installDir"
FOR /F "usebackq tokens=1 delims=," %%A IN (`%COMMAND%`) DO set platform_install_dir=%%A
if not "%platform_install_dir:not found.=%"=="%platform_install_dir%" (
    echo "Platform not installed - '%COMMAND%' failed"
    goto:eof
)
echo platform_install_dir="%platform_install_dir%"

rem get 7-zip install location
set COMMAND=get_registry_value.bat "HKEY_LOCAL_MACHINE\SOFTWARE\7-Zip" "path"
FOR /F "usebackq tokens=1 delims=," %%A IN (`%COMMAND%`) DO set seven_zip_dir=%%A
if not "%seven_zip_dir:not found.=%"=="%seven_zip_dir%" (
    echo "Platform not installed - '%COMMAND%' failed"
    goto:eof
)
echo seven_zip_dir="%seven_zip_dir%"

rem Stage the keystore
copy "%platform_install_dir%\jboss\server\onaro\cert\originator\netapp.keystore" "%fileName%.keystore"

rem Stage the DB backup
"%mysqlbase_dir%\bin\mysqldump" "%user%" "--port=%port%" --add-drop-database --add-drop-table --single-transaction --no-autocommit --hex-blob --result-file "%fileName%.sql" --databases acquisition sanscreen management netapp_model netapp_model_view netapp_performance

rem Create the archive
"%seven_zip_dir%\7z" a "%fileName%" "%fileName%.keystore" "%fileName%.sql"

rem Cleanup
del "%fileName%.keystore"
del "%fileName%.sql"