#!/bin/sh -e

if [ "" = "$1" ]; then
  echo "usage: ocie-backup.sh file"
  exit 1
fi

# Create a tar archive containing the DB backup and the keystore used to encrypt/decrypt passwords in the DB

# Stage the keystore
cp /opt/netapp/essentials/jboss/server/onaro/cert/originator/netapp.keystore $1.keystore

# Stage the DB backup
/opt/mysql/server-5.6/bin/mysqldump -uroot --port=3306 --add-drop-database --add-drop-table --single-transaction --no-autocommit --hex-blob --result-file $1.sql --databases acquisition sanscreen management netapp_model netapp_model_view netapp_performance

# Create the archive
tar zcvf $1 $1.keystore $1.sql > /dev/null

# Cleanup
rm $1.keystore $1.sql