/*
SQLyog Enterprise - MySQL GUI v8.2 
MySQL - 5.6.18-enterprise-commercial-advanced : Database - netapp_model
*********************************************************************
*/

/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`netapp_model` /*!40100 DEFAULT CHARACTER SET utf8 */;

USE `netapp_model`;

/*Table structure for table `aggregate` */

DROP TABLE IF EXISTS `aggregate`;

CREATE TABLE `aggregate` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: aggr-get-iter.aggr-attributes',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the aggregate',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `type` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of aggregate. Possible values: aggr, trad "aggr" (for aggregates that can contain flexible volumes) "trad" (for aggregates embedded in traditional volumes)',
  `isHybrid` tinyint(1) DEFAULT NULL COMMENT 'If true, aggregate currently contains both SSD and non-SSD RAID groups',
  `isHybridEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, aggregate is eligible to contain both SSD and non-SSD RAID groups',
  `usesSharedDisks` tinyint(1) DEFAULT NULL,
  `state` enum('NOT_MAPPED','CREATING','DESTROYING','FAILED','FROZEN','INCONSISTENT','IRON_RESTRICTED','MOUNTING','ONLINE','OFFLINE','PARTIAL','QUIESCED','QUIESCING','RESTRICTED','REVERTED','UNKNOWN','UNMOUNTED','UNMOUNTING') COLLATE utf8_bin DEFAULT NULL COMMENT 'State of aggregatha_paire',
  `stateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `aggregateType` enum('NOT_MAPPED','HDD','SSD','HYBRID','LUN','VMDISK') COLLATE utf8_bin DEFAULT NULL COMMENT 'Aggregate Type.',
  `aggregateTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw aggregate type.',
  `snapshotSizeTotal` bigint(20) DEFAULT NULL COMMENT 'Total size (in bytes) of the referenced file system. If the referenced file system is restricted or offline, a value 0 is returned',
  `snapshotSizeUsed` bigint(20) DEFAULT NULL COMMENT 'Number of bytes used in the referenced file system. If the referenced file system is restricted or offline, a value of 0 is returned',
  `snapshotSizeAvail` bigint(20) DEFAULT NULL COMMENT 'Number of bytes still available in the referenced file system. ZAPIs: aggr-get-iter aggr-snapshot-attributes size-available',
  `hybridCacheSizeTotal` bigint(20) DEFAULT NULL COMMENT 'Total cache size (in bytes) in a hybrid aggregate. If the referenced aggregate is restricted or offline, or if it is not a hybrid aggregate, a value of 0 is returned',
  `sizeTotal` bigint(20) DEFAULT NULL COMMENT 'Total size (in bytes) of the referenced file system . If the referenced file system is restricted or offline, a value of 0 is returned',
  `sizeUsed` bigint(20) DEFAULT NULL COMMENT 'Number of bytes used in the referenced file system. If the referenced file system is restricted or offline, a value of 0 is returned',
  `sizeUsedPercent` int(11) DEFAULT NULL COMMENT 'Size used on aggregate as a percentage of total.  ZAPIs: aggr-get-iter aggr-space-attributes percent-used-capacity',
  `sizeAvail` bigint(20) DEFAULT NULL COMMENT 'Number of bytes still available in the referenced file system. ZAPIs: aggr-get-iter aggr-space-attributes size-available',
  `sizeAvailPercent` int(11) DEFAULT NULL COMMENT 'DERIVED. Size available on aggregate as a percentage of total.',
  `totalCommitted` bigint(20) DEFAULT NULL COMMENT 'A derived measure of the committed capacity of all Volumes on this Aggregate.  "Committed" here is defined as the total capacity a volume might consume if entirely full.',
  `totalReservedSpace` bigint(20) DEFAULT NULL COMMENT 'The total disk space in bytes that is reserved on the referenced file system. The reserved space is already counted in the used space, so this element can be used to see what portion of the used space represents space reserved for future use',
  `raidStatus` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'RAID status as string',
  `raidType` enum('NOT_MAPPED','RAID_DP','RAID_4','RAID_0','MIXED_RAID_TYPE','RAID4','RAID0') COLLATE utf8_bin DEFAULT NULL,
  `raidTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `mirrorStatus` enum('INVALID','UNINITIALIZED','NEEDS_CP_COUNT_CHECK','CP_COUNT_CHECK_IN_PROGRESS','UNMIRRORED','MIRRORED','MIRROR_DEGRADED','MIRROR_RESYNCHRONIZING','FAILED','LIMBO','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Aggregate''s mirror status, ZAPIs: aggr-get-iter mirror-status',
  `mirrorStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `blockType` enum('32_BIT','64_BIT','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The indirect block format that the aggregate can have. ZAPIs: aggr-get-iter block-type',
  `blockTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `is64BitUpgradeInProgress` tinyint(1) DEFAULT NULL COMMENT 'True if the 64-bit upgrade is in progress. ZAPIs: aggr-get-iter is-64-bit-upgrade-in-progress',
  `volumeDedupeSpaceSavings` bigint(20) DEFAULT NULL COMMENT '[DERVIED] Sum of dedupe savings on SIS enabled Volumes residing on this Aggregate.  In bytes.',
  `volumeCompressionSpaceSavings` bigint(20) DEFAULT NULL COMMENT '[DERVIED] Sum of compression savings on SIS enabled Volumes residing on this Aggregate.  In bytes.',
  `raidSize` bigint(20) DEFAULT NULL COMMENT 'Specifies the maximum number of disks in each RAID group in the aggregate. The maximum value for this parameter is 28. ZAPIs: aggr-get-iter raid-size',
  `hasLocalRoot` tinyint(1) DEFAULT NULL COMMENT 'Whether the aggregate contains the local root volume. ZAPIs: aggr-get-iter has-local-root.',
  `hasPartnerRoot` tinyint(1) DEFAULT NULL COMMENT 'Whether the aggregate contains the partner''s root volume. ZAPIs: aggr-get-iter has-partner-root.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `aggregate_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `aggregate_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `application_record` */

DROP TABLE IF EXISTS `application_record`;

CREATE TABLE `application_record` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of ApplicationRecord. Not from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally',
  `clusterId` bigint(20) NOT NULL,
  `recordName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT ' The name of the record key to set the value.',
  `recordValue` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The value for the record key.',
  `modifiedFrom` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Location from where the value was last modified.',
  `lastModifiedTimestamp` timestamp NULL DEFAULT NULL COMMENT 'Last time the value was modified.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `application_record_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


/*Table structure for table `change_delete_detail` */

DROP TABLE IF EXISTS `change_delete_detail`;

CREATE TABLE `change_delete_detail` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `deleteTime` bigint(20) NOT NULL COMMENT 'The time that the object was deleted',
  `objectType` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Type of the object that was deleted',
  `objId` bigint(20) NOT NULL COMMENT 'ID of the object that was deleted',
  `clusterId` bigint(20) NOT NULL COMMENT 'ID of the cluster associated to the deleted object',
  `nodeId` bigint(20) DEFAULT NULL COMMENT 'ID of the node associated to the object or NULL if object is not a child of node',
  `vserverId` bigint(20) DEFAULT NULL COMMENT 'ID of the vserver associated to the object or NULL if object is not a child of vserver',
  `aggregateId` bigint(20) DEFAULT NULL COMMENT 'ID of the aggregate associated to the object or NULL if object is not a child of aggregate',
  `volumeId` bigint(20) DEFAULT NULL COMMENT 'ID of the volume associated to the object or NULL if object is not a child of volume',
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of deleted object or NULL if object does not have a name',
  `ancestorDeleted` tinyint(1) DEFAULT NULL COMMENT 'True if the object''s node, vserver, aggregate or volume was also removed in the same transaction',
  PRIMARY KEY (`id`),
  KEY `deletetime_index` (`deleteTime`),
  KEY `deletetime_objid_index` (`deleteTime`,`objId`),
  KEY `objid_index` (`objId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `change_record` */

DROP TABLE IF EXISTS `change_record`;

CREATE TABLE `change_record` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `updateTime` bigint(20) NOT NULL COMMENT 'The time that the change was made',
  `clusterId` bigint(20) NOT NULL COMMENT 'Id of the cluster for which this update was made',
  `objId` bigint(20) NOT NULL COMMENT 'Id of the object that was updated',
  `objectType` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Type of the object that was updated',
  `changeType` enum('ADDED','UPDATED','DELETED','PURGED') COLLATE utf8_bin NOT NULL COMMENT 'Type of change',
  PRIMARY KEY (`id`),
  KEY `updatetime_objid_index` (`updateTime`,`objId`),
  KEY `updatetime_clusterId_changeType_objectType_index` (`updateTime`,`clusterId`,`changeType`,`objectType`),
  KEY `objid_index` (`objId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `changed_attribute` */

DROP TABLE IF EXISTS `changed_attribute`;

CREATE TABLE `changed_attribute` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `updateTime` bigint(20) NOT NULL COMMENT 'The time that the change was made',
  `objId` bigint(20) NOT NULL COMMENT 'Id of the object that was updated',
  `attribute` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Name of the attribute that was updated',
  `oldValue` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Attribute value before the update',
  `newValue` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Attribute value after the update',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `cifs_share` */

DROP TABLE IF EXISTS `cifs_share`;

CREATE TABLE `cifs_share` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  cifs-share-get-iter.cifs-share',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the CIFS share. Equal to {ClusterUUID}.{VserverUUID}.{shareName}. Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Name of the CIFS share',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `volumeId` bigint(20) DEFAULT NULL,
  `qtreeId` bigint(20) DEFAULT NULL,
  `path` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The file system path that is shared through this CIFS share',
  `comment` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Description of the CIFS share. CIFS clients see this description when browsing the Vserver''s CIFS shares',
  `shareProperties` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The list of properties for this CIFS share.  Ordered, comma separated values.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `FK_qtreeId` (`qtreeId`),
  KEY `objState_index` (`objState`,`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `cifs_share_acl` */

DROP TABLE IF EXISTS `cifs_share_acl`;

CREATE TABLE `cifs_share_acl` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the CIFS Share Access Control List. Equal to {VserverUUID}.{shareName}.{userOrGroup}  Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `cifsShareId` bigint(20) NOT NULL,
  `userOrGroup` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The user or group name for which the permissions are listed',
  `permission` enum('NOT_MAPPED','NO_ACCESS','READ','CHANGE','FULL_CONTROL') COLLATE utf8_bin DEFAULT NULL COMMENT 'The access rights that the user or group has on the defined CIFS share',
  `permissionRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The access rights that the user or group has on the defined CIFS share - ZAPI raw value',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_cifsShareId` (`cifsShareId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `cifs_share_acl_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `cifs_share_acl_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `cifs_share_acl_ibfk_3` FOREIGN KEY (`cifsShareId`) REFERENCES `cifs_share` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `cluster` */

DROP TABLE IF EXISTS `cluster`;

CREATE TABLE `cluster` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: cluster-identity-get.cluster-identity-info',
  `originid` bigint(20) NOT NULL,
  `datasourceId` bigint(20) DEFAULT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the cluster',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `serialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Serial number',
  `managementIp` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Address used to acquire information about this cluster',
  `version` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Version of the cluster',
  `versionGeneration` int(11) DEFAULT NULL COMMENT 'First integer of the Data ONTAP version tuple corresponding to the lowest version across the cluster',
  `versionMajor` int(11) DEFAULT NULL COMMENT 'Second integer of the Data ONTAP version tuple corresponding to the lowest version across the cluster',
  `versionMinor` int(11) DEFAULT NULL COMMENT 'Third integer of the Data ONTAP version tuple corresponding to the lowest version across the cluster',
  `rawDiskBytesTotal` bigint(20) DEFAULT NULL COMMENT 'Aggregated from disks  regardless of state or role. ZAPIs: storage-disk-get-iter physical-blocks',
  `rawDiskBytesUsed` bigint(20) DEFAULT NULL COMMENT 'Aggregated from disks regardless of state or role. ZAPIs: storage-disk-get-iter used-blocks',
  `contact` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The contact information for the cluster, ZAPIs: cluster-identity-get cluster-contact',
  `location` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The location of the cluster, ZAPIs: cluster-identity-get cluster-location',
  `diagnosisStatus` enum('NOT_MAPPED','OK','OK_WITH_SUPPRESSED','DEGRADED','UNREACHABLE','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'Overall system health as determined by diagnosis framework.',
  `diagnosisStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Overall system health as determined by diagnosis framework - ZAPI raw value',
  `haConfigured` tinyint(1) DEFAULT NULL COMMENT 'This parameter specifies the current state of cluster HA. A boolean value of true means that cluster HA is enabled Attributes: non-creatable, modifiable.',
  `timeZone` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Current timezone name where the storage system is operating.',
  `timeZoneUTC` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Current timezone of the storage system in UTC +/-hhmm format',
  `timeZoneVersion` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Version of the time zone database.',
  `isMetrocluster` tinyint(1) DEFAULT NULL COMMENT 'If cluster is part of a metrocluster.',
  `mtDrPartnerClusterUUID` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'The partner cluster UUID on the metrocluster',
  `mtConfigurationState` enum('UNKNOWN','NOT_REACHABLE','NOT_CONFIGURED','CONFIGURATION_ERROR','PARTIALLY_CONFIGURED','CONFIGURED','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'state of local cluster configuration.',
  `mtConfigurationStateRaw` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'state of local cluster configuration.Raw enum value from ZAPI',
  `mtMode` enum('UNKNOWN','NOT_REACHABLE','NOT_CONFIGURED','NORMAL','SWITCHOVER','WAITING_FOR_SWITCHBACK','PARTIAL_SWITCHOVER','PARTIAL_SWITCHBACK','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL,
  `mtModeRaw` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'Mode of operation of local cluster.Raw enum value from ZAPI',
  `mtDrPartnerClusterId` bigint(20) DEFAULT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `lastUpdateTime` bigint(20) DEFAULT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `disk` */

DROP TABLE IF EXISTS `disk`;

CREATE TABLE `disk` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  storage-disk-get-iter.storage-disk-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the disk',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `uid` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk unique identifier. Maximum length of 90 characters. ZAPIs:  storage-disk-get-iter storage-disk-info disk-uid',
  `clusterId` bigint(20) NOT NULL,
  `homeNodeId` bigint(20) DEFAULT NULL,
  `homeNodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Show homeNodeName so that homeNodeId can be found for home node in remote cluster.',
  `ownerNodeId` bigint(20) DEFAULT NULL,
  `ownerNodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Show ownerNodeName so that ownerNodeId can be found for owner node in remote cluster.',
  `activeNodeId` bigint(20) DEFAULT NULL,
  `activeNodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Show activeNodeName so that activeNodeId can be found for active node in remote cluster.',
  `raidGroupId` bigint(20) DEFAULT NULL,
  `storagePoolId` bigint(20) DEFAULT NULL,
  `partitioningType` enum('NOT_MAPPED','ROOT_DATA','STORAGE_POOL') COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk partitioning Type.',
  `partitioningTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw disk partitioning type.',
  `interfaceType` enum('NOT_MAPPED','ATA','BSAS','EATA','FCAL','LUN','MSATA','SAS','SATA','SCSI','SSD','XATA','XSAS','FSAS','VMDISK','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of disk',
  `interfaceTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `effectiveInterfaceType` enum('NOT_MAPPED','ATA','BSAS','EATA','FCAL','LUN','MSATA','SAS','SATA','SCSI','SSD','XATA','XSAS','FSAS','VMDISK','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'Effective Type of disk',
  `effectiveInterfaceTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `model` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk model string',
  `firmwareRevision` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Firmware revision of disk. The format of the firmware revision will vary depending on the type of disk and its vendor',
  `rpm` int(11) DEFAULT NULL COMMENT 'Disk RPM',
  `serialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk serial number',
  `pool` int(11) DEFAULT NULL COMMENT 'Pool to which disk is assigned.  ZAPIs: storage-disk-get-iter disk-ownership-info pool',
  `checksumCompatibility` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'An indication of the checksum types that this disk is capable of supporting.  ZAPIs: storage-disk-get-iter disk-inventory-info checksum-compatability.',
  `shelf` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk shelf, if it can be determined',
  `shelfBay` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk shelf bay, if it can be determined',
  `vendor` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk vendor',
  `containerType` enum('NOT_MAPPED','AGGREGATE','BROKEN','FOREIGN','LABELMAINT','MAINTENANCE','SPARE','SHARED','UNASSIGNED','VOLUME','UNSUPPORTED','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of overlying disk container',
  `containerTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `isFailed` tinyint(1) DEFAULT NULL COMMENT 'Disk failed',
  `physicalBlocks` bigint(20) DEFAULT NULL COMMENT 'RAID recorded disk capacity expressed in units of 4096-byte blocks',
  `usedBlocks` bigint(20) DEFAULT NULL COMMENT 'RAID recorded size of file system region on this disk, given in units of 4096-byte blocks.',
  `usedBytes` bigint(20) DEFAULT NULL COMMENT 'DERIVED from usedBlocks * 4096 bytes/block.',
  `totalBytes` bigint(20) DEFAULT NULL COMMENT 'DERIVED from totalBlocks * 4096 bytes/block.',
  `usableDataSize` bigint(20) DEFAULT NULL COMMENT 'If non-zero, indicates amount of usable space for a disk partition.',
  `usableRootSize` bigint(20) DEFAULT NULL COMMENT 'If non-zero, indicates amount of usable space for a root partition.',
  `bytesPerSector` bigint(20) DEFAULT NULL COMMENT 'Number of bytes per disk sector. A sector count element, such as `capacity-sectors` and `right-size-sectors`, may be multiplied by this value to convert to a byte count.',
  `raidPosition` enum('NOT_MAPPED','COPY','DATA','DPARITY','ORPHAN','PARITY','PENDING','PRESENT','SHARED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Position of disk relative to its container-type',
  `raidPositionRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `isVirtual` tinyint(1) DEFAULT NULL COMMENT 'To determine if disk is virtual',
  `isZeroed` tinyint(1) DEFAULT NULL COMMENT 'True if disk is in pre-zeroed state. ZAPIs: storage-disk-get-iter disk-aggregate-info is-zeroed',
  `isZeroing` tinyint(1) DEFAULT NULL COMMENT 'True only if disk position is ''pending'' and disk is in process of being zeroed.  ZAPIs:  storage-disk-get-iter disk-aggregate-info is-zeroing',
  `zeroingPercent` int(11) DEFAULT NULL COMMENT 'Percent completion of disk zeroing.  ZAPIs: storage-disk-get-iter disk-aggregate-info zeroing-percent-complete',
  `isMediaScrubbing` tinyint(1) DEFAULT NULL COMMENT 'True if media scrub is currently active for this disk.  ZAPIs: storage-disk-get-iter disk-aggregate-info is-media-scrubbing',
  `isOffline` tinyint(1) DEFAULT NULL COMMENT 'True if disk is offline.  ZAPIs: storage-disk-get-iter disk-aggregate-info is-offline',
  `isPrefailed` tinyint(1) DEFAULT NULL COMMENT 'True if the admin issued a ''disk fail'' or if the the system marked this disk for Rapid RAID Recovery.   ZAPIs: storage-disk-get-iter disk-aggregate-info is-prefailed',
  `isReconstructing` tinyint(1) DEFAULT NULL COMMENT 'True if disk is in process of being reconstructed.   ZAPIs: storage-disk-get-iter disk-aggregate-info is-reconstructing',
  `isReplacing` tinyint(1) DEFAULT NULL COMMENT 'True if the admin issued ''disk replace'' to replace this disk with a specified replacement disk.   ZAPIs: storage-disk-get-iter disk-aggregate-info is-replacing',
  `isShared` tinyint(1) DEFAULT NULL,
  `isLocalAttach` tinyint(1) DEFAULT NULL COMMENT 'Indicator if the disk is locally attached.',
  `capacitySectors` bigint(20) DEFAULT NULL COMMENT 'Total number of disk sectors on this disk, given in units of ''bytes-per-sector''. ZAPI: disk-inventory-info.capacity-sectors',
  `rightSizeSectors` bigint(20) DEFAULT NULL COMMENT 'Number of usable disk sectors that remain after subtracting the right-size adjustment for this disk. Given in units of ''bytes-per-sector''. ZAPI: disk-inventory-info.right-size-sectors',
  `percentSparesConsumed` int(11) DEFAULT NULL COMMENT 'Percentage of device spare blocks that have been used.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `isInFdr` tinyint(1) DEFAULT NULL COMMENT 'True if disk has entry in the persistent Failed Disk Registry. ZAPI: storage-disk-get-iter.disk-raid-info.disk-outage-info.is-in-fdr',
  `failedReason` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Reason disk is not in service. ZAPI: storage-disk-get-iter.disk-raid-info.disk-outage-info.reason',
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_raidGroupid` (`raidGroupId`),
  KEY `FK_homeNodeId` (`homeNodeId`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_storagePoolId` (`storagePoolId`),
  CONSTRAINT `disk_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `disk_ibfk_4` FOREIGN KEY (`raidGroupId`) REFERENCES `raid_group` (`objid`),
  CONSTRAINT `disk_ibfk_5` FOREIGN KEY (`homeNodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `disk_ibfk_6` FOREIGN KEY (`storagePoolId`) REFERENCES `storage_pool` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `disk_aggregate_relationship` */

DROP TABLE IF EXISTS `disk_aggregate_relationship`;

CREATE TABLE `disk_aggregate_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique relationship identifier. ZAPI: aggr-status-get-iter aggr-status-info.aggr-plex-info.aggr-raidgroup-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of this relationship.  DERIVED:{DiskUUID}.{AggregateUUID}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `diskId` bigint(20) NOT NULL,
  `aggregateId` bigint(20) NOT NULL,
  `isCache` tinyint(1) DEFAULT NULL COMMENT 'indicating if the disk is used as cache.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_diskId` (`diskId`),
  KEY `FK_aggregateId` (`aggregateId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `disk_aggregate_relationship_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `disk_aggregate_relationship_ibfk_2` FOREIGN KEY (`diskId`) REFERENCES `disk` (`objid`),
  CONSTRAINT `disk_aggregate_relationship_ibfk_3` FOREIGN KEY (`aggregateId`) REFERENCES `aggregate` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `disk_path` */

DROP TABLE IF EXISTS `disk_path`;

CREATE TABLE `disk_path` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  storage-disk-get-iter.storage-disk-info.disk-paths.disk-path-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'UUID of the Disk Path equivalent to "{diskUUID}.{initiatorName}.{targetWWN}". This is not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `diskId` bigint(20) NOT NULL,
  `initiatorPortId` bigint(20) DEFAULT NULL COMMENT 'Reference to initiator storage adapter in the cluster',
  `arrayName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of the array providing the LUN',
  `diskPort` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk port associated with this path. Possible values are "A" or "B". Omitted for non-disk target',
  `diskPortName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Disk port name associated with this path. This has the form {attachment-style}:{disk-port}, where <attachment-style> is either "FC" for FibreChannel, or "SA" for SAS, and <disk-port> is either "A" or "B". Omitted for non-disk target',
  `initiatorSideSwitchPort` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The name of the switch connected to the controller initiator port, or N/A when using direct attach',
  `lun` int(11) DEFAULT NULL COMMENT 'Logical Unit Number. Range: [0..65535]',
  `lunPathUseState` enum('INU','RDY','ERR','QNG','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'ONTAP use of this path: In Use, Ready, High Error, Quiescing',
  `lunPathUseStateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw value of ONTAP use of this path',
  `targetWWPN` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'World Wide Port Name of target port providing the disk',
  `targetSideSwitchPort` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Name of the switch port connected to the target array, or UNKNOWN if direct attached',
  `tpgn` bigint(20) DEFAULT NULL COMMENT 'The Target Port Group Number of the array target port. Range: [0..2^64-1]',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `FK_diskId` (`diskId`),
  KEY `FK_initiatorPortId` (`initiatorPortId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `disk_path_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `disk_path_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `disk_path_ibfk_3` FOREIGN KEY (`diskId`) REFERENCES `disk` (`objid`),
  CONSTRAINT `disk_path_ibfk_4` FOREIGN KEY (`initiatorPortId`) REFERENCES `storage_adapter` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `export_policy` */

DROP TABLE IF EXISTS `export_policy`;

CREATE TABLE `export_policy` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  export-policy-get-iter.export-policy-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the policy. Equal to the policy ID',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of the policy',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `policyId` bigint(20) DEFAULT NULL COMMENT 'Export rule index',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `export_policy_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `export_policy_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `export_rule` */

DROP TABLE IF EXISTS `export_rule`;

CREATE TABLE `export_rule` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  export-rule-get-iter.export-rule-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the export rule. Equal to {VserverUUID}.{policyID}.{ruleIndex}. Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `exportPolicyId` bigint(20) NOT NULL,
  `ruleIndex` int(11) DEFAULT NULL COMMENT 'Export rule index',
  `clientMatch` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Client match specification for Export rule. The clients specified are enforced with this Export rule. The rule with the higher rule index value takes precedence',
  `accessProtocol` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Client access protocol. Default value is ''any''. May be comma separated',
  `roRule` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Rule for read-only access.   Ordered, comma separated list of the array values in ONTAP.',
  `rwRule` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Rule for read-write access.   Ordered, comma separated list of the array values in ONTAP.',
  `superUserSecurity` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Security flavors for the superuser. Ordered, comma separated values.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_exportPolicyId` (`exportPolicyId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `export_rule_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `export_rule_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `export_rule_ibfk_3` FOREIGN KEY (`exportPolicyId`) REFERENCES `export_policy` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `fcp_lif` */

DROP TABLE IF EXISTS `fcp_lif`;

CREATE TABLE `fcp_lif` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  net-interface-get-iter.net-interface-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of this LIF. For ONTAP 8.2 and later ZAPI: net-interface-get-iter net-interface-info.lif-uuid. For ONTAP 8.1:  Not available in ZAPI. Uses {VserverUUID}.{LIFName}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `currentPortId` bigint(20) DEFAULT NULL,
  `homePortId` bigint(20) DEFAULT NULL,
  `nodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'World Wide Node Name (WWNN) of the LIF. All LIFs in a Vserver have the same WWNN as the Vserver FCP service',
  `portName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'World Wide Port Name (WWPN) of the LIF',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_currentPortId` (`currentPortId`),
  KEY `FK_homePortId` (`homePortId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `fcp_lif_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `fcp_lif_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `fcp_lif_ibfk_4` FOREIGN KEY (`currentPortId`) REFERENCES `fcp_port` (`objid`),
  CONSTRAINT `fcp_lif_ibfk_6` FOREIGN KEY (`homePortId`) REFERENCES `fcp_port` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `fcp_port` */

DROP TABLE IF EXISTS `fcp_port`;

CREATE TABLE `fcp_port` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: fcp-adapter-get-iter.fcp-config-adapter-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the fcp port. Not available in ZAPI. Uses fcp-config-adapter-info.port-name',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `nodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'FCP World Wide Node Name (WWNN) of the adapter.',
  `portName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'FCP World Wide Port Name (WWPN) of adapter.',
  `adapter` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The slot name of the FC adapter.',
  `fabricEstablished` tinyint(1) DEFAULT NULL COMMENT '1 if fabric is established to this adapter, 0 otherwise.',
  `firmwareRev` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Firmware revision of adapter.',
  `infoName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Info name given to this adapter.',
  `maxSpeed` int(11) DEFAULT NULL COMMENT 'The maximum speed of this adapter in Gbit/sec.',
  `speed` enum('AUTO','GIGABIT_1','GIGABIT_2','GIGABIT_4','GIGABIT_8','GIGABIT_10','GIGABIT_16','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Speed configured for this adapter',
  `SpeedRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `physicalProtocol` enum('FIBRE_CHANNEL','ETHERNET','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The physical protocol of the adapter.',
  `PhysicalProtocolRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `state` enum('STARTUP','UNINITIALIZED','INITIALIZING_FIRMWARE','LINK_NOT_CONNECTED','WAITING_FOR_LINK_UP','ONLINE','LINK_DISCONNECTED','RESETTING','OFFLINE','OFFLINED_BY_USER_OR_SYSTEM','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Status of the adapter.',
  `StateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `status` enum('ONLINE','OFFLINE','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Status of the port.',
  `StatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `switchPort` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Switch and port this adapter is connected to. The string will be of the form X:Y where X is the name of the switch and Y is the port value.',
  `dataLinkRate` int(11) DEFAULT NULL COMMENT 'Data link rate in Gbits',
  `mediaType` enum('UNDEF','AUTO','PTP','LOOP','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Media configured for this adapter',
  `MediaTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `fcp_port_ibfk_1` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `fcp_port_ibfk_2` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `flash_device` */

DROP TABLE IF EXISTS `flash_device`;

CREATE TABLE `flash_device` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of FlashDevice',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED.  A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `slotNumber` int(11) DEFAULT NULL COMMENT 'The name of routing group.',
  `serialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT '10-digit serial number of the flash device ',
  `modelName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Model name of the flash device in XXXXXX-XX format.',
  `firmwareRevision` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Firmware revision of FPGA on the flash device. ',
  `capacityGB` int(11) DEFAULT NULL COMMENT 'Advertised capacity of the device, in gigabytes.',
  `percentOnline` int(11) DEFAULT NULL COMMENT 'Percentage of device capacity that is currently online.',
  `status` enum('NOT_MAPPED','ONLINE','OFFLINE_FAILED','OFFLINE_THRESHOLD') COLLATE utf8_bin DEFAULT NULL COMMENT 'The current status of the device',
  `statusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The current status of the device - ZAPI raw value',
  `serviceTime` int(11) DEFAULT NULL COMMENT 'Total number of hours the device was operational.',
  `thresholdProfile` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The name of the threshold profile being used for this flash device.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `flash_device_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `flash_device_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `ha_pair` */

DROP TABLE IF EXISTS `ha_pair`;

CREATE TABLE `ha_pair` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  cf-get-iter.storage-failover-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the HA Pair',
  `node1Id` bigint(20) NOT NULL COMMENT 'The objid of node1 in this ha_pair.',
  `node2Id` bigint(20) NOT NULL COMMENT 'The objid of node2 in this ha_pair.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_node1Id` (`node1Id`),
  KEY `FK_node2Id` (`node2Id`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `ha_pair_ibfk_1` FOREIGN KEY (`node1Id`) REFERENCES `node` (`objid`),
  CONSTRAINT `ha_pair_ibfk_2` FOREIGN KEY (`node2Id`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `igroup` */

DROP TABLE IF EXISTS `igroup`;

CREATE TABLE `igroup` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  igroup-get-iter.initiator-group-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the igroup',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `osType` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'OS type of the initiator group',
  `type` enum('NOT_MAPPED','ISCSI','FCP','MIXED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of the initiators in this group',
  `typeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw value of type of initiators in this group. ',
  `aluaEnabled` tinyint(1) DEFAULT NULL COMMENT 'Indicates if this initiator group has ALUA (Asymmetric Logical Unit Access) features enabled for luns mapped to this initiator group.',
  `vsaEnabled` tinyint(1) DEFAULT NULL COMMENT 'Indicates if this initiator group has Volume Set Addressing (VSA) enabled or disabled. ',
  `usePartner` tinyint(1) DEFAULT NULL COMMENT 'Boolean value to indicate if this initiator group is configured for its luns to require the use of host multi-pathing software for correct high-availability failover operation.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `igroup_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `igroup_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `igroup_initiator` */

DROP TABLE IF EXISTS `igroup_initiator`;

CREATE TABLE `igroup_initiator` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  igroup-get-iter.initiator-group-info.initiators.initiator-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the igroup initiator',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `igroupId` bigint(20) NOT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_igroupId` (`igroupId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `igroup_initiator_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `igroup_initiator_ibfk_2` FOREIGN KEY (`igroupId`) REFERENCES `igroup` (`objid`),
  CONSTRAINT `igroup_initiator_ibfk_3` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `iscsi_portal_group` */

DROP TABLE IF EXISTS `iscsi_portal_group`;

CREATE TABLE `iscsi_portal_group` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: net-port-get-iter.net-port-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the iSCSI Portal Group equivalent to "{clusterUUID}.{VserverUUID}.{portalGroupName}". This is not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `tag` int(11) DEFAULT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `iscsi_portal_group_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `iscsi_portal_group_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `iscsi_portal_group_lif` */

DROP TABLE IF EXISTS `iscsi_portal_group_lif`;

CREATE TABLE `iscsi_portal_group_lif` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  iscsi-tpgroup-get-iter.iscsi-tpgroup-list-entry-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the iSCSI Portal Group LIF. This is not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `targetPortalGroupId` bigint(20) NOT NULL,
  `lifId` bigint(20) NOT NULL,
  `interfaceName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of the interface',
  `ipAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'iSCSI target portal IP address',
  `ipPort` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'iSCSI target portal TCP port',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_iscsiPortalGroupId` (`targetPortalGroupId`),
  KEY `FK_lifId` (`lifId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `iscsi_portal_group_lif_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `iscsi_portal_group_lif_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `iscsi_portal_group_lif_ibfk_3` FOREIGN KEY (`targetPortalGroupId`) REFERENCES `iscsi_portal_group` (`objid`),
  CONSTRAINT `iscsi_portal_group_lif_ibfk_4` FOREIGN KEY (`lifId`) REFERENCES `network_lif` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `iscsi_security_entry` */

DROP TABLE IF EXISTS `iscsi_security_entry`;

CREATE TABLE `iscsi_security_entry` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  iscsi-initiator-auth-get-iter.iscsi-security-entry-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the security entry. Equal to "{clusterUUID}.{VserverUUID}.{initiatorNodeName}.{security}". Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `authenticationType` enum('CHAP','NONE','DENY','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Authentication type',
  `initiator` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of initiator',
  `outboundUserName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Outbound CHAP user name, returned only if auth-type is CHAP, and outbound authentication is set for initiator.',
  `username` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Inbound CHAP user name, returned only if auth-type is CHAP.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `iscsi_security_entry_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `iscsi_security_entry_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `iscsi_session` */

DROP TABLE IF EXISTS `iscsi_session`;

CREATE TABLE `iscsi_session` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  iscsi-session-get-iter.iscsi-session-list-entry-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the iSCSI Session. Equal to "{clusterUUID}.{VserverUUID}.{portalGroupName}.{targetSessionId}"',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `targetPortalGroupId` bigint(20) NOT NULL,
  `initiatorSessionId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'ISID for this session selected by initiator represented as 6 hexadecimal octets separated by colons, for example: "40:01:37:00:00:00".',
  `targetSessionId` int(11) DEFAULT NULL COMMENT 'The iSCSI session identifier assigned by the storage system',
  `initiatorNodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of initiator. The initiator name must conform to RFC 3720, for example: "iqn.1987-06.com.initvendor1:appsrv.sn.2346"',
  `initiatorAliasName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The user-friendly name assigned to initiator',
  `maxConnections` int(11) DEFAULT NULL COMMENT 'Maximum number of connections for this session',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_iscsiPortalGroupId` (`targetPortalGroupId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `iscsi_session_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `iscsi_session_ibfk_2` FOREIGN KEY (`targetPortalGroupId`) REFERENCES `iscsi_portal_group` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `iscsi_session_connection` */

DROP TABLE IF EXISTS `iscsi_session_connection`;

CREATE TABLE `iscsi_session_connection` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  iscsi-session-get-iter.iscsi-session-list-entry-info.iscsi-session-connection-list-entries.iscsi-session-connection-list-entry-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the iSCSI Session connection. Equal to "{clusterUUID}.{VserverUUID}.{portalGroupName}.{targetSessionId}.{connectionId}". Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `iscsiSessionId` bigint(20) NOT NULL,
  `lifId` bigint(20) NOT NULL,
  `connectionId` int(11) DEFAULT NULL COMMENT 'Connection ID within the session',
  `localIpAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Local storage system iSCSI target interface address',
  `localIpPort` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Local storage system iSCSI target TCP port',
  `remoteIpAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Remote initiator TCP port',
  `authenticationStyle` enum('CHAP','NONE','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Authentication method of this connection',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_iscsiSessionId` (`iscsiSessionId`),
  KEY `FK_lifId` (`lifId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `iscsi_session_connection_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `iscsi_session_connection_ibfk_2` FOREIGN KEY (`iscsiSessionId`) REFERENCES `iscsi_session` (`objid`),
  CONSTRAINT `iscsi_session_connection_ibfk_3` FOREIGN KEY (`lifId`) REFERENCES `network_lif` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `job_schedule` */

DROP TABLE IF EXISTS `job_schedule`;

CREATE TABLE `job_schedule` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of the job schedule.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The name of the job schedule.   ZAPIs:  job-schedule-iter job-schedule-info job-schedule-name',
  `clusterId` bigint(20) NOT NULL,
  `description` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The description of the job schedule.  ZAPIs:  job-schedule-iter job-schedule-info job-schedule-description',
  `scheduleType` enum('CRON','INTERVAL','BUILTIN','UNKNOWN','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT ' The type of job schedule.  ZAPIs: job-schedule-iter job-schedule-info job-schedule-type.',
  `scheduleTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `cronDayOfMonth` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The day(s) of the month when the job should be run.  ZAPIs: job-schedule-cron-get-iter job-schedule-cron-info job-schedule-cron-day.',
  `cronDayOfWeek` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The day(s) in the week when the job should be run.   ZAPIs:  job-schedule-cron-get-iter job-schedule-cron-info job-schedule-cron-day-of-week',
  `cronHour` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The hour(s) of the day when the job should be run.  ZAPIs: job-schedule-cron-get-iter job-schedule-cron-info job-schedule-cron-hour',
  `cronMinute` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The minute(s) of each hour when the job should be run.  ZAPIs:  job-schedule-cron-get-iter job-schedule-cron-info job-schedule-cron-minute',
  `cronMonth` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The month(s) when the job should be run.   ZAPIs: job-schedule-cron-get-iter job-schedule-cron-info job-schedule-cron-month.',
  `intervalDays` int(11) DEFAULT NULL COMMENT 'The number of days between jobs.  ZAPIs:  job-schedule-internval-get-iter job-schedule-interval-info job-schedule-interval-days',
  `intervalHours` int(11) DEFAULT NULL COMMENT 'The number of hours between jobs.   ZAPIs: job-schedule-internval-get-iter job-schedule-interval-info job-schedule-interval-hours',
  `intervalMinutes` int(11) DEFAULT NULL COMMENT 'The number of minutes between jobs   ZAPIs:  job-schedule-internval-get-iter job-schedule-interval-info job-schedule-interval-minutes',
  `intervalSeconds` int(11) DEFAULT NULL COMMENT 'The number of seconds between jobs.   ZAPIs: job-schedule-internval-get-iter job-schedule-interval-info job-schedule-interval-seconds',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `job_schedule_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `license` */

DROP TABLE IF EXISTS `license`;

CREATE TABLE `license` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  interim-license-list-get.licenses.interim-license-cluster-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the license.  DERIVED from {clusterUUID}.{package name}.{serial number}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `ownerNodeId` bigint(20) DEFAULT NULL COMMENT 'objId of Node, present only if ownerType is NODE ',
  `ownerType` enum('NODE','CLUSTER','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'The entity type of the owner',
  `ownerName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The name of the owner that owns the serial number.',
  `package` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Name of licensed feature',
  `clusterId` bigint(20) NOT NULL,
  `serialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Serial number of owning entity (cluster in RR.x)',
  `expirationTime` timestamp NULL DEFAULT NULL COMMENT 'License expiration time',
  `description` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Description of the licensed package',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`ownerNodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `license_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `license_ibfk_2` FOREIGN KEY (`ownerNodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `lif` */

DROP TABLE IF EXISTS `lif`;

CREATE TABLE `lif` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  net-interface-get-iter.net-interface-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of this LIF. Not available in ZAPI. Uses {VserverUUID}.{LIFName}',
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `currentNodeId` bigint(20) DEFAULT NULL,
  `homeNodeId` bigint(20) DEFAULT NULL,
  `lifType` enum('NETWORK_LIF','FCP_LIF') COLLATE utf8_bin NOT NULL COMMENT 'Lif type',
  `isAutoRevert` tinyint(1) DEFAULT NULL COMMENT 'If true, data LIF will revert to its home node under certain circumstances such as startup, and load balancing migration is disabled automatically',
  `isHome` tinyint(1) DEFAULT NULL COMMENT 'True if LIF is currently on home node and home port',
  `operationalStatus` enum('UP','DOWN','UNKNOWN','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'State of aggregate',
  `operationalStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `administrativeStatus` enum('UP','DOWN','UNKNOWN','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'State of aggregate',
  `administrativeStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `role` enum('UNDEF','CLUSTER','DATA','NODE_MGMT','INTERCLUSTER','NOT_MAPPED','CLUSTER_MGMT') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the role associated with the LIF',
  `roleRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `dataProtocols` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the list of data protocols configured on the LIF. This can be comma separated. Possible values: nfs, cifs, iscsi, fcp, fcache, none',
  `failoverGroup` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the failover group name',
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_currentNodeId` (`currentNodeId`),
  KEY `FK_homeNodeId` (`homeNodeId`),
  CONSTRAINT `FK_clusterId` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `FK_currentNodeId` FOREIGN KEY (`currentNodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `FK_homeNodeId` FOREIGN KEY (`homeNodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `FK_vserverId` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `lun` */

DROP TABLE IF EXISTS `lun`;

CREATE TABLE `lun` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  lun-get-iter.lun-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the LUN',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `qtreeId` bigint(20) NOT NULL,
  `volumeId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `qosPolicyGroupId` bigint(20) DEFAULT NULL,
  `path` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Path of the LUN',
  `isOnline` tinyint(1) DEFAULT NULL COMMENT 'Is LUN online?',
  `size` bigint(20) DEFAULT NULL COMMENT 'Size of the LUN in bytes',
  `sizeUsed` bigint(20) DEFAULT NULL COMMENT 'Used bytes in the LUN',
  `isSpaceReservationEnabled` tinyint(1) DEFAULT NULL COMMENT 'Whether or not the LUN has space reservation enabled',
  `isSpaceAllocEnabled` tinyint(1) DEFAULT NULL COMMENT 'Whether or not the LUN has space allocation enabled',
  `isMapped` tinyint(1) DEFAULT NULL COMMENT 'Is the LUN mapped to any initiator?',
  `serialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Serial number of the LUN',
  `multiProtocolType` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The OS type of the LUN',
  `alignment` enum('NOT_MAPPED','ALIGNED','MISALIGNED','POSSIBLY_MISALIGNED','INDETERMINATE') COLLATE utf8_bin DEFAULT NULL COMMENT 'Alignment state of the LUN',
  `alignmentRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Alignment state of the LUN - ZAPI raw value',
  `prefixSize` bigint(20) DEFAULT NULL COMMENT 'Size of the prefix stream for this LUN in bytes',
  `suffixSize` bigint(20) DEFAULT NULL COMMENT 'Size of the suffix stream for this LUN in bytes',
  `lunClass` enum('NOT_MAPPED','REGULAR','PROTCOL_ENDPOINT','VVOL') COLLATE utf8_bin DEFAULT NULL COMMENT 'The class of the LUN',
  `lunClassRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The class of the LUN - ZAPI raw value',
  `comment` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'User defined comments on LUN',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_qtreeId` (`qtreeId`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_qosPolicyGroupId` (`qosPolicyGroupId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `lun_ibfk_1` FOREIGN KEY (`qtreeId`) REFERENCES `qtree` (`objid`),
  CONSTRAINT `lun_ibfk_2` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `lun_ibfk_3` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `lun_ibfk_4` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `lun_ibfk_5` FOREIGN KEY (`qosPolicyGroupId`) REFERENCES `qos_policy_group` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `lun_map` */

DROP TABLE IF EXISTS `lun_map`;

CREATE TABLE `lun_map` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  lun-map-get-iter.lun-map-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the LUN map. DERIVED from {igroupUUID}.{lunUUID}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `igroupId` bigint(20) NOT NULL,
  `lunId` bigint(20) NOT NULL,
  `owningNodeId` bigint(20) DEFAULT NULL COMMENT 'The owning node Id.',
  `lun` int(11) DEFAULT NULL COMMENT 'Logical Unit Number which the lun is mapped to for the requested initiator',
  `path` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Path of the LUN which is mapped to the requested initiator',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_igroupId` (`igroupId`),
  KEY `FK_lunId` (`lunId`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_owningNodeId` (`owningNodeId`),
  CONSTRAINT `lun_map_ibfk_5` FOREIGN KEY (`owningNodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `lun_map_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `lun_map_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `lun_map_ibfk_3` FOREIGN KEY (`igroupId`) REFERENCES `igroup` (`objid`),
  CONSTRAINT `lun_map_ibfk_4` FOREIGN KEY (`lunId`) REFERENCES `lun` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `lun_map_reporting_node` */

DROP TABLE IF EXISTS `lun_map_reporting_node`;

CREATE TABLE `lun_map_reporting_node` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the relationship',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `lunMapId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_lunMapId` (`lunMapId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `lun_map_reporting_node_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `lun_map_reporting_node_ibfk_2` FOREIGN KEY (`lunMapId`) REFERENCES `lun_map` (`objid`),
  CONSTRAINT `lun_map_reporting_node_ibfk_3` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `network_failover_group` */

DROP TABLE IF EXISTS `network_failover_group`;

CREATE TABLE `network_failover_group` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPI: net-failover-group-get-iter.net-failover-group-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the broadcast domain DERIVED: cluster_uuid.failover_group_name.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The cluster-wide unique name of the failover group.',
  `clusterId` bigint(20) NOT NULL,
  `networkPortBroadcastDomainId` bigint(20) DEFAULT NULL COMMENT 'The Object Id of the network port broadcast domain associated with the network failover group.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_networkPortBroadcastDomainId` (`networkPortBroadcastDomainId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `network_failover_group_domain_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `network_failover_group_domain_ibfk_2` FOREIGN KEY (`networkPortBroadcastDomainId`) REFERENCES `network_port_broadcast_domain` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `network_ip_space` */

DROP TABLE IF EXISTS `network_ip_space`;

CREATE TABLE `network_ip_space` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPI:  net-ipspaces-get-iter.net-ipspaces-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the ip space.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The cluster-wide unique name of the ip space.',
  `clusterId` bigint(20) NOT NULL,
  `networkIpSpaceId` bigint(20) DEFAULT NULL COMMENT 'The ID of the IPspace.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `network_ip_space_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `network_lif` */

DROP TABLE IF EXISTS `network_lif`;

CREATE TABLE `network_lif` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  net-interface-get-iter.net-interface-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of this LIF. For ONTAP 8.2 and later ZAPI: net-interface-get-iter net-interface-info.lif-uuid. For ONTAP 8.1:  Not available in ZAPI. Uses {VserverUUID}.{LIFName}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `currentPortId` bigint(20) DEFAULT NULL,
  `homePortId` bigint(20) DEFAULT NULL,
  `routingGroupId` bigint(20) DEFAULT NULL,
  `address` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'LIFs IP address. THis element is valid for all data prtocols except FCP',
  `netmask` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the LIFs netmask. This element is valid for all data protocols except FCP',
  `netmaskLength` int(11) DEFAULT NULL COMMENT 'Specifies the number of bits in the netmask',
  `dnsDomainName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the unique, fully qualified domain name of the DNS zone of this LIF',
  `failoverPolicy` enum('NOT_MAPPED','NEXTAVAIL','PRIORITY','DISABLED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the failover policy for the LIF',
  `failoverPolicyRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_currentPortId` (`currentPortId`),
  KEY `FK_homePortId` (`homePortId`),
  KEY `FK_routingGroupId` (`routingGroupId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `network_lif_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `network_lif_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `network_lif_ibfk_4` FOREIGN KEY (`currentPortId`) REFERENCES `network_port` (`objid`),
  CONSTRAINT `network_lif_ibfk_6` FOREIGN KEY (`homePortId`) REFERENCES `network_port` (`objid`),
  CONSTRAINT `network_lif_ibfk_7` FOREIGN KEY (`routingGroupId`) REFERENCES `routing_group` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `network_port` */

DROP TABLE IF EXISTS `network_port`;

CREATE TABLE `network_port` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: net-port-get-iter.net-port-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the network port. Not available in ZAPI. Uses {PortName}.{MACAddress}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `macAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the MAC address of the port',
  `administrativeSpeed` enum('UNDEF','AUTO','MEGABIT_10','MEGABIT_100','GIGABIT_1','GIGABIT_10','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Speed setting preferred by the port',
  `administrativeSpeedRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `operationalSpeed` enum('UNDEF','AUTO','MEGABIT_10','MEGABIT_100','GIGABIT_1','GIGABIT_10','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Speed setting preferred by the port',
  `operationalSpeedRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `linkStatus` enum('UNKNOWN','UP','DOWN','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the link status of the port',
  `linkStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `role` enum('UNDEF','CLUSTER','DATA','NODE_MGMT','INTERCLUSTER','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the role associated with the port',
  `roleRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `portType` enum('PHYSICAL','IF_GROUP','VLAN','UNDEF','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the role associated with the port',
  `portTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `vlanIdentifier` bigint(20) DEFAULT NULL COMMENT 'For ports of type VLAN, the VLAN ID',
  `mtu` bigint(20) DEFAULT NULL COMMENT 'Specifies the maximum transmission unit of the port',
  `operationalDuplex` enum('UNDEF','AUTO','HALF','FULL','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Duplex setting reported by the port after Ethernet auto-negotiation',
  `operationalDuplexRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `networkIpSpaceId` bigint(20) DEFAULT NULL COMMENT 'IP Space associated with the network port.',
  `networkPortBroadcastDomainId` bigint(20) DEFAULT NULL COMMENT 'Broadcast domain associated with the network port.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_networkIpSpaceId` (`networkIpSpaceId`),
  KEY `FK_networkPortBroadcastDomainId` (`networkPortBroadcastDomainId`),
  CONSTRAINT `network_port_ibfk_4` FOREIGN KEY (`networkPortBroadcastDomainId`) REFERENCES `network_port_broadcast_domain` (`objid`),
  CONSTRAINT `network_port_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `network_port_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `network_port_ibfk_3` FOREIGN KEY (`networkIpSpaceId`) REFERENCES `network_ip_space` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `network_port_broadcast_domain` */

DROP TABLE IF EXISTS `network_port_broadcast_domain`;

CREATE TABLE `network_port_broadcast_domain` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPI:  net-port-broadcast-domain-get-iter.net-port-broadcast-domain-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the broadcast domain DERIVED: cluster_uuid.broadcast_domain_name.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The cluster-wide unique name of the broadcast domain.',
  `clusterId` bigint(20) NOT NULL,
  `mtu` bigint(20) DEFAULT NULL COMMENT 'Maximum Transmission Unit (MTU) of the broadcast domain',
  `networkIpSpaceId` bigint(20) DEFAULT NULL COMMENT 'The Object Id of the IPspace associated with the broadcast domain.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_networkIPSpaceId` (`networkIpSpaceId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `network_port_broadcast_domain_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `network_port_broadcast_domain_ibfk_2` FOREIGN KEY (`networkIpSpaceId`) REFERENCES `network_ip_space` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `network_port_relationship` */

DROP TABLE IF EXISTS `network_port_relationship`;

CREATE TABLE `network_port_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the Network Port. Not from ZAPI',
  `vlanPortId` bigint(20) DEFAULT NULL COMMENT 'ID of the physical port on which the VLAN is created',
  `ifgrpPortId` bigint(20) DEFAULT NULL COMMENT 'ID of the IFGRP port on which the port belongs',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `network_port_relationship_ibfk_1` FOREIGN KEY (`objid`) REFERENCES `network_port` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `nis_domain` */

DROP TABLE IF EXISTS `nis_domain`;

CREATE TABLE `nis_domain` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of NIS domain. Derived from ClusterUUID.VserverUUID.{NISDomain name}. Not from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `nisDomain` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the NIS domain.',
  `nisServers` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Ordered list of IP addresses of the NIS servers in this domain.  Comma separated',
  `isActive` tinyint(1) DEFAULT NULL COMMENT ' Specifies whether the NIS domain configuration is active or inactive.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `nis_domain_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `nis_domain_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `node` */

DROP TABLE IF EXISTS `node`;

CREATE TABLE `node` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: system-node-get-iter.node-details-info, system-get-node-info-iter.system-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the node',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `partnerNodeId` bigint(20) DEFAULT NULL,
  `mtDrPartnerNodeUUID` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'The partner node UUID on the MetroCluster',
  `mtDrOperationState` enum('NORMAL','SWITCHOVER_IN_PROGRESS','SWITCHOVER_FAILED','SWITCHOVER_COMPLETED','HEAL_AGGRS_IN_PROGRESS','HEAL_AGGRS_FAILED','HEAL_AGGRS_COMPLETED','HEAL_ROOTS_FAILED','HEAL_ROOTS_COMPLETED','SWITCHBACK_IN_PROGRESS','SWTICHBACK_FAILED','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The operation state of partner node on metrocluster.',
  `mtDrOperationStateRaw` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'The operation state of partner node on metrocluster.Raw enum value from ZAPI',
  `mtDrPartnerNodeId` bigint(20) DEFAULT NULL,
  `serialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Serial number',
  `version` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Version of the cluster',
  `model` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Hardware model of this node.',
  `uptime` bigint(20) DEFAULT NULL COMMENT 'The uptime of this node, in seconds.',
  `vendor` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Hardware vendor of the node.',
  `location` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Location of the node.',
  `failoverState` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Failover state.   See ZAPI documentation on cf-status for more information.',
  `cpuProcessorType` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Processor type (defined by CPU manufacturer).',
  `cpuProcessorId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Processor ID (defined by CPU manufacturer).',
  `numberOfProcessors` int(11) DEFAULT NULL COMMENT 'Number of processors on Node.',
  `memorySizeMB` bigint(20) DEFAULT NULL COMMENT 'Size of system memory in MB.',
  `productType` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Will be set to "V-Series" to indicate a v-series system for NetApp filers. For IBM filers, "gateway" will used.',
  `nvramId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Vendor specific NVRAM ID of the node. ZAPI: system-node-get-iter node-nvram-id',
  `cpuFirmwareRelease` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Firmware release number. ZAPI: system-node-get-iter cpu-firware-relsease',
  `isOverTemperature` tinyint(1) DEFAULT NULL COMMENT 'An indication of whether the hardware is currently operating outside of its recommended temperature range. ZAPI: system-node-get-iter env-over-temperature',
  `failedFanCount` int(11) DEFAULT NULL COMMENT 'Number of failed fans. ZAPI: system-node-get-iter env-failed-fan-count',
  `failedPowerSupplyCount` int(11) DEFAULT NULL COMMENT 'Number of failed power supply units. ZAPI: system-node-get-iter env-failed-power-supply-count',
  `nvramBatteryStatus` enum('BATTERY_OK','BATTERY_NOT_PRESENT','BATTERY_NEAR_END_OF_LIFE','BATTERY_AT_END_OF_LIFE','BATTERY_UNKNOWN','BATTERY_FULLY_CHARGED','BATTERY_PARTIALLY_DISCHARGED','BATTERY_FULLY_DISCHARGED','BATTERY_OVER_CHARGED','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'NVRAM Battery Attributes. ZAPI: system-node-get-iter nvram-battery-status',
  `nvramBatteryStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `rawDiskBytesTotal` bigint(20) DEFAULT NULL COMMENT 'DERIVED.Sum of all disks size total',
  `rawDiskBytesUsed` bigint(20) DEFAULT NULL COMMENT 'DERIVED.Sum of all disks size used',
  `aggregateBytesTotal` bigint(20) DEFAULT NULL COMMENT 'DERIVED.  Sum of bytes total (including snapshot) on all aggregates in the Node.',
  `aggregateBytesUsed` bigint(20) DEFAULT NULL COMMENT 'DERIVED.  Sum of bytes used (including snapshot) on all aggregates in the Node.',
  `isFailoverEnabled` tinyint(1) DEFAULT NULL COMMENT 'True, if the storage failover facility is enabled, false otherwise. ZAPI: cf-status is-enabled',
  `isTakeOverPossible` tinyint(1) DEFAULT NULL COMMENT 'True, if storage failover takeover is currently possible, false otherwise. ZAPI: cf-status takeover-possible',
  `partnerFirmwareState` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Partner firmware state as communicated by the partner through interconnect. ZAPI: cf-status partner-firmware-state',
  `localFirmwareState` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Local firmware state that will be communicated through interconnect to the partner. ZAPI: cf-status local-firmware-state',
  `isInterconnectUp` tinyint(1) DEFAULT NULL COMMENT 'True, if high availability interconnect is up. ZAPI: cf-status is-interconnect-up',
  `interconnectLinks` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'States of the individual interconnect links. ZAPI: cf-status interconnect-links',
  `interconnectType` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Type and Vendor of the interconnect. ZAPI: cf-status interconnect-type ',
  `versionGeneration` int(11) DEFAULT NULL COMMENT 'First integer of the Data ONTAP version tuple corresponding to this Node.',
  `versionMajor` int(11) DEFAULT NULL COMMENT 'Second integer of the Data ONTAP version tuple corresponding to this Node',
  `versionMinor` int(11) DEFAULT NULL COMMENT 'Third integer of the Data ONTAP version tuple corresponding to this Node',
  `owner` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The owner of the Node. ZAPI: system-node-get-iter node-owner',
  `isNodeHealthy` tinyint(1) DEFAULT NULL COMMENT 'The RDB health of the node. True means the node is in quorum. ZAPI: system-node-get-iter is-node-healthy',
  `isEpsilonNode` tinyint(1) DEFAULT NULL COMMENT 'You can designate a node as epsilon to add weight to its voting in a cluster with an even number of nodes. In a cluster, only one node can be designated as epsilon at any given time. A boolean value of true means the node is epsilon. Attributes: non-creatable, modifiable.',
  `isAllFlashOptimized` tinyint(1) DEFAULT NULL COMMENT 'Is this node configured to only support SSD drives. If true, no HDDs are allowed on this node.',
  `envFailedFanMessage` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Text message describing the current condition of chassis fans. This is useful only if env-failed-fan-count is not zero. ZAPI: system-node-get-iter.env-failed-fan-message',
  `envFailedPowerSupplyMessage` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Text message describing the state of any power supplies which are currently degraded. This is useful only if env-failed-power-supply-count is not zero. ZAPI: system-node-get-iter.env-failed-power-supply-message',
  `giveBackState` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Giveback state of the node. ZAPI: cf-status.giveback-state',
  `currentMode` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Current HA mode',
  `takeoverByPartnerNotPossibleReason` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'If takeover by the partner is not possible, list of one or more reasons why. Translated to a comma separated, lexiographically sorted, list of reasons',
  `takeoverOfPartnerNotPossibleReason` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'If is-enabled is false, list of one or more reasons why. Translated to a comma separated, lexiographically sorted, list of reasons',
  `takeoverFailureReason` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'If is-enabled is false, list of one or more reasons why. If state == takeover_failed, this is the reason for the takeover failure',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `node_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `param` */

DROP TABLE IF EXISTS `param`;

CREATE TABLE `param` (
  `param` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Configuration Parameter Key',
  `value` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Configuration Parameter Value',
  PRIMARY KEY (`param`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Data for the table `param` */

insert  into `param`(`param`,`value`) values ('CHANGES_LIFETIME','3600000'),('HISTORY_LIFETIME','2592000000'),('PERFORMANCE_TABLES_LIFESPAN_DAYS','96'),('PERFORMANCE_UPDATE_CURRENT_SAMPLE','0'),('PRESERVE_OFFLINE_OBJECTS','1'),('RECORD_FULL_CLUSTER_CHANGE','0'),('SOFT_DELETE_PURGE_LIFETIME_MS','2592000000');

/*Table structure for table `plex` */

DROP TABLE IF EXISTS `plex`;

CREATE TABLE `plex` (
  `objid` bigint(20) NOT NULL COMMENT 'Object ID within the platform server.  ZAPIs:  aggr-get-iter.aggr-attributes.plex-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the plex. Not available in ZAPI. Uses {AggregateUUID}.{PlexName}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `aggregateId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `isOnline` tinyint(1) DEFAULT NULL COMMENT 'if plex is online',
  `status` enum('NORMAL','FAILED','EMPTY','INVALID','UNINITIALIZED','FAILED_ASSIMILATION','LIMBO','ACTIVE','INACTIVE','RESYNCING','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The plex status.',
  `statusRaw` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'The plex status. Raw value from ZAPI',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_aggregateId` (`aggregateId`),
  KEY `FK_clusterid` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `plex_ibfk_1` FOREIGN KEY (`aggregateId`) REFERENCES `aggregate` (`objid`),
  CONSTRAINT `plex_ibfk_2` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `plex_ibfk_3` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `portset` */

DROP TABLE IF EXISTS `portset`;

CREATE TABLE `portset` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  portset-get-iter.portset-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the portset.  DERIVED as the {vserverUUID}.{portset name}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `type` enum('NOT_MAPPED','ISCSI','FCP','MIXED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of the ports in this group',
  `typeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'portsetType - ZAPI raw value',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `portset_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `portset_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `portset_port` */

DROP TABLE IF EXISTS `portset_port`;

CREATE TABLE `portset_port` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  portset-get-iter.portset-info.portset-port-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the port. DERIVED from {clusterID},{porsetId},{name}',
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'String representing a member of a portset. In Data ONTAP Cluster-Mode, the port name is the name of an FCP data lif or iSCSI target portal group',
  `fcpLifId` bigint(20) DEFAULT NULL COMMENT 'for fcp port, show objid in fcp_lif table; otherwise show null',
  `iSCSIPortalGroupId` bigint(20) DEFAULT NULL COMMENT 'for iscsi port, show objid in iscsi_portal_group table; otherwise show null',
  `clusterId` bigint(20) NOT NULL,
  `portsetId` bigint(20) NOT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_portsetId` (`portsetId`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_fcpLifId` (`fcpLifId`),
  KEY `FK_iSCSIPortalGroupId` (`iSCSIPortalGroupId`),
  CONSTRAINT `portset_port_ibfk_4` FOREIGN KEY (`iSCSIPortalGroupId`) REFERENCES `iscsi_portal_group` (`objid`),
  CONSTRAINT `portset_port_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `portset_port_ibfk_2` FOREIGN KEY (`portsetId`) REFERENCES `portset` (`objid`),
  CONSTRAINT `portset_port_ibfk_3` FOREIGN KEY (`fcpLifId`) REFERENCES `fcp_lif` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `portset_to_igroup` */

DROP TABLE IF EXISTS `portset_to_igroup`;

CREATE TABLE `portset_to_igroup` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  portset-get-iter.portset-info.initiator-group-info.initiator-group-name',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the portset igroup ref. DERIVED from {clusterId},{porsetId},{igroupId}',
  `clusterId` bigint(20) NOT NULL,
  `portsetId` bigint(20) NOT NULL,
  `igroupId` bigint(20) NOT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_portsetId` (`portsetId`),
  KEY `FK_igroupId` (`igroupId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `portset_to_igroup_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `portset_to_igroup_ibfk_2` FOREIGN KEY (`portsetId`) REFERENCES `portset` (`objid`),
  CONSTRAINT `portset_to_igroup_ibfk_3` FOREIGN KEY (`igroupId`) REFERENCES `igroup` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `processor` */

DROP TABLE IF EXISTS `processor`;

CREATE TABLE `processor` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  system-get-node-info-iter.system-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The UUID of the object. Equal to the {NodeUUID}.{processorNumber } Not returned from ZAPI.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `processorNumber` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Processor Number',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL COMMENT 'Object ID of the Node on which this processor resides',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `processor_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `processor_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qos_policy_group` */

DROP TABLE IF EXISTS `qos_policy_group`;

CREATE TABLE `qos_policy_group` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `UUID` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Policy group UUID.  ZAPIs: qos-policy-group-get-iter.qos-policy-group-info.uuid',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED.  A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `policyGroup` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of the policy group.  ZAPIs: qos-policy-group-get-iter.qos-policy-group-info.policy-group',
  `pgIdentifier` bigint(20) DEFAULT NULL COMMENT 'The ID used to identify the policy group. ZAPIs: qos-policy-group-get-iter.qos-policy-group-info.pgid ',
  `policyGroupClass` enum('NOT_MAPPED','PRESET','USER_DEFINED','SYSTEM_DEFINED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Class for the policy group. ZAPIs: qos-policy-group-get-iter.qos-policy-group-info.policy-group-class',
  `policyGroupClassRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `maxThroughput` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Maximum throughput defined by this policy. It is specified in terms of IOPS or MB/s, and the range is zero to infinity.  ZAPIs: qos-policy-group-get-iter.qos-policy-group-info.max-throughput ',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qos_policy_group_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qos_policy_group_vserver_relationship` */

DROP TABLE IF EXISTS `qos_policy_group_vserver_relationship`;

CREATE TABLE `qos_policy_group_vserver_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the referenced QoS policy groupI',
  `vserverId` bigint(20) DEFAULT NULL COMMENT 'ID of the vserver the QoS Policy Group references',
  `checksum` int(11) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_vserverid` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qos_policy_group_vserver_relationship_ibfk_1` FOREIGN KEY (`objid`) REFERENCES `qos_policy_group` (`objid`),
  CONSTRAINT `qos_policy_group_vserver_relationship_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qos_service_center` */

DROP TABLE IF EXISTS `qos_service_center`;

CREATE TABLE `qos_service_center` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier. ZAPIs: perf-object-instance-list-info-iter (with object-name "resource")',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(512) COLLATE utf8_bin NOT NULL,
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `aggregateId` bigint(20) DEFAULT NULL COMMENT 'Optional ID of the Aggregate the service center is associated with',
  `type` enum('NOT_MAPPED','RESOURCE','DELAY_CENTER') COLLATE utf8_bin NOT NULL COMMENT 'Identifies whether the service center is a resource or a delay center',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `FK_aggregateId` (`aggregateId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qos_service_center_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `qos_service_center_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `qos_service_center_ibfk_3` FOREIGN KEY (`aggregateId`) REFERENCES `aggregate` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qos_service_center_relationship` */

DROP TABLE IF EXISTS `qos_service_center_relationship`;

CREATE TABLE `qos_service_center_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: qos-workload-get-iter.qos-workload-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the QoS Service Center',
  `parentQosServiceCenterId` bigint(20) NOT NULL COMMENT 'ID of the parent service center',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_parentResourceId` (`parentQosServiceCenterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qos_service_center_relationship_ibfk_1` FOREIGN KEY (`objid`) REFERENCES `qos_service_center` (`objid`),
  CONSTRAINT `qos_service_center_relationship_ibfk_2` FOREIGN KEY (`parentQosServiceCenterId`) REFERENCES `qos_service_center` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qos_volume_workload` */

DROP TABLE IF EXISTS `qos_volume_workload`;

CREATE TABLE `qos_volume_workload` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: qos-workload-get-iter.qos-workload-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the QoS Workload',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) DEFAULT NULL COMMENT 'ID of the vserver the workload is associated with',
  `volumeId` bigint(20) DEFAULT NULL COMMENT 'ID of the volume the workload is associated with',
  `workloadClass` enum('NOT_MAPPED','PRESET','USER_DEFINED','SYSTEM_DEFINED','UNDEFINED','AUTOVOLUME') COLLATE utf8_bin NOT NULL COMMENT 'Identifies how the workload was created',
  `workloadClassRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Identifies how the workload was created - ZAPI raw value',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qos_volume_workload_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `qos_volume_workload_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `qos_volume_workload_ibfk_3` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qos_workload_detail` */

DROP TABLE IF EXISTS `qos_workload_detail`;

CREATE TABLE `qos_workload_detail` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier. ZAPIs: perf-object-instance-list-info-iter (with object-name "workload_detail")',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(512) COLLATE utf8_bin NOT NULL,
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `workloadId` bigint(20) NOT NULL COMMENT 'ID of the QoS Workload item associated with this QoS Workload Detail',
  `serviceCenterId` bigint(20) NOT NULL COMMENT 'ID of the QoS Service Center item associated with this QoS Workload Detail',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_workloadId` (`workloadId`),
  KEY `FK_serviceCenterId` (`serviceCenterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qos_workload_detail_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `qos_workload_detail_ibfk_2` FOREIGN KEY (`workloadId`) REFERENCES `qos_volume_workload` (`objid`),
  CONSTRAINT `qos_workload_detail_ibfk_3` FOREIGN KEY (`serviceCenterId`) REFERENCES `qos_service_center` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qos_workload_node_relationship` */

DROP TABLE IF EXISTS `qos_workload_node_relationship`;

CREATE TABLE `qos_workload_node_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the relationship',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL COMMENT 'ID of the Node',
  `workloadId` bigint(20) NOT NULL COMMENT 'ID of the QoS Workload',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_workloadId` (`workloadId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qos_workload_node_relationship_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `qos_workload_node_relationship_ibfk_2` FOREIGN KEY (`workloadId`) REFERENCES `qos_volume_workload` (`objid`),
  CONSTRAINT `qos_workload_node_relationship_ibfk_3` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qtree` */

DROP TABLE IF EXISTS `qtree`;

CREATE TABLE `qtree` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  qtree-list-iter.qtree-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the qtree. Not available in ZAPI. Uses {QtreeId}.{VolumeUUID}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Name of the Qtree, blank if the root Qtree',
  `qtreeIdentifier` int(11) DEFAULT NULL COMMENT 'ID of the qtree within its volume. This is not globally unique',
  `clusterId` bigint(20) NOT NULL,
  `volumeId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `status` enum('NOT_MAPPED','SNAPVAULTED','SNAPMIRRORED','NORMAL','READONLY') COLLATE utf8_bin DEFAULT NULL COMMENT 'State of the Qtree',
  `statusRaw` varchar(256) COLLATE utf8_bin DEFAULT NULL,
  `securityStyle` enum('NOT_MAPPED','UNIX','NTFS','MIXED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Security style of the Qtree',
  `securityStyleRaw` varchar(256) COLLATE utf8_bin DEFAULT NULL,
  `oplocks` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Is opportunistic locking enabled on this Qtree',
  `exportPolicyId` bigint(20) DEFAULT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_aggregateId` (`volumeId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_exportPolicyId` (`exportPolicyId`),
  CONSTRAINT `qtree_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `qtree_ibfk_2` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `qtree_ibfk_3` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `qtree_ibfk_4` FOREIGN KEY (`exportPolicyId`) REFERENCES `export_policy` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `qtree_quota` */

DROP TABLE IF EXISTS `qtree_quota`;

CREATE TABLE `qtree_quota` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  quota-report-iter.quota',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'UUID of the quota. Equal to the {VolumeUUID}.{QtreeUUID}.{QuotaType}.{QuotaTarget}. Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `volumeId` bigint(20) NOT NULL COMMENT 'Reference to the volume to which this quota belongs to',
  `qtreeId` bigint(20) DEFAULT NULL COMMENT 'Reference to the qtree to which this quota applies',
  `quotaTarget` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'For an explicit quota, this value is specified in the /etc/quotas file and the domain in the QUOTA_TARGET_DOMAIN directive is in effect. Multiple targets are comma separated. For a derived quota, the field is blank.',
  `quotaType` enum('USER','GROUP','TREE','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of quota',
  `diskLimit` bigint(20) DEFAULT NULL COMMENT 'Maximum amount of disk space, in kilobytes, allowed for the quota target (hard disk space limit)',
  `diskLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no disk limit',
  `diskUsed` bigint(20) DEFAULT NULL COMMENT 'Current amount of disk space, in kilobytes, used by the quota target',
  `diskUsedUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no limit fot the disk used',
  `fileLimit` bigint(20) DEFAULT NULL COMMENT 'Maximum number of files allowed for the quota target',
  `fileLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no file limit',
  `fileUsed` bigint(20) DEFAULT NULL COMMENT 'Current number of files used by the quota target',
  `fileUsedUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no limit for file used',
  `softDiskLimit` bigint(20) DEFAULT NULL COMMENT 'Soft disk space limit, in kilobytes, for the quota target',
  `softDiskLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no soft disk limit',
  `softFileLimit` bigint(20) DEFAULT NULL COMMENT 'Soft file limit, in number of files, for the quota target',
  `softFileLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no soft file limit',
  `threshold` bigint(20) DEFAULT NULL COMMENT 'Disk space threshold, in kilobytes, for the quota target',
  `thresholdUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no threshold limit',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `FK_qtreeId` (`qtreeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `qtree_quota_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `qtree_quota_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `qtree_quota_ibfk_3` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `qtree_quota_ibfk_4` FOREIGN KEY (`qtreeId`) REFERENCES `qtree` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `quota_user` */

DROP TABLE IF EXISTS `quota_user`;

CREATE TABLE `quota_user` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  quota-report-iter.quota.quota-users.quota-user',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'UUID of the quota. Equal to the {QuotaUUID}.{quotaUserName} Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `userQuotaId` bigint(20) NOT NULL COMMENT 'Reference to the userquota to which this user belongs to',
  `quotaUserId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The id of the user. The quota-user-type determines the format. For uid and gid, the format is an integer. For sid, the format is the usual style',
  `quotaUserName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of the user, group, or sid',
  `quotaUserType` enum('SID','UID','GID','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of quota user',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_userQuotaId` (`userQuotaId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `quota_user_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `quota_user_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `quota_user_ibfk_4` FOREIGN KEY (`userQuotaId`) REFERENCES `user_quota` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `raid_group` */

DROP TABLE IF EXISTS `raid_group`;

CREATE TABLE `raid_group` (
  `objid` bigint(20) NOT NULL COMMENT 'Object ID within the platform server.  ZAPIs:   aggr-get-iter.aggr-attributes.raid-group-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the raid group. Not available in ZAPI. Uses {AggregateUUID}.{PlexName}.{RaidGroupName}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `plexId` bigint(20) NOT NULL,
  `aggregateId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `isReconstructing` tinyint(1) DEFAULT NULL COMMENT 'true if the RAID group is currently reconstructing.',
  `raidType` enum('NOT_MAPPED','RAID_DP','RAID4','RAID0','MIXED_RAID_TYPE','INVALID') COLLATE utf8_bin DEFAULT NULL COMMENT 'For OnTap 8.3 and above : RAID Type of RAID Group; Set to Null for OnTap 8.2 and below.',
  `raidTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'For OnTap 8.3 and above : RAID Type of RAID Group; Set to Null for OnTap 8.2 and below.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_plexId` (`plexId`),
  KEY `FK_aggregateId` (`aggregateId`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `raid_group_ibfk_1` FOREIGN KEY (`plexId`) REFERENCES `plex` (`objid`),
  CONSTRAINT `raid_group_ibfk_2` FOREIGN KEY (`aggregateId`) REFERENCES `aggregate` (`objid`),
  CONSTRAINT `raid_group_ibfk_3` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `raid_group_ibfk_4` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `routing_group` */

DROP TABLE IF EXISTS `routing_group`;

CREATE TABLE `routing_group` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the RoutingGroup. DERIVED from {clusterUUID}.{vserver-uuid}.{routing-group}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED.  A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `routingGroupName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The name of routing group.',
  `addressFamily` enum('IPV4','IPV6','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Address family.',
  `addressFamilyRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Address family - raw zapi value.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `routing_group_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `routing_group_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `routing_group_destination` */

DROP TABLE IF EXISTS `routing_group_destination`;

CREATE TABLE `routing_group_destination` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the RoutingGroupDestination. DERIVED from {clusterUUID}.{vserver-uuid}.{routing-group}.{destination-address}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `routingGroupId` bigint(20) NOT NULL,
  `destinationAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The IP address and subnet mask of destination',
  `gatewayAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The IP address and subnet mask of destination',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_routingGroupId` (`routingGroupId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `routing_group_destination_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `routing_group_destination_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `routing_group_destination_ibfk_3` FOREIGN KEY (`routingGroupId`) REFERENCES `routing_group` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `service_processor` */

DROP TABLE IF EXISTS `service_processor`;

CREATE TABLE `service_processor` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `UUID` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the ServiceProcessor. DERIVED from  {clusterUUID}.{macAddress}.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED.  A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) DEFAULT NULL,
  `macAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'MAC address of the device.',
  `ipAddress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Ordered list of Public addresses of the device, comma separated.',
  `type` enum('RLM','SP','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of device.',
  `typeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of device - raw zapi value.',
  `status` enum('ONLINE','OFFLINE','SP_DAEMON_OFFLINE','NODE_OFFLINE','DEGRADED','REBOOTING','UNKNOWN','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Current status of the device.',
  `statusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Current status of the device - raw zapi value.',
  `isIpConfigured` tinyint(1) NOT NULL COMMENT 'Is network configured on the device to have at least one public IP address',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `service_processor_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `service_processor_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `sis_policy` */

DROP TABLE IF EXISTS `sis_policy`;

CREATE TABLE `sis_policy` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of the sis policy.  DERIVED from {VserverUUID}.{policy name}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The name of the sis policy.',
  `vserverId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `jobScheduleId` bigint(20) DEFAULT NULL,
  `isEnabled` tinyint(1) DEFAULT NULL COMMENT 'If the value is true, the sis policy is active and sis operations will be triggered on the volume on the specified schedule',
  `comment` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'A brief description of the policy.',
  `duration` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The duration in hours for which the scheduled sis operation should run',
  `qosPolicy` enum('BACKGROUND','BEST_EFFORT','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'QoS policy for the sis operation.',
  `qosPolicyRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_jobScheduleId` (`jobScheduleId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `sis_policy_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `sis_policy_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `sis_policy_ibfk_3` FOREIGN KEY (`jobScheduleId`) REFERENCES `job_schedule` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snap_mirror` */

DROP TABLE IF EXISTS `snap_mirror`;

CREATE TABLE `snap_mirror` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  snapmirror-get-iter.snapmirror-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The UUID of the object. Equal to the {SourceLocation}.{DestinationLocation} Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `volumeId` bigint(20) DEFAULT NULL,
  `nodeId` bigint(20) DEFAULT NULL,
  `vserverId` bigint(20) NOT NULL,
  `destinationLocation` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the destination endpoint of the SnapMirror relationship in the format: [cluster:]//vserver/volume',
  `sourceClusterId` bigint(20) DEFAULT NULL,
  `sourceVolumeId` bigint(20) DEFAULT NULL,
  `sourceVserverId` bigint(20) DEFAULT NULL,
  `sourceCluster` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the source cluster of the SnapMirror relationship. The source Vserver and source volume must also be specified if using this parameter',
  `sourceVolume` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the source volume of the SnapMirror relationship. The source cluster and source Vserver must also be specified if using this parameter',
  `sourceVserver` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the source Vserver of the SnapMirror relationship. The source cluster and source volume must also be specified if using this parameter',
  `sourceLocation` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the source endpoint of the SnapMirror relationship in the format: [cluster:]//vserver/volume',
  `mirrorState` enum('UNINITIALIZED','SNAPMIRRORED','BROKEN_OFF','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the mirror state of the SnapMirror relationship',
  `mirrorStateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw mirror state enum value',
  `exportedSnapshotId` bigint(20) DEFAULT NULL COMMENT 'The exported snapshot copy on the destination volume',
  `newestSnapshotId` bigint(20) DEFAULT NULL COMMENT 'The newest snapshot copy on the destination volume',
  `networkCompressionRatio` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The compression ratio achieved for the data sent over the wire with network compression enabled',
  `operationId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Operation unique identifier of the currently executing SnapMirror operation.',
  `transferSnapshot` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The name of the current snapshot copy being transferred. This is set only when the relationship-status indicates that an activity is in progress',
  `snapMirrorPolicyId` bigint(20) DEFAULT NULL,
  `isConstituent` tinyint(1) DEFAULT NULL COMMENT 'Constituent relationship',
  `isHealthy` tinyint(1) DEFAULT NULL COMMENT 'False if the last manual or scheduled update failed or was aborted, or if the last scheduled update was delayed. Otherwise true',
  `maxTransferRate` bigint(20) DEFAULT NULL COMMENT 'Specifies the upper bound, in kilobytes per second, at which data is transferred between clusters',
  `relationshipProgress` bigint(20) DEFAULT NULL COMMENT 'The total number of bytes that have been processed so far for the current activity of the relationship as returned in the relationship-status',
  `relationshipStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw relationship status enum value',
  `relationshipType` enum('DATA_PROTECTION','LOAD_SHARING','VAULT','RESTORE','TRANSITION_DATA_PROTECTION','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the status of the SnapMirror relationship',
  `relationshipTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw relationship status enum value',
  `tries` int(11) DEFAULT NULL COMMENT 'Specifies the maximum number of times to attempt each manual or scheduled transfer for a SnapMirror relationship. The default is eight times',
  `unhealthyReason` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The reason the relationship is not healthy',
  `snapshotCheckpoint` bigint(20) DEFAULT NULL COMMENT 'The number of bytes transferred as recorded for the checkpoint of the current or most recent transfer snapshot',
  `snapshotProgress` bigint(20) DEFAULT NULL COMMENT 'The number of bytes transferred for the transfer snapshot. This is set only when the relationship-status indicates that an activity is in progress',
  `currentMaxTransferRate` bigint(20) DEFAULT NULL COMMENT 'The upper bound in kilobytes per second, at which data is transferred between clusters for the current transfer.',
  `currentTransferError` varchar(1024) COLLATE utf8_bin DEFAULT NULL COMMENT 'A  message describing the LAST retryable error encountered BY the current transfer.',
  `currentTransferPriority` enum('LOW','NORMAL','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Priority assigned to the ongoing transfer.',
  `currentTransferPriorityRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `currentTransferType` enum('INITIALIZE','UPDATE','RESYNC','RESTORE','CHECK','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of transfer taking place.',
  `currentTransferTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `lagTime` bigint(20) DEFAULT NULL,
  `lastTransferDuration` bigint(20) DEFAULT NULL,
  `lastTransferEndTimestamp` timestamp NULL DEFAULT NULL COMMENT 'The Timestamp of the end of the last transfer',
  `lastTransferError` varchar(1024) COLLATE utf8_bin DEFAULT NULL COMMENT 'A message describing the cause of the LAST transfer failure.',
  `lastTransferErrorCodes` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'List of codes providing additional information on the cause and context of the last transfer failure.',
  `lastTransferNetworkCompressionRatio` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The compression ratio achieved for the data sent over the wire as a part of the last transfer',
  `lastTransferType` enum('INITIALIZE','UPDATE','RESYNC','RESTORE','CHECK','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the previous transfer for the relationship.',
  `lastTransferTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `progressLastUpdated` timestamp NULL DEFAULT NULL COMMENT 'A timestamp indicating when the progress of the transfer was last updated.',
  `lastTransferSize` bigint(20) DEFAULT NULL COMMENT 'The total number of bytes transferred as part of the last transfer. ZAPI: snapmirror-info.last-transfer-size',
  `relationshipControlPlane` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the control plane used for the relationship.',
  `relationshipGroupType` enum('NOT_MAPPED','NONE','VSERVER','INFINITEVOL') COLLATE utf8_bin DEFAULT NULL COMMENT 'For FlexVol relationships, specifies the type of the group relationship that includes this FlexVol. For group relationships, specifies the type of the group relationship.',
  `relationshipGroupTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'For FlexVol relationships, specifies the type of the group relationship that includes this FlexVol. For group relationships, specifies the type of the group relationship.',
  `relationshipIdentifier` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'A unique identifier assigned to the SnapMirror relationship when it is created.',
  `jobScheduleId` bigint(20) DEFAULT NULL,
  `destVolDerivedStyle` enum('UNKNOWN','FLEXVOL','INFINIVOL','CONSTITUENT','STRIPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The derived style of the destination volume.',
  `relationshipStatus` enum('IDLE','TRANSFERRING','CHECKING','QUIESCING','QUIESCED','QUEUED','PREPARING','FINALIZING','ABORTING','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the status of the SnapMirror relationship',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_exportedSnapshotId` (`exportedSnapshotId`),
  KEY `FK_newestSnapshotId` (`newestSnapshotId`),
  KEY `FK_sourceClusterId` (`sourceClusterId`),
  KEY `FK_sourceVolumeId` (`sourceVolumeId`),
  KEY `FK_sourceVserverId` (`sourceVserverId`),
  KEY `FK_snapMirrorPolicyId` (`snapMirrorPolicyId`),
  KEY `FK_jobScheduleId` (`jobScheduleId`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `FK_jobScheduleId` FOREIGN KEY (`jobScheduleId`) REFERENCES `job_schedule` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_10` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_11` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_12` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_13` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_4` FOREIGN KEY (`exportedSnapshotId`) REFERENCES `snapshot` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_5` FOREIGN KEY (`newestSnapshotId`) REFERENCES `snapshot` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_6` FOREIGN KEY (`sourceClusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_7` FOREIGN KEY (`sourceVolumeId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_8` FOREIGN KEY (`sourceVserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `snap_mirror_ibfk_9` FOREIGN KEY (`snapMirrorPolicyId`) REFERENCES `snap_mirror_policy` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snap_mirror_policy` */

DROP TABLE IF EXISTS `snap_mirror_policy`;

CREATE TABLE `snap_mirror_policy` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of the snapmirror policy. DERIVED from {VserverUUID}.{policy name}.   If cluster scoped, this will just be the policy name.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT ' The name of the policy.',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) DEFAULT NULL,
  `comment` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'A human readable description associated with the snapmirror policy.',
  `createSnapshot` tinyint(1) DEFAULT NULL COMMENT 'Specifies whether a new Snapshot Copy is created at the time of a SnapMirror transfer.',
  `ignoreAccessTime` tinyint(1) DEFAULT NULL COMMENT 'Specifies whether incremental transfers will ignore files which have only their access time changed.',
  `isNetworkCompressionEnabled` tinyint(1) DEFAULT NULL COMMENT 'Specifies whether network compression is enabled for transfers.',
  `restart` enum('NOT_MAPPED','ALWAYS','NEVER','DEFAULT') COLLATE utf8_bin DEFAULT NULL COMMENT 'Defines the behavior of SnapMirror if an interrupted transfer exists - "always" , "never" , "default".',
  `restartRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Defines the behavior of SnapMirror if an interrupted transfer exists - "always" , "never" , "default".',
  `totalKeep` bigint(20) DEFAULT NULL COMMENT 'Total retention count for all rules in the policy.',
  `transferPriority` enum('LOW','NORMAL','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the priority at which a SnapMirror transfer runs.',
  `transferPriorityRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `tries` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the maximum number of times to attempt each manual or scheduled transfer for a SnapMirror relationship.',
  `type` enum('NOT_MAPPED','VAULT','ASYNC_MIRROR','MIRROR_VAULT','SYNC_MIRROR') COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the Snapmirror policy - "vault" , "async_mirror" , "mirror_vault" ,"sync_mirror"',
  `typeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the Snapmirror policy - "vault" , "async_mirror" , "mirror_vault" ,"sync_mirror"',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `snap_mirror_policy_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `snap_mirror_policy_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snap_mirror_policy_rule` */

DROP TABLE IF EXISTS `snap_mirror_policy_rule`;

CREATE TABLE `snap_mirror_policy_rule` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of the snapmirror policy rule. DERIVED from {SnapmirrorPolicyUUID}.{ordinalIndex}.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `snapMirrorPolicyId` bigint(20) NOT NULL,
  `keep` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the snapmirror copy retention count.',
  `preserve` tinyint(1) DEFAULT NULL COMMENT 'Specifies whether snapmirror copy preserve is enabled',
  `snapMirrorLabel` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies the snapmirror copy label.',
  `warn` bigint(20) DEFAULT NULL COMMENT 'Specifies the warning threshold count.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_snapMirrorPolicyId` (`snapMirrorPolicyId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `snap_mirror_policy_rule_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `snap_mirror_policy_rule_ibfk_2` FOREIGN KEY (`snapMirrorPolicyId`) REFERENCES `snap_mirror_policy` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snap_mirror_self_relationship` */

DROP TABLE IF EXISTS `snap_mirror_self_relationship`;

CREATE TABLE `snap_mirror_self_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'UUID of the Volume Snap Mirror',
  `vserverSnapMirrorId` bigint(20) DEFAULT NULL COMMENT 'ID of the parent vserver snap mirror',
  `checksum` int(11) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_vserverSnapMirrorId` (`vserverSnapMirrorId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `snap_mirror_self_relationship_ibfk_1` FOREIGN KEY (`objid`) REFERENCES `snap_mirror` (`objid`),
  CONSTRAINT `snap_mirror_self_relationship_ibfk_2` FOREIGN KEY (`vserverSnapMirrorId`) REFERENCES `snap_mirror` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snapshot` */

DROP TABLE IF EXISTS `snapshot`;

CREATE TABLE `snapshot` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the snapshot. Not available in ZAPI. Uses {VolumeUUID}.{SnapshotInstanceUUID}',
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Name of the snapshot.  ZAPI:  snapshot-get-ter snapshot-info name',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `volumeId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `instanceUUID` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The 128 bit unique snapshot identifier expressed in the form of UUID. This field uniquely identifies the snapshot''s physical data layout.  ZAPI:  snapshot-get-ter snapshot-info snapshot-instance-uuid',
  `versionUUID` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The 128 bit unique snapshot identifier expressed in the form of UUID. This field uniquely identifies the snapshot''s logical data layout.  ZAPI:  snapshot-get-ter snapshot-info snapshot-version-uuid',
  `isBusy` tinyint(1) DEFAULT NULL COMMENT 'True if the snapshot is being used by an application.  ZAPI: snapshot-get-ter snapshot-info busy',
  `accessTime` timestamp NULL DEFAULT NULL COMMENT 'The volume access time when the snapshot was created in seconds since Jan 1, 1970. This value will not change even if the snapshot is accessed. ZAPI: snapshot-get-ter snapshot-info access-time',
  `dependency` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Application(s) dependent on this snapshot.  ZAPI:  snapshot-get-ter snapshot-info dependency',
  `percentageOfTotalBlocks` int(11) DEFAULT NULL COMMENT 'Percentage of blocks owned by this snapshot, relative to the total number of blocks in the volume.  ZAPI: snapshot-get-ter snapshot-info percentage-of-total-blocks',
  `cumulativePercentageOfTotalBlocks` int(11) DEFAULT NULL COMMENT 'Percentage of blocks owned by this snapshot and all more recent snapshots, relative to the total number of blocks in the volume.  snapshot-get-ter snapshot-info cumulative-percentage-of-total-blocks',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `snapshot_ibfk_1` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `snapshot_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `snapshot_ibfk_3` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snapshot_policy` */

DROP TABLE IF EXISTS `snapshot_policy`;

CREATE TABLE `snapshot_policy` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of the snapshot policy. DERIVED from {ClusterUUID}.{VserverUUID}.{policy name}. If cluster scoped, this will just be the policy name.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'A human readable string describing the name of the snapshot scheduling policy.',
  `clusterId` bigint(20) NOT NULL,
  `isEnabled` tinyint(1) DEFAULT NULL COMMENT 'The state of the snapshot policy. If true, the snapshot policy is enabled and scheduled snapshots will be created on the volume associated with this policy.',
  `comment` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'A human readable description associated with the snasphot policy.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `snapshot_policy_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snapshot_policy_schedule` */

DROP TABLE IF EXISTS `snapshot_policy_schedule`;

CREATE TABLE `snapshot_policy_schedule` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of the snapshot policy schedule. DERIVED from {ClusterUUID}.{VserverUUID}.{snapshotPolicy.name}.{schedule.prefix}.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `snapshotPolicyId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `jobScheduleId` bigint(20) DEFAULT NULL,
  `prefix` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Snapshot name prefix for the schedule present in the snapshot policy.',
  `snapMirrorLabel` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Snapshot SnapMirror Label for the schedule present in the snapshot policy.',
  `count` bigint(20) DEFAULT NULL COMMENT 'Maximum number of snapshots to retain for the schedule present in the snapshot policy.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_snapshotPolicyId` (`snapshotPolicyId`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_jobScheduleId` (`jobScheduleId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `snapshot_policy_schedule_ibfk_1` FOREIGN KEY (`snapshotPolicyId`) REFERENCES `snapshot_policy` (`objid`),
  CONSTRAINT `snapshot_policy_schedule_ibfk_2` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `snapshot_policy_schedule_ibfk_3` FOREIGN KEY (`jobScheduleId`) REFERENCES `job_schedule` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `snapshot_policy_vserver_relationship` */

DROP TABLE IF EXISTS `snapshot_policy_vserver_relationship`;

CREATE TABLE `snapshot_policy_vserver_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the Snapshot Policy to vserver relationship.',
  `vserverId` bigint(20) DEFAULT NULL COMMENT 'ID of the vserver that this Snapshot Policy is associated with.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `snapshot_policy_vserver_relationship_ibfk_1` FOREIGN KEY (`objid`) REFERENCES `snapshot_policy` (`objid`),
  CONSTRAINT `snapshot_policy_vserver_relationship_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_adapter` */

DROP TABLE IF EXISTS `storage_adapter`;

CREATE TABLE `storage_adapter` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  storage-adapter-get-adapter-list.adapter-list.adapter-name-elem, storage-adapter-get-adapter-info.adapter-details.adapter-detail-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the adapter. Not from ZAPI. Format is {NodeUUID.{adapterName}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `name` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name of the adapter',
  `fcNodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'FCP World Wide Node Name (WWNN) of the adapter. Only for FC type adapters',
  `fcPortName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Fibre Channel World Wide Port Name (WWPN) of adapter.',
  `state` enum('NOT_MAPPED','UP','DOWN','OFFLINE_SOFT','OFFLINE_HARD','OFFLINE_LOOPBACK') COLLATE utf8_bin DEFAULT NULL COMMENT 'Current state of the adapter',
  `stateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw value of Current state of the adapter',
  `cableEndIdentifier` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Each cable has two ends. This field shows which end of the cable is connected to the shelf.',
  `cableLength` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Cable Length.',
  `cableManufacturer` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Manufacturer of the cable.',
  `cablePartNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Part number of the cable as assigned by the cable manufacturer.',
  `cableSerialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Cable identifier. For backwards compatibility this is reported as cable-serial-number.',
  `attachedSerialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Serial number of the attached cable as assigned by the cable manufacturer.',
  `cableTechnology` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Cable Technology.',
  `isInUse` tinyint(1) DEFAULT NULL COMMENT 'Is the adapter inuse? Only for FC type adapters',
  `model` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Model of the adapter. Only for FC type adapters',
  `status` enum('ONLINE','OFFLINE','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Status of the adapter',
  `adapterType` enum('ADT_IF_ATA','ADT_IF_PARALLEL_SCSI','ADT_IF_SAS','ADT_IF_FC','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of adapter present in the system',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_adapter_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `storage_adapter_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_pool` */

DROP TABLE IF EXISTS `storage_pool`;

CREATE TABLE `storage_pool` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPI:  storage-pool-get-iter.storage-pool-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the storage pool. DERIVED: {ClusterUUID}.{StoragePoolName}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The cluster-wide unique name of the storage pool.',
  `clusterId` bigint(20) NOT NULL,
  `allocationUnitSize` bigint(20) NOT NULL COMMENT 'Minimum size that can be allocated from the storage pool.',
  `diskCount` bigint(20) NOT NULL COMMENT 'The number of disks that are part of the  storage pool',
  `isHealthy` tinyint(1) DEFAULT NULL,
  `poolUsableSize` bigint(20) DEFAULT NULL COMMENT 'The amount of usable size in bytes in the  storage pool.',
  `poolTotalSize` bigint(20) DEFAULT NULL COMMENT 'The total size of the  storage pool.',
  `storageType` enum('NOT_MAPPED','ATA','BSAS','FCAL','FSAS','LUN','MSATA','SAS','SATA','SSD') COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the disks that constitute the storage pool',
  `storageTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the disks that constitute the storage pool',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_pool_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_pool_aggregate_relationship` */

DROP TABLE IF EXISTS `storage_pool_aggregate_relationship`;

CREATE TABLE `storage_pool_aggregate_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique relationship identifier. ZAPI:storage-pool-aggregate-get-iter.storage-pool-aggregate-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of this relationship. DERIVED:{ClusterUUID}.{StoragePoolName}.{AggregateUUID}.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `storagePoolId` bigint(20) NOT NULL,
  `aggregateId` bigint(20) NOT NULL,
  `usedCapacity` bigint(20) DEFAULT NULL COMMENT 'Capacity provisioned by aggregate from  storage pool',
  `allocatedUnitCount` bigint(20) DEFAULT NULL COMMENT 'No of memory units provisioned by aggregate from  storage pool',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_storagePoolId` (`storagePoolId`),
  KEY `FK_aggregateId` (`aggregateId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_pool_aggregate_relationship_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `storage_pool_aggregate_relationship_ibfk_2` FOREIGN KEY (`storagePoolId`) REFERENCES `storage_pool` (`objid`),
  CONSTRAINT `storage_pool_aggregate_relationship_ibfk_3` FOREIGN KEY (`aggregateId`) REFERENCES `aggregate` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_pool_available` */

DROP TABLE IF EXISTS `storage_pool_available`;

CREATE TABLE `storage_pool_available` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique relationship identifier.ZAPI: storage-pool-spare-capacity-get-iter.storage-pool-spare-capacity-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of this relationship.  DERIVED:{ClusterUUID}.{NodeUUID}.{StoragePoolName}.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `storagePoolId` bigint(20) NOT NULL,
  `allocationUnitCount` bigint(20) NOT NULL COMMENT 'The total number of units which can be allocated as spare capacity for aggregates',
  `allocationUnitSize` bigint(20) NOT NULL COMMENT 'Minimum size that can be allocated from the  storage pool',
  `availableSize` bigint(20) DEFAULT NULL,
  `storageType` enum('NOT_MAPPED','ATA','BSAS','FCAL','FSAS','LUN','MSATA','SAS','SATA','SSD') COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the disks that constitute the storage pool',
  `storageTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the disks that constitute the storage pool',
  `syncmirrorPool` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The name of the syncmirror pool.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_storagePoolId` (`storagePoolId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_pool_available_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `storage_pool_available_ibfk_2` FOREIGN KEY (`storagePoolId`) REFERENCES `storage_pool` (`objid`),
  CONSTRAINT `storage_pool_available_ibfk_3` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_service` */

DROP TABLE IF EXISTS `storage_service`;

CREATE TABLE `storage_service` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `UUID` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the Storage Service. DERIVED from  {volumeUUID}.{storageServiceIdentifier}.',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED.  A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `storageServiceIdentifier` bigint(20) NOT NULL COMMENT 'Storage Service ID. ZAPIs: volume-storage-service-get-iter.storage-service-info.storage-service-id',
  `storageServiceName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Storage Service Name. ZAPIs: volume-storage-service-get-iter.storage-service-info.storage-service',
  `sizeUsed` bigint(20) DEFAULT NULL COMMENT 'Derived.  Sum of sizeUsed over all constituent volumes assigned to this service. In bytes.',
  `sizeTotal` bigint(20) DEFAULT NULL COMMENT 'Derived.  Sum of sizeTotal over all constituent volumes assigned to this service. In bytes.',
  `sizeUsedBySnapshots` bigint(20) DEFAULT NULL COMMENT 'Derived.  Sum of sizeUsedBySnapshots over all constituent volumes assigned to this service. In bytes.',
  `snapshotReserveSize` bigint(20) DEFAULT NULL COMMENT 'Derived.  Sum of snapshotReserveSize over all constituent volumes assigned to this service. In bytes.',
  `deduplicationSpaceSaved` bigint(20) DEFAULT NULL COMMENT 'Derived.  Sum of deduplicationSpaceSaved over all constituent volumes assigned to this service. In bytes.',
  `compressionSpaceSaved` bigint(20) DEFAULT NULL COMMENT 'Derived.  Sum of compressionSpaceSaved over all constituent volumes assigned to this service. In bytes.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_service_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `storage_service_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_service_volume_relationship` */

DROP TABLE IF EXISTS `storage_service_volume_relationship`;

CREATE TABLE `storage_service_volume_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the relationship. Not from ZAPI',
  `storageServiceId` bigint(20) DEFAULT NULL COMMENT 'ID of the storage service',
  `volumeId` bigint(20) DEFAULT NULL COMMENT 'ID of the volume the storage service references',
  `checksum` int(11) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_service_volume_relationship_ibfk_1` FOREIGN KEY (`objid`) REFERENCES `storage_service` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_shelf` */

DROP TABLE IF EXISTS `storage_shelf`;

CREATE TABLE `storage_shelf` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the storage shelf. Derived from ShelfUUID. Not from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `partnerNodeId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Partner Node UUID',
  `shelfUuid` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Shelf unique identifier that distinguishes it from other shelves manufactured',
  `shelfIdentifier` int(11) DEFAULT NULL COMMENT 'The shelf id switch setting',
  `sesProductId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Enclosure product identifier',
  `firmwareRevisionA` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Shelf module A firmware revision',
  `firmwareRevisionB` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Shelf module B firmware revision',
  `module` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The shelf module attachment',
  `channelName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The channel/port-number the shelf (hub) is attached to',
  `partnerChannelName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Partner Channel Name',
  `shelfType` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Shelf module type',
  `state` enum('NOT_MAPPED','NO_STATUS','INIT_REQUIRED','ONLINE','OFFLINE','MISSING','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'The current state of the shelf',
  `stateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The current state of the shelf - ZAPI raw value',
  `isLocalAttach` tinyint(1) DEFAULT NULL,
  `stackId` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Adding StackId to storage_shelf',
  `temperatureSensorCount` int(11) DEFAULT NULL COMMENT 'Count of temperature sensors on this shelf',
  `temperatureSensorFailedCount` int(11) DEFAULT NULL COMMENT 'Count of failed temperature sensors on this shelf. (temp-sensor-info.temp-sensor-is-error)',
  `coolingElementCount` int(11) DEFAULT NULL COMMENT 'Count of cooling elements on this shelf',
  `coolingElementFailedCount` int(11) DEFAULT NULL COMMENT 'Count of failed cooling elements on this shelf. (cooling-element-info.cooling-element-is-error)',
  `powerSupplyCount` int(11) DEFAULT NULL COMMENT 'Count of power supplies on this shelf',
  `powerSupplyFailedCount` int(11) DEFAULT NULL COMMENT 'Count of failed power supplies on this shelf (power-supply-info.power-supply-is-error)',
  `currentSensorCount` int(11) DEFAULT NULL COMMENT 'Count of current sensors on this shelf',
  `currentSensorFailedCount` int(11) DEFAULT NULL COMMENT 'Current of failed current sensors on this shelf (current-sensor-info.is-sensor-error)',
  `voltageSensorCount` int(11) DEFAULT NULL COMMENT 'Count of current sensors on this shelf',
  `voltageSensorFailedCount` int(11) DEFAULT NULL COMMENT 'Current of failed current sensors on this shelf (current-sensor-info.is-sensor-error)',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_shelf_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `storage_shelf_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_shelf_cable` */

DROP TABLE IF EXISTS `storage_shelf_cable`;

CREATE TABLE `storage_shelf_cable` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `UUID` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the Application Record. Equal to {ClusterUUID}.{ShelfId}.{ChannelName}.{PartNumber}.{SerialNumber}.{ConnectorNumber}. Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally',
  `clusterId` bigint(20) NOT NULL,
  `nodeId` bigint(20) NOT NULL,
  `shelfId` bigint(20) NOT NULL,
  `channelName` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Storage controller channel the shelf is connected to.',
  `isShelfChannelFailure` tinyint(1) DEFAULT NULL COMMENT 'Indicates whether any shelves on this channel have experienced a failure.',
  `endIdentifier` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Each cable has two ends. This field shows which end of the cable is connected to the shelf.',
  `length` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Cable length',
  `manufacturer` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Manufacturer of the cable.',
  `partNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Part number of the cable as assigned by the cable manufacturer.',
  `serialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Cable identifier. For backwards compatibility this is reported as cable-serial-no.',
  `attachedSerialNumber` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Serial number of the attached cable as assigned by the cable manufacturer.',
  `technology` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Cable Technology.',
  `type` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of the cable being used',
  `connectorDesignator` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Connector Designator',
  `connectorNumber` int(11) DEFAULT NULL COMMENT 'Connector Number',
  `isCableConnected` tinyint(1) DEFAULT NULL COMMENT 'Indicates whether a cable is connected at this connector location. No further information will be provided if a cable is not connected at this connector location. Note that a cable connection does not necessarily mean that the shelf is connected to a storage controller. This will also depend on the other end of the cable.',
  `isConnectorError` tinyint(1) DEFAULT NULL COMMENT 'Indicates whether the connector element has encountered an error.',
  `swapCount` int(11) DEFAULT NULL COMMENT 'Number of times, since last boot, a cable has been inserted into this connector',
  `shelfModule` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Shelf module for this connector.',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `FK_shelfId` (`shelfId`),
  CONSTRAINT `storage_shelf_cable_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `storage_shelf_cable_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`),
  CONSTRAINT `storage_shelf_cable_ibfk_3` FOREIGN KEY (`shelfId`) REFERENCES `storage_shelf` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `storage_switch` */

DROP TABLE IF EXISTS `storage_switch`;

CREATE TABLE `storage_switch` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPI:  storage-pool-get-iter.storage-pool-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Derived from WWN. Not from ZAPI. DERIVED: {WWN}',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Name of the switch',
  `clusterId` bigint(20) NOT NULL,
  `wwn` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'World Wide Name of the switch',
  `vendor` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Vendor of the switch. E.g.: ''cisco'' or ''brocade''',
  `firmwareVersion` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Firmware version of the switch',
  `ipAddress` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'IP address of the switch',
  `model` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Model of the switch',
  `role` enum('NOT_MAPPED','UNKNOWN','PRIMARY','SUBORDINATE') COLLATE utf8_bin DEFAULT NULL COMMENT 'Role of switch in the fabric',
  `roleRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Role of switch in the fabric',
  `status` enum('NOT_MAPPED','UNKNOWN','OK','ERROR') COLLATE utf8_bin DEFAULT NULL COMMENT 'Status of switch in the fabric',
  `statusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Status of switch in the fabric',
  `sensorCount` int(11) DEFAULT NULL COMMENT 'Sensor count',
  `powerSupplyCount` int(11) DEFAULT NULL COMMENT 'Power supply count',
  `fanCount` int(11) DEFAULT NULL COMMENT 'Fan count',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `storage_switch_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `system_health_alert` */

DROP TABLE IF EXISTS `system_health_alert`;

CREATE TABLE `system_health_alert` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the SHM events Derived: {clusterUUID}.alertId.alertingResource',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `alertId` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Alert identification',
  `alertingResource` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Unique name of resource that generated the alert',
  `alertingResourceName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Display name of resource that generated the alert.',
  `clusterId` bigint(20) NOT NULL COMMENT 'Cluseter objid hosting this health monitor',
  `nodeId` bigint(20) NOT NULL COMMENT 'Node objid hosting this health monitor',
  `indicationTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Time of alert generation',
  `monitor` enum('NOT_MAPPED','NODE_CONNECT','SYSTEM_CONNECT','SYSTEM') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of health monitor',
  `monitorRAW` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of health monitor. Value from ZAPI',
  `perceivedSeverity` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'Severity of alert',
  `policy` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Policy rule responsible for creating this alert',
  `possibleEffect` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'Possible effect seen due to this problem',
  `correctiveActions` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'Recommended actions to correct the problem reported by alert',
  `probableCause` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'Probable cause for alert generation',
  `probableCauseDescription` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'Detailed description of probable cause for alert generation',
  `subsystem` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of subsystem being monitored',
  `additionalInfo` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'Additional information from the resource that generated this alert',
  `acknowledge` tinyint(1) DEFAULT NULL COMMENT ' Acknowledge the alert condition',
  `acknowledger` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'Person who acknowledged this alert',
  `suppress` tinyint(1) DEFAULT NULL COMMENT 'Suppress this alert',
  `suppressor` varchar(45) COLLATE utf8_bin DEFAULT NULL COMMENT 'Person who suppressed this alert',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`objid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_nodeId` (`nodeId`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `system_health_alert_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `system_health_alert_ibfk_2` FOREIGN KEY (`nodeId`) REFERENCES `node` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `update_history` */

DROP TABLE IF EXISTS `update_history`;

CREATE TABLE `update_history` (
  `createTime` bigint(20) NOT NULL,
  `starttime` bigint(20) NOT NULL DEFAULT '0',
  `duration` bigint(20) NOT NULL DEFAULT '0',
  `originid` bigint(20) NOT NULL,
  `physicalchange` int(11) NOT NULL DEFAULT '0',
  `runnerchange` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`createTime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `upgrade_history` */

DROP TABLE IF EXISTS `upgrade_history`;

CREATE TABLE `upgrade_history` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `starttime` bigint(20) NOT NULL,
  `duration` bigint(20) NOT NULL,
  `fromMajor` int(11) NOT NULL,
  `fromMinor` int(11) NOT NULL,
  `fromMaintenance` int(11) NOT NULL,
  `fromLevel` int(11) NOT NULL,
  `toMajor` int(11) NOT NULL,
  `toMinor` int(11) NOT NULL,
  `toMaintenance` int(11) NOT NULL,
  `toLevel` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `user_quota` */

DROP TABLE IF EXISTS `user_quota`;

CREATE TABLE `user_quota` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  quota-report-iter.quota',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'UUID of the quota. Equal to the {VolumeUUID}.{QtreeUUID}.{QuotaType}.{QuotaTarget}.{UserHash} Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally.',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `volumeId` bigint(20) NOT NULL COMMENT 'Reference to the volume to which this quota belongs to',
  `qtreeId` bigint(20) DEFAULT NULL COMMENT 'Reference to the qtree to which this quota applies',
  `quotaTarget` varchar(512) COLLATE utf8_bin DEFAULT NULL COMMENT 'For an explicit quota, this value is specified in the /etc/quotas file and the domain in the QUOTA_TARGET_DOMAIN directive is in effect. Multiple targets are comma separated. For a derived quota, the field is blank.',
  `quotaType` enum('USER','GROUP','TREE','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of quota',
  `diskLimit` bigint(20) DEFAULT NULL COMMENT 'Maximum amount of disk space, in kilobytes, allowed for the quota target (hard disk space limit)',
  `diskLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no disk limit',
  `diskUsed` bigint(20) DEFAULT NULL COMMENT 'Current amount of disk space, in kilobytes, used by the quota target',
  `diskUsedUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no limit fot the disk used',
  `fileLimit` bigint(20) DEFAULT NULL COMMENT 'Maximum number of files allowed for the quota target',
  `fileLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no file limit',
  `fileUsed` bigint(20) DEFAULT NULL COMMENT 'Current number of files used by the quota target',
  `fileUsedUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no limit for file used',
  `softDiskLimit` bigint(20) DEFAULT NULL COMMENT 'Soft disk space limit, in kilobytes, for the quota target',
  `softDiskLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no soft disk limit',
  `softFileLimit` bigint(20) DEFAULT NULL COMMENT 'Soft file limit, in number of files, for the quota target',
  `softFileLimitUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no soft file limit',
  `threshold` bigint(20) DEFAULT NULL COMMENT 'Disk space threshold, in kilobytes, for the quota target',
  `thresholdUnlimited` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'True if there is no threshold limit',
  `users` varchar(1024) COLLATE utf8_bin DEFAULT NULL COMMENT 'Specifies all associated users of the quota in ordered CSV style strings ',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `FK_qtreeId` (`qtreeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `user_quota_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `user_quota_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `user_quota_ibfk_3` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `user_quota_ibfk_4` FOREIGN KEY (`qtreeId`) REFERENCES `qtree` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `version` */

DROP TABLE IF EXISTS `version`;

CREATE TABLE `version` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `major` int(11) NOT NULL,
  `minor` int(11) NOT NULL,
  `maintenance` int(11) NOT NULL,
  `patch` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Data for the table `version` */

insert  into `version`(`id`,`major`,`minor`,`maintenance`,`patch`) values (1,1,3,0,0);

/*Table structure for table `volume` */

DROP TABLE IF EXISTS `volume`;

CREATE TABLE `volume` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs: volume-get-iter.volume-attributes',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the volume',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `aggregateId` bigint(20) DEFAULT NULL,
  `exportPolicyId` bigint(20) DEFAULT NULL,
  `cloneParentId` bigint(20) DEFAULT NULL COMMENT 'Clone parent if applicable.',
  `flexCacheOriginId` bigint(20) DEFAULT NULL COMMENT 'The name of the flex cache origin volume that contains the authoritative data.  Only applicable on FlexCache volumes.  ZAPIs: volume-get-iter volume-flexcache-attributes origin',
  `snapshotPolicyId` bigint(20) DEFAULT NULL,
  `sisPolicyId` bigint(20) DEFAULT NULL,
  `storageServiceId` bigint(20) DEFAULT NULL,
  `qosPolicyGroupId` bigint(20) DEFAULT NULL,
  `instanceUUID` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Globally unique ID of the Volume that remains unchanged after a volume move',
  `size` bigint(20) DEFAULT NULL COMMENT 'Size of volume in bytes. Includes WAFL reserve and snapshot reserve',
  `sizeTotal` bigint(20) DEFAULT NULL COMMENT 'Usable size of volume in bytes for data (not including WAFL reserve or snapshot reserve)',
  `sizeUsed` bigint(20) DEFAULT NULL COMMENT 'Used size of the volume in bytes',
  `sizeUsedPercent` int(11) DEFAULT NULL COMMENT 'DERIVED.  0-100.  Percentage bytes used out of total.',
  `sizeAvail` bigint(20) DEFAULT NULL COMMENT 'DERIVED.  Difference between sizeTotal and sizeUsed.',
  `sizeAvailPercent` int(11) DEFAULT NULL COMMENT 'DERIVED.  0-100.  Percentage bytes available out of total.',
  `isVserverRoot` tinyint(1) DEFAULT NULL COMMENT 'Is the volume the root of a vserver',
  `state` enum('NOT_MAPPED','ONLINE','RESTRICTED','OFFLINE','MIXED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Volume state',
  `stateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `junctionPath` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The junction path at which this volume is mounted',
  `isJunctionActive` tinyint(1) DEFAULT NULL COMMENT 'If mounted volume is accessible',
  `style` enum('NOT_MAPPED','FLEXVOL','STRIPED','INFINIVOL') COLLATE utf8_bin DEFAULT NULL COMMENT 'Volume style',
  `styleRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `DerivedStyle` enum('UNKNOWN','FLEXVOL','INFINIVOL','CONSTITUENT','STRIPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'DERIVED.  Similar to ZAPI based style, but adds in constituent as necessary.',
  `isSisVolume` tinyint(1) DEFAULT NULL COMMENT 'True if volume contains shared data (deduplication, file clones) or compressed data',
  `isDataProtectionMirror` tinyint(1) DEFAULT NULL COMMENT 'True if volume is a data protection mirror',
  `isLoadSharingMirror` tinyint(1) DEFAULT NULL COMMENT 'True if volume is a load sharing mirror',
  `isMoveMirror` tinyint(1) DEFAULT NULL COMMENT 'True if this is a move volume',
  `isReplicaVolume` tinyint(1) DEFAULT NULL COMMENT 'True if this is a read only replica volume',
  `isSpaceGuaranteeEnabled` tinyint(1) DEFAULT NULL COMMENT 'Whether or not the storage guarantee associated with the flexible volume is currently in effect',
  `spaceGuarantee` enum('NOT_MAPPED','NONE','VOLUME','FILE') COLLATE utf8_bin DEFAULT NULL COMMENT 'The storage guarantee option that is associated with the flexible volume. ZAPIs: volume-get-iter volume-space-attributes space-guarantee',
  `spaceGuaranteeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `vmAlignSector` int(11) DEFAULT NULL COMMENT 'The virtual machine alignment 512 bytes sector number',
  `vmAlignSuffix` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The virtual machine alignment suffix. The suffix such as ".xyz". is used to identify the files which needs to be aligned',
  `overwriteReserve` bigint(20) DEFAULT NULL COMMENT 'The size (in bytes) that is reserved for overwriting snapshoted data in an otherwise full volume',
  `overwriteReserveRequired` bigint(20) DEFAULT NULL COMMENT 'The reserved size (in bytes) that is required to ensure that the reserved space is sufficient to allow all space-reserved files and LUNs to be overwritten when the volume is full',
  `overwriteReserveUsed` bigint(20) DEFAULT NULL COMMENT 'The reserved size (in bytes) that is not available for new overwrites',
  `overwriteReserveAvail` bigint(20) DEFAULT NULL COMMENT 'DERIVED.  OverwriteReserve - OverwriteReserveUsed.',
  `overwriteReserveActualUsed` bigint(20) DEFAULT NULL COMMENT 'The reserved size (in bytes) that has been used',
  `snapshotReserveSize` bigint(20) DEFAULT NULL COMMENT 'The size (in bytes) in the volume that has been set aside as reserve for snapshot usage',
  `percentageSnapshotReserve` int(11) DEFAULT NULL COMMENT 'Percentage of the volume reserved for snapshots.  Integer 0-100.  ZAPIs: volume-get-iter volume-space-attributes percentage-snapshot-reserve',
  `sizeUsedBySnapshots` bigint(20) DEFAULT NULL COMMENT 'The size (in bytes) that is used by snapshots in the volume.  ZAPIs: volume-get-iter size-volume-space-attributes size-used-by-snapshots',
  `percentageSnapshotReserveUsed` int(11) DEFAULT NULL COMMENT 'Percentage of the volume reserved for snapshots that has been used',
  `sizeAvailableForSnapshot` bigint(20) DEFAULT NULL COMMENT 'Total free space (in bytes) available in the volume and snapshot reserve',
  `percentageFractionalReserve` int(11) DEFAULT NULL COMMENT 'This field can be used to change the amount of space reserved for overwrites of reserved objects (e.g., files, LUNs) in a volume',
  `deduplicationSpaceSaved` bigint(20) DEFAULT NULL COMMENT 'The total disk space (in bytes) that is saved by deduplication',
  `compressionSpaceSaved` bigint(20) DEFAULT NULL COMMENT 'The total disk space (in bytes) that is saved by compressing blocks on the referenced file system',
  `securityStyle` enum('NOT_MAPPED','MIXED','NTFS','UNIX','UNIFIED') COLLATE utf8_bin DEFAULT NULL COMMENT 'The security style associated with this volume',
  `securityStyleRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `hybridCacheEligibility` enum('READ','READ_WRITE','NOT_MAPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Hybrid cacPlhe eligibility of a volume',
  `hybridCacheEligibilityRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `inodeFilesUsed` bigint(20) DEFAULT NULL COMMENT 'Number of user-visible files (inodes) used. This field is valid only when the volume is online.  ZAPIs: volume-get-iter volume-inode-attributes files-used',
  `inodeFilesTotal` bigint(20) DEFAULT NULL COMMENT 'Total user-visible file (inode) count, i.e., current maximum number of user-visible files (inodes) that this volume can currently hold.  ZAPIs: volume-get-iter volume-inode-attributes files-total',
  `inodeBlockType` enum('NOT_MAPPED','32_BIT','64_BIT') COLLATE utf8_bin DEFAULT NULL COMMENT 'The indirect block format of the volume.  ZAPIs: volume-get-iter volume-inode-attributes block-type',
  `inodeBlockTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `quotaCommitted` bigint(20) DEFAULT NULL COMMENT 'DERIVED.  Sum of quota limits on all Qtrees on this Volume.',
  `quotaOverCommitted` bigint(20) DEFAULT NULL COMMENT 'DERIVED.  QuotaCommitted bytes adjusted by the volume size and snapshot size.',
  `quotaStatus` enum('NOT_MAPPED','CORRUPT','INITIALIZING','OFF','ON','RESIZING','REVERTING','UPGRADING') COLLATE utf8_bin DEFAULT NULL COMMENT 'Primary status of quotas on the indicated volume',
  `quotaStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw value of primary status of quotas on the indicated volume',
  `flexCacheMinReserve` bigint(20) DEFAULT NULL COMMENT 'The amount of space requested to be preallocated in the aggregate hosting the FlexCache volume. ZAPIs: volume-get-iter volume-flexcache-attributes min-reserve',
  `isSnapshotCloneDependencyEnabled` tinyint(1) DEFAULT NULL COMMENT 'Controls the locking of LUN clones. ZAPIs: volume-get-iter volume-snapshot-attributes snapshot-clone-dependency-enabled',
  `isI2pEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, native inode-to-parent information is kept for inodes. ZAPIs: volume-get-iter volume-directory-attributes i2p-enabled',
  `isAutoSnapshotsEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, enable automatic snapshots on the volume. ZAPIs: volume-get-iter volume-snapshot-attributes auto-snapshots-enabled',
  `isSnapDirAccessEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, enable the visible .snapshot directory that is normally present at system internal mount points. ZAPIs: volume-get-iter volume-snapshot-attributes snapdir-access-enabled',
  `languageCode` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The volume language code (e.g. en_US). ZAPIs: volume-get-iter volume-language-attributes language-code',
  `volType` enum('NOT_MAPPED','RW','LS','DP','DC','TMP') COLLATE utf8_bin DEFAULT NULL COMMENT 'The type of the volume. ZAPIs: volume-get-iter volume-id-attributes type',
  `volTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `spaceMgmtOptionTryFirst` enum('NOT_MAPPED','VOLUME_GROW','SNAP_DELETE') COLLATE utf8_bin DEFAULT NULL COMMENT 'This field controls the strategy to try first when this volume is space-challenged. ZAPIs: volume-get-iter volume-space-attributes space-mgmt-option-try-first',
  `spaceMgmtOptionTryFirstRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `autoSizeMode` enum('NOT_MAPPED','OFF','GROW','GROW_SHRINK') COLLATE utf8_bin DEFAULT NULL COMMENT 'The current mode of operation of volume autosize.  ZAPIs: volume-get-iter volume-autosize-attributes mode',
  `autoSizeModeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `autoSizeMaximumSize` bigint(20) DEFAULT NULL COMMENT 'The maximum size (in bytes) to which the volume would be grown automatically.  ZAPIs: volume-get-iter volume-autosize-attributes maximum-size',
  `autoSizeIncrementSize` bigint(20) DEFAULT NULL COMMENT 'The increment size (in bytes) by which the volume would be grown.  ZAPIs: volume-get-iter volume-autosize-attributes increment-size',
  `isAtimeUpdateEnabled` tinyint(1) DEFAULT NULL COMMENT 'If false, prevent the update of inode access times when a file is read.  ZAPIs: volume-get-iter volume-performance-attributes is-atime-update-enabled',
  `isCreateUcodeEnabled` tinyint(1) DEFAULT NULL COMMENT 'This field controls whether all directories in this volume are forced to use the UNICODE format when they are created, both from NFS and CIFS.  ZAPIs: volume-get-iter volume-language-attributes is-create-ucode-enabled',
  `isConvertUcodeEnabled` tinyint(1) DEFAULT NULL COMMENT 'This field controls whether all directories in this volume are forcibly converted to UNICODE format when accessed from both NFS and CIFS.  ZAPIs: volume-get-iter volume-language-attributes is-convert-ucode-enabled',
  `cloneSplitEstimate` bigint(20) DEFAULT NULL COMMENT 'If volume is a clone, the split Estimate.  ZAPIs: volume-clone-get-iter volume-clone-info split-estimate',
  `cloneChildCount` int(11) DEFAULT NULL COMMENT 'Number of clones for which this volume is the parent.  ZAPIs: volume-get-iter volume-clone-attributes clone-child-count',
  `snapshotCount` int(11) DEFAULT NULL COMMENT 'Number of Snapshot copies in the volume.  ZAPIs: volume-get-iter volume-snapshot-attributes snapshot-count',
  `isSnapshotAutoDeleteEnabled` tinyint(1) DEFAULT NULL COMMENT 'This option determines if the snapshot autodelete is currently enabled for the volume.  ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes is-autodelete-enabled',
  `snapshotAutoDeleteCommitment` enum('NOT_MAPPED','TRY','DISRUPT','DESTROY') COLLATE utf8_bin DEFAULT NULL COMMENT 'This option determines the snapshots that "snapshot autodelete" is allowed to delete to get back space.  ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes commitment',
  `snapshotAutoDeleteCommitmentRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `snapshotAutoDeleteDeleteOrder` enum('NOT_MAPPED','OLDEST_FIRST','NEWEST_FIRST') COLLATE utf8_bin DEFAULT NULL COMMENT 'This option determines if the oldest or newest snapshot is deleted first.  ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes delete-order',
  `snapshotAutoDeleteDeleteOrderRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `snapshotAutoDeleteDeferDelete` enum('NOT_MAPPED','SCHEDULED','USER_CREATED','PREFIX','NONE') COLLATE utf8_bin DEFAULT NULL COMMENT 'This option determines which kind of snapshots to delete.  ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes defer-delete',
  `snapshotAutoDeleteDeferDeleteRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `snapshotAutoDeleteTargetFreeSpace` int(11) DEFAULT NULL COMMENT 'This option determines when snapshot autodelete should stop deleting snapshot. ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes target-free-space',
  `snapshotAutoDeleteTrigger` enum('NOT_MAPPED','VOLUME','SNAP_RESERVE','SPACE_RESERVE') COLLATE utf8_bin DEFAULT NULL COMMENT 'This option determines the condition in which snapshots should be automatically deleted.  ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes trigger',
  `snapshotAutoDeleteTriggerRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `snapshotAutoDeletePrefix` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'This option provides the prefix string for the "prefix" field value of the "defer-delete" option.   ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes prefix',
  `snapshotAutoDeleteDestroyList` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'This options specifies the list of service that can be destroyed if the snapshot is backing that service.   ZAPIs: volume-get-iter volume-snapshot-autodelete-attributes destroy-list',
  `oldestSnapshotTimestamp` timestamp NULL DEFAULT NULL COMMENT 'Creation time of the oldest snapshot of this volume',
  `sisStatus` enum('NOT_MAPPED','IDLE','INITIALIZING','ACTIVE','UNDOING','PENDING','DOWNGRADING','DISABLED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Status of any sis operation running on the volume. This parameter is not supported on Infinite Volumes. ZAPIs: sis-get-iter status',
  `sisStatusRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `sisState` enum('NOT_MAPPED','DISABLED','ENABLED') COLLATE utf8_bin DEFAULT NULL COMMENT 'State of sis configured on the volume.  ZAPIs: sis-get-iter state',
  `sisStateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `sisProgress` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The progress of the current sis operation with information as to which stage of sis process is currently in progress and how much data is processed for that stage.  ZAPIs: sis-get-iter progress',
  `sisType` enum('NOT_MAPPED','REGULAR','SNAPVAULT') COLLATE utf8_bin DEFAULT NULL COMMENT 'Any sis volume with Snapvault qtree in it would be marked as Snapvault and all others would be returned as type Regular.  ZAPIs: sis-get-iter sis-status-info.type',
  `sisTypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `sisSchedule` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The schedule for sis operation on the volume.  ZAPIs: sis-get-iter schedule',
  `sisLastOpBeginTimestamp` timestamp NULL DEFAULT NULL COMMENT 'Start timestamp of the last sis operation. The value is in seconds since January 1, 1970.  ZAPIs: sis-get-iter last-op-begin-timestamp',
  `sisLastOpEndTimestamp` timestamp NULL DEFAULT NULL COMMENT 'End timestamp of the last sis operation. The value is in seconds since January 1, 1970.  ZAPIs: sis-get-iter last-op-begin-timestamp',
  `sisLastOpError` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'A human readable error message of the last sis operation. Present when there was an error. ZAPIs: sis-get-iter last-op-error',
  `sisLastOpState` enum('NOT_MAPPED','SUCCESS','FAILURE') COLLATE utf8_bin DEFAULT NULL COMMENT 'Completion status for the last operation. ZAPIs: sis-get-iter last-op-state',
  `sisLastOpStateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `sisLastOpSize` bigint(20) DEFAULT NULL COMMENT 'The amount of data processed in bytes for the last sis operation.  ZAPIs: sis-get-iter last-op-size',
  `isSisCompressionEnabled` tinyint(1) DEFAULT NULL COMMENT 'Compression state of the volume. ZAPIs: sis-get-iter is-compression-enabled',
  `isSisInlineCompressionEnabled` tinyint(1) DEFAULT NULL COMMENT 'Inline compression state of the volume.  ZAPIs: sis-get-iter is-inline-compression-enabled',
  `percentageDeduplicationSpaceSaved` int(11) DEFAULT NULL COMMENT 'Percentage of the total disk space that is saved by deduplication and file cloning.  ZAPIs: volume-get-iter volume-sis-attributes percentage-deduplication-space-saved',
  `percentageCompressionSpaceSaved` int(11) DEFAULT NULL COMMENT 'Percentage of the total disk space that is saved by compressing blocks on the referenced file system.  ZAPIs: volume-get-iter volume-sis-attributes percentage-compression-space-saved',
  `isSnapDiffEnabled` tinyint(1) DEFAULT NULL COMMENT 'Whether to enable Snapdiff. If enabled, the namespace mirrors will be created for Snapdiff use.   ZAPI: Volume-infinitevol-attributes.enable-snapdiff',
  `isManagedByService` tinyint(1) DEFAULT NULL COMMENT 'Specifies if the volume is managed by GUI services.  ZAPI: Volume-infinitevol-attributes.is-managed-by-service',
  `maxDataConstituentSize` bigint(20) DEFAULT NULL COMMENT 'The maximum size of each data constituent in bytes. The smallest, "maximum FlexVol size" setting on all nodes used by the Infinite Volume, is chosen as the default value. ZAPI:Volume-infinitevol-attributes.max-data-constituent-size',
  `maxNamespaceConstituentSize` bigint(20) DEFAULT NULL COMMENT 'The maximum size of the namespace constituent. The default value is 10TB.   ZAPI: Volume-infinitevol-attributes.max-namespace-constituent-size',
  `constituentRole` enum('NOT_MAPPED','NAMESPACE','DATA','NS_MIRROR','OLS','UNKNOWN') COLLATE utf8_bin DEFAULT NULL COMMENT 'This field specifies the role of a constituent within an Infinite Volume. This field is only supported for Infinite Volume constituents.  ZAPI:Volume-infinitevol-attributes.constituent-role',
  `constituentRoleRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `IsConstituent` tinyint(1) DEFAULT NULL,
  `securityUserID` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The UNIX user ID for the volume. The default value is 0 (''root'')',
  `securityGroupID` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The UNIX group ID for the volume. The default value is 0 (''root'')',
  `securityPermissions` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Unix permission bits in octal string format',
  `volumeBlocksFootPrint` bigint(20) DEFAULT NULL COMMENT 'The footprint of blocks written to the volume in bytes',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `cloneParentId_index` (`cloneParentId`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_aggregateId` (`aggregateId`),
  KEY `FK_exportPolicyId` (`exportPolicyId`),
  KEY `FK_snapshotPolicyId` (`snapshotPolicyId`),
  KEY `FK_sisPolicyId` (`sisPolicyId`),
  KEY `FK_storageServiceId` (`storageServiceId`),
  KEY `FK_qosPolicyGroupId` (`qosPolicyGroupId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `volume_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `volume_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `volume_ibfk_3` FOREIGN KEY (`aggregateId`) REFERENCES `aggregate` (`objid`),
  CONSTRAINT `volume_ibfk_4` FOREIGN KEY (`exportPolicyId`) REFERENCES `export_policy` (`objid`),
  CONSTRAINT `volume_ibfk_5` FOREIGN KEY (`snapshotPolicyId`) REFERENCES `snapshot_policy` (`objid`),
  CONSTRAINT `volume_ibfk_6` FOREIGN KEY (`sisPolicyId`) REFERENCES `sis_policy` (`objid`),
  CONSTRAINT `volume_ibfk_7` FOREIGN KEY (`storageServiceId`) REFERENCES `storage_service` (`objid`),
  CONSTRAINT `volume_ibfk_8` FOREIGN KEY (`qosPolicyGroupId`) REFERENCES `qos_policy_group` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `volume_flexcache` */

DROP TABLE IF EXISTS `volume_flexcache`;

CREATE TABLE `volume_flexcache` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  volume-get-iter volume-attributes volume-flexcache-attributes',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the Volume Flexcache Pair',
  `flexCacheId` bigint(20) NOT NULL,
  `originVolumeId` bigint(20) NOT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_flexCacheId` (`flexCacheId`),
  KEY `FK_originVolumeId` (`originVolumeId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `volume_flexcache_ibfk_1` FOREIGN KEY (`flexCacheId`) REFERENCES `volume` (`objid`),
  CONSTRAINT `volume_flexcache_ibfk_2` FOREIGN KEY (`originVolumeId`) REFERENCES `volume` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `volume_move_job` */

DROP TABLE IF EXISTS `volume_move_job`;

CREATE TABLE `volume_move_job` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The job uuid of the move job.  ZAPI:  volume-move-get-iter volume-move-info job-uuid',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `volumeId` bigint(20) NOT NULL,
  `sourceAggregateId` bigint(20) NOT NULL,
  `destinationAggregateId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `jobIdentifier` bigint(20) DEFAULT NULL COMMENT 'The ui job id of the move job.  ZAPI:  volume-move-get-iter volume-move-info job-id',
  `startTime` timestamp NULL DEFAULT NULL COMMENT 'The date and time in cluster timezone when the volume move started.  ZAPI: volume-move-get-iter volume-move-info start-timestamp',
  `completionTime` timestamp NULL DEFAULT NULL COMMENT 'The date and time in cluster timezone when the volume move completed (successfully or otherwise).   ZAPI: volume-move-get-iter volume-move-info actual-completion-timestamp',
  `phase` enum('NOT_MAPPED','QUEUED','INITIALIZING','REPLICATING','CUTOVER','CUTOVER_HARD_DEFERRED','CUTOVER_SOFT_DEFERRED','COMPLETED','CLEANING_UP','FAILED','RESTARTING') COLLATE utf8_bin NOT NULL COMMENT 'The phase of the move operation.   ZAPI:  volume-move-get-iter volume-move-info phase',
  `phaseRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `state` enum('NOT_MAPPED','HEALTHY','DONE','FAILED','WARNING','ALERT') COLLATE utf8_bin NOT NULL COMMENT 'The state of the volume move at the time of issuing the command and the system gathering up the information about the move.   ZAPI: volume-move-get-iter volume-move-info state',
  `stateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `details` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'This field contains details about any warnings, errors and state of the move operation.   ZAPI: volume-move-get-iter volume-move-info details',
  `percentComplete` int(11) DEFAULT NULL COMMENT 'The amount of work to move the volume completed thus far in terms of percentage.  ZAPI: volume-move-get-iter volume-move-info percent-complete',
  `estimatedCompletionTime` timestamp NULL DEFAULT NULL COMMENT 'The approximate date and time in the cluster time zone when the entire volume move operation is expected to complete.  ZAPI: volume-move-get-iter volume-move-info estimated-completion-time',
  `inactive` tinyint(1) NOT NULL DEFAULT '0',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `originId_inactive_index` (`originid`,`inactive`),
  KEY `updatetime_inactive_index` (`updatetime`,`inactive`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_volumeId` (`volumeId`),
  KEY `FK_sourceAggregateId` (`sourceAggregateId`),
  KEY `FK_destinationAggregateId` (`destinationAggregateId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `volume_move_job_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`) ON DELETE CASCADE,
  CONSTRAINT `volume_move_job_ibfk_2` FOREIGN KEY (`volumeId`) REFERENCES `volume` (`objid`) ON DELETE CASCADE,
  CONSTRAINT `volume_move_job_ibfk_3` FOREIGN KEY (`sourceAggregateId`) REFERENCES `aggregate` (`objid`) ON DELETE CASCADE,
  CONSTRAINT `volume_move_job_ibfk_4` FOREIGN KEY (`destinationAggregateId`) REFERENCES `aggregate` (`objid`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `volume_self_relationship` */

DROP TABLE IF EXISTS `volume_self_relationship`;

CREATE TABLE `volume_self_relationship` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'UUID of the Volume',
  `junctionParentId` bigint(20) DEFAULT NULL COMMENT 'ID of the parent volume the QoS Policy Group references',
  `cloneParentId` bigint(20) DEFAULT NULL COMMENT 'Parent (source) volume of the clone pair',
  `checksum` int(11) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_junctionParentid` (`junctionParentId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `volume_self_relationship_ibfk_1` FOREIGN KEY (`objid`) REFERENCES `volume` (`objid`),
  CONSTRAINT `volume_self_relationship_ibfk_2` FOREIGN KEY (`junctionParentId`) REFERENCES `volume` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `vserver` */

DROP TABLE IF EXISTS `vserver`;

CREATE TABLE `vserver` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.  ZAPIs:  vserver-get-iter.vserver-info',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the vserver',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL,
  `name` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Textual name',
  `clusterId` bigint(20) NOT NULL,
  `rootVolumeId` bigint(20) DEFAULT NULL,
  `snapshotPolicyId` bigint(20) DEFAULT NULL,
  `qosPolicyGroupId` bigint(20) DEFAULT NULL,
  `rootVolumeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'showing root volume name for vserver.',
  `state` enum('NOT_MAPPED','RUNNING','STOPPED','STARTING','STOPPING','INITIALIZING','DELETING') COLLATE utf8_bin DEFAULT NULL COMMENT 'Data serving state of Vserver ',
  `stateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `operationalState` enum('NOT_MAPPED','RUNNING','STOPPED') COLLATE utf8_bin DEFAULT NULL COMMENT 'Operational state of Vserver.',
  `operationalStateRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw operationalState of Vserver.',
  `type` enum('NOT_MAPPED','CLUSTER','DATA','ADMIN','NODE') COLLATE utf8_bin DEFAULT NULL COMMENT 'Type of Vserver',
  `typeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `subtype` enum('NOT_MAPPED','DEFAULT','DP_DESTINATION','SYNC_SOURCE','SYNC_DESTINATION') COLLATE utf8_bin DEFAULT NULL COMMENT 'Subtype of Vserver.',
  `subtypeRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Raw subtype of Vserver.',
  `allowedProtocols` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Ordered list of allowed protocols. List of: cifs, nfs, iscsi, and fcp',
  `disallowedProtocols` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Ordered list of disallowed protocols. List of: cifs, nfs, iscsi, and fcp',
  `networkIpSpaceId` bigint(20) DEFAULT NULL COMMENT 'IP Space associated with the vServer.',
  `isConfigLockedForChanges` tinyint(1) DEFAULT NULL COMMENT 'Is the Vserver configuration locked for modificatiion. If the config-lock is true, then modifying the Vserver configuration is not allowed',
  `nfsEnabled` tinyint(1) DEFAULT NULL COMMENT 'NFS access is supported and enabled',
  `nfsV2Supported` tinyint(1) DEFAULT NULL COMMENT 'NFS V2 is supported',
  `nfsV3Supported` tinyint(1) DEFAULT NULL COMMENT 'NFS V3 is supported',
  `nfsV4Supported` tinyint(1) DEFAULT NULL COMMENT 'NFS V4 is supported',
  `nfsV41Supported` tinyint(1) DEFAULT NULL COMMENT 'NFS V4.1 is supported',
  `nfsV41PnfsEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, then Parallel NFS support for NFS version 4.1 is enabled',
  `nfs41AclEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, then NFSv4.1 ACL feature is enabled',
  `nfsV4ReadDelegationEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, NFSv4.0 read delegation feature is enabled',
  `nfsV4WriteDelegationEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, NFSv4.0 write delegation feature is enabled',
  `nfsV4MigrationEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, NFSv4.0 migration feature is enabled',
  `nfsV4ReferralsEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, NFSv4.0 referrals feature is enabled',
  `nfsV41MigrationEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, NFSv4.1 migration feature is enabled',
  `nfsV41ReferralsEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, NFSv4.1 referrals feature is enabled',
  `cifsEnabled` tinyint(1) DEFAULT NULL COMMENT 'CIFS access is supported and enabled',
  `cifsServer` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'NetBIOS name of the CIFS server',
  `cifsAuthenticationStyle` enum('NOT_MAPPED','DOMAIN','WORKGROUP') COLLATE utf8_bin DEFAULT NULL COMMENT 'Authentication style for CIFS clients',
  `cifsAuthenticationStyleRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `cifsDomain` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Fully qualified domain name of the Windows Active Directory this CIFS server belongs to',
  `exportPolicyEnabled` tinyint(1) DEFAULT NULL COMMENT 'Specifies whether the CIFS server uses export policies to control client access.',
  `defaultUnixUser` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The default UNIX user used if the identity of a CIFS user cannot be mapped using normal user mapping rules.',
  `defaultUnixGroup` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The default UNIX group used if the identity of a CIFS group cannot be mapped using normal group mapping rules.',
  `iscsiEnabled` tinyint(1) DEFAULT NULL COMMENT 'iSCSI access is supported and enabled',
  `iscsiNodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'iSCSI target name for the vserver',
  `iscsiAliasName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'iSCSI target alias',
  `fcpEnabled` tinyint(1) DEFAULT NULL COMMENT 'FCP access is supported and enabled',
  `fcpNodeName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'WWN of the vserver FCP target',
  `nisEnabled` tinyint(1) DEFAULT NULL COMMENT 'Specifies whether the NIS domain configuration is active or inactive',
  `activeNisDomainName` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'DERIVED. Domain name of the active NIS server - NULL if none is active.',
  `activeNisServers` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'DERIVED.  NIS servers value of the active NIS server - NULL if none is active.',
  `dnsEnabled` tinyint(1) DEFAULT NULL COMMENT 'True if DNS enabled',
  `dnsServers` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'IPv4 addresses of name servers. Multiple values will be sorted comma separated',
  `dnsDomainNames` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'List of DNS domains. The first domain is the one that the Vserver belongs to',
  `maximumVolumes` int(11) DEFAULT NULL COMMENT 'Maximum number of volumes that can be created on the Vserver',
  `language` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Language to use for the Vserver',
  `nameServerSwitch` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Name Server switch configuration details for the Vserver.Multiple values will be ordered comma separated',
  `volumeBytesUsed` bigint(20) DEFAULT NULL COMMENT 'DERIVED. Sum of all used bytes on volumes in Vserver',
  `volumeBytesAvail` bigint(20) DEFAULT NULL COMMENT 'DERIVED.  Difference between volumeBytesTotal and volumeBytesUsed.',
  `volumeBytesTotal` bigint(20) DEFAULT NULL COMMENT 'DERIVED. Sum of all total bytes on volumes in Vserver',
  `isRepository` tinyint(1) DEFAULT NULL COMMENT 'Specifies if this Vserver is a repository Vserver',
  `ldapClientEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true, the corresponding Lightweight Directory Access Protocol (LDAP) configuration is enabled for this Vserver.',
  `isKerberosEnabled` tinyint(1) DEFAULT NULL COMMENT 'If true,  kerberos security is enabled. ZAPIs:  kerberors-config-get-iter kerberos-config-info.is-kerberos-enabled',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_snapshotPolicyId` (`snapshotPolicyId`),
  KEY `FK_qosPolicyGroupId` (`qosPolicyGroupId`),
  KEY `objState_index` (`objState`,`objid`),
  KEY `FK_networkIpSpaceId` (`networkIpSpaceId`),
  CONSTRAINT `vserver_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `vserver_ibfk_2` FOREIGN KEY (`snapshotPolicyId`) REFERENCES `snapshot_policy` (`objid`),
  CONSTRAINT `vserver_ibfk_3` FOREIGN KEY (`qosPolicyGroupId`) REFERENCES `qos_policy_group` (`objid`),
  CONSTRAINT `vserver_ibfk_4` FOREIGN KEY (`networkIpSpaceId`) REFERENCES `network_ip_space` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `vserver_name_mapping` */

DROP TABLE IF EXISTS `vserver_name_mapping`;

CREATE TABLE `vserver_name_mapping` (
  `objid` bigint(20) NOT NULL COMMENT 'Locally unique object identifier.',
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'Globally unique ID of the VServer Name Mapping. Equal to {VserverUUID}.{direction}.{position} Not returned from ZAPI',
  `resourceKey` varchar(512) COLLATE utf8_bin NOT NULL COMMENT 'DERIVED. A structured key that may be used to uniquely identify this resource globally',
  `clusterId` bigint(20) NOT NULL,
  `vserverId` bigint(20) NOT NULL,
  `position` int(11) NOT NULL COMMENT 'Position of an existing name mapping in the list of name mappings for this Vserver',
  `direction` enum('NOT_MAPPED','KRB_UNIX','WIN_UNIX','UNIX_WIN') COLLATE utf8_bin DEFAULT NULL COMMENT 'The vserver name mapping direction',
  `directionRaw` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The vserver name mapping direction - ZAPI raw value',
  `pattern` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'Pattern to use to match the name while searching for a name that can be used as a replacement',
  `replacement` varchar(255) COLLATE utf8_bin DEFAULT NULL COMMENT 'The name that is to be used as a replacement if the pattern associated with this entry matches',
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `vserver_name_mapping_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `vserver_name_mapping_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*Table structure for table `vserver_to_aggregate` */

DROP TABLE IF EXISTS `vserver_to_aggregate`;

CREATE TABLE `vserver_to_aggregate` (
  `objid` bigint(20) NOT NULL,
  `originid` bigint(20) NOT NULL,
  `uuid` varchar(255) COLLATE utf8_bin NOT NULL COMMENT 'The uuid of this relationship.  DERIVED as the composite of vserver and aggregate UUIDs.',
  `vserverId` bigint(20) NOT NULL,
  `aggregateId` bigint(20) NOT NULL,
  `clusterId` bigint(20) NOT NULL,
  `checksum` int(11) NOT NULL,
  `changeDetailChecksum` int(11) NOT NULL,
  `createtime` bigint(20) NOT NULL,
  `updatetime` bigint(20) NOT NULL,
  `objState` enum('LIVE','DEAD') COLLATE utf8_bin NOT NULL DEFAULT 'LIVE' COMMENT 'Internal object state',
  PRIMARY KEY (`objid`),
  KEY `updatetime_index` (`updatetime`),
  KEY `originId_index` (`originid`),
  KEY `FK_clusterId` (`clusterId`),
  KEY `FK_vserverId` (`vserverId`),
  KEY `FK_aggregateId` (`aggregateId`),
  KEY `objState_index` (`objState`,`objid`),
  CONSTRAINT `vserver_to_aggregate_ibfk_1` FOREIGN KEY (`clusterId`) REFERENCES `cluster` (`objid`),
  CONSTRAINT `vserver_to_aggregate_ibfk_2` FOREIGN KEY (`vserverId`) REFERENCES `vserver` (`objid`),
  CONSTRAINT `vserver_to_aggregate_ibfk_3` FOREIGN KEY (`aggregateId`) REFERENCES `aggregate` (`objid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
